package STOCKHOLM;

use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use File::Files;
use String::StringUtil;
use Sequence::sequence;

############################ sub loadAlign1d ####################################
sub loadAlign {
  my $aln_file 	 = $_[1];
  
  my %hash_aln 	= ();
  my @aln_array = ();
  my @aln_info 	= ();
  my $value    	= "";
  my $item;

  if (FilesIO->isFile($aln_file) eq "true"){
    my @aln_array = FilesIO->lineFileToArray($aln_file);
    foreach $item (@aln_array){
      @aln_info = split(/ +/, $item);
      if (index($item,"#") < 0 && $item ne "\n" && index($item,"//") < 0){
	   	if (scalar(@aln_info) == 2){
			$value = $hash_aln{$aln_info[0]};
        	if ($value){
          		$hash_aln{$aln_info[0]} .= String->removeCaracter($aln_info[1],"\n");
	  		}else{
                $hash_aln{$aln_info[0]} = String->removeCaracter($aln_info[1],"\n");
	  		}
		}
      }
    } 
	
    return %hash_aln;
  }
  else {
    print "ERROR::Could not open file $aln_file  to read !\n";
  }  
}

############################ sub loadAlign1d ####################################
sub convertToSTOCKHOLM {
	my $aln_file_in	 = $_[1];
	my $aln_file_out = $_[2];
	my $verbose = $_[3];
	    
	my @array_aln = FilesIO->lineFileToArray($aln_file_in);
	my $line; my $info_aln = "";
	foreach $line (@array_aln){
		if (index($line, "CLUSTAL") >= 0){
			$info_aln = "# STOCKHOLM 1.0\n";			
		}elsif(index($line, "*") < 0 && index($line, ".") < 0 && index($line, ":") < 0){
			$line =~ s/\-/\./g;
			$info_aln .= $line;
		}
		
	}
	$info_aln .= "//";
	FilesIO->saveFile($aln_file_out, $info_aln, $verbose);
}

############################ sub loadAlign1d ####################################
sub convertSTOCKHOLMToFasta {
	my $aln_file_in	 	= $_[1];
	my $aln_file_out 	= $_[2];
	my $verbose 		= $_[3];
	
	my $line; 				my $info_aln = "";
	my @array_aux = ();		my $index = 0;
	my @array_seq = ();		my %hash_aln = ();
	my $ID = "";			my $sequence = "";
	
	my @array_aln = FilesIO->lineFileToArray($aln_file_in);
	
	foreach $line (@array_aln){
		if (index($line, "#") < 0 && $line ne "\n" && index($line, "//") < 0){
			@array_seq = split(/ +/, $line);
			$ID = $array_seq[0];
			$sequence = String->removeCaracter($array_seq[1], "\n");
			
			if (!exists($hash_aln{$ID})){
				$hash_aln{$ID} = $sequence;
			}else{
				$hash_aln{$ID} .= $sequence;
			}
		}	
	}
	while ( my ($key, $value) = each(%hash_aln) ) {
		$value =~ s/\./-/g;
		$info_aln .=">".$key."\n".Sequences->divideSeq(uc($value), 60)."\n";		
	}

	FilesIO->saveFile($aln_file_out, $info_aln, $verbose);
}
1














