package Alignment;
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
#use File::Files;
use Align::Struct::Mammoth;
use Align::Primary::clustalw;
use Align::Primary::STOCKHOLM;

my $GAP = "-";

##############################################################################################################
# sub findIdentityAlign{
#   
#   my $score_col = 0;
#   my $score_col_tot = 0;
#   my $score_align = 0;
#   
#   for (my $j = 0; $j < $cols; $j++){
#     $score_col_tot = 0;
#     for (my $i = 0; $i < $rows; $i++){
#         $score_col = 0;
#         for (my $k = $i; $k < $rows; $k++){
#             $score_col +=  &calcScore($mat[$i][$j], $mat[$k][$j]);
#         }
#         $score_col_tot +=  $score_col/ ($rows-1);
#     }      
#     $score_align += $score_col_tot;
#   }
#   $score_align = $score_align/$cols;
#   return $score_align;
# }

############################ sub loadAlign1d ####################################
# sub loadAlign {
#   my $aln_file 	 = $_[1];
#   
#   my %hash_aln 	= ();
#   my @aln_array = ();
#   my @aln_info 	= ();
#   my $value    	= "";
#   my $item;
# 
#   if (FilesIO->isFile($aln_file) eq "true"){
#     my @aln_array = FilesIO->lineFileToArray($aln_file);
#     foreach $item (@aln_array){
#       @aln_info = split(/ +/, $item);
#       if (scalar(@aln_info) == 2){
# 	  $value = $hash_aln{$aln_info[0]};
#           if ($value){
#           	$hash_aln{$aln_info[0]} .= String->removeCaracter($aln_info[1],"\n");
# 	  }else{
#                 $hash_aln{$aln_info[0]} = String->removeCaracter($aln_info[1],"\n");
# 	  }
# 	}
#     } 
#     return %hash_aln;
#   }
#   else {
#     print "Could not open file $aln_file  to read !\n";
#   }  
# }

############################ sub loadAlign1d ####################################
sub alignSeqToMat {
	#my(%aln_hash) = %{(shift)};
	my (@aln_hash) = @_;
 	
	my $key_aln; 
  	my $value_aln;
 	my $i;
	my @mat = ();
	my $rows = 0;

	for (my $i=1; $i < scalar(@aln_hash); $i++){
		if ($i % 2 == 0){
			#print $aln_hash[$i]."\n";
			my $seq_aln = $aln_hash[$i];
			#print length($seq_aln)."\n";
			for(my $j = 0 ; $j < length($seq_aln) ; $j++){
 				my $car = substr($seq_aln,$j,1);
         			$mat[$rows][$j] = $car; 
   			}
	      		$rows++; 
		}
	}
	
# 	while (($key_aln, $value_aln) = each(%aln_hash)){
# 		print "oi". $key_aln."\n";
#      		for($i = 0 ; $i < length($value_aln) ; $i++){
# 			my $car = substr($value_aln,$i,1);
#         		$mat[$rows][$i] = $car; 
#   		}
#      		$rows++; 
#   	}
	return @mat;	
}

sub testing {
        my @count = @_;
	my $key_aln; 
  	my $value_aln;
   	foreach my $c (@count){
	#while (($key_aln, $value_aln) = each(%{$count})){
		print "oi". $c;
	}
	
}

############################ sub removeCaracter ####################################
sub countGaps {
	my $seq_aligned	 = $_[1];
	my $pos_start    = $_[2];
	my $pos_end      = $_[3];
	
	my $countGaps	= 0;

	my @array = split(//,$seq_aligned);
	
	for (my $i=$pos_start; $i < $pos_end; $i++){
		if ($array[$i] eq $GAP){
			$countGaps++;
		}
	}
	return $countGaps;

}
############################ sub isGap ####################################
sub isGap{
	my $seq_aligned	= $_[1];
	my $pos         = $_[2];

	my @array = split(//,$seq_aligned);
	if ($array[$pos] eq $GAP){
		return "true";
	}
	return "false";
}

############################ sub isGap ####################################
sub getResidue{
	my $seq_aligned	= $_[1];
	my $pos         = $_[2];

	my @array = split(//,$seq_aligned);
	return $array[$pos]
		
	
}
############################ sub isGap ####################################
sub removeGaps{
	my $seq_aligned	= $_[1];
	my $info = "";

	my @array = split(//,$seq_aligned);
	for (my $i=0; $i < scalar(@array); $i++){
		if ($array[$i] ne $GAP){
			$info .= $array[$i];
		}
	}		
	return $info;
}

############################ sub isGap ####################################
sub getIdentity{
	my $seq_aligned_file	= $_[1];
	my $kind_aln			= $_[2];
	my $info = "";
	my $key_aln      = "";
 	my $value_aln    = "";
 	my $aa;
 	my @mat_2d = (); my $i = 0; my $j = 0;
	my $col = 0;
	my $count_identity = 0; my $count_aligned = 0;
	
	if (!defined($kind_aln)){
		$kind_aln = "clustalw";
	}
	my %hash_aln;
	
	if ($kind_aln eq "clustalw"){
		%hash_aln = Clustalw->loadAlign($seq_aligned_file);
	}elsif ($kind_aln eq "stockholm"){
		%hash_aln = STOCKHOLM->loadAlign($seq_aligned_file);
	}
	 
	
	while (($key_aln, $value_aln) = each(%hash_aln)){
		#print $key_aln."\t".$value_aln."\n";
		$j = 0;
		my @array = split(//,$value_aln);
		foreach $aa (@array) {
       		$mat_2d[$i][$j++] = $aa; 
        }      
        $col = $j;
		$i++;
	}	
	
	for($j = 0; $j< $col; $j++){
		for($i = 0; $i< scalar(@mat_2d); $i++){		
			for(my $k = $i + 1; $k< scalar(@mat_2d); $k++){		
				#print "mat_2d[$i][$j] = ". $mat_2d[$i][$j]." mat_2d[$k][$j] ".$mat_2d[$k][$j]. " \n";
				if ( ( $mat_2d[$i][$j] ne '-'  ||  $mat_2d[$i][$j] ne '.')  && uc($mat_2d[$i][$j]) eq uc($mat_2d[$k][$j])){
							$count_identity++;					
				}
				if ($mat_2d[$i][$j] ne '-' && $mat_2d[$k][$j] ne '-' && $mat_2d[$i][$j] ne '.' && $mat_2d[$k][$j] ne '.' ){
					$count_aligned++;
				}
		
			}	
		
		}	
	}	
	if ($count_aligned == 0){
		print "ERROR::".FilesIO->lineFileToString($seq_aligned_file);
	}
	
	
	return ($count_identity/$count_aligned);
	
	
}

############################ sub isGap ####################################
sub removeSequencesByIdentity{
	my $seq_aligned_file	= $_[1];
	my $output 				= $_[2];
	my $MAX_IDENTITY 		= $_[3];
	my $verbose 			= $_[4];
	
	my $info = ""; 				my $identity_local;
	my $sequences_info = "";	my $count = 0;
	my $not_save;
	
	my @array_aln = FilesIO->fileToArray2d($seq_aligned_file, "\t");
	
	
	for (my $i=0; $i< scalar(@array_aln); $i++){
		$not_save = "false";	
		for (my $j=$i+1; $j< scalar(@array_aln); $j++){
			$info = "";	
			$info .= $array_aln[$i][0]." ".$array_aln[$i][1]."\n";
			$info .= $array_aln[$j][0]." ".$array_aln[$j][1]."\n";
			FilesIO->saveFile($output, $info, $verbose);
			$identity_local = Alignment->getIdentity($output, "clustalw");
			#print  $array_aln[$i][0]."\t".$array_aln[$j][0]."\tIDL = $identity_local\n";
						
			if ($identity_local > $MAX_IDENTITY){
				$not_save = "true";
				$j = scalar(@array_aln);
			}	
		}
		if ($not_save eq "false"){
			$sequences_info .= ">".$array_aln[$i][0]."\n".$array_aln[$i][1]."\n";	
			$count++;	
		}
	}		
	FilesIO->saveFile($output, $sequences_info, $verbose);
	print "LOG::QTD SEQ Brut $count\n";
}

1
	