package Clustalw;

use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use File::Files;
use String::StringUtil;
use Align::Primary::clustalw;
use Sequence::sequence;
use Util::Array;


############################ sub getSequences ##################################
sub getSequencesFromAlign {
	my $file_aln		= $_[1];
	my $filer_sequence	= $_[2];

	my %hash_aln =	();

	my $item; my $value; my $key_aln;my $value_aln;
	my $tag_clustal = "CLUSTAL";
	my $info_file   = "";

	my @aln_file		= ();			
	my @aln_info		= ();
        
        my $dir_sequence;

	if (FilesIO->isFile($file_aln)){
	   @aln_file = FilesIO->lineFileToArray($file_aln);
	   foreach $item (@aln_file){
	      if (index($item,$tag_clustal)< 0){
	         @aln_info = split(/ +/,$item);
		 if (scalar(@aln_info) >1){
		    if (index($aln_info[0],"pdb") >= 0 ){ 		
		       $value = $hash_aln{$aln_info[0]};
		       if ($value){
		          $hash_aln{$aln_info[0]} = $value. String->removeCaracter(substr($aln_info[1],0,index($aln_info[1],"\n")),"-");
			}
			else{
			   $hash_aln{$aln_info[0]} = String->removeCaracter(substr($aln_info[1],0,index($aln_info[1],"\n")),"-"); 
			}
		     }						
		   }
		  }
		}
		
		while (($key_aln, $value_aln) = each(%hash_aln)){
				#print $key_aln."oi\n".$value_aln."oi\n" ;
				$value_aln = &divideSequence($value_aln);
				$hash_aln{$key_aln} = $value_aln;
		}
		
		while (($key_aln, $value_aln) = each(%hash_aln)){
				$info_file.=">".$key_aln."\n".$value_aln."\n\n" ;				
		}
		#print $info_file;
		#&saveFile($dir_sequence.$seq_file_name, $info_file);
		#close ALNFILE;
	}
	else{
		#print "the file $dir_aln$aln_file_name not found";
	}
}

############################ sub getSequences ##################################
sub runAlign {
  my $input_file_name	= $_[1];
  my $output_file_name	= $_[2];
  my $verbose	= $_[3];
	
	if (!defined($verbose)){
		$verbose = "true";
	}

  my $line;

  my $cmd = "clustalw2 -OUTFILE=$output_file_name -OUTORDER=INPUT -SEQNOS=OFF -MATRIX=BLOSUM -INFILE=$input_file_name > log.clustal";
  #my $cmd = "clustalw -OUTFILE=$output_file_name -OUTORDER=INPUT -SEQNOS=OFF -MATRIX=GONNET -INFILE=$input_file_name";
  if ($verbose eq "true"){
  	print $cmd;
  }
  system ($cmd);
  
  if (FilesIO->isFile($output_file_name) eq "false"){
  	print "ERROR:: alignment $output_file_name NOT created \n";
  	exit;
  }
}

############################ sub getSequences ##################################
sub formatAlign {
  	my $input_file	= $_[1];
	my $line	= "";
	my $entry;

	if (FilesIO->isFile($input_file) eq "true"){
		my @array_aln = FilesIO->lineFileToArray($input_file);
		foreach $entry (@array_aln){
			my @array_line = split(/ +/, $entry);
			if (index($entry,"CLUSTAL") < 0 && index($array_line[0],"\n") != 0){
				if (scalar(@array_line) > 2){
					$line .=$array_line[0].$array_line[1]."      ". $array_line[2];
				}
			}
			else{
				$line .= $entry;
			}
		}
		if ($line ne ""){
			FilesIO->saveFile($input_file, $line);
		}
	}
	else{
		print "ERROR Align::Primary::clustalw: File not found $input_file \n";
	}

}

############################ sub getSequences ##################################
sub formatAlign2 {
  	my $input_file	= $_[1];
	my $line	= "";
	my $entry;

	if (FilesIO->isFile($input_file) eq "true"){
		my @array_aln = FilesIO->lineFileToArray($input_file);
		foreach $entry (@array_aln){
			my @array_line = split(/ +/, $entry);
			if (index($entry,"CLUSTAL") < 0 && index($array_line[0],"\n") != 0){
				$line .=String->removeCaracter($entry,"\t");
			}
			else{
				$line .= $entry;
			}
		}
		if ($line ne ""){
			FilesIO->saveFile($input_file, $line);	
		}
	}
	else{
		print "ERROR Align::Primary::clustalw: File not found $input_file \n";
	}

}

############################ sub loadAlign1d ####################################
sub loadAlign {
  my $aln_file 	 = $_[1];
  
  my %hash_aln 	= ();
  my @aln_array = ();
  my @aln_info 	= ();
  my $value    	= "";
  my $item;

  if (FilesIO->isFile($aln_file) eq "true"){
    my @aln_array = FilesIO->lineFileToArray($aln_file);
    foreach $item (@aln_array){
      @aln_info = split(/ +/, $item);
      if (index($item,"CLUSTAL") < 0 && $item ne "\n" && $item =~ /[a-zA-Z0-9_]/ ){
	   if (scalar(@aln_info) == 2){
		$value = $hash_aln{$aln_info[0]};
          	if ($value){
          		$hash_aln{$aln_info[0]} .= String->removeCaracter($aln_info[1],"\n");
	  	}else{
                	$hash_aln{$aln_info[0]} = String->removeCaracter($aln_info[1],"\n");
	  	}
	}
      }
    } 
	
    return %hash_aln;
  }
  else {
    print "Could not open file $aln_file  to read !\n";
  }  
}


############################ sub loadAlign1d ####################################
sub getOrderSeqAlign {
  my $aln_file 	 = $_[1];
  
  my %hash_aln 	= ();
  my @aln_array = ();
  my @aln_info 	= ();
  my $item;
  my $key;
  my $count = 0;

  if (FilesIO->isFile($aln_file) eq "true"){
    my @aln_array = FilesIO->lineFileToArray($aln_file);
    foreach $item (@aln_array){
    	@aln_info = split(/ +/, $item);
      	if (index($item,"CLUSTAL") < 0 && $item ne "\n" && $item =~ /[a-zA-Z0-9_]/ ){
	   		if (scalar(@aln_info) == 2){
	   			$key = $aln_info[0];
	   			if (!exists($hash_aln{$key})){
	   				$count++;
	   				$hash_aln{$key} = $count;
	   			}
	   		}
    	} 
    }
    return %hash_aln;
  }
  else {
    print "Could not open file $aln_file  to read !\n";
  }  
}
############################ sub formatAlign1d ####################################
sub replaceFirstLine {
  my $path 	 = $_[1];
  my $path_out	 = $_[2];
  my $item;

  my $info = "";
  my $first = "true";
   
  if (open(FILE, "$path")){
    my @aln_file = <FILE>;
    foreach $item (@aln_file){
	 if ($first eq "true" && $item ne "\n"){
		$first = "false";
		$info = "CLUSTAL W (1.82) multiple sequence alignment\n\n";
	 }
	 elsif ($first eq "false"){
		$info .= $item;
	}
   } 
  }
  if ($info eq ""){
 	print "ERROR: There is not first line $path\n";
  }
  else{
	FilesIO->saveFile($path_out, $info);	
  }
   
}

############################ sub formatAlign1d ####################################
sub formatAlign1d {
  my $path 	 = $_[1];
  my $len 	 = $_[2];
  my @mat_aux   = ([],[]);
  
   
  my @aln_file = ();  
  my @aln_info = ();
  my $value    = "";
  my $item;
  my $info = "CLUSTAL W (1.82) multiple sequence alignment\n\n";
  my $count_seq = 0;
  my $i = 0;
  my $len_aln = 0;
  
  my $start_pos = 0;
  my $end_pos   = 0;

  if (open(FILE, "$path")){
    @aln_file = <FILE>;
    foreach $item (@aln_file){
      @aln_info = split(/ +/,$item);
      if (scalar(@aln_info) == 2){
	    $mat_aux[0][$count_seq] = $aln_info[0];
            $mat_aux[1][$count_seq] = substr($aln_info[1],0,index($aln_info[1],"\n"));
            $len_aln = length($mat_aux[1][$count_seq]);
            $count_seq++;
            print $count_seq."\n";	  
      }
    }
    
   
    while($end_pos < $len_aln){
      if (($start_pos + $len) < $len_aln){
          $end_pos = $start_pos + $len;
      }
      else{
        $end_pos = $start_pos + ($len_aln - $start_pos);
      }        
      #print "\n $end_pos  $len_aln $start_pos $len \n";
      while($i < $count_seq){
       $info .= $mat_aux[0][$i] . "      ".substr($mat_aux[1][$i],$start_pos,$len)."\n";       
       $i++;
      }
      $info .="\n\n";
      $start_pos = $end_pos;
      $i = 0;
      
    }
    return $info;
    #print $info;      
  }
  else {
    print "Could not open file $path  to read !\n";
    exit;
  }  
}


############################ sub formatAlign1d ####################################
sub formatAlignClustalw {
  my $version 		= $_[1];
  my $outputFile 	= $_[2];
  my $spaces		= $_[3];
  my $params1 		= $_[4];
  my $params2 		= $_[5];
  my %hash = %$params2;
  my %hashOrder = %$params1;
  
  my $bigger = 0;
  my $len_key;
  
  my $info = "CLUSTAL $version multiple sequence alignment\n\n";
  while ( my ($key, $value) = each(%hash) ) {
  	$len_key = length($key);
  	if ($len_key > $bigger){
  		$bigger = $len_key;
  	}
  }
  
  print "bigger = $bigger\n";
  
  my @matrix = ();my $key_seq;
  while ( my ($key, $value) = each(%hashOrder) ) {
  	$len_key = length($key);
  	$len_key = $bigger - $len_key + $spaces;
  	$key_seq = $key.String->gap($len_key);
  	$matrix[$value-1][0] = $key_seq;
  	$matrix[$value-1][1] = $hash{$key};
  }
  $info .= Array->printMatrix2( "", "\n",  \@matrix);
  FilesIO->saveFile($outputFile, $info, "false");
 
  
}
############################ sub formatAlign1d ####################################
sub convertIntoLineFormat {
 	my $aln 	 = $_[1];
 	my $output 	 = $_[2];
 	my $verbose	 = $_[3];

	my $key; my $value;
	my %hash_aln = Clustalw->loadAlign($aln);
	my $info = "";
  	while (($key, $value) = each %hash_aln)
	{
  		$info .= $key." ". $value. "\n";
	}
	FilesIO->saveFile($output, $info, $verbose);	
 }
 
 ############################ sub formatAlign1d ####################################
sub convertIntoLineFormatRename {
 	my $aln 	 = $_[1];
 	my $output 	 = $_[2];
 	my $verbose	 = $_[3];

	my $key; my $value;
	my $dir = FilesIO->getDirectory($output);
	my %hash_aln = Clustalw->loadAlign($aln);
	my $info = "";
	my $info_map = "";
	my $count = 1;
  	while (($key, $value) = each %hash_aln)
	{
		#print $key." ".$value."\n";
		$info_map .= "seq".$count."\t".$key."\n";
  		$info .= "seq".$count." ". $value. "\n";
  		$count++;
	}
	
	FilesIO->saveFile($output, $info, $verbose);	
	FilesIO->saveFile(FilesIO->getDirectory($output)."seqs_map.txt", $info_map, $verbose);	
 }
 
 ############################ sub formatAlign1d ####################################
sub formatPhylip{
	my $aln 	 = $_[1];
 	my $output 	 = $_[2];
 	my $verbose	 = $_[3];
 	
 	my $key; 		my $value;
 	my $len_aln;    my $qtd_seq = 0;
 	my $info = "";  my $space4 = "    ";
 	
 	my %hash_aln = Clustalw->loadAlign($aln);
 	
 	while (($key, $value) = each %hash_aln)
	{
		$len_aln = length($value);
		$qtd_seq++;
		$info .= $key.$space4.$value."\n";
	}	
	$info = "   $qtd_seq   $len_aln\n".$info;
	FilesIO->saveFile($output, $info, $verbose);	
}
 
1