use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use File::Files;
use String::StringUtil;
use Sequence::sequence;
use Align::Primary::STOCKHOLM;

my $alnFile	= "";
my $outputFile  	= "";
my $kind		= 1;
#1 - stockomo to fasta
my $verbose = "false";

my $PROG_NAME = "perlLib::Align::Primary::convert_aln.pl";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-alnFile"){
			$alnFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-kind"){
			$kind = $ARGV[$counter+1];		
		}            	  	 			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEqual($verbose,"true,false",$PROG_NAME."::ERROR::Parameter -verbose must be true or false!");
	
	String->isEmpty($alnFile, $PROG_NAME."::ERROR::Parameter -alnFile having alignment file is required!");
	FilesIO->checkFile($alnFile, $PROG_NAME."ERROR:: File $alnFile NOT found ");	
	String->isEmpty($outputFile, $PROG_NAME."::ERROR::Parameter -outputFile having output File is required!");
	
	print "-alnFile = $alnFile\n";
	print "-outputFile = $outputFile\n"; 
	print "-kind = $kind\n"; 
	print "-verbose = $verbose\n";	
	print "ok\n";
}	



########################### sub main ####################################
sub main { 
	
	if ($kind  == 1){
		STOCKHOLM->convertSTOCKHOLMToFasta($alnFile, $outputFile, $verbose);
	}elsif ($kind  == 2){#Clustalw to STOCKHOLM
		STOCKHOLM->convertToSTOCKHOLM($alnFile, $outputFile, $verbose);
	}
	else{
		print $PROG_NAME."::ERROR:: Option kind=$kind is not valid\n";
		exit;
	}
}