package Mafft;
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use File::Files;
use String::StringUtil;


my $PROG_NAME = "perlLib::Align::Primary::mafft.pm::";


############################ sub getSequences ##################################
sub getSequencesFromAlign {
	my $file_aln		= $_[1];
	my $filer_sequence	= $_[2];

	my %hash_aln =	();

	my $item; my $value; my $key_aln;my $value_aln;
	my $tag_clustal = "CLUSTAL";
	my $info_file   = "";

	my @aln_file		= ();			
	my @aln_info		= ();
        
        my $dir_sequence;

	if (FilesIO->isFile($file_aln)){
	   @aln_file = FilesIO->lineFileToArray($file_aln);
	   foreach $item (@aln_file){
	      if (index($item,$tag_clustal)< 0){
	         @aln_info = split(/ +/,$item);
		 if (scalar(@aln_info) >1){
		    if (index($aln_info[0],"pdb") >= 0 ){ 		
		       $value = $hash_aln{$aln_info[0]};
		       if ($value){
		          $hash_aln{$aln_info[0]} = $value. String->removeCaracter(substr($aln_info[1],0,index($aln_info[1],"\n")),"-");
			}
			else{
			   $hash_aln{$aln_info[0]} = String->removeCaracter(substr($aln_info[1],0,index($aln_info[1],"\n")),"-"); 
			}
		     }						
		   }
		  }
		}
		
		while (($key_aln, $value_aln) = each(%hash_aln)){
				#print $key_aln."oi\n".$value_aln."oi\n" ;
				$value_aln = &divideSequence($value_aln);
				$hash_aln{$key_aln} = $value_aln;
		}
		
		while (($key_aln, $value_aln) = each(%hash_aln)){
				$info_file.=">".$key_aln."\n".$value_aln."\n\n" ;				
		}
		#print $info_file;
		#&saveFile($dir_sequence.$seq_file_name, $info_file);
		#close ALNFILE;
	}
	else{
		#print "the file $dir_aln$aln_file_name not found";
	}
}

############################ sub getSequences ##################################
sub runAlignFClustal {
  my $input_file_name	= $_[1]; 
  my $output_file_name	= $_[2];
  my $parameters		= $_[3];
  my $verbose			= $_[4];

  my $line;

  my $cmd = "mafft --clustalout $parameters $input_file_name > $output_file_name ";
  #my $cmd = "clustalw -OUTFILE=$output_file_name -OUTORDER=INPUT -SEQNOS=OFF -MATRIX=GONNET -INFILE=$input_file_name";
  print $cmd;
  system ($cmd);
  
  if (FilesIO->isFile($output_file_name) eq "false"){
  	print $PROG_NAME. "ERROR:: Alignment file: $output_file_name not created\n";
  }elsif ($verbose eq "true"){
  	print "Alignment file  $output_file_name created\n";
  }
}

############################ sub getSequences ##################################
sub formatAlign {
  	my $input_file	= $_[1];
	my $line	= "";
	my $entry;

	if (FilesIO->isFile($input_file) eq "true"){
		my @array_aln = FilesIO->lineFileToArray($input_file);
		foreach $entry (@array_aln){
			my @array_line = split(/ +/, $entry);
			if (index($entry,"CLUSTAL") < 0 && index($array_line[0],"\n") != 0){
				if (scalar(@array_line) > 2){
					$line .=$array_line[0].$array_line[1]."      ". $array_line[2];
				}
			}
			else{
				$line .= $entry;
			}
		}
		if ($line ne ""){
			FilesIO->saveFile($input_file, $line);
		}
	}
	else{
		print "ERROR Align::Primary::clustalw: File not found $input_file \n";
	}

}

############################ sub getSequences ##################################
sub formatAlign2 {
  	my $input_file	= $_[1];
	my $line	= "";
	my $entry;

	if (FilesIO->isFile($input_file) eq "true"){
		my @array_aln = FilesIO->lineFileToArray($input_file);
		foreach $entry (@array_aln){
			my @array_line = split(/ +/, $entry);
			if (index($entry,"CLUSTAL") < 0 && index($array_line[0],"\n") != 0){
				$line .=String->removeCaracter($entry,"\t");
			}
			else{
				$line .= $entry;
			}
		}
		if ($line ne ""){
			FilesIO->saveFile($input_file, $line);	
		}
	}
	else{
		print "ERROR Align::Primary::clustalw: File not found $input_file \n";
	}

}

############################ sub loadAlign1d ####################################
sub loadAlign {
  my $aln_file 	 = $_[1];
  
  my %hash_aln 	= ();
  my @aln_array = ();
  my @aln_info 	= ();
  my $value    	= "";
  my $item;

  if (FilesIO->isFile($aln_file) eq "true"){
    my @aln_array = FilesIO->lineFileToArray($aln_file);
    foreach $item (@aln_array){
      @aln_info = split(/ +/, $item);
      if (index($item,"CLUSTAL") < 0 && $item ne "\n" && $item =~ /[a-zA-Z0-9_]/ ){
	   if (scalar(@aln_info) == 2){
		$value = $hash_aln{$aln_info[0]};
          	if ($value){
          		$hash_aln{$aln_info[0]} .= String->removeCaracter($aln_info[1],"\n");
	  	}else{
                	$hash_aln{$aln_info[0]} = String->removeCaracter($aln_info[1],"\n");
	  	}
	}
      }
    } 
	
    return %hash_aln;
  }
  else {
    print "Could not open file $aln_file  to read !\n";
  }  
}

############################ sub formatAlign1d ####################################
sub formatAlign1d {
  my $path 	 = $_[1];
  my $len 	 = $_[2];
  my @mat_aux   = ([],[]);
  
   
  my @aln_file = ();  
  my @aln_info = ();
  my $value    = "";
  my $item;
  my $info = "CLUSTAL W (1.82) multiple sequence alignment\n\n";
  my $count_seq = 0;
  my $i = 0;
  my $len_aln = 0;
  
  my $start_pos = 0;
  my $end_pos   = 0;

  if (open(FILE, "$path")){
    @aln_file = <FILE>;
    foreach $item (@aln_file){
      @aln_info = split(/ +/,$item);
      if (scalar(@aln_info) == 2){
	    $mat_aux[0][$count_seq] = $aln_info[0];
            $mat_aux[1][$count_seq] = substr($aln_info[1],0,index($aln_info[1],"\n"));
            $len_aln = length($mat_aux[1][$count_seq]);
            $count_seq++;
            #print $count_seq."\n";	  
      }
    }
    
   
    while($end_pos < $len_aln){
      if (($start_pos + $len) < $len_aln){
          $end_pos = $start_pos + $len;
      }
      else{
        $end_pos = $start_pos + ($len_aln - $start_pos);
      }        
      #print "\n $end_pos  $len_aln $start_pos $len \n";
      while($i < $count_seq){
       $info .= $mat_aux[0][$i] . "      ".substr($mat_aux[1][$i],$start_pos,$len)."\n";       
       $i++;
      }
      $info .="\n\n";
      $start_pos = $end_pos;
      $i = 0;
      
    }
    return $info;
    #print $info;      
  }
  else {
    print "Could not open file $path  to read !\n";
    exit;
  }  
}




1