package NW;
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use File::Files;
use String::StringUtil;
use Sequence::sequence;

my $PROG_NAME = "perlLib::Align::Primary::nw_align.pm";
my $EXE_NAME = "NWAlign.jar";


############################ sub loadAlign1d ####################################
sub run {
  my $file1	 	= $_[1];
  my $file2	 	= $_[2];
  my $output 	= $_[3];
  my $verbose 	= $_[4];
  
  if (!exists($ENV{'NW_ALIGN'})){
  	print "ERROR:: Not existis NW_ALIGN\n";
  	exit;
  }
  chdir($ENV{'NW_ALIGN'});
  my $cmd = "java -jar $EXE_NAME $file1 $file2 > $output";
  
  if ($verbose eq "true"){
  	print $cmd."\n";
  }
  system $cmd;
  
  #formatar o resultado para clustalw output.
  
  FilesIO->checkFile($output, "ERROR::".$PROG_NAME.":: File $output Not created\n");	
  
}

############################ sub loadAlign1d ####################################
sub getIdentity {
  my $file	 	= $_[1];
  my $verbose	= $_[2];
  
  my $token= "Sequence identity=";
  
  my @array = FilesIO->lineFileToArrayWithToken($file, $token);
  @array = split(/=/,$array[0]);
  @array = split(/ +/, $array[1]);
  
  my $identity = $array[0];
  return $identity;
  
}

############################ sub loadAlign1d ####################################
sub alignToHash {
  	my $aln_file	 	= $_[1];
  	my $seq1_file	 	= $_[2];
  	my $seq1_name 		= $_[3];
  	my $seq2_file	 	= $_[4];
  	my $seq2_name 		= $_[5];

	my $item;				my $sequence;
	my $aligned_sequence;	my %hash_aln = ();

	my @array = FilesIO->lineFileToArray($aln_file);
	
	my @array_sequence1 = Sequences->getSequenceFromFastaArray2D($seq1_file);
	my @array_sequence2 = Sequences->getSequenceFromFastaArray2D($seq2_file);

	
	foreach $item (@array){
		
		if ($item !~ m/\:|\=|[0-9]|\#/ && $item ne "\n" && $item !~ m/ +/){
			
			$aligned_sequence = String->removeCaracter($item, "\n");
			$sequence = String->removeCaracter($aligned_sequence, "-");
			if (uc($sequence) eq uc($array_sequence1[0][1])){
				$hash_aln{$seq1_name} = $aligned_sequence;
			}elsif (uc($sequence) eq uc($array_sequence2[0][1])){
				$hash_aln{$seq2_name} = $aligned_sequence;
			}else{
				print $aln_file."\n";
				print "ERROR::".$PROG_NAME.":: $sequence NOT found\n"
			}			
		}else{
			#print $item;
		}
	}
	return %hash_aln;
}

1