package Mammoth;
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use File::Files;
use String::StringUtil;

my @mat_3d   = ([],[]);


############################ sub loadAlign1d ####################################
sub formatAlign1d {
  my $path 	 = $_[1];
  my $len 	 = $_[2];
  my @mat_aux   = ([],[]);
  
   
  my @aln_file = ();  
  my @aln_info = ();
  my $value    = "";
  my $item;
  my $info = "CLUSTAL W (1.82) multiple sequence alignment\n\n";
  my $count_seq = 0;
  my $i = 0;
  my $len_aln = 0;
  
  my $start_pos = 0;
  my $end_pos   = 0;

  if (open(FILE, "$path")){
    @aln_file = <FILE>;
    foreach $item (@aln_file){
      @aln_info = split(/ +/,$item);
      if (scalar(@aln_info) == 2){
	  if (index($aln_info[0],"pdb") >= 0 ){ 		
            $mat_aux[0][$count_seq] = $aln_info[0];
            $mat_aux[1][$count_seq] = substr($aln_info[1],0,index($aln_info[1],"\n"));
            $len_aln = length($mat_aux[1][$count_seq]);
            $count_seq++;
            #print $count_seq."\n";
	  }
      }
    }
    
   
    while($end_pos < $len_aln){
      if (($start_pos + $len) < $len_aln){
          $end_pos = $start_pos + $len;
      }
      else{
        $end_pos = $start_pos + ($len_aln - $start_pos);
      }        
      #print "\n $end_pos  $len_aln $start_pos $len \n";
      while($i < $count_seq){
       $info .= $mat_aux[0][$i] . "      ".substr($mat_aux[1][$i],$start_pos,$len)."\n";       
       $i++;
      }
      $info .="\n\n";
      $start_pos = $end_pos;
      $i = 0;
      
    }
    return $info;
    #print $info;      
  }
  else {
    print "Could not open file $path  to read !\n";
    exit;
  }  
}
############################ sub loadAlign1d ####################################
sub loadAlign1d {
  my $path 	 = $_[1];
  print $path."\n";
  my %hash_aln = ();     
  my @aln_file = ();  
  my @aln_info = ();
  my $value    = "";
  my $item;

  if (open(FILE, "$path")){
    @aln_file = <FILE>;
    foreach $item (@aln_file){
      @aln_info = split(/ +/,$item);
      if (scalar(@aln_info) == 2){
	  if (index($aln_info[0],"pdb") >= 0 ){ 
              $value = $hash_aln{$aln_info[0]};
           if ($value){
                $hash_aln{$aln_info[0]} .= substr($aln_info[1], 0 , index($aln_info[1],"\n"));
	      }
	      else{
                $hash_aln{$aln_info[0]} = substr($aln_info[1], 0 , index($aln_info[1],"\n"));
	      }
		}
      }
    }
    close FILE;


    return %hash_aln;
  }
  else {
    print "Could not open file $path  to read !\n";
    exit;
  }  
}

############################ sub loadAlign1d ####################################
sub loadInfo3d {
  my $path 	 = $_[1];
  
  my %hash_aln = ();     
  my @aln_file = ();  
  my @aln_info = ();
  my $value    = "";
  my $item;
  my $name = "pdb";
  my $count = 0;

  if (open(FILE, "$path")){
    @aln_file = <FILE>;
    foreach $item (@aln_file){
      $hash_aln{$name.$count} .= substr($item, 0 , index($item,"\n"));
      $count++;
    }
    close FILE;
    return %hash_aln;
  }
  else {
    print "Could not open file $path  to read !\n";
    exit;
  }  
}


############################ sub getSeqAln1d ####################################
sub getSeqAln1d {
  my $path 	 = $_[1];
  
  my @aln_file = ();  
  my @aln_info = ();
  my @aln_seq = ();
  my $value    = "";
  my $item;

  if (open(FILE, "$path")){
    @aln_file = <FILE>;
    foreach $item (@aln_file){
      @aln_info = split(/ +/,$item);
      if (index($aln_info[0],"pdb") >= 0 ){ 
         push(@aln_seq,$aln_info[0]);	    
      }
    }
    close FILE;
    return @aln_seq;
  }
  else {
    print "Could not open file $path  to read !\n";
    exit;
  }  
}

############################ sub getSeqAln1d ####################################
sub getSeqAln {
  my $path 	 = $_[1];
  
  my @aln_file = ();  
  my @aln_info = ();
  my @aln_seq = ();
  my $value    = "";
  my $item;

  if (open(FILE, "$path")){
    @aln_file = <FILE>;
    foreach $item (@aln_file){
      @aln_info = split(/\t/,$item);
      if (index($aln_info[0],"pdb") >= 0 ){ 
         push(@aln_seq,$aln_info[0]);	    
      }
    }
    close FILE;
    return @aln_seq;
  }
  else {
    print "Could not open file $path  to read !\n";
    exit;
  }  
}

############################ sub loadAlign1d ####################################
sub get2dAln {
  my $path 	 = $_[1];
  
  my @mat_2d   = ([],[]);
  my @aln_file = ();  
  my @aln_info = ();
  my $value    = "";
  my $item;
  my $elem;
  my $i =0; my $j = 0;
  my $aa;

  if (open(FILE, "$path")){
    @aln_file = <FILE>;
    foreach $item (@aln_file){
    	print "ss$item"."oo";
      if ($item ne "\n" && index($item, "CLUSTAL") < 0){
      	@aln_info = split(/ +/,$item);
      	$j =0;
      	if (scalar(@aln_info) == 2){
      		foreach $elem (@aln_info) {
       			if (index($elem,"pdb") < 0 && $elem ne " "){ 
       				$elem = String->removeCaracter($elem, "\n");
       				my @array_seq = split(//, $elem);
       				foreach $aa (@array_seq) {
       					$mat_2d[$i][$j++] = $aa; 
       				}       
       			}
      		}
     		$i++;      	
      	}
      	
      }     
   }   
   #print $i. " ". "$j\n"; 
    close FILE;
    #for (my $l=0; $l < $i; $l++){
     # for (my $c=0; $c < $j; $c++){
      #  print $mat_2d[$l][$c]." ";    
      #}
      #print "\n";
    #}
    
       
    return @mat_2d;
  }
  else {
    print "Could not open file $path  to read !\n";
    exit;
  }  
}

############################ sub displayAlign1d ####################################
#sub displayAlign1d {
#  my $key_aln; 
 # my $value_aln;
  
 # while (($key_aln, $value_aln) = each(%hash_aln)){
  #  print $key_aln."\t".$value_aln."\n" ;    
  #}
#}

############################ sub displayAlign1d ####################################
sub find3dConsens {
  my $path       = $_[1];
  
 
  my @array_file = ();
  my @array_aux  = ();
  
  my $item;
  my $i = 0;
  my $j = 0;

  if (open(FILE, "$path")){
       @array_file  = <FILE>;
       foreach $item (@array_file){
         @array_aux = split(/\t/,$item);
         for ($j = 0; $j < scalar(@array_aux); $j++){
           $mat_3d[$j][$i] = $array_aux[$j];
           $j++;
         }
         $i++;
       }
       &sum3dMat($i--,$j--);
  }
  else {
   print "Could not open file $path  to read !\n";
  }
}
############################ sub displayAlign1d ####################################
sub sum3dMat {
  my $rows       = $_[0];
  my $cols       = $_[1];
  
  my $i      = 0;
  my $j      = 0;
  my $sum    = 0;
  my $count  = 0;
  
  my @array_sum  = ();
  
  for ($j = 0; $j < $cols; $j++){
     for ($i = 0; $i < $rows; $i++){
      if ($mat_3d[$j][$i] > 0) {
        $sum += $mat_3d[$j][$i];
        $count++;
      }      
    }
    if ($count > 0){
      $sum = $sum / $count;
      $array_sum[$j] = $sum;
    }
    $sum = 0;  $count = 0;   
  }
  return @array_sum;
}
############################ sub displayAlign1d ####################################
sub display3dMat {
  my $rows       = $_[0];
  my $cols       = $_[1];
  
  my $i = 0;
  my $j = 0;
  $cols = 5;
  
  for ($i = 0; $i < $rows; $i++){
    for ($j = 0; $j < $cols; $j++){
      print $mat_3d[$j][$i]."\t";
    }
    print "\n";
  }
}

############################ sub run ####################################
sub run {
  my $path_mammoth       = $_[1];
  my $input_file	 = $_[2];
  my $dir_out		 = $_[3];
  
  
  chdir(FilesIO->getDirectory($input_file)); 
   my  $file_name = FilesIO->getNameFile($input_file);
 
   my $cmd = "$path_mammoth $file_name";
   print $cmd."\n";
   system ($cmd);
  

  $cmd = "mv *-FINAL.??? $dir_out";
  print $cmd."\n";

  #system ($cmd);
  #my $ext_name = FilesIO->getExt($input_file);
  #$file_name = substr($file_name, 0, index($file_name,".". $ext_name));
  if (FilesIO->isFile($dir_out.$file_name."-FINAL.aln") eq "true"){
	return $dir_out.$file_name."-FINAL.aln". " was created\n" 
  }else{
  	return $dir_out.$file_name."-FINAL.aln". " NOT was created\n" 
  }
  
  
}

############################ sub run ####################################
sub verifyRun {
  my $input_file	 = $_[1];
  my $dir_out		 = $_[2];
  
  
   #chdir(FilesIO->getDirectory($input_file)); 
   #my  $file_name = FilesIO->getNameFile($input_file);
   #my $ext_name = FilesIO->getExt($input_file);
   #$file_name = substr($file_name, 0, index($file_name,".". $ext_name));
   #my $cmd = "$path_mammoth $file_name";
   #system ($cmd);
   #print $cmd."\n";
	my  $file_name = $input_file."-FINAL.pdb";
  #$cmd = "mv *-FINAL.??? $dir_out";
  #print $cmd."\n";

  #system ($cmd);
  if (FilesIO->isFile($file_name) eq "true"){
	return $dir_out.$file_name."-FINAL.pdb". " has already created\n" 
  }else{
  	return $dir_out.$file_name."-FINAL.pdb". " NOT was created\n" 
  }
}

############################ sub formatAlign ####################################
sub formatAlign {
  	my $input_file	= $_[1];
	my $line	= "";
	my $entry;

	if (FilesIO->isFile($input_file) eq "true"){
		my @array_aln = FilesIO->lineFileToArray($input_file);
		
		foreach $entry (@array_aln){
			if (index($entry,"CLUSTAL") >= 0 ){
				$line .= "CLUSTAL W (1.83) multiple sequence alignment.\n";
			}
			else{
				$line .= $entry;
			}
		}
		if ($line ne ""){
			FilesIO->saveFile($input_file, $line);
		}
	}
	else{
		print "ERROR Align::Struct::Mammoth: File not found $input_file \n";
	}
}

############################ sub formatAlign ####################################
sub getIdentity{
  	my $input_file	= $_[1];
	my @array_identity = ();	my @array_identity_aux;
	my $i = 0;	my $j = 0;
	my $tam;
	my $count_identity = 0;	my $count_residuos = 0;
	if (FilesIO->isFile($input_file) eq "true"){
		my %hash_aln = Mammoth->loadAlign1d($input_file);
		print "passou 1\n";
		foreach my $key (keys %hash_aln) {
			@array_identity_aux = split(//, $hash_aln{$key});
			$j = 0;
			foreach my $entry (@array_identity_aux) {
				$array_identity[$i][$j] = $entry;
				$j++;
			}
			$i++;
		}
		$tam = $j;
		for ($i=0; $i< $tam; $i++) {
			for ($j=0; $j< scalar(@array_identity); $j++) {
				for (my $k=$j+1; $k< scalar(@array_identity); $k++) {
					#print $k."\t".$j."\t".$i."\n";
					if ($array_identity[$j][$i] ne '-' && $array_identity[$j][$i] eq $array_identity[$k][$i]){
						$count_identity++;
						#print $array_identity[$j][$i]."\t".$array_identity[$k][$i]."\n";
						
					}
					$count_residuos++;
				}
			}
		}
		return ($count_identity/$count_residuos);
		
	}else{
		print "ERROR Align::Struct::Mammoth: File not found $input_file \n";
	}

}

################################### sub selectMammothProgram #####################################
sub selectMammothProgram{
	my $input_file	 = $_[1];
	
	my $entry2;
	my @array_aux2 = ();
	
	my $str_input = FilesIO->lineFileToString($input_file);
	my @array_aux = split (/TER/, $str_input);
	#print "sequences ". scalar(@array_aux)."\n";
	
	foreach $entry2 (@array_aux){
		@array_aux2 = split (/\n/, $entry2);
		if (scalar(@array_aux2) >300){
			return "true";
		}
	}
	return "false";
}

 ############################ sub prepareFileToHMMER3d ##################################
sub removeRemark{
	my $file		= $_[1];

	my @lines 		= ();
	my $info = "";
	my $stop = "false";
	my $i=-1;
	
	if (FilesIO->isFile($file) eq "true"){
		@lines = FilesIO->lineFileToArray($file);
		while ($i < scalar(@lines) &&  $stop eq "false") {
			$i++;
			if (index($lines[$i], "REMARK pdb-") >= 0) {
				$stop = "true";
			}  
		}

		if ($stop eq "true"){
			for (my $j = $i; $j < scalar(@lines); $j++){
				$info .= $lines[$j];
			}
			if ($info ne ""){
				FilesIO->saveFile($file, $info);
			}
		}
		else{
			print "File $file NOT have pattern REMARK pdb-\n";
		}
	}else{
		print "File $file NOT Found\n";
	}
}


1