package Tilde;
use strict;

use String::StringUtil;

############################ sub createKB ##################################
sub createKB {
	my $pred_seq_file		 = $_[1];
	my $numberModel			 = $_[2];
	my $type_ex				 = $_[3];
	my $is_test				 = $_[4];
	my $sequence_name_change = $_[5];
	
	my $entry;
	my $new_entry;
	my @array_pred = ();
	my $predicate;
	my $info = "begin(model($numberModel)).\n";
	$info .= $type_ex."\n";
	
	if ($is_test eq "true"){
		$info .= "testid(1).\n";		
	}
		
	my @predicates = FilesIO->lineFileToArray($pred_seq_file);
	
	foreach $entry (@predicates){
		$new_entry = "p".$numberModel;
		$entry =~ s/$sequence_name_change/$new_entry/;
		#@array_pred = split(/\(/, $entry);
		#$predicate = $array_pred[0];
		
				
			
		$info .= String->removeCaracter($entry,"\n").".\n";	
		
	}
	$info .= "end(model($numberModel)).\n\n";	
	
	return $info;	
}


############################ sub createKB ##################################
sub getListPredicate {
	my $pred_seq_file		 = $_[1];
	my @predicates = FilesIO->lineFileToArray($pred_seq_file);
	my $entry;
	my @array_pred;
	my $predicate = "";
	
	foreach $entry (@predicates){
		@array_pred = split(/\(/, $entry);
		$predicate .= $array_pred[0]."\n";
	}
	return $predicate;
}


############################ sub createTrainingExample ##################################
sub createConfigurationFile{
	my $pred_list		 = $_[1];
	my %predicate_hash = ();
	my @array_pred = split(/\n/, $pred_list);
	my $entry;
	
	foreach $entry (@array_pred) {
		
		if (!exists($predicate_hash{$entry})){
				$predicate_hash{$entry} = ""; 			
		}	
	}
	
	
	my $info = "load(models).\n"."prune_rules(false).\n"."use_packs(0).\n"."classes([pos,neg]).\n";
	my $key;
	my $value;
	
	#Modes
	while (($key, $value) = each(%predicate_hash)){
		#print $key_aln."oi\n".$value_aln."oi\n" ;
		$info .= "rmode(".$key."(+-S1)).\n";		
	}
	$info .= "\n\n";
	$info .= "typed_language(yes).\n";
	
	while (($key, $value) = each(%predicate_hash)){
		#print $key_aln."oi\n".$value_aln."oi\n" ;
		$info .= "type(".$key."(obj)).\n";		
	}
	$info .= "\n\n";
	$info .= "heuristic(gain).\n";
	$info .= "execute(loofl([1])).\n";
	$info .= "execute(quit).\n";
	
	return $info;
	
}

1