package Interpro;
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use String::StringUtil;
use File::Files;
use Util::Number;
use Sequence::protein;


############################ sub removeCaracter ####################################
sub getInterproDomainsForSwissProt {
  
  my $InterproFile			= $_[1]; #xml file downloaded from interpro web site
  my $outputFile			= $_[2];
  my $verbose	 			= $_[3];
  
  my @array_aux;			my $line;
  my $proteinID;			my $iprID;
  my @arrayIpr = ();		my $info = "";
  my $count = 0;			my $count_save = 0;
 
  my $TOKEN_START_PROT = "<protein ";
  my $TOKEN_END_PROT = "</protein>";
  my $TOKEN_START_IPR = "<ipr id=";
  my $TOKEN_DOMAIN =  "type=\"Domain\"";
  
  
  if (open(FILEIN, "$InterproFile")){
		while ($line = <FILEIN>) {			
			if (index($line, $TOKEN_START_PROT) >=0){
				$proteinID = String->getElementArrayLine($line, $TOKEN_START_PROT, 1);
				$proteinID = String->getElementArrayLine($proteinID, " +", 0);
				$proteinID =~ s/\"//g;
				$proteinID =~ s/id=//g;
				#print $proteinID."\n";				
			}elsif (index($line, $TOKEN_START_IPR) >=0){
				$iprID = String->getElementArrayLine($line, $TOKEN_START_IPR, 1);
				if (index($iprID, $TOKEN_DOMAIN) >=0){
					$iprID = String->getElementArrayLine($iprID, " +", 0);
					$iprID =~ s/\"//g;
					push(@arrayIpr, $iprID);
				}					
			}elsif (index($line, $TOKEN_END_PROT) >=0){
				$count++;
				if (scalar(@arrayIpr) > 0){
					$info .= $proteinID."\t". Array->printArray("\t", \@arrayIpr)."\n";
				}				
				@arrayIpr = ();			
				if ($count == 10000){
					FilesIO->apendFile($outputFile, $info, $verbose);
					$info = "";
					$count_save++;
					print "Save $count_save\n";
					$count = 0;
				}	
			}			
		}
		if ($info ne ""){
			FilesIO->apendFile($outputFile, $info, $verbose);
		}
		close FILEIN;
		
	}
	else{
		print "ERROR::perlLib::Database::Interpro.pm:: $InterproFile is NOT a file\n";
		exit;
	}  
}


############################ sub removeCaracter ####################################
sub getInterproDbs {
  
  my $InterproFile			= $_[1]; #xml file downloaded from interpro web site
  my $outputFile			= $_[2];
  my $verbose	 			= $_[3];
  
  my @array_aux;			my $line;
  my $interproACC;			my $strAux;
  my @arrayDbs = ();		my $info = "";
  my $count = 0;			my $count_save = 0;
  my $member = "";			my $idDB;
 
  my $TOKEN_INTERPRO_ID_START = "<interpro id=";
  my $TOKEN_INTERPRO_ID_END = "</interpro>";
  my $TOKEN_MEMBER_START = "<member_list>";
  my $TOKEN_MEMBER_END =  "</member_list>";
  my $TOKEN_DB_REF =  "<db_xref";
  my $TOKEN_DB =  "db=";

  
  
  if (open(FILEIN, "$InterproFile")){
		while ($line = <FILEIN>) {	
			#print $line;		
			if (index($line, $TOKEN_INTERPRO_ID_START) >=0){
				$interproACC = String->getElementArrayLine($line, $TOKEN_INTERPRO_ID_START, 1);
				$interproACC = String->getElementArrayLine($interproACC, " +", 0);
				$interproACC =~ s/\"//g;
				$interproACC =~ s/id=//g;
				print $interproACC."\n";
							
			}elsif (index($line, $TOKEN_MEMBER_START) >=0){
				$member = "true";
			}elsif (index($line, $TOKEN_MEMBER_END) >=0){
				$member = "false";
			}
			elsif ($member eq "true" && index($line, $TOKEN_DB_REF) >=0 ){
				$strAux = String->getElementArrayLine($line, $TOKEN_DB_REF, 1);
				$strAux = String->getElementArrayLine($strAux, $TOKEN_DB, 1);
				$idDB = String->getElementArrayLine($strAux, " +", 0);
				#print $idDB."\n";
				$idDB =~ s/\"//g;
				#print $idDB."\n";
				
				push(@arrayDbs, $idDB);			
			}elsif (index($line, $TOKEN_INTERPRO_ID_END) >=0){
				$count++;
				if (scalar(@arrayDbs) > 0){
					#if (Array->isInArray("PFAM", \@arrayDbs) eq "false"){
						$info .= $interproACC."\t". Array->printArray("\t", \@arrayDbs)."\n";
					#}					
				}				
				@arrayDbs = ();			
				if ($count == 10000){
					FilesIO->apendFile($outputFile, $info, $verbose);
					$info = "";
					$count_save++;
					print "Save $count_save\n";
					$count = 0;
				}	
			}			
		}
		if ($info ne ""){
			FilesIO->apendFile($outputFile, $info, $verbose);
		}
		close FILEIN;
		
	}
	else{
		print "ERROR::perlLib::Database::Interpro.pm:: $InterproFile is NOT a file\n";
		exit;
	}  
}


1