package PFAM;
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use String::StringUtil;
use File::Files;
use Util::Number;
use Sequence::protein;
use Database::PFAM;

my $PROG_NAME = "perlLib::Database::PFAM.pm::";
my $TOKEN_PFAM_FAMILY = "#=GF AC";


############################ sub main ##################################
sub getMinLengthDomain{
	my $accNumberList		= $_[1];
	my @array = FilesIO->fileToArray2d($accNumberList, "\t");
	my $starHit;					my $endHit;						
	my %hash_info = ();				my $length_domain;
	my @array_aux;					my $Start_end_domain;
	my $min_length = 10000;
	
	for (my $i=0; $i < scalar(@array); $i++){
		%hash_info	= PFAM->getInfoSequence($array[$i][0]);
		$Start_end_domain = $hash_info{"Start_end_domain"};
		@array_aux = split(/-/, $Start_end_domain);
		$starHit	= $array_aux[0];
		$endHit 	= $array_aux[1];
		$length_domain = $endHit - $starHit + 1;
		if ($length_domain < $min_length){
			$min_length = $length_domain;
		}				
	}	
	return $min_length;
}


############################ sub main ##################################
sub getAVGDomain{
	my $accNumberList		= $_[1];
	my @array = FilesIO->fileToArray2d($accNumberList, "\t");
	my $starHit;					my $endHit;						
	my %hash_info = ();				my $length_domain;
	my @array_aux;					my $Start_end_domain;
	my $sum = 0;
	
	for (my $i=0; $i < scalar(@array); $i++){
		%hash_info	= PFAM->getInfoSequence($array[$i][0]);
		$Start_end_domain = $hash_info{"Start_end_domain"};
		@array_aux = split(/-/, $Start_end_domain);
		$starHit	= $array_aux[0];
		$endHit 	= $array_aux[1];
		$length_domain = $endHit - $starHit + 1;
		$sum += $length_domain;			
	}	
	return ($sum/scalar(@array));
}

############################ sub main ##################################
sub getInfoSequence{
	my $infoSeq		= $_[1];
	
	my @array_aux = split(/\//, $infoSeq);
	my $start_end_domain = $array_aux[1]; 
	@array_aux = split(/\_/, $array_aux[0]);
    my $acc = $array_aux[0];
    my $specie = $array_aux[1];
        
    my %record = ( "AccNumber"			=> $acc,
                   "Specie" 			=> $specie,
		           "Start_end_domain"	=> $start_end_domain
		         );
	return %record;       

}

############################ sub insert ####################################
sub getAccNumber {
  my $FamilyACC			= $_[1];
  
  my @array_famACC = split(/\./, $FamilyACC);
  return $array_famACC[0];
  
}
############################ sub main ##################################
sub loadHashAccNumber {
	my $file 				= $_[1];	
	my $verbose 			= $_[2];
	
	my %hash_acc = ();			my @array_aux;
	my @array 	 = FilesIO->fileToArray2d($file, "\t");
	
	for (my $k = 0; $k < scalar(@array); $k++){
		@array_aux = split(/\//, $array[$k][0]);		
		if (!exists($hash_acc{$array_aux[0]})){
			$hash_acc{$array_aux[0]} = $array[$k][1];
		}
	}	
	return %hash_acc;
}

############################ sub main ##################################
sub getCandidateName {
	my $name 				= $_[1];	
	my $accNumber_position 	= $_[2];
	my $verbose 			= $_[3];
	
	my $tf_candidate_name = $name;
	
	if (index($name, "\|") >= 0){
		my @array_aux = split(/\|/, $name);
		my @array_index = split(/;/, $accNumber_position);
		$tf_candidate_name = "";
		for (my $k = 0; $k < scalar(@array_index); $k++){
			$tf_candidate_name .= $array_aux[$array_index[$k]];
			if ($verbose eq "true"){print $tf_candidate_name."\n";}
			if ($k != scalar(@array_index)-1){
				$tf_candidate_name .= "|";
			}
		}
	}	
	return $tf_candidate_name;	
}


############################ sub main ##################################
sub getKeyCandidateName {
	my $name 		= $_[1];	
	my $name_old 	= $_[2];
	my $accNumber_separator_before 	= $_[3];
	my $accNumber_separator_after 	= $_[4];
	my $verbose 					= $_[5];
	
	my $key;
	if (index($name_old, "\|") >= 0){
		$key = $accNumber_separator_before.$name.$accNumber_separator_after;
	}else{
		$key = $name;
	}
	if ($verbose eq "true"){print "key $key\n";} 
	return $name;
}

############################ sub main ##################################
sub getOneClan {
	my $clansFile = $_[1];	
	my $PfamId	= $_[2];
	my $verbose	= $_[3];
	
	#print "==>".$clansFile."\t". $PfamId."\n";
	
	my $clan_line = FilesIO->getLineInFileFirstOcurrence($clansFile, $PfamId, $verbose);
	return String->getElementArrayLine($clan_line, "\t", 1);

}
############################ sub main ##################################
sub getClans {
	my $clansFile	= $_[1];	
	my $PfamIdsFile	= $_[2];
	my $outputFile	= $_[3];
	my $verbose		= $_[4];
	
	my $info = "";				my $line;
	my $clan;					my $pfam_ac;
	my @array_aux;				my %hash_clan =();

	my @clans = FilesIO->lineFileToArray($clansFile);
	for (my $i=0; $i < scalar(@clans); $i++){
		$line = $clans[$i];
		$line =~ s/\n//g;
		
		if (index($line, "#=GF AC") >= 0){
			@array_aux = split(/ +/, $line);
			$clan = $array_aux[2];
			$clan = PFAM->getAccNumber($clan);
		}elsif (index($line, "#=GF MB") >= 0){
			$line =~ s/;//g;
			@array_aux = split(/ +/, $line);
			$pfam_ac =  $array_aux[2]; 
			if (!exists($hash_clan{$pfam_ac})){
				$hash_clan{$pfam_ac} = "";
			}
			$info .= $pfam_ac. "\t". $clan."\n";
		}elsif (index($line, "//") >= 0){
			
			$clan = "";
			$pfam_ac = "";
		}
	}
	 
	my @pfamAccs = FilesIO->lineFileToArray($PfamIdsFile);
	for (my $i=0; $i < scalar(@pfamAccs); $i++){
		$line = $pfamAccs[$i];
		$line =~ s/\n//g;
		$pfam_ac =  PFAM->getAccNumber($line);
		if (!exists($hash_clan{$pfam_ac})){
			$info .= $pfam_ac. "\t". "None"."\n";
		}
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
}
############################ sub main ##################################
sub getSequencesFromAlignment {
	my $PFAMFile			= $_[1]; #file Pfam-A.seed
  	my $outputFile			= $_[2];
  	my $save				= $_[3];#1=save one file having all sequences; 2=save one file per family
  	my $verbose				= $_[4];
	
	my @array_aux = ();			my $pfam_ac;
	my $line;					my $sequence;
	my $infoSeq;				my $info = "";
	my $ann;
	
	if (open(FILEIN, "$PFAMFile")){
		while ($line = <FILEIN>) {			
			if (index($line, $TOKEN_PFAM_FAMILY) >=0){
				@array_aux = split(/ +/, $line);
				$pfam_ac = 	 $array_aux[2];	
				$pfam_ac = PFAM->getAccNumber($pfam_ac);
			}elsif (index($line, "//") >= 0){
				print "LOG::".	$pfam_ac."\n";	
				if ($save == 1){
					$info .= $infoSeq;
				}else{
					FilesIO->saveFile($outputFile."/".$pfam_ac.".fasta", $infoSeq, $verbose);
				}
				$pfam_ac = "";
				$infoSeq = "";		
				
			}elsif (index($line, "#") < 0){
				@array_aux = split(/ +/, $line);
				$ann = $array_aux[0];
				$sequence = $array_aux[1];
				@array_aux = split(/_/, $ann);
				$ann = $array_aux[0];
				
				$sequence = String->removeCaracter($sequence, ".");
				$sequence = String->removeCaracter($sequence, "-");
				
				$sequence = Sequences->divideSeq($sequence, 60);
				
				$infoSeq .= ">$ann"."_".$pfam_ac."\n".$sequence;	
				
						
			}
		}
	}
	if ($save == 1){
		FilesIO->saveFile($outputFile, $info, $verbose);
	}
}

############################ sub main ##################################
sub getDomainArchs {
	my $PFAMFile			= $_[1]; #file swisspfam
  	my $outputFile			= $_[2];
  	my $verbose				= $_[3];
  	
  	my $accProt;			my $domain;
  	my @domainList = ();	my @array_aux;
  	my $info = "";			my $line;
  	my $count = 0; 			my $countT = 0;
  	my $range;

	if (open(FILEIN, "$PFAMFile")){
		while ($line = <FILEIN>) {			
			if (index($line, ">") >=0){
				if (scalar(@domainList) > 0){
					$info .= $accProt."\t".Array->printArray("\t", \@domainList)."\n";
					$count++;
					if ($count == 10000){
						FilesIO->apendFile($outputFile, $info, $verbose);
						$countT = $countT + $count;
						print $PROG_NAME."::LOG::saved  $countT\n";
						$info = "";	
						$count = 0;
					}
				}
				@array_aux = split(/ +/, $line);
				$accProt = 	 $array_aux[2];
				@array_aux = split(/\./, $accProt);
				$accProt = 	 $array_aux[0];
				@domainList = ();
			}elsif ($line ne "" && index($line, "Pfam-B") < 0){
				@array_aux = split(/\)/, $line);
				$domain = $array_aux[1];
				@array_aux = split(/ +/, $domain);
				$domain = $array_aux[1];
				$domain = PFAM->getAccNumber($domain);
				
				if ($domain ne ""){
					@array_aux = split(/ +/, $line);
					$range =$array_aux[scalar(@array_aux)-1]; 
					$range = String->removeCaracter($range, "\n");
					$domain = $domain.":".$range;
					push(@domainList, $domain);
				}				
			}
		}
	}else{
		print $PROG_NAME."::ERROR:: File $PFAMFile NOT found\n";
	}
	if (scalar(@domainList) > 0){
		$info .= $accProt."\t".Array->printArray("\t", \@domainList)."\n";
		FilesIO->apendFile($outputFile, $info, $verbose);
	}	
}

############################ sub main ##################################
sub getDomainArchsPerIdsProteins {
	my $archFile			= $_[1]; #file created in getDomainArchs
	my $idsFile				= $_[2];
  	my $outputFile			= $_[3];
  	my $verbose				= $_[4];
  	
  	my @array_aux  = ();		my $accProt;
  	my $info = "";				
  	my $line;
  	
	my %hash = FilesIO->fileToHash($idsFile, " +", 0); 	
  	
  	if (open(FILEIN, "$archFile")){
		while ($line = <FILEIN>) {
			@array_aux = split(/\t/, $line);
			$accProt = 	 $array_aux[0];
			if (exists($hash{$accProt})){
				$info .= $line;
			}
		}
	}
	else{
		print $PROG_NAME."::ERROR:: File $archFile NOT found\n";
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
}
1









































