package PlasmoDB;
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use String::StringUtil;
use File::Files;
use Util::Number;
use Sequence::protein;

my $PROG_NAME = "perlLib::Database::PlasmoDB.pm::";

my $TOKEN_ORTH_PARA = "TABLE: Orthologs and Paralogs within PlasmoDB";
my $TOKEN_GENEID = "Gene ID:";

############################ sub main ##################################
sub getFunctionPlasmoDB{
	my $annotation	 =  $_[1];
	my $verbose  	 =  $_[2];
	
	my @array_aux = split(/\|/, $annotation);
	#print "oi". $arraySeq[0][0]."\n";
	my $function = $array_aux[3];
	@array_aux = split(/=/, $function);
	$function = $array_aux[1];
	#$function = String->removeString($function, "product=");
	if (index($function, " ") ==0){
		$function = "product unspecified";
	}
	if (defined($function)){
		return $function;
	}else{
		return "";
	}	
}

############################ sub main ##################################
sub getAccNumberPlasmoDB{
	my $annotation	 =  $_[1];
	my $verbose  	 =  $_[2];
	
	my @array_aux = split(/\|/, $annotation);
	#print "oi". $arraySeq[0][0]."\n";
	my $accNumber = $array_aux[1];
	$accNumber = String->removeCaracter($accNumber, " ");
	return $accNumber;
}



############################ sub main ##################################
sub getOrthologsParalogs{
	my $geneTxtFile	 	=  $_[1];
	my $organismeSet 	=  $_[2]; #[Plasmodium falciparum 3D7:]
	my $outputFile 		=  $_[3]; 
	my $verbose  	 	=  $_[4];
	
	my $geneID;				my $orthoPara = "false";
	my @array_aux;			my $info = "";
	
	my @array_organismeSet = split(/,/, $organismeSet);
	
	if (open(FILEIN, "$geneTxtFile")){
		while (my $line = <FILEIN>) {
			$line =~ s/\n//g;			
			if (index($line, $TOKEN_GENEID) == 0){	
				@array_aux = split(/:/, $line);
				$geneID = $array_aux[1];
				$geneID  =~ s/ +//g;	
			}elsif(index($line, $TOKEN_ORTH_PARA) == 0){
				$orthoPara = "true";
			}elsif ($orthoPara eq "true"){
				if ($line eq ""){
					$orthoPara = "false";
				}else{
					@array_aux = split(/\t/, $line);
					if (Array->isInArray($array_aux[1], \@array_organismeSet) eq "true"){
						$info .= $geneID."\t". $array_aux[0]."\n";
					}
				}				
				
			}
		}
	}else{
		print "ERROR::".$PROG_NAME.":: File $geneTxtFile NOT found!\n";
	}
	
	FilesIO->saveFile($outputFile, $info, $verbose);
	
}

1