package ScopPattern;
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Sequence::sequence;
use Database::ScopPattern;

############################ sub getPattern #####################################
sub removeSuperFamilyScopTable {
	my $scoptable	= $_[1];
	my $superFamily	= $_[2];
	
	my $supfam;
	my @array_scop = FilesIO->fileToArray2d($scoptable, "\t");
	my $info = ""; my $id_family;
	for (my $i = 0 ; $i< scalar(@array_scop)  ; $i++){
		$id_family = $array_scop[$i][3];
		$supfam = ScopPattern->getPattern(3,".", $id_family);		
		if ($superFamily ne $supfam){
			$info .= $array_scop[$i][0]."\t".$array_scop[$i][1]."\t".$array_scop[$i][2]."\t".$array_scop[$i][3]."\n";
		}
	}	
	return $info;	
}


############################ sub loadAlign1d ####################################
sub divideDatabaseIntoTrainTestRandon {
	
	my ($lixo, $amount, $array) = @_;
	my @localArray = @{$array};
	
	my %repeat_hash = ();
	my @array_ret = ();
	my $count = 0;
	my $stop = "false";
	my $random_number;
	
	while ($stop eq "false"){
		$random_number = int(rand(scalar(@localArray)));
		if (!exists($repeat_hash{$random_number})){
			$array_ret[$count] = $localArray[$random_number];
			$count++;
			$repeat_hash{$random_number} = $random_number;
		}		
		if ($count == $amount){
			return @array_ret;
		}		
	}	
}

############################ sub getPattern #####################################
sub getPattern {
	my $num 	= $_[1];
	my $sep		= $_[2];
	my $string 	= $_[3];
	my $counter;
	my $indice;
	my $new_string 	= "";
        
    for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));		
		}
	}
	
	return $new_string;	
	
	
}

############################ sub getPattern #####################################
sub getPatternFamily {
	my $string 	= $_[1];
	my $field 	= $_[2]; #4-family 3-super-family
	my $counter;
	my $new_string 	= "";
	
	if (!defined($field)){
		$field = 4;
	}
    
    my @array = split(/\./, $string);
    
   for($counter = 0 ; $counter < $field ; $counter++){
		$new_string .=$array[$counter];		
		if ($counter != ($field-1)){
			$new_string .=".";
		}
	}
	return $new_string;	
}


############################ sub getPattern #####################################
sub leaveOneFamilyOut {
	my $inputFile 	= $_[1]; #FASTA format having scop sequences formated (for formating use perlLib::format::formatDatabase:)
	my $outputDir	= $_[2]; 
	my $verbose		= $_[3]; 
	
	my $info_test = "";			my $info_train = "";
	my $annotation;				my $familyId_i;
	my $familyId_j;				my %hash_family = ();
	
	my @sequences = Sequences->getSequenceFromFastaArray2D($inputFile);
	for (my $i = 0 ; $i < scalar(@sequences); $i++){
		$annotation = String->removeCaracter($sequences[$i][0], ">");
		$familyId_i = String->getElementArrayLine($annotation, " +", 1);
		$info_test = "";			$info_train = "";
		if (!exists ($hash_family{$familyId_i})){
			for (my $j = 0 ; $j < scalar(@sequences); $j++){
				$annotation = String->removeCaracter($sequences[$j][0], ">");
				$familyId_j = String->getElementArrayLine($annotation, " +", 1);
			
				if ($familyId_i eq $familyId_j){
					$info_test .= $sequences[$j][0].Sequences->divideSeq($sequences[$j][1], 60)."\n";
				}else{
					$info_train .= $sequences[$j][0].Sequences->divideSeq($sequences[$j][1], 60)."\n";
				}
			}
			$hash_family{$familyId_i} = "";
			FilesIO->saveFile($outputDir."/".$familyId_i."/pos.train.fasta", $info_train, $verbose);
			FilesIO->saveFile($outputDir."/".$familyId_i."/pos.test.fasta", $info_test, $verbose);
		}
		
		print 	$familyId_i."\n";
	}
	
	
}

############################ sub getIdsScop #####################################
# Description	: Gets fields of the SCOP database first line
# Parameters	: 
#			1) field  			= What field or fields do you want.
#			2) path_scop_db		= Path of SCOP database file
#			3) new_file			= Path of new file. This file will have fields.
#
# Parameters Values	:
#			1) field			= 1   - id scop; 
#								  2   - id family; 
#								  3   - descriptions; 
# 								  12  - id scop and id family; 
#								  13  - id scop and descriptions;
#								  23  - id family and descriptions;
#								  123 - id scop, id family and descriptions;
#			2) path_scop_db		= /home/user/folder/name_scop_database
#			3) new_file			= /home/user/folder/new_scop_fields
#
# Actions	:
#			verify if file is found;
#			Open the file path_scop_db;
#			verify if each line of file begin with the simbol ">"
#           Gets the fields; 
#
#################################################################################
sub getIdsScop {
	my $field 	     	= $_[1]; 
	my $path_scop_db 	= $_[2];
	my $new_file	 	= $_[3];
	
	my @array_line 		= ();
	my $entry;
	my $line			= "";
	
	if (FilesIO->isFile($path_scop_db) eq "true"){
		@array_line = FilesIO->lineFileToArray($path_scop_db);
		foreach $entry (@array_line){				
				if (index($entry,">") == 0){
					my @array_aux = split(/ +/,$entry);
					if ($field eq "12"){
						$line .= String->removeCaracter($array_aux[0], ">"). "\t". $array_aux[1]."\n";
					}elsif ($field eq "123"){
						$line .= String->removeCaracter($array_aux[0], ">"). "\t". $array_aux[1];
						for (my $i=2; $i< scalar(@array_aux); $i++){
							$line .= $array_aux[$i];	
						}
					}
				}
		}
		if ($line ne ""){
			FilesIO->saveFile($new_file, $line);
		}
		else{
			print "ERROR in Scop::ScopPattern:: File $new_file is empty!\n";
			exit;
		}
	}
	else{
		print "ERROR in Scop::ScopPattern:: File $path_scop_db not found!\n";
		exit;
	}
	
}

############################ sub getIdsScop #####################################
# Description	: Gets fields of the SCOP database first line
# Parameters	: 
#			1) field  	= What field or fields do you want.
#			2) line		= line of SCOP file 
#
# Parameters Values	:
#			1) field	= 1   - id scop; 
#					  2   - id family; 
#					  3   - descriptions; 
#					  12  - id scop and id family; 
#					  13  - id scop and descriptions;
#					  23  - id family and descriptions;
#					  123 - id scop, id family and descriptions;
#			2) line		=  >d1dlwa_ a.1.1.1 (A:) Protozoan/bacterial hemoglobin {Ciliate (Paramecium caudatum)}
#			
#
#################################################################################
sub getIdScop {
	my $field 	     	= $_[1]; 
	my $line		= $_[2];
		
	my @array_line 		= ();
	my $entry;
	my $info	= "";
	
	my @array_aux = split(/ +/,$line);
	if ($field eq "12"){
		$info .= String->removeCaracter($array_aux[0], ">"). "\t". $array_aux[1]."\n";
	}elsif ($field eq "123"){
		$info .= String->removeCaracter($array_aux[0], ">"). "\t". $array_aux[1];
		for (my $i=2; $i< scalar(@array_aux); $i++){
			$info .= $array_aux[$i];	
		}
	}
	return $info;	
}


#################################################################################
sub getChainsScop {
	my $line		= $_[1]; 
	
	my @chains		= ();
	my @info_chains		= ();
	my @info_sub_chains	= ();
	my $entry;
	my $i = 0;
	
	@info_chains = split(/,/,$line); #divide as subcadeias
	foreach $entry (@info_chains){
		if (index($entry,":") >= 0){
			@info_sub_chains = split(/:/,$entry);
			$chains[$i] = $info_sub_chains[0];
			$i++;
		}
     }
     return @chains;
}

#################################################################################
sub getIntervalsScop {
	my $line		= $_[1]; 
	
	my @intervals		= ();
	my @info_interval	= ();
	my @info_sub_interval	= ();
	my $entry;
	my $i = 0;
	
	@info_interval = split(/,/,$line); #divide as subcadeias
	foreach $entry (@info_interval){
		
		if (index($entry,":") >= 0){
			@info_sub_interval = split(/:/,$entry);
			$intervals[$i] = $info_sub_interval[1];			
		}
		else{
			$intervals[$i] = $entry;
		}
		$i++;
	}
	return @intervals;
}

#################################################################################
sub getIntervals {
	my $line		= $_[1]; 
	
	my @intervals		= ();
	my @info_interval	= ();
	my $entry;
	my $i = 0;
	
	@info_interval = split(/-/,$line); #divide as subcadeias
	if (scalar(@info_interval) == 3){
		if ($info_interval[0] eq ""){
			$info_interval[0] = "-".$info_interval[1];
			$info_interval[1] = $info_interval[2];
			pop(@info_interval);
		}
	}
	foreach $entry (@info_interval){	
		$intervals[$i] = $entry;	
		$i++;
	}
	return @intervals;
}

#################################################################################
sub getChains_IntervalsScop {
	my $line	= $_[1];
	
	my @mat	;
	my $row		= 0;
	my $col		= 0; 
	
	my $entry;

	my @array = split(/,/,$line); #divide as subcadeias
	
	foreach $entry (@array) {
		my @array_aux = split(/:/,$entry);
		
		if (scalar(@array_aux) > 1){
			$mat[$row][0] = $array_aux[0];#chain
			$mat[$row++][1] = $array_aux[1];#interval
		}
		elsif (index($entry,":") >=0 ){
			$mat[$row][0] = $array_aux[0];
			$mat[$row++][1] = "-";
		}elsif ($entry ne "-"){
			$mat[$row][0] = "-";	
			$mat[$row++][1] = $array_aux[0];
		}else{
			$mat[$row][0] = "-";	
			$mat[$row++][1] = "-";
		}
	}
	return @mat;
	
}

############################### sub runHmmToGroup ####################################
sub createDatabase {
	my $id_family		= $_[1];
	my $id_sup			= $_[2];
	my $db_file			= $_[3];
	my $db_new_file		= $_[4];

	my $key; my $value;
	my $info = "";

	my %hash_seq = Sequences->getSequencesFromFasta($db_file);
	while (($key, $value) = each(%hash_seq)) {
		if ((index($key, $id_family) >= 0) || (index($key, $id_sup) < 0)) {
			$info .= ">".$key."\n".$value;
		}
	}

	if ($info eq "") {
		print "ERROR:: database $db_file has not $id_family family\n";
	}else {
		FilesIO->saveFile($db_new_file, $info);
	}	
	#print $info;
}

############################### sub runHmmToGroup ####################################
sub getPartDatabase {
	my $identify		= $_[1];
	my $db_file			= $_[2];
	my $db_new_file		= $_[3];
	my $verbose			= $_[4];
	
	if (!defined($verbose)){
		$verbose = "true";
	}

	my $i = 0;
	my $info = "";

	my @array_seq = Sequences->getSequenceFromFastaArray2D($db_file);
	
	while ($i < scalar(@array_seq) ) {
		if ((index($array_seq[$i][0], $identify) >= 0)) {
			$info .= $array_seq[$i][0].$array_seq[$i][1]."\n";
		}
		$i++;
	}

	if ($info eq "") {
		print "ERROR:: database $db_file has not $identify \n";
	}else {
		FilesIO->saveFile($db_new_file, $info, "false");
	}	
	#print $info;
}


############################### sub runHmmToGroup ####################################
sub getPartDatabase2 {
	my $identify		= $_[1];
	my $db_file			= $_[2];
	my $db_new_file		= $_[3];
	my $verbose			= $_[4];
	
	my $info = "";
	my $annotation;
	my $seq = "";
	
	if (open(FILEIN, "$db_file")){
		while (my $line = <FILEIN>) {
			if (index($line, ">") ==0 ){
				if ($seq ne ""){
					if ((index($annotation, $identify) >= 0)) {
						$info .= $seq;
					}					
					$seq = ""; 
				}
				$annotation = $line;
			}
			$seq .=$line;				
		}	
		close FILEIN; 
		
		if ($info eq "") {
			print "ERROR:: database $db_file has not $identify \n";
		}else {
			FilesIO->saveFile($db_new_file, $info, "false");
		}	      
	}
	else{
		print "ERROR::perlLib::sequence.pm:: $db_file is NOT a file\n";
		exit;
	}
}
############################### sub runHmmToGroup ####################################
sub clearDatabase {
	my $db_file		= $_[1];
	my $db_new_file	= $_[2];

	my $key; my $value;
	my $info = "";
	my $info_gi = "";
	my @array = ();

	my %hash_seq = Sequences->getSequencesFromFasta($db_file);
	while (($key, $value) = each(%hash_seq)) {
		@array = split(/ +/, $key);
		print $array[0]." ". $array[1]."\n";
		$info .= ">".$array[0]." ". $array[1]."\n".$value;
		$info_gi .= $array[0]."\n";
		
	}

	if ($info eq "") {
		print "ERROR:: database $db_file has not  family\n";
	}else {
		FilesIO->saveFile($db_new_file, $info);
		FilesIO->saveFile($db_new_file."gi", $info_gi);
	}	
	#print $info;
}



############################ sub randomSequences ##################################
#	my $id_sup			 = scop superfamily id ex:a.1.1
#	my $amount_seq		 = amount of sequence ex:100
#	my $list_scop_family = list of "scop family id" and "scop id" ex:g.39.1.3	d1b8ta1

sub randomSequences{
	my $id_sup			 = $_[1];
	my $amount_seq		 = $_[2];
	my $list_scop_family = $_[3];
	
	my $random_number;
	my $i = 0;
	my $id_sup_list;
	my @array_line_seqs;
	my $seq_random_info = "";
	
	my $id_seq;
	my %repeat_hash = ();
	
	#load sequences
	my @families = FilesIO->lineFileToArray($list_scop_family);
	my $range = scalar(@families);
	while ($i < $amount_seq){
				
 		$random_number = int(rand($range));
 		#print $random_number."\n";
		$id_sup_list = $families[$random_number];
		
		@array_line_seqs = split(/\t/, $id_sup_list);
		$id_sup_list = $array_line_seqs[0];
		$id_seq = String->removeCaracter($array_line_seqs[1],"\n");
		
		$id_sup_list = ScopPattern->getPattern(3,".", $id_sup_list);
		if ($id_sup_list ne $id_sup){
			if (!exists($repeat_hash{$id_seq})){
				$repeat_hash{$id_seq} = $id_sup_list; 
				$i++;
				$seq_random_info .=$families[$random_number];
			}			
		}
		
	}	
	return $seq_random_info;
}

############################ sub main ##################################
sub replaceDataFamilyGroup {
	
	my $id_family		= $_[1];
	my $id_sup			= $_[2];	
	my $pdbId			= $_[3];
	my $scopId			= $_[4];
	my $chain			= $_[5];
	#my $logDir			= $_[6];
	my $value2			= $_[6];
	my $group_tree   	= $_[7];
	
	#print "replaceDataFamily in ". $value2."\t";
	

	if (index(($value2),("SUP_FAMILY_ID")) >= 0){
		$value2 = String->replace($value2,"SUP_FAMILY_ID", $id_sup); 							
	}
	
	if (index(($value2),("FAMILY_ID")) >= 0){
		$value2 = String->replace($value2,"FAMILY_ID", $id_family); 									
	}
	
	if (index(($value2),("PDB_ID")) >= 0){
		$value2 = String->replace($value2,"PDB_ID", $pdbId);			 						
	}
	if (index(($value2),("SCOP_ID")) >= 0){
		$value2 = String->replace($value2,"SCOP_ID", $scopId);		 						
	}
	
	if (index(($value2),("GROUP_TREE")) >= 0){
		$value2 = String->replace($value2,"GROUP_TREE", $group_tree);		 						
	}		
		
	#if (index(($value2),("JOB_ID")) >= 0){
	#	$value2 = String->replace($value2,"JOB_ID", "\$JOB_ID");			 						
	#}
	#if (index(($value2),("LOG_DIR")) >= 0){
	#	$value2 = String->replace($value2,"LOG_DIR", $logDir); 						
	#}	
	if (index(($value2),("CHAIN_INTERVAL")) >= 0){
		$value2 = String->replace($value2,"CHAIN_INTERVAL", $chain); 						
	}
	
	#print "out ". $value2."\n";
	return $value2;
}

############################ sub main ##################################
sub replaceDataFamily {
	
	my $id_family		= $_[1];
	my $id_sup			= $_[2];	
	my $pdbId			= $_[3];
	my $scopId			= $_[4];
	my $chain			= $_[5];
	#my $logDir			= $_[6];
	my $value2			= $_[6];
	my $default_family	= $_[7];
	
	#print "replaceDataFamily in ". $value2."\t";
	
	if (index(($value2),("DEFAULT_FAMILY")) >= 0){
		$value2 = String->replace($value2,"DEFAULT_FAMILY", $default_family);
		$value2 = String->replace($value2,"SUP_FAMILY_ID", ScopPattern->getPattern(3,".", $default_family));		 						
	}	
	
	if (index(($value2),("SUP_FAMILY_ID")) >= 0){
		$value2 = String->replace($value2,"SUP_FAMILY_ID", $id_sup); 							
	}
	
	if (index(($value2),("FAMILY_ID")) >= 0){
		$value2 = String->replace($value2,"FAMILY_ID", $id_family); 									
	}
	
	if (index(($value2),("PDB_ID")) >= 0){
		$value2 = String->replace($value2,"PDB_ID", $pdbId);			 						
	}
	if (index(($value2),("SCOP_ID")) >= 0){
		$value2 = String->replace($value2,"SCOP_ID", $scopId);		 						
	}
	
	
		
	#if (index(($value2),("JOB_ID")) >= 0){
	#	$value2 = String->replace($value2,"JOB_ID", "\$JOB_ID");			 						
	#}
	#if (index(($value2),("LOG_DIR")) >= 0){
	#	$value2 = String->replace($value2,"LOG_DIR", $logDir); 						
	#}	
	if (index(($value2),("CHAIN_INTERVAL")) >= 0){
		$value2 = String->replace($value2,"CHAIN_INTERVAL", $chain); 						
	}
	
	#print "out ". $value2."\n";
	return $value2;
}


############################ sub main ##################################
sub readScopParsedTableToHash {
	
	my $file		= $_[1];
	
	my @array = FilesIO->lineFileToArray($file);
	my @array_line; my $entry;
	my %hash = ();
	
	foreach $entry (@array) {
		@array_line = split(/\t/,$entry);
		#print $array_line[0]."\n";
		if (!exists($hash{$array_line[0]})){
			$hash{$array_line[0]} = $entry;
		}
		#print $hash{$array_line[0]};		
	}
	return %hash;
}

############################ sub main ##################################
sub readScopParsedTableArray {
	
	my $file		= $_[1];
	
	my @array = FilesIO->lineFileToArray($file);
	my @array_line; my $entry;
	my @array_scop = ();
	
	foreach $entry (@array) {
		@array_line = split(/\t/,$entry);
		push(@array_scop, $array_line[0]);	
		#print 	$array_line[0]."\n";
	}
	return @array_scop;
}

############################ sub saveFile ###################################
sub fileToHashCountItens {
	my $path_in 	= $_[1];
	my $sep 		= $_[2];
	my $field_key 	= $_[3];
	my $kind 		= $_[4]; #1=family; 2=superfamily
	
	#print $path_in."\n";
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my %hash = ();
	my $line; my $key;
	my $count = 0;


	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		
		foreach $line (@array_file){
			#print $line."\n";
			$line = String->removeCaracter($line, "\n");
			@array_aux = split(/$sep/, $line);
			$key = $array_aux[$field_key];	
			if ($kind == 2){
				$key = ScopPattern->getPattern(3, ".", $key);
			}
			
			if (!exists($hash{$key})){
				$hash{$key} = 1;
				$count++;
			}else{
				$hash{$key} = $hash{$key} + 1;
			}					
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return %hash;
}

################################### sub main #####################################
sub createListFileFromfasta {
	
	my $inputFile 	= $_[1];
	my $kind		= $_[2];
	my $outputFile	= $_[3];
	my $verbose		= $_[4];
	
	my $family;
	my $id;						my $info = "";
	my @array_aux = ();			my $sep = " +";
	
	my @array = Sequences->getSequenceFromFastaArray2D($inputFile);
	for (my $i = 0; $i < scalar(@array); $i++) {
		@array_aux = split(/ +/, $array[$i][0]);
		$id		=  $array_aux[0];	
		$id =~ s/>//g;			
		$family =  $array_aux[1];	
		if ($kind == 2){
			$family = ScopPattern->getPattern(3, ".", $family);
		}
		$info .= $id."\t".$family."\n";
	}
	FilesIO->saveFile($outputFile, $info, $verbose);	
}

################################### sub main #####################################
sub getFamilyOrSupFamily {
	
	my $str 	= $_[1];
	my $kind	= $_[2];
	
	if ($kind == 2){
		return ScopPattern->getPattern(3, ".", $str);
	}
	return $str;	
}

1
