package SwissProt;
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use String::StringUtil;
use File::Files;
use Util::Number;
use Sequence::protein;
use Database::PFAM;

my $PROG_NAME = "perlLib::Database::SwissProt.pm::";

my $HTTP_ADRESS = "http://pir.uniprot.org/uniprot";
my $AC_TOKEN = "AC";
my $TAXON_TOKEN = "OX";
my $END_TOKEN = "//";
my $SEQ_TOKEN = "SQ";
my $DOMAIN_TOKEN= "DR";;
my $DOMAIN_INTERPRO_TOKEN= "InterPro;";

############################ sub getPDBsFromSite ###################################
sub getACToken{
	return $AC_TOKEN;
}
############################ sub getPDBsFromSite ###################################
sub getDomainToken{
	return $DOMAIN_TOKEN;
}

############################ sub getPDBsFromSite ###################################
sub getDomainInterprotToken{
	return $DOMAIN_INTERPRO_TOKEN;
}

############################ sub getPDBsFromSite ###################################
sub getTaxonIDToken{
	return $TAXON_TOKEN;
}
############################ sub getPDBsFromSite ###################################
sub getEndToken{
	return $END_TOKEN;
}

############################ sub getPDBsFromSite ###################################
sub getSeqToken{
	return $SEQ_TOKEN;
}



############################ sub getPDBsFromSite ###################################
sub downloadSequence{
	my $id_sequence	= $_[1];
    my $outputFile	= $_[2];
    my $verbose		= $_[3];
    

    my $cmd = "wget $HTTP_ADRESS/$id_sequence.fasta -O $outputFile";
    if ($verbose eq "true"){
    	print $cmd;
    }
    system($cmd);
    
  	if (FilesIO->isFile($outputFile) eq "true"){
  		if ($verbose eq "true"){
  				print $PROG_NAME." File $outputFile created\n"; 
  		}
  	}
    else{
    	return -1;
    }
    return 0;
}


############################ sub getPDBsFromSite ###################################
sub getSpecie{
	my $sequenceFile= $_[1];
    my $verbose		= $_[2];

	my @array_seq = Sequences->getSequenceFromFastaArray2D($sequenceFile);
	
	my @array_aux = split(/\|/, $array_seq[0][0]);
	@array_aux = split(/ +/, $array_aux[2]);
	@array_aux = split(/_/, $array_aux[0]);
	return $array_aux[1];
}


############################ sub removeCaracter ####################################
sub getOneSequenceFromDatabase {
  
  my $database 				= $_[1];
  my $accNumber 			= $_[2];
  my $stop					= $_[3];
  my $verbose	 			= $_[4];
  
  my $TOKEN_ACC_NUMBER = "AC   ".$accNumber;
  my $TOKEN_START_SEQ = "SQ   SEQUENCE   ";
  my $TOKEN_END_SEQ = "//\n";
  my $line;
  my $getSeq = "false";
  my $found = "false";
  
  my $sequence = "";
  
  if (open(FILEIN, "$database")){
		while ($line = <FILEIN>) {
			if (index($line, $TOKEN_ACC_NUMBER) == 0){
				$found = "true";				
			}elsif ($found eq "true" && index($line, $TOKEN_START_SEQ) == 0){
				$getSeq = "true";
			}elsif ($found eq "true" && $getSeq eq "true"){
				if (index($line, $TOKEN_END_SEQ) == -1){
					$sequence .= String->removeCaracter(String->removeCaracter($line, "\n"), " ");
				}else{
					$sequence = Sequences->divideSeq($sequence, 50);
					$sequence = ">".$accNumber."\n".$sequence;
					close FILEIN;
					return $sequence;
				}
			}
		}
		close FILEIN;
		print "ERROR::perlLib::Database::SwissProt.pm:: Accession number $accNumber NOT found in $database\n";
		if ($stop eq "true"){
			exit;
		}	
	}
	else{
		print "ERROR::perlLib::Database::SwissProt.pm:: $database is NOT a file\n";
		exit;
	}  
	return "";
}


############################ sub removeCaracter ####################################
sub getSequencesFromDatabaseAccNumberListSpecie {
  
  my $database 				= $_[1];
  my $accNumberListFile		= $_[2];
  my $stop					= $_[3];
  my $verbose	 			= $_[4];
  my $accNumber;
  my %hash_specie = ();
  my %record_sequence;
  
  my @array = FilesIO->fileToArray2d($accNumberListFile, "\t");
  
  my $TOKEN_ACC_NUMBER = "AC   ";
  my $TOKEN_START_SEQ = "SQ   SEQUENCE   ";
  my $TOKEN_END_SEQ = "//\n";
  my $line;
  my $getSeq = "false";
  my $found = "false";
  
  my $sequence = "";
  my $sequences = "";
  
  
  if (open(FILEIN, "$database")){
		while ($line = <FILEIN>) {
			if (index($line, $TOKEN_ACC_NUMBER) == 0){
				for (my $i=0; $i < scalar(@array); $i++){
					$accNumber = $array[$i][1];
					if (index($line, $TOKEN_ACC_NUMBER.$accNumber) == 0){
						%record_sequence = PFAM->getInfoSequence($array[$i][0]);
						if (!exists($hash_specie{$record_sequence{"Specie"}})){
							$found = "true";
							$hash_specie{$record_sequence{"Specie"}} = $accNumber;
							if ($verbose eq "true"){print $accNumber."\n";}
						}else{
							if ($verbose eq "true"){print $record_sequence{"Specie"}." saved\n";}
						}
						$i = scalar(@array);						
					}
				}
				if ($found eq "false"){
					#print "ERROR::perlLib::Database::SwissProt.pm:: Accession number $accNumber NOT found in $database\n";
					if ($stop eq "true"){
						exit;
					}
				}							
			}elsif ($found eq "true" && index($line, $TOKEN_START_SEQ) == 0){
				$getSeq = "true";
			}elsif ($found eq "true" && $getSeq eq "true"){
				if (index($line, $TOKEN_END_SEQ) == -1){
					$sequence .= String->removeCaracter(String->removeCaracter($line, "\n"), " ");
				}else{
					$sequence = Sequences->divideSeq($sequence, 50);
					$sequence = ">".$accNumber."\n".$sequence;
					$sequences .= $sequence."\n";
					$sequence = "";  $getSeq = "false"; $found = "false";
				}
			}
		}
		close FILEIN;
		#print "ERROR::perlLib::Database::SwissProt.pm:: Accession number $accNumber NOT found in $database\n";
		if ($stop eq "true"){
			exit;
		}	
	}
	else{
		print "ERROR::perlLib::Database::SwissProt.pm:: $database is NOT a file\n";
		exit;
	}  
	return $sequences;
}



  


1