#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;


my $outputDir 	= "";
my $modelFile 	= "";
my $verbose		= "false";


my $PROG_NAME = "transFactor::hmmer3Exp::scripts::prepare::modelSeparate.pl";	
	
&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-modelFile"){
			$modelFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputDir"){
			$outputDir = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}   			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	my %hash_msg = FilesIO->fileToHash($ENV{'BASE_DIR'}."messages.txt", "=", 0);
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: ". $hash_msg{"VERBOSE"});
	String->isEmpty($modelFile, "ERROR::".$PROG_NAME.":: ".$hash_msg{"HMM_MODEL_FILE"});
	FilesIO->checkFile($modelFile, "ERROR::".$PROG_NAME.":: ".$hash_msg{"MSG_ERROR_FILE_NOT_FOUND"}.$modelFile);
	
	String->isEmpty($outputDir, "ERROR::".$PROG_NAME.":: ".$hash_msg{"OUTPUT_DIR"});
	
	print "-modelFile = $modelFile\n";
	print "-verbose = $verbose\n";
	print "-outputDir = $outputDir\n";
	print "ok\n";	
}	

############################ sub main ##################################
sub main {
	my $info = "";
	my $tokenACC = "ACC   ";
	my $pfamACC;
	my $modelFileName;
	
	if (open(FILEIN, "$modelFile")){
		while (my $line = <FILEIN>){
			if (index($line, $tokenACC) == 0){
				$pfamACC = String->getElementArrayLine($line, " +", 1);
				#print $pfamACC."\n";
			}
			if (index($line, "//\n") == 0){
				$info .= $line;
				$modelFileName = $outputDir.$pfamACC."/model.hmm";
				FilesIO->saveFile($modelFileName, $info, $verbose);
				$info = "";
			}else{
				$info .= $line;
			}			
		}
		close FILEIN;
	}		
	
	
}