#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Database::SwissProt;

my $database = "";
my $verbose = "false";
my $outputFile = ""; 

my $PROG_NAME = "perlLib::Database::run::GetCorrespPFamInterpro.pl";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-interProFile"){
			$database = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	
	String->isEmpty($database, "ERROR::".$PROG_NAME.":: Parameter -database having SwissProt database required!");	
	FilesIO->checkFile($database, "ERROR::".$PROG_NAME.":: File NOT found ".$database);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required it must contain the output file! ");	
	

	print "-database = $database\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $info = "";		my @array_aux = ();
	my $ACC = "";		my $pfamACC = "";
	my $lenSeq = 0;		my $count = 0;
	my $countT = 0;		my @array_ACC = ();
	my $domainInfo = "";my $memberList = "false";

	if (open(FILEOUT, ">>$outputFile")){
		if (open(FILEIN, "$database")){
			while (my $line = <FILEIN>) {
				if (index($line, "<interpro ") == 0){
					@array_aux = split(/ +/, $line);
					$ACC = $array_aux[1];					
					$ACC =~ s/\"//g; 					
					$ACC =~ s/id=//g;
					$count++;					
				}elsif (index($line, "<member_list>") >= 0){
					$memberList ="true";
				}elsif (index($line, "</member_list>") >= 0){
					$memberList ="false";					
				}elsif ($memberList eq "true"){
					if (index($line, "PFAM") >= 0){
						@array_aux = split(/ +/, $line);
						$pfamACC = $array_aux[4];
						$pfamACC =~ s/\"//g; 
						$pfamACC =~ s/dbkey=//g;
						$info .=$ACC."\t".$pfamACC."\n";
					}
				}elsif (index($line, "</interpro>") >= 0){
					if ($info ne ""){
						print FILEOUT $info;
					}
					$info = "";
					$memberList ="false";
					$ACC = "";
				}
				if ($count == 1000){
					$countT = $countT + $count;
					print "LOG::".$PROG_NAME.":: Done $countT\n";
					$count = 0;
				}
			}
			close FILEIN;
		}else{
			print "ERROR::".$PROG_NAME.":: File $database NOT found!\n";
		}
		close FILEOUT;	
	}else{
		print "ERROR::".$PROG_NAME.":: File $outputFile NOT available for writting!\n";
	}		
}