#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Database::ScopPattern;
use Util::Hash;

my $inputFile = "";
my $verbose = "false";
my $output = ""; 
my $option	= "1"; #1-execute leaveOneFamilyOut
my $kind = "1"; #1=family; 2=super-family
my $QTD = 5;

my $PROG_NAME = "perlLib::Database::run::runScop.pl";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile" || $ARGV[$counter] eq "-i" ){
			$inputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose" || $ARGV[$counter] eq "-v" ){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-output" || $ARGV[$counter] eq "-o" ){
			$output = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-option" || $ARGV[$counter] eq "-op" ){
			$option = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-kind" || $ARGV[$counter] eq "-k" ){
			$kind = $ARGV[$counter+1];		
		} 	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	
	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile having input file is required!");	
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found ".$inputFile);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($output, "ERROR::".$PROG_NAME.":: Parameter -output (File or Directory) is required it must contain the output file! ");	
	

	print "-inputFile = $inputFile\n";
	print "-verbose = $verbose\n";
	print "-output = $output\n";
	print "-option = $option\n";
	print "-kind = $kind (1=family, 2=super-family)\n";
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $info = "";		my @array_aux = ();
	my $ACC = "";		my $taxonID = "";
	my $lenSeq = 0;		my $count = 0;
	my $countT = 0;		my @array_ACC = ();

	if ($option == 1){
		ScopPattern->leaveOneFamilyOut($inputFile, $output, $verbose);
	}elsif ($option == 2){#print family or superFamily Distribution
		my %hash_member = ScopPattern->fileToHashCountItens($inputFile, "\t", 1, $kind);
		$info = Hash->printHash(\%hash_member);
		FilesIO->saveFile($output, $info, $verbose);	
	}elsif($option == 3){#create family or superFamily file having more than x proteins per family/superFamily
		my %hash_member = ScopPattern->fileToHashCountItens($inputFile, "\t", 1, $kind);
		while ( my ($key, $value) = each(%hash_member) ) {
			if ($value >=$QTD){
				$info .= $key ."\t$value\n";
			}
		}	
		FilesIO->saveFile($output, $info, $verbose);			
	}elsif($option == 4){#create list file from fasta
		$info = ScopPattern->createListFileFromfasta($inputFile, $kind, $output, $verbose);
	}	
	
}
