package R8;
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}


use String::StringUtil;
use File::Files;

my $PROG_NAME = "DecisionTree::R8";

my $MSG_ERROR_DIR_NOT_FOUND = "ERROR::$PROG_NAME:: Directory NOT found = "; 
my $MSG_ERROR_FILE_NOT_FOUND = "ERROR::$PROG_NAME:: File NOT found = "; 
my $MSG_ERROR_FILE_NOT_CREATED = "ERROR::$PROG_NAME:: File NOT created = "; 

############################ sub loadAlign1d ####################################
sub consult {
	
	my $datasetDir	 = $_[1];
	my $fileTreeName = $_[2];
  	my $testFile	 = $_[3];
  	my $output  	 = $_[4];
  	my $verbose  	 = $_[5];
  	
  	FilesIO->checkDirectory($datasetDir, "$MSG_ERROR_DIR_NOT_FOUND $datasetDir");
  	FilesIO->checkFile($testFile, "$MSG_ERROR_FILE_NOT_FOUND $testFile");

	my $cmd = "consult -f $fileTreeName < $testFile >  $output";
	chdir($datasetDir);	
	print $cmd;
	system($cmd);
	FilesIO->checkFile($output, "$MSG_ERROR_FILE_NOT_CREATED $output");		
}

############################ sub loadAlign1d ####################################
sub run {
	
	my $datasetDir	 = $_[1];
	my $parameters   = $_[2];
  	my $output  	 = $_[3];
  	my $verbose  	 = $_[4];
  	
  	FilesIO->checkDirectory($datasetDir, "$MSG_ERROR_DIR_NOT_FOUND $datasetDir");
  	FilesIO->checkFile($testFile, "$MSG_ERROR_FILE_NOT_FOUND $testFile");

	my $cmd = "c4.5 -f $datasetDir $parameters > $output";
	chdir($datasetDir);	
	print $cmd;
	system($cmd);
	FilesIO->checkFile($output, "$MSG_ERROR_FILE_NOT_CREATED $output");		
}


