#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;
use Sequence::Domain;
use Util::Array;

my $DOMAIN_COV_THRESHOLD	= "40";
my $evalue = "1";
my $inputFile  = "";
my $outputDir	= "";
my $dbIdsFile = "";
my $verbose			= "false";
my $svmProbFile = "";
my $CUT_OFF_PROB = 0.05;
my $PFAM_ACC = "";

my $PROG_NAME = "PFAM_ANNOTATION::scripts::prepare::createRandomDomainsList.pl";	

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile" || $ARGV[$counter] eq "-i"){
			$inputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputDir" || $ARGV[$counter] eq "-o"){
			$outputDir= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-dbIdsFile" || $ARGV[$counter] eq "-d"){
			$dbIdsFile= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-PFAM_ACC"){
			$PFAM_ACC = $ARGV[$counter+1];	
			my @array = split(/\./, $PFAM_ACC);
			$PFAM_ACC = $array[0];
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile having result CASH file is required!");	
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found ".$inputFile);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputDir, "ERROR::".$PROG_NAME.":: Parameter -outputDir is required it must contain the output directory! ");	
	String->isEmpty($dbIdsFile, "ERROR::".$PROG_NAME.":: Parameter -dbIdsFile having info about fasta database!");	
	FilesIO->checkFile($dbIdsFile, "ERROR::".$PROG_NAME.":: File NOT found ".$dbIdsFile);
	String->isEmpty($PFAM_ACC, "ERROR::".$PROG_NAME.":: Parameter -PFAM_ACC having PFAM domain ID is required!");
	
	print "-inputFile = $inputFile\n";
	print "-outputDir = $outputDir\n";
	print "-dbIdsFile = $dbIdsFile\n";
	print "-PFAM_ACC = $PFAM_ACC\n";
	print "-verbose = $verbose\n";	
	
	print "ok\n";
}	

################################### sub main #####################################
sub main {
	my @proteinIds = ();				my $proteinID	= "";
	my $domains = "";					my $info		= "";
	my @array_aux;						my @array = ();
	
	@proteinIds = FilesIO->fileToArray2d($dbIdsFile, "\t");
	
	
	for (my $i=0; $i<scalar(@proteinIds); $i++) {
		$info = "";
		$proteinID = $proteinIds[$i][0];
		print	"LOG PID = ". $proteinID. "\n";
		$domains   = FilesIO->getLineInFile($inputFile, $proteinID, $verbose);
		@array_aux = String->StringToArray2d($domains, "\n", "\t");
		for (my $j=0; $j<scalar(@array_aux); $j++) {
			if ($array_aux[$j][4] eq $proteinID){
				@array = Array->copyRowMatrixToArray2($j, \@array_aux);
				$info .= Array->printArray("\t", \@array)."\n";
			}
		}
		if ($info ne ""){
			FilesIO->saveFile($outputDir.$proteinID."/domains.random", $info, $verbose);
		}	
	
	}
	
	
	#FilesIO->saveFile($outputFile, $info, $verbose);	
	#print "LOG::".$PROG_NAME."::Total Ramdom  $count_ramdom \n";
	
}

