#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;
use Sequence::Domain;
use Util::Array;
use analisys::analisys;

my $DOMAIN_COV_THRESHOLD	= "40";
my $evalue = "1";
my $inputFile  = "";
my $outputFile	= "";
my $dbIdsFile = "";
my $domainOrgFile = "";
my $tmpDir = "";
my $verbose			= "false";
my $columnDom = "4";
my $columnAcc = "3";
my $columnStart = "1";
my $columnEnd= "2";
my $columnEvalue = 0;
my $kind = 1;
my $totalDomain = 0;
my $removeSame = "false";
my $PFAM_ACC = "";
my $maxFDR = 0;

my $START = 1;
my $END = 1e-80;
my $JUMP = 1e05;


my @random_ids = ();
my @array_aux = ();
my $count_random_total = 0;			my $count_random = 0;
my %hashRealDomains = ();			my $count_real = 0;
my %hashProteins = ();	


my $PROG_NAME = "PerlLib::FDR::curves.pl";

	
&getParameters;
&checkParameters;



my %hash_IDs = FilesIO->fileToHash2($dbIdsFile, "\t", 0);

&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile" || $ARGV[$counter] eq "-i"){
			$inputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-dbIdsFile" || $ARGV[$counter] eq "-d"){
			$dbIdsFile= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-columnDom"){
			$columnDom = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-columnAcc"){
			$columnAcc= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-columnStart"){
			$columnStart= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-columnEnd"){
			$columnEnd= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-columnEvalue"){
			$columnEvalue= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-totalProtein"){
			$totalDomain= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-tmpDir"){
			$tmpDir = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-kind"){
			$kind = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-removeSame"){
			$removeSame = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-maxFDR"){
			$maxFDR = $ARGV[$counter+1];
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile having result CASH file is required!");	
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found ".$inputFile);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($dbIdsFile, "ERROR::".$PROG_NAME.":: Parameter -dbIdsFile having info about fasta database!");	
	String->isEmpty($tmpDir, "ERROR::".$PROG_NAME.":: Parameter -tmpDir having tmp directory!");	
	FilesIO->checkFile($dbIdsFile, "ERROR::".$PROG_NAME.":: File NOT found ".$dbIdsFile);
	
	print "-inputFile = $inputFile\n";
	print "-dbIdsFile = $dbIdsFile\n";
	print "-columnDom = $columnDom\n";
	print "-columnAcc = $columnAcc\n";
	print "-outputFile = $outputFile\n";
	print "-removeSame=$removeSame\n";
	print "-verbose = $verbose\n";	
	
	print "ok\n";
}	

################################### sub main #####################################
sub main {
	my @new_archs = ();					my $info = "";
	my @random_archs = ();				my $info_random = "";
	my $dco;							my $totalReal;
	
	#my @FDRs = Analisys->initialArrayCountHistogramFloatJumpLog($START, $END, $JUMP);
	#my @FDRs1 = Array->createArrayInterval(1e-300, 1e-50, 1e5, 2);
	#print Array->printArray("\n", \@FDRs1);
	my @FDRs2 = Array->createArrayInterval(1e-45, 1e-04, 1.8, 2);
	my @FDRs3 = Array->createArrayInterval(0.0001, 0.01, 0.001, 1);
	#print Array->printArray("\n", \@FDRs3);
	
	push (@FDRs3, 1);
	my @FDRs = ();
	#push(@FDRs, @FDRs1);
	push(@FDRs, @FDRs2);
	push(@FDRs, @FDRs3);
	#print Array->printArray("\n", \@FDRs);
	#exit;

	#@FDRs = (1e-50, 1e-40, 1e-30, 1e-25, 1e-20, 1e-15,1e-10,1e-09,1e-08,1e-07,1e-06,1e-05,0.0001,0.0003,0.0005,0.0007,0.0009,0.001);
	my @array_file = FilesIO->fileToArray2d($inputFile, "\t");
	
	
	#test
	#@array_aux = Array->reduceMatrixSmaller2($columnEvalue, 1, \@array_file);
	#&calculeFDR;
	#print Array->printMatrix2("\t", "\n", \@array_aux);
	#print scalar(@array_aux)."\n";
	#exit;
	
	
	
	if ($kind ==2){
		@array_aux = @array_file;
		$totalReal = countReal();
		#print $totalReal."\n";
	}
	#&calculeFDRKind2($totalReal);
	for (my $i=0; $i<scalar(@FDRs); $i++){
		#print "entrou";
		@array_aux = Array->reduceMatrixSmaller2($columnEvalue, $FDRs[$i], \@array_file);
		#FilesIO->saveFile($tmpDir."archs$i.tmp", Array->printMatrix2("\t", "\n", \@array_aux));
		print "EV cutoff = ".$FDRs[$i]."\n";
		if ($kind ==1){
			$info .= $FDRs[$i]."\t".&calculeFDR."\n";
		}
		else{
			$info .= $FDRs[$i]."\t".&calculeFDRKind2($totalReal)."\n";			
		}
	}	
	FilesIO->saveFile($outputFile, $info, $verbose);
	
}
################################### sub main #####################################
sub calculeFDR {
	my $FDR;							my 	$domainsProtein;
	$count_random_total = 0;			$count_random = 0;
	%hashRealDomains = ();				$count_real = 0;	
	
	for (my $i=0; $i<scalar(@array_aux); $i++){
		countDomains($array_aux[$i][$columnAcc],  $array_aux[$i][$columnStart], $array_aux[$i][$columnDom], $array_aux[$i][$columnEvalue]);
		%hashRealDomains = ();
		#print "count_random_total=$count_random_total count_real=$count_real count_random=$count_random\n";
	}
	
	if ($removeSame eq "true"){
		$FDR = $count_random/$count_real;
	}else{
		$FDR = $count_random_total/$count_real;
	}
	
	if ($FDR != 0 && $FDR >= $maxFDR){
		print "FDR = ".$FDR."\n";
		FilesIO->saveFile($outputFile.".archs", Array->printMatrix2("\t", "\n", \@array_aux), $verbose);
		exit;  
	}
	if ($totalDomain > 0){
		$domainsProtein = $count_real/$totalDomain;
	}
	#print $count_pred."\n";
	#print "$count_real\t$count_random\t$FDR";
	return "$count_real\t$domainsProtein\t$count_random\t$FDR";
	
}

################################### sub main #####################################
sub calculeFDRKind2 {
	my $realTotal = $_[0];
	my $FDR;							my $accHit;			
	my @arrayHits = ();					my $accHitOld = "";
	my $domainsProtein;					my $numberProteins;
	
	$count_random_total = 0;			$count_random = 0;
	%hashRealDomains = ();				$count_real = 0;	
	%hashProteins = ();		
		
	for (my $i=0; $i<scalar(@array_aux); $i++){
		$accHit = $array_aux[$i][$columnAcc];	
		
		if ($accHit ne $accHitOld && $accHitOld ne ""){
			
			@arrayHits = Array->sortArray2d($columnStart, \@arrayHits);
			#print Array->printMatrix2("\t", "\n", \@arrayHits)."\n";
			
			for (my $j=0; $j<scalar(@arrayHits); $j++){
				countDomains($arrayHits[$j][$columnAcc],  $arrayHits[$j][$columnStart], $arrayHits[$j][$columnDom], $arrayHits[$j][$columnEvalue]);
				#print "count_random_total=$count_random_total count_real=$count_real count_random=$count_random\n";
			}
			
			%hashRealDomains = ();
			@arrayHits = ();
		}
		push(@arrayHits, $array_aux[$i]);	
		$accHitOld = $accHit;
	}
	
	for (my $i=0; $i<scalar(@arrayHits); $i++){
		countDomains($arrayHits[$i][$columnAcc],  $arrayHits[$i][$columnStart], $arrayHits[$i][$columnDom], $arrayHits[$i][$columnEvalue]);
	}
	
	if ($removeSame eq "true"){
		$FDR = $count_random/$realTotal;
	}else{
		$FDR = $count_random_total/$realTotal;
	}
	
	$numberProteins = scalar(keys(%hashProteins));
	

	if ($totalDomain > 0){
		$domainsProtein = $count_real/$totalDomain;
	}
	print "$count_real\t$count_random\t$FDR";
	
	return "$count_real\t$domainsProtein\t$count_random\t$FDR\t$numberProteins";

}


################################### sub countDomains #####################################
sub countDomains{
	my $accHitLocal = $_[0];
	my $hit_start	= $_[1];
	my $domain 		= $_[2];
	my $evalue 		= $_[3];
	my $len;
	
	if (exists($hash_IDs{$accHitLocal})){
		$hashProteins{$accHitLocal} = "";
		$len = $hash_IDs{$accHitLocal};
		#print "LOG::False::$accHitLocal\t$hit_start\tlen=$len\t$domain\n";
		if ($hit_start > $len){
			$count_random_total++;
			if (!exists($hashRealDomains{$domain})){
				$count_random++;
				#print "LOG::False::$accHitLocal\t$hit_start\t$hit_end\tlen=$len\t$domain\n";
			}	
			else{
				print "LOG::NOT false::$accHitLocal\t$hit_start\tlen=$len\t$domain\n";
			}	
			
			#if ($evalue <= 1e-06){
			#	print print "LOG::$accHitLocal\t$hit_start\tlen=$len\t$domain\t$evalue\n";
			#}													
		}else{
			$count_real++;
			$hashRealDomains{$domain} = "";
		}
	}else{
		print "LOG::ERROR:: $accHitLocal NOT found $dbIdsFile\n";
	}		
	
}


################################### sub main #####################################
sub countReal {
	my $count_random =	0 ;				my $count_real = 0;
	my $hit_start	 = "";				my $hit_end = "";					
	my $len			 = "";				my $accHit;
	my $FDR;							my $domain;
	
	for (my $i=0; $i<scalar(@array_aux); $i++){
		$hit_start = $array_aux[$i][$columnStart];
		$hit_end = $array_aux[$i][$columnEnd];
		$accHit = $array_aux[$i][$columnAcc];
		$domain = $array_aux[$i][$columnDom];
		#print "--".$accHit."--\n";
		
		if (exists($hash_IDs{$accHit})){
			$len = $hash_IDs{$accHit};
			if ($hit_start > $len){
				$count_random++;				
			}else{
				$count_real++;
			}
		}else{
			#print "LOG::ERROR:: $accHit NOT found $dbIdsFile\n";
		}
		
	}
	
	return $count_real;

}




