#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;
use Sequence::Domain;
use Util::Array;

my $fastaFile	= "";
my $evalue = "1";
my $inputFile  = "";
my $outputFile	= "";
my $dbIdsFile = "";
my $verbose			= "false";
my $svmProbFile = "";
my $CUT_OFF_PROB = 0.05;
my $colInputFile = "";

my $colStart = 1;
my $colEnd = 2;
my $colAcc = 3;
my $colDom = 4;


my $PROG_NAME = "perlLib::scripts::prepare::filterRamdomDomains.pl";	

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile" || $ARGV[$counter] eq "-i"){
			$inputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-fastaFile"){
			$fastaFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colInputFile"){
			$colInputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile having result CASH file is required!");	
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found ".$inputFile);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required it must contain the output file! ");	
	String->isEmpty($fastaFile, "ERROR::".$PROG_NAME.":: Parameter -fastaFile having info about fasta database!");	
	FilesIO->checkFile($fastaFile, "ERROR::".$PROG_NAME.":: File NOT found ".$fastaFile);
	
	
	print "-inputFile = $inputFile\n";
	print "-outputFile = $outputFile\n";
	print "-fastaFile = $fastaFile\n";
	print "-verbose = $verbose\n";	
	
	print "ok\n";
}	

################################### sub main #####################################
sub main {
	my @sequences = (); 			my %hash = ();
	my %hashSeq = ();				my $keySeq;
	my $info 	= "";				my $sequence_new;
	my @array;
	
	@sequences = Sequences->getSequenceFromFastaArray2D($fastaFile);
	%hash = FilesIO->fileToHashConcatKeyKeepLineFile($inputFile, "\t", $colInputFile);
	
	for (my $i=0; $i<scalar(@sequences); $i++) {
		$keySeq = String->removeCaracter($sequences[$i][0], ">");		
		$keySeq = String->getElementArrayLine($keySeq, "\t", 0);
		$hashSeq{$keySeq} = $sequences[$i][1];
	}
	

	while ( my ($key, $value) = each(%hash) ) {
		@array = String->StringToArray2d($value, "\n", "\t");
		@array = Array->sortArray2d($colStart, \@array);
		
		for (my $i=0; $i<scalar(@array); $i++) {
			$sequence_new = Sequences->getInterval($hashSeq{$array[$i][$colAcc]}, $array[$i][$colStart], $array[$i][$colEnd]);
			$info .=">".$array[$i][$colAcc]."-".$array[$i][$colDom]."-".$array[$i][$colStart]."-".$array[$i][$colEnd]."\n";
			$info .=$sequence_new."\n";
		}
	}
	FilesIO->saveFile($outputFile, $info, $verbose);	

	
}
