package FilesIO;
use strict;

use String::StringUtil;
use Util::Array;
use File::stat;
#use Time::localtime;
#use Date::Format;

my $verbose = "false";



############################ sub isDirectory ####################################
sub checkFile {
	my $file		= $_[1];
	my $msg			= $_[2];
	
	if (FilesIO->isFile($file) eq "false"){
		print $msg."\n";
		exit;
	}
}


############################ sub isDirectory ####################################
sub checkFileNotExit {
	my $file		= $_[1];
	my $msg			= $_[2];
	
	if (FilesIO->isFile($file) eq "false"){
		print $msg."\n";
	}
}


############################ sub isDirectory ####################################
sub checkDirectory {
	my $file		= $_[1];
	my $msg			= $_[2];
	
	if (FilesIO->isDirectory($file) eq "false"){
		print $msg."\n";
		exit;
	}
}
############################ sub isDirectory ####################################
sub createDirectory {
	my $dir		= $_[1];
	my $verbose		= $_[2];
	
	if (!defined($verbose)){
		$verbose = "false";
	}
	if (FilesIO->isDirectory($dir) eq "true"){
		if ($verbose eq "true"){
			print "Directory $dir already created\n";	
		}  		
    }else{
    	my $cmd = "mkdir -p $dir";
    	if ($verbose eq "true"){
    		print $cmd."\n";
    	}
  		system $cmd;
  		if (FilesIO->isDirectory($dir) eq "false"){
  			print "ERROR::FilesIO::createDirectory:: The directory $dir NOT created\n";
  			exit;
  		}elsif ($verbose eq "true"){
  			print "LOG::FilesIO::createDirectory:: The directory $dir was created\n";  			
  		}  			
  	}	
}

############################ sub isDirectory ####################################
sub deleteLastDirectory {
	my $dir		= $_[1];
	my $info = "";
	my @file_aux = split(/\//,$dir);
	for (my $i = 0; $i < scalar(@file_aux) -1; $i++){
		if ($file_aux[$i] ne ""){
			$info .= "/".$file_aux[$i];
		}	
	}
	$info .= "/";
	return $info;
}


############################ sub isDirectory ####################################
sub getLastDirectory2 {
	my $dir		= $_[1];
	my $info = "";
	my @file_aux = split(/\//,$dir);
	return $file_aux[scalar(@file_aux) -1];
}

############################ sub isDirectory ####################################
sub getLastDirectory {
	my $dir		= $_[1];
	my $folder = "";
	
  	my @file_aux = split(//,$dir);
        my $len = scalar(@file_aux);
        
        my $i = $len -2; 
        my $stop = "false";
	

        while($i > 0 && $stop eq "false"){
	 
          if ($file_aux[$i] ne "/"){
              $folder =	$file_aux[$i].$folder; 
	      $i--; 
          }
          else{
            $stop = "true";
          }    
        }
	return $folder;

  print "The directory $dir was created\n";
	
}

############################ sub isDirectory ####################################
sub isDirectory {
	my $dir		= $_[1];
	
	if (-d $dir) {
		return "true";
	}
	else {
		return "false";	
	}
}
############################ sub isDirectory ####################################
sub isFile {
	my $path	= $_[1];
	#print "ooooo".$path."\n";
	if (-e "$path")
	{
		my $size = -s "$path";
		if ($size > 0){
			return "true";
		} 	 
	} 
	return "false";	
}

############################ sub isDirectory ####################################
sub listDirectory {
	my $dir	= $_[1];
	
	my $random_number = int(rand(100000));
	my $file  = "temp".$random_number.".list";
	my $line;
	if (FilesIO->isDirectory($dir) eq "true"){
		my $cmd = "ls $dir > $file";
		system($cmd);
		my $info = FilesIO->lineFileToString($file);
		my @array = split(/\n/, $info);
		FilesIO->removeFile($file);
		return @array;	
	}
	else{
		print "ERROR::FileIO::listDirectory:: Directory NOT found $dir \n";
	}
}

############################ sub isDirectory ####################################
sub listDirectoryFromPrefixFile {
	my $prefixFile	= $_[1];
	my $tmpFile 	= $_[2];
	my $verbose 	= $_[3];
	
	if (!defined($verbose)){
		$verbose =  "true";
	}
	
	my $random_number = int(rand(100000));
	my $file  = $tmpFile."temp".$random_number.".list";
	my $line;
	my $cmd = "ls -n1 $prefixFile > $file";
	system($cmd);
	my $info = FilesIO->lineFileToString($file);
	my @array = split(/\n/, $info);
	my @array_aux; my @array_ret=();
	foreach $line (@array){
		@array_aux = split(/ +/, $line);
		push(@array_ret, $array_aux[scalar(@array_aux) -1]);
	}
	FilesIO->removeFile($file, $verbose);
	return @array_ret;	
}

############################ sub isDirectory ####################################
sub getDirectory {
	my $file	= $_[1];
	
        my $dir;
        my $i;
        my $stop = "false";
        my @file_aux = split(//,$file);
        my $len = scalar(@file_aux);
        
        $i = $len -1; 
        
        while($i > 0 && $stop eq "false"){
          if ($file_aux[$i] ne "/"){
              $i--;
          }
          else{
            $stop = "true";
          }        
        }
        
        $dir = substr($file, 0 , $i+1);
        
        
	return $dir;
}


############################ sub getNameFile ####################################
sub getOnlyNameFile {
        my $file        = $_[1];
 
        my $dir;
        my $i;
        my $stop = "false";
        my @file_aux = split(//,$file);
        my $len = scalar(@file_aux);
        my $fileName = "";
         
        $i = $len -1;
         
        while($i > 0 && $stop eq "false"){
          if ($file_aux[$i] ne "/"){
              $i--;
          }
          else{
            $stop = "true";
          }
        }
         
        $dir = substr($file, $i+1 , $len);
        
        my @array_aux = split(/\./, $dir);
        
        if (scalar(@array_aux) == 1){
        	return $array_aux[0]; 
        }
        
        for (my $i = 0; $i < scalar(@array_aux)-1; $i++){	
        	$fileName .= $array_aux[$i];
        	if ( $i < scalar(@array_aux)-2){
        		$fileName .= ".";
        	}
        }	
        return $fileName;
}


############################ sub getNameFile ####################################
sub getNameFile {
        my $file        = $_[1];
 
        my $dir;
        my $i;
        my $stop = "false";
        my @file_aux = split(//,$file);
        my $len = scalar(@file_aux);
         
        $i = $len -1;
         
        while($i > 0 && $stop eq "false"){
          if ($file_aux[$i] ne "/"){
              $i--;
          }
          else{
            $stop = "true";
          }
        }
         
        $dir = substr($file, $i+1 , $len);
         
         
        return $dir;
}

############################ sub getNameFile ####################################
sub getExt {
        my $file        = $_[1];
 
        my $dir;
        my $i;
        my $stop = "false";
        my @file_aux = split(//,$file);
        my $len = scalar(@file_aux);
         
        $i = $len -1;
         
        while($i > 0 && $stop eq "false"){
          if ($file_aux[$i] ne "."){
              $i--;
          }
          else{
            $stop = "true";
          }
        }
         
        $dir = substr($file, $i+1 , $len);
         
         
        return $dir;
}
############################ sub saveFile ###################################
sub saveFile {
	my $path 	= $_[1];
	my $info	= $_[2];
	my $verbose	= $_[3];
	
	if (!defined($verbose)){
		$verbose = "true";
	}
	
	if (index($path, "/") >=0){
		my $dir = FilesIO->getDirectory($path);
		if (FilesIO->isDirectory($dir) eq "false") {
			FilesIO->createDirectory($dir);
		}
	}
	

	if (open(FILE, ">$path")){
       	print FILE $info;     
       	if ($verbose eq "true") {
       		print "file $path created\n";  
       	}       	     	 
        close FILE;
        my $ext = FilesIO->getExt($path);
        
        if ($ext eq "sh"){
    		my $cmd = "chmod +x $path";
    		system($cmd);
        }
    }
	else {
	    print "ERROR:: Could not open file $path  to write !\n";
	}

	
}

############################ sub saveFile ###################################
sub removeFile {
	my $path 	= $_[1];
	my $verbose	= $_[2];
	
	if (!defined($verbose)){
		$verbose = "true";
	}
	
	if (!defined($verbose)){
		$verbose = "false";
	}
	
	if (open(FILE, "$path")){
       	my $cmd = "rm $path";
        close FILE;
		system $cmd;
		if ($verbose eq "true") {
			print "file $path removed\n";
		}
    }
	elsif ($verbose eq "true"){
	    print "ERROR::Could not remove file $path Not Found!\n";
	}
}

############################ sub saveFile ###################################
sub removeFileByDate {
	my $file 	= $_[1];
	my $date	= $_[2];
	my $verbose	= $_[3];
	
	my $date_string = "";
	#my $date_string = ctime(stat($file)->mtime);
	if (index($date_string, $date) < 0){
		if ($verbose eq "true"){
			print "File $file $date_string\n";
		}
	}
	else{
		my $cmd = "rm $file";
		if ($verbose eq "true"){
			print "OLD $file $date_string\n";
			print "$cmd\n";
			system $cmd;
		}
	}
	
}


############################ sub saveFile ###################################
sub removeFileByNotDate {
	my $file 	= $_[1];
	my $date	= $_[2];
	my $verbose	= $_[3];
	

	my $date_string = "";
	#my $date_string = ctime(stat($file)->mtime);
	if (index($date_string, $date) >= 0){
		if ($verbose eq "true"){
			print "File $file $date_string\n";
		}
	}
	else{
		my $cmd = "rm $file";
		if ($verbose eq "true"){
			print "OLD $file $date_string\n";
			print "$cmd\n";
			system $cmd;
		}
	}
	
}


############################ sub saveFile ###################################
sub removeFiles {
	my $path 	= $_[1];
	my $verbose	= $_[2];
	if (!defined($verbose)){
		$verbose = "true";
	}
	
	if (open(FILE, "$path")){
       	my $cmd = "rm $path"."*";
                close FILE;
		system $cmd;
		if ($verbose eq "true") {
			print "file $path removed\n";
		}
    	}
	else {
	    print "Could not remove file $path . Not Found!\n";
	}
}


############################ sub saveFile ###################################
sub removeDirectory {
	my $path 		= $_[1];
	my $verbose 	= $_[2];
	
	if (!defined($verbose)){
		$verbose = "false";
	}
	
	
	if (FilesIO->isDirectory($path) eq "true"){
       	my $cmd = "rm -rf $path";
        
		system $cmd;
		if ($verbose eq "true"){
			print  $cmd."\n";
			print "LOG::Files::Directory $path removed\n";    	
		}		
	}
}


############################ sub sortFile ###################################
sub sortFile {
	my $path_in 	= $_[1];
	my $path_out 	= $_[2];
	my $col		    = $_[3];
	
	my $cmd 	= "";

	if (open(FILEIN, "$path_in")){
          close FILEIN;
       		if (open(FILEOUT, ">$path_out")){
			close FILEOUT;
                        #$cmd = "sort -g +$col $path_in > $path_out";
                        $cmd = "sort  -n -k $col $path_in > $path_out";
			system 	$cmd;
		}
		else {
	    		print "ERROR::FilesIO::Could not open file $path_out to write !\n";
		}       		
    	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
}

############################ sub sortFile ###################################
sub sortFileOrderDesc {
	my $path_in 	= $_[1];
	my $path_out 	= $_[2];
	my $col		    = $_[3];
	my $sep		    = $_[4];
	
	if (open(FILEIN, "$path_in")){
          close FILEIN;
       		if (open(FILEOUT, ">$path_out")){
			close FILEOUT;
                        #$cmd = "sort -g +$col $path_in > $path_out";
                      my  $cmd = "sort -t\"$sep\" -k$col -r $path_in > $path_out";
                      #print $cmd;
			system 	$cmd;
		}
		else {
	    		print "ERROR::FilesIO::Could not open file $path_out to write !\n";
		}       		
    	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}

	
}
############################ sub saveFile ###################################
sub fileToArray {
	my $path_in 	= $_[1];
	my $sep 	= $_[2];
	my $field 	= $_[3];
	
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my @array_ret 	= ();
	my $line;

	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		foreach $line (@array_file){
			@array_aux = split(/$sep/, $line);
			push(@array_ret, String->removeCaracter($array_aux[$field], "\n"));
		}
                close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return @array_ret;
}

############################ sub saveFile ###################################
sub fileToArray2d {
	my $path_in = $_[1];
	my $sep 	= $_[2];
	my $eliminateCaracter 	= $_[3];
	
	if (!defined($eliminateCaracter)){
		$eliminateCaracter = "";
	}    
 
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my @array_ret 	= ();
	my $line;
	my $count = 0;


	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		foreach $line (@array_file){
			if (index($line, "\#") == 0){
				print "removed:: $line";
			}else{
				@array_aux = split(/$sep/, $line);
				for (my $i=0; $i<scalar(@array_aux); $i++){
					$array_aux[$i] = String->removeCaracter($array_aux[$i], $eliminateCaracter);
					if ($i == (scalar(@array_aux)-1)){
						$array_ret[$count][$i] = String->removeCaracter($array_aux[$i], "\n");
					}else{
						$array_ret[$count][$i] = $array_aux[$i];
					}				
				}
				$count++;
			}
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return @array_ret;
}
############################ sub saveFile ###################################
sub fileToHash {
	my $path_in 	= $_[1];
	my $sep 		= $_[2];
	my $field_key 	= $_[3];
	my $removeBL 	= $_[4];
	
	my $sepArray;
	if (!defined($removeBL)){
		$removeBL = "false";
	}

	#print $path_in."\t".$field_key."\n" ;
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my %hash = ();
	my $line; my $info;

	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		foreach $line (@array_file){
			$info = "";
			$line = String->removeCaracter($line, "\n");
			if ($sep ne ""){
				if ($sep eq " "){
					$sepArray = " +";
				}else{
					$sepArray = $sep;
				}
				@array_aux = split(/$sepArray/, $line);
				for (my $i =0; $i< scalar(@array_aux); $i++){
					#if ($i != $field_key){
						$info .= $array_aux[$i];
						if ($i != scalar(@array_aux)-1){
							$info .= $sep;
						}
					#}			 
				}
				
				if (!exists($hash{$array_aux[$field_key]})){
					#$hash{$array_aux[$field_key]} = String->removeCaracter($info, "\n");
					#print "field".$array_aux[$field_key]."\n";
					$hash{$array_aux[$field_key]} = $info;				
				}else{
					#$hash{$array_aux[$field_key]} .= String->removeCaracter($info, "\n");
					$hash{$array_aux[$field_key]} .= $info;
				}	
				if ($removeBL eq "false"){
					$hash{$array_aux[$field_key]} .= "\n";
				}
			}else{
				$line = String->removeCaracter($line, "\n");
				$hash{$line} = $line;
			}					
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return %hash;
}

############################ sub saveFile ###################################
sub fileToHash2 {
	my $path_in 	= $_[1];
	my $sep 		= $_[2];
	my $field_key 	= $_[3];
	
	#print $path_in."\n";
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my %hash = ();
	my $line; my $info;
	my @array_item = ();

	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		
		foreach $line (@array_file){
			$info = "";
			#print $line."\n";
			$line = String->removeCaracter($line, "\n");
			if ($sep ne ""){
				@array_aux = split(/$sep/, $line);
				@array_item = ();
				for (my $i =0; $i< scalar(@array_aux); $i++){
					if ($i != $field_key){
						$info = $array_aux[$i];
						push(@array_item, $info);
					}			 
				}	
				$info = Array->printArray($sep, \@array_item);	
				
				if (!exists($hash{$array_aux[$field_key]})){
					#$hash{$array_aux[$field_key]} = String->removeCaracter($info, "\n");
					#print "field".$array_aux[$field_key]."\n";
					$hash{$array_aux[$field_key]} = $info;
				}else{
					#$hash{$array_aux[$field_key]} .= String->removeCaracter($info, "\n");
					$hash{$array_aux[$field_key]} .= "\n".$info;
				}	
			}else{
				$line = String->removeCaracter($line, "\n");
				$hash{$line} = $line;
			}					
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return %hash;
}


############################ sub saveFile ###################################
sub fileToHashCountItens {
	my $path_in 	= $_[1];
	my $sep 		= $_[2];
	my $field_key 	= $_[3];
	
	#print $path_in."\n";
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my %hash = ();
	my $line; my $key;
	my $count = 0;

	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		
		foreach $line (@array_file){
			#print $line."\n";
			$line = String->removeCaracter($line, "\n");
			@array_aux = split(/$sep/, $line);
			$key = $array_aux[$field_key];	
			if (!exists($hash{$key})){
				$hash{$key} = 1;
				$count++;
			}else{
				$hash{$key} = $hash{$key} + 1;
			}					
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return %hash;
}


############################ sub saveFile ###################################
sub fileToHashPosition {
	my $path_in 	= $_[1];
	my $sep 		= $_[2];
	my $field_key 	= $_[3];
	
	#print $path_in."\n";
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my %hash = ();
	my $line; my $key;
	my $count = 0;

	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		
		foreach $line (@array_file){
			#print $line."\n";
			$line = String->removeCaracter($line, "\n");
			@array_aux = split(/$sep/, $line);
			$key = $array_aux[$field_key];	
			if (!exists($hash{$key})){
				$hash{$key} = $count;
				$count++;
			}					
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return %hash;
}

############################ sub saveFile ###################################
sub fileToHashConcatKeyOneLine {
	my $path_in 	= $_[1];
	my $sep 		= $_[2];
	my $fields 	    = $_[3];#Separated by comma,	
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my %hash = ();
	my $line; my $info;
	my @array_aux_hash = ();
	
	my @array_fields = split(/\,/, $fields);
	
	
	
	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		foreach $line (@array_file){
			$info = "";
			$line = String->removeCaracter($line, "\n");
			if ($sep ne ""){
				@array_aux = split(/$sep/, $line);
				for (my $i =0; $i< scalar(@array_aux); $i++){
					if (Array->isInArray($i, \@array_fields) eq "false"){
						push(@array_aux_hash, $array_aux[$i]);
					}			 
				}
				$fields = "";
				for (my $i =0; $i< scalar(@array_fields); $i++){
					$fields .=$array_aux[$array_fields[$i]];
				}
				
				if (!exists($hash{$fields})){
					$hash{$fields} = Array->printArray("\t", \@array_aux_hash);
					@array_aux_hash = ();
				}	
			}else{
				$line = String->removeCaracter($line, "\n");
				$hash{$line} = $line;
			}					
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return %hash;
}

############################ sub saveFile ###################################
sub fileToHashConcatKey {
	my $path_in 	= $_[1];
	my $sep 		= $_[2];
	my $fields 	    = $_[3];#Separated by comma,	
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my %hash = ();
	my $line; my $info;
	
	my @array_fields = split(/\,/, $fields);
	
	
	
	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		foreach $line (@array_file){
			$info = "";
			$line = String->removeCaracter($line, "\n");
			if ($sep ne ""){
				@array_aux = split(/$sep/, $line);
				for (my $i =0; $i< scalar(@array_aux); $i++){
					#if ($i != $field_key){
						$info .= $array_aux[$i];
						if ($i != scalar(@array_aux)-1){
							$info .= $sep;
						}
					#}			 
				}
				$fields = "";
				for (my $i =0; $i< scalar(@array_fields); $i++){
					$fields .=$array_aux[$array_fields[$i]];
				}
				
				if (!exists($hash{$fields})){
					$hash{$fields} = $info."\n";
				}else{
					$hash{$fields} .= $info."\n";
				}	
			}else{
				$line = String->removeCaracter($line, "\n");
				$hash{$line} = $line;
			}					
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return %hash;
}

############################ sub saveFile ###################################
sub fileToHashConcatKeyKeepLineFile {
	my $path_in 	= $_[1];
	my $sep 		= $_[2];
	my $fields 	    = $_[3];#Separated by :,	
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my %hash = ();
	my $line; my $info;
	
	my @array_fields = split(/\:/, $fields);
	
	
	
	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		foreach $line (@array_file){
			$info = "";
			if (index($line, "\#") < 0){
				if ($sep ne ""){
					@array_aux = split(/$sep/, $line);
			
					$fields = "";
					for (my $i =0; $i< scalar(@array_fields); $i++){
						$fields .= String->removeCaracter($array_aux[$array_fields[$i]], "\n");
					}
				
					if (!exists($hash{$fields})){
						$hash{$fields} = $line;
					}else{
						$hash{$fields} .= $line;
					}	
				}	
			}						
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return %hash;
}

############################ sub lineFileToArray ###################################
sub getSize {
	my $path_in 	= $_[1];	
	
	my @array_file 	= ();

	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
        close FILEIN;
		return scalar(@array_file);                  
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
        exit;
	}
	return -1;
}



############################ sub lineFileToArray ###################################
sub lineFileToArray {
	my $path_in 	= $_[1];	
	
	my @array_file 	= ();

	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
                close FILEIN;
		return @array_file;                  
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
        exit;
	}
	
}

############################ sub lineFileToArrayWithToken ###################################
sub download {
	my $url		 	= $_[1];	
	my $outputFile	= $_[2];	
	my $verbose		= $_[3];
	my $check		= $_[4];
	
	my $cmd = "wget -O $outputFile -d --no-http-keep-alive --ignore-length $url";
	
	if (!defined($verbose)){
		$verbose = "true";
	}
	if (!defined($check)){
		$check = "true";
	}
	if ($verbose eq "true"){
		print "FilesIO::LOG:: $cmd\n";
	}
	
	my $dir = 	FilesIO->getDirectory($outputFile);
	FilesIO->createDirectory($dir);
	system ($cmd);
	
	if ($check eq "true"){
		FilesIO->checkFileNotExit($outputFile, "FilesIO::ERROR:: File $outputFile NOT Found\n");	
	}
}

############################ sub lineFileToArrayWithToken ###################################
sub removelineFileStartWith {
	my $path_in 	= $_[1];	
	my $token	 	= $_[2];	
	my $path_out 	= $_[3];	
	my $start		= "false";
	my $info = "";
	my @array_file 	= ();
	if (open(FILEIN, "$path_in")){
		while (my $line = <FILEIN>) {
			if (index($line, $token) >=0){
				$start = "true";
			}elsif ($start eq "true"){
				$info .= $line;
			}
		}
		close FILEIN;
		if ($info ne ""){
			FilesIO->saveFile($path_out, $info, "false");
		}else{
			print "ERROR::FilesIO::removelineFileStartWith Could not open file $path_in to read !\n";
        	 exit;
		}		
		                
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
         exit;
	}
	
}



############################ sub lineFileToArrayWithToken ###################################
sub lineFileToArrayStartWith {
	my $path_in 	= $_[1];	
	my $token	 	= $_[2];	
	my $start		= "false";
	
	my @array_file 	= ();

	if (open(FILEIN, "$path_in")){
		while (my $line = <FILEIN>) {
			if (index($line, $token) ==0){
				push(@array_file, $line);
			}
		}
		close FILEIN;
		
		if (scalar(@array_file) ==0){
			print "ERROR::FilesIO:: Token $token NOT found in $path_in!\n";
         	exit;
		}
		
		return @array_file;                  
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
         exit;
	}
	
}


############################ sub lineFileToArrayWithToken ###################################
sub lineFileToArrayWithToken {
	my $path_in 	= $_[1];	
	my $token	 	= $_[2];	
	my $start		= "false";
	
	my @array_file 	= ();

	if (open(FILEIN, "$path_in")){
		while (my $line = <FILEIN>) {
			if (index($line, $token) >=0){
				$start = "true";
			}
			if ($start eq "true"){
				push(@array_file, $line);
			}
		}
		close FILEIN;
		
		if (scalar(@array_file) ==0){
			print "ERROR::FilesIO:: Token $token NOT found in $path_in!\n";
         	exit;
		}
		
		return @array_file;                  
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
         exit;
	}
	
}


############################ sub lineFileToArrayWithToken ###################################
sub lineFileToArrayWithTokenStarStop {
	my $path_in 	= $_[1];	
	my $tokenStart 	= $_[2];	
	my $tokenStop 	= $_[3];	
	my $start		= "false";
	my $stop = "false";
	my @array_file 	= ();
	#print "tokenStart  $tokenStart \n";
	#print "tokenStop  $tokenStop \n";

	if (open(FILEIN, "$path_in")){
		while (my $line = <FILEIN>) {
			#print $line;
			if (index($line, $tokenStart) >=0){
				$start = "true";
			}
			if ($start eq "true"){
				if (index($line, $tokenStop) >=0){
					$stop = "true";
				}
			}			
			if ($start eq "true" && $stop eq "false"){
				if (index($line, $tokenStart) <0){
					push(@array_file, $line);
				}				
			}
			#my $index = index($line, $tokenStop);
			#print ">>>>".$start."\t".$stop."\t$index\n";
		}
		close FILEIN;
		
		if (scalar(@array_file) ==0){
			print "ERROR::FilesIO:: Token $tokenStart and  $tokenStop NOT found in $path_in!\n";
         	exit;
		}
		
		return @array_file;                  
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
         exit;
	}
	
}
############################ sub lineFileToString ###################################
sub lineFileToString {
	my $path_in 	= $_[1];	
	
	my @array_file 	= ();
	my $line	= "";
	my $entry;

	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
                close FILEIN;
		foreach $entry (@array_file){
			$line .= $entry;
		}
		return $line;
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
            exit;
	}
	
}

############################ sub getNumberLineFile ###################################
sub getNumberLineFile {
	my $path_in 	= $_[1];	
	
	my @array_file 	= ();

	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
                close FILEIN;
		return scalar(@array_file);                  
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
            exit;
	}	
}
############################ sub saveFile ###################################
sub apendFile {
	my $path 	= $_[1];
	my $info	= $_[2];
	my $verbose	= $_[3];

	if (open(FILE, ">>$path")){
       	print FILE $info;
        close FILE;
		if ($verbose eq "true"){
			print "file $path apended\n";    
		}
	}
	else {
	    print "Could not open file $path  to write !\n";
	}
}

############################ sub saveFile ###################################
sub copyFileToDirectory {
	my $file 	= $_[1];
    my $dir 	= $_[2];
    my $verbose	= $_[3];
	
	if (!defined($verbose)){
		$verbose = "true";
	}
	
 
 	if (FilesIO->isDirectory($dir) eq "false"){
 		#print "ERROR:: File::Files:: Directory $dir NOT found\n";
 		FilesIO->createDirectory($dir, $verbose);
 	}
 	
 	if (FilesIO->isFile($file) eq "false"){
		print "ERROR:: File::Files:: File $file NOT Found!\n";
		exit;
	}
	
	my $cmd = "cp $file $dir";
	system($cmd);
	
	my  $file_name = $dir.FilesIO->getNameFile($file);
	
	if (FilesIO->isFile($file_name) eq "false"){
		print "ERROR:: File::Files:: File $file_name NOT copied!\n";
		exit;
	}elsif ($verbose eq "true"){
		print "File $file_name copied!\n";
	}	
	return $file_name;	
}

############################ sub saveFile ###################################
sub createLink {
	my $file 	= $_[1];
    my $dir 	= $_[2];
    my $verbose	= $_[3];
	
	if (!defined($verbose)){
		$verbose = "true";
	}    
 
 	if (FilesIO->isDirectory($dir) eq "false") {
		FilesIO->createDirectory($dir);
	}
 	
 	if (FilesIO->isFile($file) eq "false"){
		print "ERROR:: File::Files:: File $file NOT Found!\n";
		exit;
	}
	
	my $cmd = "ln -s $file $dir";
	if ($verbose eq "true"){
		print $cmd."\n";
	}	
		
	system($cmd);
	
	my  $file_name = $dir.FilesIO->getNameFile($file);
	
	if (FilesIO->isFile($file_name) eq "false"){
		print "ERROR:: File::Files:: File $file_name NOT copied!\n";
		exit;
	}elsif ($verbose eq "true"){
		print "File $file_name linked!\n";
	}	
	return $file_name;	
}

############################ sub saveFile ###################################
sub copyFileDir {
	my $file 	= $_[1];
    my $dir 	= $_[2];
    my $verbose	= $_[3];
	
	
	if (!defined($verbose)){
		$verbose = "true";
	}    
 
 	if (FilesIO->isDirectory($dir) eq "false") {
		FilesIO->createDirectory($dir);
	}
 	
 	if (FilesIO->isFile($file) eq "false"){
		print "ERROR:: File::Files::copyFileDir:: File $file NOT Found!\n";
		exit;
	}
	
	my $cmd = "cp $file $dir";
	if ($verbose eq "true"){
		print $cmd."\n";
	}	
		
	system($cmd);
	
	my  $file_name = $dir.FilesIO->getNameFile($file);
	
	if (FilesIO->isFile($file_name) eq "false"){
		print "ERROR:: File::Files::copyFileDir:: File $file_name NOT copied!\n";
		exit;
	}elsif ($verbose eq "true"){
		print "File::Files::copyFileDir:: $file_name linked!\n";
	}	
	return $file_name;	
}

############################ sub saveFile ###################################
sub concat {
	my $file1 	= $_[1];
    my $file2	= $_[2];
    my $outputFile	= $_[3];
    my $verbose	= $_[4];
	
	if (!defined($verbose)){
		$verbose = "true";
	}    
 
	my $cmd = "cat $file1 $file2 > $outputFile";
	if ($verbose eq "true"){
		print $cmd."\n";
	}	
	system($cmd);
	FilesIO->checkFile($outputFile, "ERROR::File::Files::concat File not created ".$outputFile);
	
}


############################ sub saveFile ###################################
sub copyDir {
	my $dir_from 	= $_[1];
    my $dir_to	= $_[2];
    my $verbose	= $_[3];
	
	if (!defined($verbose)){
		$verbose = "true";
	}    
 
 	if (FilesIO->isDirectory($dir_from) eq "false") {
		print "ERROR::File::Files:: Directory $dir_from NOT Found!\n";
		exit;
	}
 	if (FilesIO->isDirectory($dir_to) eq "false") {
		FilesIO->createDirectory($dir_to);
	}
 	
	my $cmd = "cp -rf $dir_from/ $dir_to";
	if ($verbose eq "true"){
		print $cmd."\n";
	}	
	system($cmd);
}

############################ sub saveFile ###################################
sub createLinkRelative {
	my $file 	= $_[1];
    my $dir 	= $_[2];
    my $verbose	= $_[3];
	
	if (!defined($verbose)){
		$verbose = "true";
	}
    
    my $new_file = ""; my $point; my $slach = "";
    
    my @array_file = split(/\//, $file);
    my @array_dir = split(/\//, $dir);
    
    my $i = 0;
    while ($i < scalar(@array_dir)){
    	
    	if ($array_file[$i] ne $array_dir[$i]){
    		for (my $j = $i; $j < scalar(@array_file); $j++){
    			$new_file .= "/".$array_file[$j];
    		}
    		$point = scalar(@array_dir) - $i;
    		 $i = scalar(@array_dir);
    	}
    	$i++;
    }
    
    for (my $i = 0; $i < $point; $i++){
    	$slach .= "../";
    }
    $new_file = $slach.$new_file;
 
 	if (FilesIO->isDirectory($dir) eq "false") {
		FilesIO->createDirectory($dir);
	}
 	
 	if (FilesIO->isFile($file) eq "false"){
		print "ERROR:: File::Files:: File $file NOT Found!\n";
		exit;
	}
	
	my $cmd = "ln -s $new_file $dir";
	
	if ($verbose eq "true"){
		print $cmd."\n";
	}
	system($cmd);
	
	my  $file_name = $dir.FilesIO->getNameFile($file);
	
	if (FilesIO->isFile($file_name) eq "false"){
		print "ERROR:: File::Files:: File $file_name NOT copied!\n";
		exit;
	}elsif ($verbose eq "true"){		
		print "File $file_name linked!\n";
	}	
	return $file_name;	
}
############################ sub saveFile ###################################
sub uncompactTgz {
	my $file 	= $_[1];
    
 	if (FilesIO->isFile($file) eq "false"){
		print "ERROR:: File::Files:: File $file NOT Found!\n";
		exit;
	}
	my $dir = FilesIO->getDirectory($file);
	chdir($dir);
	
	my $name_file = FilesIO->getNameFile($file);
	my $cmd = "tar -xzf $name_file";
	system($cmd);
	
	
}

############################ sub saveFile ###################################
sub listDir {
	my $dir 	= $_[1];
	my $entry;
	my $name_dir;
	my @array_result = ();
	
	if (FilesIO->isDirectory($dir) eq "false"){
		print "ERROR:: File::Files:: Directory $dir NOT Found!\n";
		exit;
	}
	
	my $cmd = "ls -lh $dir > out.txt";
	system($cmd);
	
	if (FilesIO->isFile("out.txt") eq "false"){
		print "ERROR:: File::Files::Dir Not listed!\n";
		exit;
	}
	
	my @array = FilesIO->lineFileToArray("out.txt");
	
	foreach $entry (@array) {
		print $entry."\n";
		my @array_line = split(/ +/, $entry);
		$name_dir = String->removeCaracter($array_line[scalar(@array_line) -1], "\n");
		print $name_dir."xx";
		if (scalar(@array_line) > 7){
			push(@array_result, $name_dir);
		}		
	}
	FilesIO->removeFile("out.txt");
	return @array_result;
}

############################ sub saveFile ###################################
sub compactTgz {
	my $dir 	= $_[1];
	
	if (FilesIO->isDirectory($dir) eq "false"){
		print "ERROR:: File::Files:: Directory $dir NOT Found!\n";
		exit;
	}
	my $prev_dir = FilesIO->deleteLastDirectory($dir);
	
	chdir($prev_dir);
	my $name_file =   FilesIO->getLastDirectory2($dir).".tar.gz";
	my $name_dir = FilesIO->getLastDirectory2($dir);
	my $cmd = "tar -czf $name_file $name_dir";
	system($cmd);
	
	
	if (FilesIO->isFile($prev_dir.$name_file) eq "false"){
		print "ERROR:: File::Files:: File $prev_dir.$name_file NOT created!\n";
		exit;
	}
	print "File $prev_dir$name_file created!\n";
	return $prev_dir.$name_file;
	#print $name_compact;
	
	
	
}


############################ sub saveFile ###################################
sub compactFileTgz {
	my $file 		= $_[1];
	my $verbose 	= $_[2];
	
	if (FilesIO->isFile($file) eq "false"){
		print "ERROR:: File::Files::compactFileTgz:: File $file NOT Found!\n";
		exit;
	}
	my $prev_dir = FilesIO->getDirectory($file);
	
	chdir($prev_dir);
	my $name_file =  FilesIO->getNameFile($file);
	my $name_file_gz = $name_file.".tar.gz";
	my $cmd = "tar -czf $name_file_gz $name_file";
	if ($verbose eq "true"){
		print "File::Files::compactFileTgz:: $cmd\n";
	}
	system($cmd);
	
	
	if (FilesIO->isFile($prev_dir.$name_file_gz) eq "false"){
		print "ERROR:: File::Files::compactFileTgz:: File $prev_dir.$name_file_gz NOT created!\n";
		exit;
	}
	if ($verbose eq "true"){
		print "File::Files::compactFileTgz:: $prev_dir$name_file created!\n";
	}
	return $prev_dir.$name_file_gz;
	#print $name_compact;
	
	
	
}

############################ sub saveFile ###################################
sub unCompactGzip {
	my $path	= $_[1];
	my $verbose	= $_[2];
	
	if (!defined($verbose)){
		$verbose = "true";
	}    
  	
		
	if (FilesIO->isFile($path) eq "false"){
		print "ERROR:: File::Files:: File $path NOT Found!\n";
		#exit;
	}
	my $cmd = "gzip -d $path";
	if ($verbose eq "true"){
		print $cmd."\n";
	}	
	
	system($cmd);
	
	my $newFile = substr($path, 0, index($path,".".FilesIO->getExt($path)));
	
	FilesIO->checkFileNotExit($newFile, "FilesIO::ERROR:: File $newFile NOT Found\n");	
	
}

############################ sub saveFile ###################################
sub copyFile {
	my $path_in 	= $_[1];
    my $path_out 	= $_[2];
	my $verbose	= $_[3];
	
	if (!defined($verbose)){
		$verbose = "true";
	}    
  	
 	if (FilesIO->isFile($path_in) eq "false"){
		print "ERROR:: File::Files:: File $path_in NOT Found!\n";
		exit;
	}
	
	my $cmd = "cp $path_in $path_out";
	if ($verbose eq "true"){
		print $cmd."\n";
	}	
		
	system($cmd);
	 

}

############################ sub concatFiles ###################################
sub concatFiles {
	my $file1 	= $_[1];
	my $file2	= $_[2];
	my $file_result	= $_[3];

	if (FilesIO->isFile($file1) eq "false"){
		print "ERROR:: file  $file1 not found!\n";
		#exit;
	}elsif (FilesIO->isFile($file2) eq "false"){
		print "ERROR:: file  $file2 not found!\n";
		#exit;
	}else{
		my $str_file1 = FilesIO->lineFileToString($file1);
		my $str_file2 = FilesIO->lineFileToString($file2);
		my $info = $str_file1.$str_file2;
		FilesIO->saveFile($file_result, $info);
	}  	
	
}

############################ sub concatFiles ###################################
sub compare {
	my $file1 = $_[1];
	my $file2	= $_[2];
	

	if (FilesIO->isFile($file1) eq "false" || FilesIO->isFile($file2) eq "false"){
		print "Erro file  $file1 or $file2 not found!\n";
		exit;
	}else{
		my $cmd = "diff $file1 $file2";
		my $diff_file = system($cmd);
		print "oiiiiiii". $diff_file;
		return $diff_file;
    	}
	
}

############################ sub createDirFromFile ###################################
sub createDirFromFile {
	my $file = $_[1];
	
	my $dir_hmm = FilesIO->getDirectory($file);
	
	if (FilesIO->isDirectory($dir_hmm) eq "false"){
		FilesIO->createDirectory($dir_hmm);
	}
}


############################ sub removeCaracter ####################################
sub getLineFromFile {
  
  my $file	 				= $_[1];
  my $lineNumber 			= $_[2];
  my $verbose	 			= $_[3];
 
  my $save_seq = "false";
  my $count = 0;
  my $seq = "";
  my $name_sequence;
  my @array = ();
  
  if (open(FILEIN, "$file")){
		while (my $line = <FILEIN>) {
			if ($count == $lineNumber){
				return $line;
			}
			$count++;
		}	
		close FILEIN;
		return "false";		    
	}
	else{
		print "ERROR::perlLib::sequence.pm:: $file is NOT a file\n";
		exit;
	}  
}


############################ sub removeCaracter ####################################
sub searchInFile {
  
  my $file	 	= $_[1];
  my $word	 	= $_[2];
  my $verbose	= $_[3];

  my $random_number = rand(100000);
  my $ret;

  my $file_out = "/tmp/out.$random_number";
  
  my $cmd = "grep -m 1 \"$word\" $file > $file_out ";
  system($cmd);
  
  if (FilesIO->isFile($file_out) eq "false"){
  	$ret = "false";
  }else{
  	$ret = "true";
  }
  FilesIO->removeFile($file_out, $verbose);
  return $ret;

}

############################ sub removeCaracter ####################################
sub getLineInFileByPosition {
  
  my $file	 	= $_[1];
  my $position 	= $_[2];
  my $verbose	= $_[3];


  if ($position eq ""){
  	print "ERROR:: Parameter $position is empty\n";
  	exit;
  }
  my $random_number = rand(100000);
  my $ret = "";

  my $file_out = $file.".out.$random_number";
  
  my $cmd = "awk \"NR\=\=$position\{print;exit\}\" $file > $file_out";

  if ($verbose eq "true"){print $cmd."\n";}
  system($cmd);
  
  if (FilesIO->isFile($file_out) eq "true"){
  	$ret = FilesIO->lineFileToString($file_out);
  }else{
  	print "ERROR:: $position NOT found in $file\n";
  	FilesIO->removeFile($file_out, $verbose);
  	#exit;
  }
  FilesIO->removeFile($file_out, $verbose);
  return $ret;

}



############################ sub removeCaracter ####################################
sub getLineInFile {
  
  my $file	 	= $_[1];
  my $word	 	= $_[2];
  my $verbose	= $_[3];


  if ($word eq ""){
  	print "ERROR:: Parameter word is empty\n";
  	exit;
  }
  my $random_number = rand(100000);
  my $ret = "";

  my $file_out = $file.".out.$random_number";
  
  my $cmd = "grep -w \"$word\" $file > $file_out ";
  if ($verbose eq "true"){print $cmd."\n";}
  system($cmd);
  
  if (FilesIO->isFile($file_out) eq "true"){
  	$ret = FilesIO->lineFileToString($file_out);
  }else{
  	if ($verbose eq "true"){print "ERROR:: $word NOT found in $file\n";}
  	FilesIO->removeFile($file_out, $verbose);
  	#exit;
  }
  FilesIO->removeFile($file_out, $verbose);
  return $ret;

}


############################ sub removeCaracter ####################################
sub getLineInFileFirstOcurrence {
  
  my $file	 	= $_[1];
  my $word	 	= $_[2];
  my $verbose	= $_[3];


  if ($word eq ""){
  	print "ERROR:: Parameter word is empty\n";
  	exit;
  }
  my $random_number = rand(100000);
  my $ret = "";

  my $file_out = "/tmp/out.$random_number";
  
  my $cmd = "grep -m 1 \"$word\" $file > $file_out ";
  if ($verbose eq "true"){print $cmd."\n";}
  system($cmd);
  
  if (FilesIO->isFile($file_out) eq "true"){
  	$ret = FilesIO->lineFileToString($file_out);
  }elsif ($verbose eq "true"){
  	print "ERROR:: $word NOT found in $file\n";
  	$ret = "";
  	#exit;
  }
  FilesIO->removeFile($file_out, $verbose);
  return $ret;

}


############################ sub removeCaracter ####################################
sub getLinesInFile {
  
  my $file	 	= $_[1];
  my $word	 	= $_[2];
  my $verbose	= $_[3];


  if ($word eq ""){
  	print "ERROR:: Parameter word is empty\n";
  	exit;
  }
  my $random_number = rand(100000);
  my $ret;

  my $file_out = "/tmp/out.$random_number";
  
  my $cmd = "grep \"$word\" $file > $file_out ";
  if ($verbose eq "true"){print $cmd."\n";}
  system($cmd);
  
  if (FilesIO->isFile($file_out) eq "true"){
  	$ret = FilesIO->lineFileToString($file_out);
	if ($ret eq ""){
		print "$word is empty\n";
		exit;
	}
  }elsif($verbose eq "true"){
  	print "ERROR:: $word NOT found in $file\n";
  	$ret = "";
  }else{
  	$ret = "";
  }
  FilesIO->removeFile($file_out, $verbose);
  return $ret;

}

############################ sub removeCaracter ####################################
sub getLinesInFileMatchColumn {
  
  my $file	 	= $_[1];
  my $word	 	= $_[2];
  my $column	= $_[3];
  my $verbose	= $_[4];


  if ($word eq ""){
  	print "ERROR:: Parameter word is empty\n";
  	exit;
  }
  my $random_number = rand(100000);
  my $ret;

  my $file_out = $file.".out.$random_number";
  
  my $cmd = "cat $file | awk \'\$".$column. " == \"$word\" { print \$0 }\' > $file_out";
  if ($verbose eq "true"){print $cmd."\n";}
  system($cmd);
  
  if (FilesIO->isFile($file_out) eq "true"){
  	$ret = FilesIO->lineFileToString($file_out);
  }elsif($verbose eq "true"){
  	print "ERROR:: $word NOT found in $file\n";
  	$ret = "";
  }else{
  	$ret = "";
  }
  FilesIO->removeFile($file_out, $verbose);
  return $ret;

}



############################ sub removeCaracter ####################################
sub getLinesInFileCascade {
  
  my $file	 	= $_[1];
  my $word	 	= $_[2];#separeted by spaces
  my $verbose	= $_[3];
  my $cmd = "";

  if ($word eq ""){
  	print "ERROR:: Parameter word is empty\n";
  	exit;
  }
  my $random_number = rand(100000);
  my $ret;

  my $file_out = $file.".out.$random_number";
  
  my @array = split(/ +/, $word);
  
  $cmd = "grep \"".$array[0]."\" $file ";
  for (my $i = 1; $i < scalar(@array); $i++){
  	 $cmd .= "\| grep \"".$array[$i]."\" ";
  }
  $cmd .=  " > $file_out";
 
  if ($verbose eq "true"){print $cmd."\n";}
  system($cmd);
  
  if (FilesIO->isFile($file_out) eq "true"){
  	$ret = FilesIO->lineFileToString($file_out);
  }elsif($verbose eq "true"){
  	print "ERROR:: $word NOT found in $file\n";
  	$ret = "";
  }else{
  	$ret = "";
  }
  FilesIO->removeFile($file_out, $verbose);
  return $ret;

}
############################ sub removeCaracter ####################################
sub getElementLineInFile {
  
  my $file	 	= $_[1];
  my $word	 	= $_[2];
  my $verbose	= $_[3];

  my @array_aux = ();		my $line = 0;

  if ($word eq ""){
  	print "ERROR:: Parameter word is empty\n";
  	exit;
  }
  my $random_number = rand(100000);
  my $ret;

  my $file_out = $file.".out.$random_number";
  
  my $cmd = "grep -nr \"$word\" $file > $file_out ";
  if ($verbose eq "true"){print $cmd."\n";}
  system($cmd);
  
  if (FilesIO->isFile($file_out) eq "true"){
  	$ret = FilesIO->lineFileToString($file_out);
  	@array_aux = split(/:/, $ret);
  	$line = $array_aux[0];
  }
  elsif($verbose eq "true"){
  	print "ERROR:: $word NOT found in $file\n";
  }
  
  FilesIO->removeFile($file_out, $verbose);
  return $line;

}

1
