
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Util::Array;
use Util::Number;
use HMMs::HMMER::hmmer;
use HMMs::HMMER::hmmpfam;

my $verbose    	= "false";
my $kind	= "1";
my $outputFile	= "";
my $inputFile	= "";
my $trueFile = "";
my $totalPos = 5;
my $totalNeg = 10;

my $arg1 = "";
my $arg2 = "";
my $arg3 = "";
my $arg4 = "";
my $arg5 = "";
my $arg6 = "";

my $PROG_NAME = "PerlLib::HMMs::HMMER::hmmer.pl";


&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-arg1" || $ARGV[$counter] eq "-i"){
			$arg1 = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose" || $ARGV[$counter] eq "-v"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-arg2" || $ARGV[$counter] eq "-o"){
			$arg2 = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-kind" || $ARGV[$counter] eq "-k"){
			$kind = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-arg3"){
			$arg3 = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-arg4"){
			$arg4 = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-arg5" || $ARGV[$counter] eq "-t"){
			$arg5= $ARGV[$counter+1];
		}	
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";

	String->isEmpty($kind, "ERROR::".$PROG_NAME.":: Parameter -kind is required ");
	String->isEqual($verbose,"true,false", "ERROR:: verbose = [true, false]");

	print "-verbose = $verbose\n";
	print "-kind = $kind\n";
	print "ok\n";	
}	

############################ sub main ##################################
sub main{

	if ($kind == 1){
		#arg1 = pHMM file; arg2 = Number of sequence; arg3=outputFile; arg4=accNumber
		HMMER->createRandomSequences($arg1, " -N $arg2 ", $arg3, $arg4,$verbose);
	}elsif ($kind == 2){
		my $parameters = " --acc --cut_ga --domtblout $arg2".".out";
		#arg1 = pHMM file; arg2 = resultFile; arg3=sequence file; 
		HMMER->search($arg1, $arg2, $arg3, $parameters, "", $verbose);
	}elsif ($kind == 3){
		#formatting HMMscan result file for SSF format
		#arg1 = HMMscan result file; arg2 = output file; 
		HMMPfam->formatHmmscanSSF($arg1, $arg2, $verbose);
	}elsif ($kind == 4){
		#formatting HMMscan result file for CASH format
		#arg1 = HMMscan result file; arg2 = output file; arg3=cols to save; arg4=col domain !=-1 format domain
		HMMPfam->formatHmmscan($arg1, $arg2, $arg3, $arg4, $verbose);		
	}elsif ($kind == 5){
		#remove overlapping from same clan, you must run formatting HMMscan before.
		#arg1 = HMMscan result file; arg2 = file having ids of proteins; arg3 = output file; arg4= clan File;
		HMMPfam->removeOverlapClan($arg1, $arg2, $arg3, $arg4, $verbose);		
	}elsif ($kind == 6){
		#remove overlapping from same clan, you must run formatting HMMscan before.
		#arg1 = HMMscan result file; arg2= output file; 
	    HMMPfam->removeOverlap($arg1, $arg2, $verbose);		
	}
}