package HMMERSTRUCT;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use HMMs::HMMER::hmmer;
use File::Files;

my $linker_program		= "./LinkerHMMERPDB";

my %hash_sec = ();

##############################################################################

sub buildHmmerStruct {
	my $model_file_3d	= $_[1];
	my $nome_model		= $_[2];
	my $file_aln		= $_[3];
	my $file_mat 		= $_[4];
	my $parametes		= $_[5];
	my $path_hmmer_build= $_[6];
	
	$parametes     =  $parametes. " --pdb $file_mat ";
	
	#print $file_mat."\n";
	if (FilesIO->isFile($file_mat) eq "true" && FilesIO->isFile($file_aln) eq "true"){
		HMMER->buildModel($model_file_3d, $file_aln, $parametes, $path_hmmer_build);
		HMMER->renameModel($model_file_3d, $nome_model);	
    }else{
    	print "ERROR:: $file_mat or $file_aln NOT found\n";
    }	
}


##############################################################################

sub calibrateHmmerStruct {
	my $model_file_3d	= $_[1];
	my $parameters_calibrate = $_[2];
	my $path_hmmer_calibrate= $_[3];

	if (FilesIO->isFile($model_file_3d) eq "true"){
		HMMER->calibrateModel($model_file_3d, $parameters_calibrate ,$path_hmmer_calibrate);	
	}	
}

##############################################################################

sub runHmm3d {
	my $model_file_3d	= $_[1];
	my $family_id		= $_[2];
	my $result_file_3d	= $_[3];
	my $file_aln		= $_[4];
	my $file_mat 		= $_[5];
	my $db_new_file		= $_[6];
	my $parametes		= $_[7];	
   
	#print $file_mat."\n";
	if (FilesIO->isFile($file_mat) eq "true" && FilesIO->isFile($file_aln) eq "true"){
		HMMER->buildModel($model_file_3d, $file_aln, $parametes, $path_hmmer_build);
    }

	if (FilesIO->isFile($model_file_3d) eq "true"){
		HMMER->calibrateModel($model_file_3d, $parameters_calibrate ,$path_hmmer_calibrate);
		HMMER->renameModel($model_file_3d, $family_id.".3d");	
		HMMER->search($model_file_3d, $result_file_3d, $db_new_file, $parameters_search, $path_hmmer_search);
	}	
}

############################ sub runLinkerHmmer ##################################
sub runLinkerHmmer{
	my $aln_file_name		= $_[1];
	my $aln3d_file_name		= $_[2];
	my $path_linker			= $_[3];
	my $dir_mat_save		= $_[4];
	
	my $parameters	=  "-align_mammoth $aln_file_name -"."mammoth"."_pdb $aln3d_file_name";
	
	print $parameters."\n";


	if (FilesIO->isFile($aln_file_name) eq "false" || FilesIO->isFile($aln3d_file_name) eq "false"){
		print "ERROR:: Check files: \n $aln_file_name \n $aln3d_file_name \n";
		exit;
	}
	else{	
		my $cmd = $path_linker . $linker_program. " ".$parameters;
		print  "\n linker ". $cmd. "\n";
	    system $cmd;
	    my $mat_name   = FilesIO->getNameFile($aln_file_name);
	    my $ext = FilesIO->getExt($mat_name);
	    $mat_name =  String->replace($mat_name, $ext, "");
	    my $file_mat = 	FilesIO->getDirectory($aln_file_name).$mat_name."mat";
	    if (FilesIO->isFile($file_mat) eq "false"){
	    	print "ERROR:: File $file_mat NOT created\n";
	    	exit;
	    }	
	    print "File $file_mat created\n";
	    my $dir_to = $dir_mat_save;
	    
	    if (FilesIO->isDirectory($dir_to) eq "false"){
	    	FilesIO->createDirectory($dir_to);
	    }
	    $cmd = "mv $file_mat  $dir_to";
	    system $cmd;
	    
	    $file_mat = $dir_to.$mat_name."mat";
	    if (FilesIO->isFile($file_mat) eq "false"){
	    	print "ERROR:: File $file_mat NOT moved\n";
	    	exit;
	    }	
	     print "File $file_mat moved\n";
	}	
}

########################### sub createSecMatriz ####################################
sub createSecMatriz { 
 
  
  my $aln_file		= $_[1];
  my $list_joy		= $_[2];
  my $dir_mat_save	= $_[3];
  my $alpha_weigth    = $_[4];
  my $beta_weigth     = $_[5];
  my $phi_weigth      = $_[6];
  my $loop_weigth     = $_[7];

  my $mat_name   = FilesIO->getNameFile($aln_file);
  
  
  my $line          = "";
  my $sequenceJoy   = "";
  my $struct2dJoy   = "";
  my $start_pos;
  my $aux;
  my $new_seq;
  my $fileJoy      = "";
  my $filePdb      = "";
  my $key_aln      = "";
  my $value_aln    = "";
  my $key_sec      = "";
  my $value_sec    = "";
  my %hash_aln     = ();
  my $found_info   = "false";
  my $pdb_id       = "";
  my $info_aln = "CLUSTAL W (1.82) multiple sequence alignment\n";
  my $info_sec = "";
  
  my @array_file = ();
 
  my @array_info  = ();
  %hash_aln = Mammoth->loadAlign1d($aln_file);	
      
  my @array_joy = split(/\n/,$list_joy);
  foreach $line (@array_joy){
    $fileJoy = String->removeCaracter($line,"\n");
    $sequenceJoy = Joy->getSequence($fileJoy);
    $struct2dJoy = Joy->getSecundaryStruct($fileJoy);
    
    while (($key_aln, $value_aln) = each(%hash_aln)){
      $aux = String->removeCaracter($value_aln,"-");
      $aux = uc($aux);
      $new_seq =String->removeCaracter($sequenceJoy,"-"); 
      $new_seq = uc($new_seq);
      
      if (index($new_seq, $aux) >= 0) {
        $found_info = "true";
        $start_pos = index(uc($new_seq), $aux); 
        my $sec = Joy->getAlign($value_aln, $struct2dJoy, $start_pos);
        my $info_struc = Joy->convertSecundaryToNumbers($sec, $alpha_weigth, $beta_weigth, $phi_weigth, $loop_weigth);
        $hash_sec{$key_aln} = $info_struc; 
      }
 
    }
    if ($found_info eq "false"){
        #$info_log .= "Lost $id_family $line\n";
	print "Lost $id_family $line\n";
    }
    $found_info = "false";
  }
 
  &saveStructMatriz($dir_mat_save."$mat_name.2d");
  FilesIO->sortFile($dir_mat_save."$mat_name.2d",$dir_mat_save."$mat_name.2dsort", 0);
  my @array_sec = FilesIO->lineFileToArray($dir_mat_save."$mat_name.2dsort");
  FilesIO->copyFile($dir_mat_save."$mat_name.2dsort", $dir_mat_save."$mat_name.2d");
  FilesIO->removeFile($dir_mat_save."$mat_name.2dsort"); 	
   
 }
 
 ########################### sub createAccSolMatriz ####################################
sub createAccSolMatriz { 
 
  my $aln_file		= $_[1];
  my $list_joy		= $_[2];
  my $dir_mat_save	= $_[3];
  my $acc_weigth	= $_[4];
  my $no_acc_weigth = $_[5];

  my $mat_name   = FilesIO->getNameFile($aln_file);
   
  
  my $line          = "";
  my $sequenceJoy   = "";
  my $struct2dJoy   = "";
  my $start_pos;
  my $aux;
  my $new_seq;
  my $fileJoy      = "";
  my $key_aln      = "";
  my $value_aln    = "";
  my $key_sec      = "";
  my $value_sec    = "";
  my %hash_aln     = ();  
  my $found_info   = "false";
  my $pdb_id       = "";
  my $info_sec = "";
    

  my @array_info  = ();
  
  %hash_aln = Mammoth->loadAlign1d($aln_file);	
  
  my @array_joy = split(/\n/,$list_joy);
  foreach $line (@array_joy){
    $fileJoy = String->removeCaracter($line,"\n");
    $sequenceJoy = Joy->getSequence($fileJoy);
    $struct2dJoy = Joy->getSolventAccessibility($fileJoy);
    
    while (($key_aln, $value_aln) = each(%hash_aln)){
      $aux = String->removeCaracter($value_aln,"-");
      $aux = uc($aux);
      $new_seq =String->removeCaracter($sequenceJoy,"-"); 
      $new_seq = uc($new_seq);
   
      if (index($new_seq, $aux) >= 0) {
        $found_info = "true";
        $start_pos = index(uc($new_seq), $aux); 
        my $sec = Joy->getAlign($value_aln, $struct2dJoy, $start_pos);
        my $info_struc = Joy->convertAccessibilityToNumbers($sec, $acc_weigth, $no_acc_weigth);
        #print $value_aln."\n";
        #print $info_struc."\n";
        $hash_sec{$key_aln} = $info_struc; 
      } 
    }
      if ($found_info eq "false"){
        $info_log .= "ERROR:: Lost $id_family $line\n";
    }
    $found_info = "false";
   
  }
  
  &saveStructMatriz($dir_mat_save."$mat_name.acc");
  FilesIO->sortFile($dir_mat_save."$mat_name.acc",$dir_mat_save."$mat_name.accsort", 0);
  my @array_sec = FilesIO->lineFileToArray($dir_mat_save."$mat_name.accsort");
  FilesIO->copyFile($dir_mat_save."$mat_name.accsort", $dir_mat_save."$mat_name.acc");
  FilesIO->removeFile($dir_mat_save."$mat_name.accsort"); 
}

########################### sub createOiNumberMatriz ####################################
sub createOiNumberMatriz { 
 
  
  my $aln_file		= $_[1];
  my $list_joy		= $_[2];
  my $dir_mat_save	= $_[3];
  
  my $mat_name   = FilesIO->getNameFile($aln_file);
   
  
  my $line          = "";
  my $sequenceJoy   = "";
  my $struct2dJoy   = "";
  my $start_pos;
  my $aux;
  my $new_seq;
  my $fileJoy      = "";
  my $key_aln      = "";
  my $value_aln    = "";
  my $key_sec      = "";
  my $value_sec    = "";
  my %hash_aln     = ();  
  my $found_info   = "false";
  my $pdb_id       = "";
  my $info_sec = "";
    
  my @array_info  = ();
  
  
  %hash_aln = Mammoth->loadAlign1d($aln_file);	
  
  my @array_joy = split(/\n/,$list_joy);
  foreach $line (@array_joy){
    $fileJoy = String->removeCaracter($line,"\n");
    $sequenceJoy = Joy->getSequence($fileJoy);
    $struct2dJoy = Joy->getOoiNumber($fileJoy);
    
    while (($key_aln, $value_aln) = each(%hash_aln)){
      $aux = String->removeCaracter($value_aln,"-");
      $aux = uc($aux);
      $new_seq =String->removeCaracter($sequenceJoy,"-"); 
      $new_seq = uc($new_seq);
   
      if (index($new_seq, $aux) >= 0) {
        $found_info = "true";
        $start_pos = index(uc($new_seq), $aux); 
        my $sec = Joy->getOiNumberAlign($value_aln, $struct2dJoy, $start_pos);
        my $info_struc = Joy->convertOiNumberToNumbers($sec);
        #print $value_aln."\n";
        #print $info_struc."\n";
        $hash_sec{$key_aln} = $info_struc; 
      }      
    }
      if ($found_info eq "false"){
        $info_log .= "Lost $id_family $line\n";
    }
    $found_info = "false";
    
  }
  
  &saveStructMatriz($dir_mat_save."$mat_name.oi");
  FilesIO->sortFile($dir_mat_save."$mat_name.oi",$dir_mat_save."$mat_name.oisort", 0);
  my @array_sec = FilesIO->lineFileToArray($dir_mat_save."$mat_name.oisort");
  FilesIO->copyFile($dir_mat_save."$mat_name.oisort", $dir_mat_save."$mat_name.oi");
  FilesIO->removeFile($dir_mat_save."$mat_name.oisort");

}

 ########################### sub saveStructMatriz ####################################
sub saveStructMatriz { 
  my $sec_file		= $_[0];
  my $key_sec;
  my $value_sec;
  my $info = "";
  
  while (($key_sec, $value_sec) = each(%hash_sec)){
     $info .=$key_sec."\t". $value_sec."\n";   
   }
   #print $info;
   FilesIO->saveFile($sec_file,$info);
 }
 

 
1
