package HMMPfam;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use String::StringUtil;
use File::Files;
use Sequence::Domain;
use strict;
use Database::PFAM;


my $pfam_hmm = "./hmmpfam";
my $PROG_NAME = "perlLib::HMMs::HMMER::hmmspfam::";
my $space = " ";

my $C_EV = "11";
my $C_SCORE = "7";
my $C_START_Q = "17";
my $C_END_Q = "18";
my $C_START_M = "15";
my $C_END_M = "16";
my $C_QUERY = "3";
my $C_DOMAIN = "1";
my $C_DOMAIN_NAME = "0";
my $C_IDENTITY = "20";

my @array_hits = ();

my @mat_hits		= ([],[]);
my @array_sorted	= ();
############################ sub clearHmmPfamOut ##############################
sub clearHmmPfamOut {
	my $path_in		= $_[1];
	my $path_out		= $_[2];
        my $ev_cutoff		= $_[3];
	my $first_line		= $_[4];
	
	my @results		= ();
	my $item 		= "";
	my $qtd_results		= 0;
	my $count		= 0;
	my $hit			= "false";
	
	my $ind_seq		= 0;
	my $ind_des		= 4;
	my $ind_model		= 1;
	my $ind_score		= 2;	
	my $ind_evalue		= 3;
	my $count_hits		= 0;
	my $sequence		= "";
	my $description		= "";
	
	my @array_aux		= ();
	
	my $info;
	
	if (open(FILEG,"$path_in")){
		@results = <FILEG>;
		$qtd_results = scalar(@results);
		print $qtd_results . "\n";
		while ($count < $qtd_results){
			if ($results[$count]=~ /^Query +sequence/){
				@array_aux = split(/:/,$results[$count]);
				if (scalar(@array_aux) == 2){
					$sequence = String->removeCaracter(substr($array_aux[1],0,index($array_aux[1],"\n"))," ");
				}
				else{
					print "Error bad format\n"; exit;
				}
			}
			elsif ($results[$count]=~ /^Description:/) {
				$description = substr($results[$count],index($results[$count],":")+1, length($results[$count]));
				$description = substr($description,0,index($description,"\n"));
				$description = String->trim($description);
			}elsif ($results[$count]=~ /^Model +Description/){
				$count +=2;
				if (index($results[$count],"no hits above thresholds") < 0){
					@array_aux = split(/ +/,$results[$count]);
					while (scalar(@array_aux) == 4){
						$mat_hits[$ind_seq][$count_hits] = $sequence;
						$mat_hits[$ind_des][$count_hits] = $description;
						$mat_hits[$ind_model][$count_hits] = $array_aux[0];
						$mat_hits[$ind_score][$count_hits] = $array_aux[1];
						$mat_hits[$ind_evalue][$count_hits] = $array_aux[2];
						$count++;$count_hits++;
						@array_aux = split(/ +/,$results[$count]);
					}	
				}
			}
			$count++;
		}
                $info = printMatToSort(5,$count_hits,$ev_cutoff,$ind_des,$ind_evalue);
		FilesIO->saveFile($path_out.".tmp",$info);
		FilesIO->sortFile($path_out.".tmp",$path_out.".tmp.sorted",3);		
		@array_sorted = FilesIO->fileToArray($path_out.".tmp.sorted","\t", 0);
		FilesIO->removeFile($path_out.".tmp"); 
		FilesIO->removeFile($path_out.".tmp.sorted");
		if ($first_line eq "true"){
			$info = printMatSortedFirstLine(5,$count_hits,$ev_cutoff,$ind_evalue);
		}
		else{
			$info = printMatSorted(5,$count_hits,$ev_cutoff,$ind_evalue);
		}
		FilesIO->saveFile($path_out,$info);
		close FILEG;
	}	
	else{
		print "ERROR: file $path_in not found\n";
	}	
}

############################ sub printMatSorted ##############################
sub printMatSorted {
	my $cols	= $_[0];
	my $rows	= $_[1];
	my $ev_cutoff	= $_[2];
	my $ind_ev	= $_[3];
        
        my $seq_new 	= "";
	my $seq_old	= "";
	my $ev;
	my $info	= "";
	my $item;
	my $found	= "false";
	
	my $i = -1;
	my $j = 0;
	
	
	foreach $item (@array_sorted){
		while ($i < $rows && $found eq "false"){
			$i++;
			if ($item eq $mat_hits[0][$i]){
				$found = "true";
			}
		}
		
		$ev	 = $mat_hits[$ind_ev][$i];
		
		do{
			$seq_new = $mat_hits[0][$i];
			if ($ev < $ev_cutoff) {	
				for ($j = 0; $j < $cols; $j++){
					#if ($seq_new ne $seq_old && $j==0){
					#	$info.= $mat_hits[0][$i]. "\t";
					#}
					#elsif ($j == 0){$info.= "\t\t\t";}
					#else{
						$info.= $mat_hits[$j][$i]. "\t";
					#}
				}
				$seq_old = $seq_new;
				$info.= "\n";
			}
			$i++;
		}while($mat_hits[0][$i] eq $item);
		$found	= "false";$i= -1;
			
	}
	return $info;
}
############################ sub printMatSorted ##############################
sub printMatSortedFirstLine {
	my $cols	= $_[0];
	my $rows	= $_[1];
	my $ev_cutoff	= $_[2];
	my $ind_ev	= $_[3];
        
        my $seq_new 	= "";
	my $seq_old	= "";
	my $ev;
	my $info	= "";
	my $item;
	my $found	= "false";
	
	my $i = -1;
	my $j = 0;
	
	
	foreach $item (@array_sorted){
		while ($i < $rows && $found eq "false"){
			$i++;
			if ($item eq $mat_hits[0][$i]){
				$found = "true";
			}
		}
		
		$ev	 = $mat_hits[$ind_ev][$i];
		
		$seq_new = $mat_hits[0][$i];
		if ($ev < $ev_cutoff) {	
			for ($j = 0; $j < $cols; $j++){
				if ($seq_new ne $seq_old && $j==0){
					$info.= $mat_hits[0][$i]. "\t";
				}
				elsif ($j == 0){$info.= "\t\t\t";}
				else{
					$info.= $mat_hits[$j][$i]. "\t";
				}
			}
			$seq_old = $seq_new;
			$info.= "\n";
		}
		$found	= "false";$i= -1;			
	}
	return $info;
}

############################ sub clearHmmPfamOut ##############################
sub printMat {
	my $cols	= $_[0];
	my $rows	= $_[1];
	my $ev_cutoff	= $_[2];
	my $ind_ev	= $_[3];
        
        my $seq_new 	= "";
	my $seq_old	= "";
	my $ev;
	my $info	= "";
	
	my $i = 0;
	my $j = 0;
	
	for ($i = 0; $i < $rows; $i++){
		$seq_new = $mat_hits[0][$i];
		$ev	 = $mat_hits[$ind_ev][$i];
		
		if ($ev < $ev_cutoff) {
			for ($j = 0; $j < $cols; $j++){
				if ($seq_new ne $seq_old && $j==0){
					$info.= $mat_hits[0][$i]. "\t";
				}
				elsif ($j == 0){$info.= "\t\t\t";}
				else{
					$info.= $mat_hits[$j][$i]. "\t";
				}
			}
			$seq_old = $seq_new;
			$info.= "\n";
		}
	}
	return $info;
}
############################ sub clearHmmPfamOut ##############################
sub printMatToSort {
	my $cols	= $_[0];
	my $rows	= $_[1];
	my $ev_cutoff	= $_[2];
        my $with_out	= $_[3];
	my $ind_ev	= $_[4];
        
        my $seq_new 	= "";
	my $seq_old	= "";
	my $ev;
	my $info	= "";
	
	my $i = 0;
	my $j = 0;
	
	for ($i = 0; $i < $rows; $i++){
		$seq_new = $mat_hits[0][$i];
		$ev	 = $mat_hits[$ind_ev][$i];
		if ($ev < $ev_cutoff) {
			for ($j = 0; $j < $cols; $j++){
				if ($seq_new ne $seq_old && $j != $with_out){
                                   $info.= $mat_hits[$j][$i]. "\t";
                                }
                        }
			if ($seq_new ne $seq_old){
				$info.= "\n";
			}
			$seq_old = $seq_new;	
		}
			
	}
	return $info;
}

############################ sub clearHmmPfamOut ##############################
sub getResults {

	my $result_file		= $_[1];
	my $ev_cut_off		= $_[2];
	my $num_models		= $_[3];
	
	

	my $entry;
	my @array_line  = ();
	my @array  = ();
	my $id_protein = "";
	my @info = ();
	my $result;

	if (FilesIO->isFile($result_file) eq "true") {
		@array_line = FilesIO->lineFileToArray($result_file);
		foreach $entry (@array_line) {
			@array = split(/\t/, $entry);
			if (($array[0] ne $id_protein) && $id_protein ne ""){
				$result = &analyseResult($ev_cut_off, $num_models);
				if ($result ne ""){
					push(@info, $result);	
				}		
				@array_hits = ();
			}
			
			push(@array_hits, $entry);
			
			$id_protein = $array[0];
			#@array_hits
		}
		$result = &analyseResult($ev_cut_off, $num_models);
		if ($result ne ""){
			push(@info, $result);	
		}
		
		
	}else{
		print "ERRO:: File $result_file not found!\n"
	}
	return @info;

}


############################ sub clearHmmPfamOut ##############################
sub analyseResult{
	my $ev_cut_off		= $_[0];
	my $num_models		= $_[1];

	my $entry;
	my @array = ();
	
	#print "\n--------------------------------------------------\n";
	#print @array_hits;
	#print "\n--------------------------------------------------\n";
	if (scalar(@array_hits) >= $num_models){
		foreach $entry (@array_hits) {
			@array = split(/\t/, $entry);
			#print "ev = $array[3] \n";
			if ($array[3] <= $ev_cut_off){
				return $entry;
			}
		}
	}
	return "";
	
}

############################ sub clearHmmPfamOut ##############################
sub run {

	my $model_file		= $_[1];
	my $result_file		= $_[2];
	my $db_file		= $_[3];
	my $parameters		= $_[4];
        my $path_program	= $_[5];
	
	my $cmd = $path_program. $pfam_hmm. $space. $parameters. $space . $model_file. $space. $db_file. $space. ">". $space. $result_file;
	print $cmd."\n";
	system($cmd);
}


############################ sub clearHmmPfamOut ##############################
sub getResultpfam{
	my $result_file		= $_[1];
	my $entry;
	my @array;
	my @array_result = ();
	
	
	my @hmmPfam_ids =FilesIO->lineFileToArray($result_file); 
	
	foreach $entry (@hmmPfam_ids) {
		@array = split(/\t/, $entry);
		if (scalar(@array) >4){
			push (@array_result, $array[0]."\t".$array[1]."\t".$array[3]);
		}		
	}
	return @array_result;
	
}

############################ sub clearHmmPfamOut ##############################
sub formatHmmscanSSF{
	my $inputFile		= $_[1];
	my $outputFile		= $_[2];
	my $verbose			= $_[3];
	my $fttDomain =  "true";
	
	
	my $cols = "3:1:5:2:18:16:19:20:15:16:11:13:14";
	
	my $line;			my $info = "";
	my @array = ();		my $interval;
	my $count = 0;
	
	if (open(FILEIN, "$inputFile")){
		while (my $line = <FILEIN>) {
			
			$line =~ s/\n//g;		
			if (index($line, "#") < 0){
				
				@array = split(/ +/, $line);
				@array = Array->getPositionsArray($cols, \@array);
				if ($fttDomain eq "true"){
					$array[1] = PFAM->getAccNumber($array[1]);
					#print $array[1]."\n";
					#exit;
				}
				$interval = $array[6].":".$array[7];
				$info .= Array->printArray("\t",\@array)."\t1\t".$interval."\n";
				$count++;
			}
			if ($count == 10000){
				FilesIO->apendFile($outputFile, $info, $verbose);
				$info = ""; $count= 0;
			}
		}
		if ($info ne ""){
			FilesIO->apendFile($outputFile, $info, $verbose);
		}
		
	}else{
		print $PROG_NAME."::ERROR::File $inputFile NOT found\n";
	}
}

############################ sub clearHmmPfamOut ##############################
sub formatHmmscan{
	my $inputFile		= $_[1];
	my $outputFile		= $_[2];
	my $cols			= $_[3];
	my $col_domain		= $_[4];
	my $verbose			= $_[5];
	

	my $line;			my $info = "";
	my @array = ();		my $domain;
	my $count = 0;		my $countTotal = 0;
	
	if (FilesIO->isFile($outputFile) eq "true"){
		FilesIO->removeFile($outputFile, $verbose);
	}
	
	if ($cols eq ""){
		$cols = "$C_EV:$C_START_Q:$C_END_Q:$C_QUERY:$C_DOMAIN:$C_START_M:$C_END_M:$C_SCORE:$C_DOMAIN_NAME";
		$col_domain = 4;
	}
	
	if (open(FILEIN, "$inputFile")){
		while (my $line = <FILEIN>) {
			
			$line =~ s/\n//g;		
			if (index($line, "#") < 0){
				
				#$line =~ s/ +//g;
				@array = split(/ +/, $line);					
				@array = Array->getPositionsArray($cols, \@array);
				if ($col_domain > -1){
					$domain = $array[$col_domain];
					$domain = (split(/\./, $domain))[0];
					$array[$col_domain] = $domain;
				}
				$info .= Array->printArray("\t",\@array)."\n";
				$count++;
			}
			if ($count == 10000){
				FilesIO->apendFile($outputFile, $info, $verbose);
				$countTotal += $count;
				print "LOG::Saved ". $countTotal. "\n";
				$info = ""; $count= 0;
				
			}
		}
		if ($info ne ""){
			FilesIO->apendFile($outputFile, $info, $verbose);
		}
		
	}else{
		print $PROG_NAME."::ERROR::File $inputFile NOT found\n";
	}
}


############################ sub clearHmmPfamOut ##############################
sub removeOverlapClan{
	my $inputFile		= $_[1];
	my $idsFile			= $_[2];
	my $outputFile		= $_[3];
	my $clanFile		= $_[4];
	my $verbose			= $_[5];
	
	
	my $line;			my $info = "";
	my @array = ();		my $domain;
	my $count = 0;		my @array_aux;
	my $new_info = "";	my $count = 0;
	my $countTotal = 0;
	
	if (FilesIO->isFile($outputFile) eq "true"){
		FilesIO->removeFile($outputFile, $verbose);
	}
	
	@array = FilesIO->fileToArray2d($idsFile, "\t");
	
	for (my $i = 0; $i < scalar(@array); $i++){
		$info = FilesIO->getLineInFile($inputFile, $array[$i][0], $verbose);
		
		if ($info ne ""){
			@array_aux = String->StringToArray2d($info, "\n", "\t");
			@array_aux = Array->sortArray2d(0, \@array_aux);
			@array_aux = Domain->removeOverlapSameClan(0, 0, "", $clanFile, \@array_aux);
			$new_info .= Array->printMatrix2("\t", "\n", \@array_aux);
			$count++;
		}
		if ($count == 10000){
				FilesIO->apendFile($outputFile, $new_info, $verbose);
				$countTotal += $count;
				print "LOG::Saved ". $countTotal. "\n";
				$new_info = ""; $count= 0;
		}	
	}
	if ($new_info ne ""){
		FilesIO->apendFile($outputFile, $new_info, $verbose);
	}
}
	

############################ sub clearHmmPfamOut ##############################
sub removeOverlap{
	my $inputFile		= $_[1];
	my $outputFile		= $_[2];
	my $verbose			= $_[3];
	
	
	my $line;			my $info = "";
	my @array = ();		my $domain;
	my $count = 0;		my @array_aux = ();
	my $new_info = "";	my $count = 0;
	my $countTotal = 0; my $accNumber;
	my $accNumberOld = "";
	
	if (FilesIO->isFile($outputFile) eq "true"){
		FilesIO->removeFile($outputFile, $verbose);
	}
	
	@array = FilesIO->fileToArray2d($inputFile, "\t");
	
	for (my $i = 0; $i < scalar(@array); $i++){
		$accNumber = $array[$i][3];
		#print $accNumber."\t".$accNumberOld."\n";
		if ($accNumber ne $accNumberOld && $accNumberOld ne ""){
			
			#print Array->printMatrix2("\t", "\n", \@array_aux);
			@array_aux = Array->sortArray2d(0, \@array_aux);
			@array_aux = Domain->removeOverlapHit(0, 0, "", \@array_aux);
			#print "\nafter\n".Array->printMatrix2("\t", "\n", \@array_aux);
			$new_info .= Array->printMatrix2("\t", "\n", \@array_aux);
			$count++;
			@array_aux = ();
		}
		
		push(@array_aux, $array[$i]);
		
		$accNumberOld = $accNumber;
		if ($count == 10000){
				FilesIO->apendFile($outputFile, $new_info, $verbose);
				$countTotal += $count;
				print "LOG::Saved ". $countTotal. "\n";
				$new_info = ""; $count= 0;
		}	
	}
	@array_aux = Array->sortArray2d(0, \@array_aux);
	@array_aux = Domain->removeOverlapHit(0, 0, "", \@array_aux);
	$new_info .= Array->printMatrix2("\t", "\n", \@array_aux);
	if ($new_info ne ""){
		FilesIO->apendFile($outputFile, $new_info, $verbose);
	}
}
	
1
