package Predicate;
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}


use ILP::predicate;
use Sequence::protein;
use Sequence::sequence;



############################ sub create ####################################
sub createPercent{
	my $sequence		 = $_[1];
	my $proteinName		 = $_[2];
	my $predicateName	 = $_[3];
  	my $set	 			 = $_[4];
  	my $discretization_value		 = $_[5];
  	my $percMin			 = $_[6];
  	
  	my $entry_seq;
  	my $entry_set;
  	my $count = 0;
  	my $perc;
  	my $info = "";
  	
  	my $len_seq = length($sequence);
  	my @array_seq = split(//, $sequence);
  	my @array_set = split(//, $set);
  	
  	foreach $entry_set (@array_set){
  		foreach $entry_seq (@array_seq){
  			if (uc($entry_seq) eq uc($entry_set)){
  				$count++;
  			}  		
  		}  		
  	}
  	
  	if ($count != 0){
  			$perc = ($count / $len_seq) * 100;
  			if ($perc > $percMin){
  				$info .= $predicateName."(".$proteinName.",". Predicate->discretization($perc, $discretization_value).")\n";
  			}  			
  	}
  	return $info;
}

############################ sub create ####################################
sub createPercentPropositional{
	my $sequence		 = $_[1];
	my $proteinName		 = $_[2];
	my $predicateName	 = $_[3];
  	my $set	 			 = $_[4];
  	my $kind_discretization		 = $_[5];
  	
  	my $entry_seq;
  	my $entry_set;
  	my $count = 0;
  	my $perc;
  	my $info = "";
  	
  	my $len_seq = length($sequence);
  	my @array_seq = split(//, $sequence);
  	my @array_set = split(//, $set);
  	
  	foreach $entry_set (@array_set){
  		foreach $entry_seq (@array_seq){
  			if (uc($entry_seq) eq uc($entry_set)){
  				$count++;
  			}  		
  		}  		
  	}
  	
  	if ($count != 0){
  			$perc = ($count / $len_seq) * 100;
  			if ($kind_discretization == 10){
  				$info .= $predicateName.Predicate->discretization_10($perc)."(".$proteinName.")\n";
  			}else{
  				$info .= $predicateName.Predicate->discretization_5($perc)."(".$proteinName.")\n";
  			}
  	}
  	return $info;
}


############################ sub create ####################################
sub createAminoacidPairRatio{
	my $sequence		 = $_[1];
	my $proteinName		 = $_[2];
	my $predicateName	 = $_[3];
	my $percMin			 = $_[4];
	my $percMax			 = $_[5];
	my $discretization_value		 = $_[6];
	
	
	my $entry_aa1;
	my $entry_aa2;
	my $perc_disc;
	
	my $pair;
	my $count_pair;
	my $perc;
	my $info = "";

	
	my @array_seq = split(//, $sequence);
	my $len_seq = length($sequence);
	my @amino = Protein->getAmino1d;
	
	foreach $entry_aa1 (@amino){
		foreach $entry_aa2 (@amino){
			$count_pair = 0;
		
			#print "pair $entry_aa1$entry_aa2 ";
			for (my $i=0; $i < scalar(@array_seq) -1; $i++){
				$pair = $array_seq[$i].$array_seq[$i+1];
				if (uc($pair) eq uc($entry_aa1.$entry_aa2)){
					$count_pair++;
				}				
			}
			#print "$count_pair ";
			
			if ($count_pair >= 1){
				$perc = ($count_pair / ($len_seq -1)) * 100;
			#	print "$perc ";
				$perc_disc = Predicate->discretization($perc, $discretization_value);
			#	print "$perc ";
			 	if($perc >= $percMin && $perc <= $percMax){
			 		$info .= $predicateName."(".$proteinName.",". $entry_aa1.$entry_aa2.",". $perc_disc.")"."\n";
			 		#$info .= $predicateName."(".$proteinName.",". $entry_aa1.$entry_aa2.",". $count_pair.")"."\n";
			 		#$info .= $predicateName."(".$proteinName.",". $entry_aa1.$entry_aa2.",1)"."\n";
			#		print " $info ";
				}
			}
			#print "\n";			
		}
	}
	return $info;
	
}

############################ sub create ####################################
sub createAminoacidRatio{
	my $sequence		 = $_[1];
	my $proteinName		 = $_[2];
	my $predicateName	 = $_[3];
	my $percMin			 = $_[4];
	my $percMax			 = $_[5];
	my $kind_discretization		 = $_[6];
	
	
	my $entry_aa1;
	my $entry_aa;
	my $perc_disc;
	
	my $pair;
	my $count;
	my $perc;
	my $info = "";

	
	my @array_seq = split(//, $sequence);
	my $len_seq = length($sequence);
	my @amino = Protein->getAmino1d;
	
	foreach $entry_aa (@amino){
		$count = 0;
		for (my $i=0; $i < scalar(@array_seq) -1; $i++){
			if (uc($array_seq[$i]) eq uc($entry_aa) ) {
				$count++;
			}				
		}
		
		if ($count >= 1){
			$perc = ($count / ($len_seq -1)) * 100;
			#print "$perc ";
			if ($kind_discretization == 10){
				$perc_disc = Predicate->discretization_10($perc);
			}else{
				$perc_disc = Predicate->discretization_5($perc);
			}
			#print "$perc ";
		
		 	if($perc >= $percMin && $perc <= $percMax){
			 		$info .= $predicateName."(".$proteinName.",". $entry_aa.",". $perc_disc.")"."\n"
			}
			#print "\n";			
		}
	}
	return $info;
	
}
############################ sub create ####################################
sub createLengthSequence{
	my $sequence		 = $_[1];
	my $proteinName		 = $_[2];
	my $predicateName	 = $_[3];

	my $lenseq = Sequences->lengthSequence($sequence);
	
	my $div = int($lenseq/10) +1;
	my $info .= $predicateName."(".$proteinName.",". $div.")"."\n";
	return $info;
}

############################ sub create ####################################
sub createAminoacidPairRatioPropositional{
	my $sequence		 = $_[1];
	my $proteinName		 = $_[2];
	my $predicateName	 = $_[3];
	my $percMin			 = $_[4];
	my $percMax			 = $_[5];
	my $kind_discretization		 = $_[6];
	
	
	my $entry_aa1;
	my $entry_aa2;
	my $perc_disc;
	
	my $pair;
	my $count_pair;
	my $perc;
	my $info = "";

	
	my @array_seq = split(//, $sequence);
	my $len_seq = length($sequence);
	my @amino = Protein->getAmino1d;
	
	foreach $entry_aa1 (@amino){
		foreach $entry_aa2 (@amino){
			$count_pair = 0;
		
			#print "pair $entry_aa1$entry_aa2\n";
			for (my $i=0; $i < scalar(@array_seq) -1; $i++){
				$pair = $array_seq[$i].$array_seq[$i+1];
				if (uc($pair) eq uc($entry_aa1.$entry_aa2)){
					$count_pair++;
				}				
			}
			#print "$count_pair ";
			
			if ($count_pair > 1){
				$perc = ($count_pair / ($len_seq -1)) * 100;
				#print "$perc ";
				if ($kind_discretization == 10){
					$perc_disc = Predicate->discretization_10($perc);
				}else{
					$perc_disc = Predicate->discretization_5($perc);
				}
				#print "$perc \n";
			 	if($perc >= $percMin && $perc <= $percMax){
					$info .= $predicateName. $entry_aa1.$entry_aa2.$perc_disc."(".$proteinName.")"."\n";
					#print " $info ";
				}
			}
			#print "\n";			
		}
	}
	return $info;
	
}
############################ sub create ####################################
sub discretization{
	my $value		 			= $_[1];
	my $discretization_value	= $_[2];
	
	my $y = int($value/$discretization_value) + 1;
	
	return $y;
	
}

############################ sub create ####################################
sub discretization_10{
	my $value		 = $_[1];
	
	if ($value> 0 && $value <= 10){
		return 1;
	}elsif ($value> 10 && $value <= 20){
		return 2;
	}elsif($value> 20 && $value <= 30){
		return 3;
	}elsif($value> 30 && $value <= 40){
		return 4;
	}elsif($value> 40 && $value <= 50){
		return 5;
	}elsif($value> 50 && $value <= 60){
		return 6;
	}elsif($value> 60 && $value <= 70){
		return 7;
	}elsif($value> 70 && $value <= 80){
		return 8;
	}elsif($value> 80 && $value <= 90){
		return 9;
	}elsif($value> 90 && $value <= 100){
		return 10;
	}
}

############################ sub create ####################################
sub discretization_5{
	my $value		 = $_[1];
	
	if ($value> 0 && $value <= 20){
		return 1;
	}elsif ($value> 20 && $value <= 40){
		return 2;
	}elsif($value> 40 && $value <= 60){
		return 3;
	}elsif($value> 60 && $value <= 80){
		return 4;
	}elsif($value> 80 && $value <= 100){
		return 5;
	}
}

############################ sub create ####################################
sub createPredBySeqAlignPropositional{
	my $seq_aligned		 = $_[1];
	my $name_protein	 = $_[2];
	my $info = "";
	
	my @array = split(//, $seq_aligned);
	
	for (my $i = 0; $i< scalar(@array); $i++){
		if ($array[$i] ne "-"){
			$info .= "col".$i."_".$array[$i]."(".$name_protein.")\n";
		}
	}
	return $info;

}

############################ sub create ####################################
sub createPredBySeqAlignFirstOrder{
	my $seq_aligned		 = $_[1];
	my $name_protein	 = $_[2];
	my $info = "";
	
	my @array = split(//, $seq_aligned);
	
	for (my $i = 0; $i< scalar(@array); $i++){
		if ($array[$i] ne "-"){
			$info .= "col(".$name_protein.",".$i.",".$array[$i].")\n";
		}
	}
	return $info;

}

############################ sub create ####################################
sub createPredicateEvalue{
	my $sequence		 = $_[1];
	my $evalue			 = $_[2];
	my $sequenceList	 = $_[3];

	my $output = $sequence.".output.blast";
	my @array_sequences = FilesIO->lineFileToArray($sequenceList);		
}

############################ sub run ##################################
sub getTermsFromPredicate {
	my $predicate		= $_[1];
	
	my @array = split(/\(/, $predicate);
	$predicate = String->removeCaracter($array[1], ")");
	$predicate = String->removeCaracter($predicate, ".");
	$predicate = String->removeCaracter($predicate, "\n");
	@array = split(/,/, $predicate);
	return @array;	
}

############################ sub run ##################################
sub getNamePredicate {
	my $predicate		= $_[1];
	
	my @array = split(/\(/, $predicate);
	my $name_predicate = $array[0];
	
	return $name_predicate;	
}


1
