#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Util::Hash;
use Util::Array;
use Util::Number;
use KNN::knn;

my $testFile = "";
my $trainFile = "";
my $verbose = "false";
my $outputFile = ""; 
my $k = 5;
my $weightAtt = "";
my $classAtt  = 2;
my $leaveOneOut = "false";
my $tmpDir = "";

my $PROG_NAME = "PerlLib::KNN::weightKnn.pl";


&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-trainFile" || $ARGV[$counter] eq "-tr"){
			$trainFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile" || $ARGV[$counter] eq "-o"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-testFile" || $ARGV[$counter] eq "-te"){
			$testFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-k"){
			$k = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-weightAtt"){
			$weightAtt = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-classAtt"){
			$classAtt = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-leaveOneOut"){
			$leaveOneOut = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-tmpDir"){
			$tmpDir = $ARGV[$counter+1];		
		}
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";	
	
	String->isEmpty($trainFile, "ERROR::".$PROG_NAME.":: Parameter -trainFile having training file is required.");	
	FilesIO->checkFile($trainFile, "ERROR::".$PROG_NAME.":: File NOT found ".$trainFile);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false.");
	if ($leaveOneOut eq "false"){
		String->isEmpty($testFile, "ERROR::".$PROG_NAME.":: Parameter -testFile having test file is required.");	
		FilesIO->checkFile($testFile, "ERROR::".$PROG_NAME.":: File NOT found ".$testFile);	
		print "-testFile = $testFile\n";
	}
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required it must contain the output file.");	
	String->isEmpty($tmpDir, "ERROR::".$PROG_NAME.":: Parameter -tmpDir is required it must contain the temporary directory name.");	
	FilesIO->createDirectory($tmpDir);

	print "-trainFile = $trainFile\n";
	print "-testFile = $testFile\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "-classAtt = $classAtt\n";
	print "-weightAtt = $weightAtt\n";	
	print "-k = $k\n";
	print "-tmpDir = $tmpDir\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $ignoreAttTest = $weightAtt;
	
	print "Weight kNN\t". KNN->leaveOneOut($trainFile, $k, "", $ignoreAttTest, $weightAtt, $classAtt, $tmpDir, $verbose)."\n";
	#print "Normal kNN\t". KNN->leaveOneOut($trainFile, $k, "", $ignoreAttTest, "", 		   $classAtt, $tmpDir, $verbose)."\n";
	
}