#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Array;
use Plot::gnuplot;



my $headFile = "";
my $outputFile = "";
my $verbose = "false";
my $counter = 0;
my $ending_value = scalar(@ARGV);
my @fileListParameters = ();


my $PROG_NAME = "PERL_LIB::Plot::createPlotGnuplot.pl";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
    $counter = 0;		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-head"){
			$headFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		} elsif($ARGV[$counter] eq "-fileList"){
			$counter++;
			@fileListParameters = &getparametersScript("-fileList");				
		}	
	}
}
############################ sub getparametersScript ##################################
sub getparametersScript {
	my $name_parameter			= $_[0];	
	my $parameters_info = "";
	my @parameters = ();
	my $i = 0;
	
	
	if ($ARGV[$counter] ne "("){
		print "ERROR::".$PROG_NAME.":: Incorrect $name_parameter must be (list of parameter)\n";
		exit;
	}	
	$counter++;
	while ($ARGV[$counter] ne ");" && $counter < $ending_value){
		$parameters_info .= $ARGV[$counter]. " ";
		#print $parameters_info."\n";
		#push(@parameters, $ARGV[$counter]);
		$counter++;						
	}
	if ($ARGV[$counter] ne ");"){
		print "ERROR::".$PROG_NAME.":: Incorrect -$name_parameter must be (list of parameter)\n";
		exit;
	}
	@parameters = split(/,/, $parameters_info);
	
	return 	@parameters;	
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for ".$PROG_NAME."\n";
	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false");
	String->isEmpty($headFile, "ERROR::".$PROG_NAME.":: Head File is required");
	FilesIO->checkFile($headFile, "ERROR::".$PROG_NAME.":: $headFile NOT Found");	
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: File to save output is required");
	
	print "-headFile = $headFile\n";
	print "-outputFile = $outputFile\n";	
	print "-verbose = $verbose\n";		
	print "ok\n";
}

########################### sub main ####################################
sub main { 
	gnuplot->createplot($headFile, $outputFile, $verbose, \@fileListParameters);
}

