package gnuplot;


if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;

############################ sub loadAlign1d ####################################
sub createHistogramPair {
	my $file1	= $_[1];
	my $file2	= $_[2];
	my $name1	= $_[3];
	my $name2	= $_[4];
  	my $output	= $_[5];
  	my $yrange	= $_[6];
  	my $ylabel	= $_[7];
  	my $xlabel	= $_[8];
  	my $title	= $_[9];
  	my $color1	= $_[10];
	my $color2	= $_[11];
  	my $verbose = $_[12];
	
	FilesIO->checkFile($file1, "ERROR::perlLib::Plot::gnuplot:: File $file1 NOT found");
	FilesIO->checkFile($file2, "ERROR::perlLib::Plot::gnuplot:: File $file2 NOT found");
	my $cmd_gnu = "set terminal pdf fsize 11 fname \'Times\'\nset key below\n";
	$cmd_gnu .= "set ytics 0,1\nset output \'$output\'\nset yrange [$yrange]\nset ylabel \'$ylabel\'\n";
	#$cmd_gnu .= "set xlabel \'$xlabel\'\nset title \'$title\'\nset auto x\nset style data histogram\n"; 
	$cmd_gnu .= "set xlabel \'$xlabel\'\nset auto x\nset style data histogram\n"; 
	$cmd_gnu .= "set style histogram cluster gap 1\nset style fill solid border -1\nset boxwidth 0.5\nset xtics nomirror rotate by -45\n";
	$cmd_gnu .= "plot \'$file1\' using 2:xtic(1) title \'$name1\' linecolor $color1, \'$file2\'  using 2:xtic(1) title \'$name2\' linecolor $color2";
	
	FilesIO->saveFile($output.".plot", $cmd_gnu, $verbose);
	
	system ("gnuplot ".$output.".plot");
	
	FilesIO->checkFile($output, "ERROR::perlLib::Plot::gnuplot:: File $output NOT Created");
	FilesIO->removeFile($output.".plot", $verbose);

}

############################ sub createplot ####################################
sub createplot {
	my ($lixo, $headFile, $output, $verbose, $arrayParameters) = @_; 
	
	my $head = FilesIO->lineFileToString($headFile);
	my $body = $head."\n\n"."set output '$output'\n\nplot ";
	
	for (my $i = 0; $i <scalar(@{$arrayParameters}); $i++){
		$body .= @{$arrayParameters}->[$i];
		if ($i < scalar(@{$arrayParameters}) -1){
			$body .= ", ";
		} 
	}
	FilesIO->saveFile($output.".plot", $body, $verbose);
	system ("gnuplot ".$output.".plot");
	
	FilesIO->checkFile($output, "ERROR::perlLib::Plot::gnuplot:: File $output NOT Created");
	#FilesIO->removeFile($output.".plot", $verbose);	
}
	
1