package Matrix;
use strict;


my %hash_amino_code;


$hash_amino_code{"A"} = 0;
$hash_amino_code{"R"} = 1;
$hash_amino_code{"N"} = 2;
$hash_amino_code{"D"} = 3;
$hash_amino_code{"C"} = 4;
$hash_amino_code{"Q"} = 5;
$hash_amino_code{"E"} = 6;
$hash_amino_code{"G"} = 7;
$hash_amino_code{"H"} = 8;
$hash_amino_code{"I"} = 9;
$hash_amino_code{"L"} = 10;
$hash_amino_code{"K"} = 11;
$hash_amino_code{"M"} = 12;
$hash_amino_code{"F"} = 13;
$hash_amino_code{"P"} = 14;
$hash_amino_code{"S"} = 15;
$hash_amino_code{"T"} = 16;
$hash_amino_code{"W"} = 17;
$hash_amino_code{"Y"} = 18;
$hash_amino_code{"V"} = 19;
$hash_amino_code{"B"} = 20;
$hash_amino_code{"J"} = 21;
$hash_amino_code{"Z"} = 22;
$hash_amino_code{"X"} = 23;


my %hash_code_amino;


$hash_code_amino{0} = "A";
$hash_code_amino{1} = "R";
$hash_code_amino{2} = "N";
$hash_code_amino{3} = "D";
$hash_code_amino{4} = "C";
$hash_code_amino{5} = "Q";
$hash_code_amino{6} = "E";
$hash_code_amino{7} = "G";
$hash_code_amino{8} = "H";
$hash_code_amino{9} = "I";
$hash_code_amino{10} = "L";
$hash_code_amino{11} = "K";
$hash_code_amino{12} = "M";
$hash_code_amino{13} = "F";
$hash_code_amino{14} = "P";
$hash_code_amino{15} = "S";
$hash_code_amino{16} = "T";
$hash_code_amino{17} = "W";
$hash_code_amino{18} = "Y";
$hash_code_amino{19} = "V";
$hash_code_amino{20} = "B";
$hash_code_amino{21} = "J";
$hash_code_amino{22} = "Z";
$hash_code_amino{23} = "X";

############################ sub read Matrix ##################################
sub getCodeFromAmino{
	my $amino	 	= $_[1];
	
	if (exists($hash_amino_code{uc($amino)})){
		return $hash_amino_code{uc($amino)};
	}else{
		print "ERROR amino $amino NOT exists\n";
	}
	
}                                         

############################ sub read Matrix ##################################
sub read{
	
	my $matrixFile	 	= $_[1];
	my $entry;
	my $entry2;
	my @array_aux ; my $j = 0;
	my @matriz_array = ();
	
	my @array = FilesIO->lineFileToArray($matrixFile);
	
	foreach $entry (@array){
		if (index($entry, "#") < 0){
			@array_aux = split(/ +/, $entry);
			#print $entry."\n";
			#if ($array_aux[0] ne "" && $array_aux[0] ne "X" && $array_aux[0] ne "*" ){
			if ($array_aux[0] ne "" &&  $array_aux[0] ne "*" ){
				for (my $i = 1; $i < scalar(@array_aux) -1; $i++){
						$matriz_array[$i-1][$j] = $array_aux[$i]; 	
				}
				$j++;
			}
		}
	}
	return @matriz_array;

}

############################ sub getAminoPositive ##################################
sub getAminoPositive {
	
	my ($lixo, $amino, $matriz_array) = @_;
	my @array_amino = ();
	
	my $indice = $hash_amino_code{uc($amino)};
	
	my @array_indice = @{$matriz_array}[$indice];
	
		
	for (my $i = 0; $i < 20; $i++){
		if ($array_indice[0][$i] >= 0){
			push(@array_amino, $hash_code_amino{$i});
		}		
	}
	return @array_amino;

}

############################ sub getAminoPositive ##################################
sub getAminos {
	
	my ($lixo, $amino, $rows, $matriz_array) = @_;
	my @array_amino = ();
	
	
	
	my $indice = $hash_amino_code{uc($amino)};
	
	my @array_indice = @{$matriz_array}[$indice];
	
		
	for (my $i = 0; $i < $rows; $i++){
		$array_amino[$i][0] = $hash_code_amino{$i};
		$array_amino[$i][1] = $array_indice[0][$i];	
		
	}
	return @array_amino;

}

############################ sub getAminoPositive ##################################
sub getValueAminos {
	
	my ($lixo, $amino, $matriz_array) = @_;
	my @array_amino = ();
	
	
	
	my $indice = $hash_amino_code{uc($amino)};
	
	my @array_indice = @{$matriz_array}[$indice];
	
		
	for (my $i = 0; $i < 20; $i++){
		$array_amino[$i][0] = $array_indice[0][$i];	
		
	}
	return @array_amino;

}

############################ sub getAminoPositive ##################################
sub getValueForAmino {
	
	my ($lixo, $amino, $matriz_array) = @_;
	my @array_amino = ();
	
	
	
	my $indice = $hash_amino_code{uc($amino)};
	
	my @array_indice = @{$matriz_array}[$indice];
	
	return $array_indice[0][1];	
	
}

1
