
export ENV_VAR_FILE=$1;

source $ENV_VAR_FILE;

export TF_TABLE=$2;
export LOG_DIR=$3;
export NAME_PROG=$4;
export QTD_FILE=$5;

export ATT_FILE=$6;
export CLASS=$7;
export IDS=$8;
export OUTPUT_FILE=$9;

export VERBOSE=false;

perl $PERL_LIB/run/runTestSetPFAMFamily.pl \
-trans_factor_table $TF_TABLE \
-nameRun ${NAME_PROG}_runFamily \
-logDir $LOG_DIR \
-kindRun 1 \
-qtdFile $QTD_FILE \
-prePost \( \
echo \"LOG::START::FAMILY_FACTOR\", \
TOP date, \
TOP echo \$HOSTNAME, \
TOP export PERL_LIB=$PERL_LIB, \
TOP export BASE_DIR=$BASE_DIR, \
TOP export SCRIPT_DIR=$SCRIPT_DIR, \
TOP export PATH=$PATH_HMMER\:$PATH, \
TOP export TMP_DIR=$TMP/NUM_FILE/, \
TOP mkdir -p \$TMP_DIR, \
cp $ATT_FILE \$TMP_DIR/FAMILY_FACTOR.att, \
END_LINE \
\) \
-scriptParameters \( \
END_LINE, \
perl $PERL_LIB/SVM/createFoldSVMLib.pl, \
-attributesFile \$TMP_DIR/FAMILY_FACTOR.att, \
-outputFile \$TMP_DIR/FAMILY_FACTOR.svmLib, \
-class $CLASS, \
-tmpDir \$TMP_DIR/, \
-ids $IDS, \
-verbose $VERBOSE, \
END_LINE, \
if [ -s \$TMP_DIR/FAMILY_FACTOR.svmLib ], \
END_LINE,\
then, \
END_LINE,\
export DIR=\$\(dirname ${OUTPUT_FILE}\), \
END_LINE,\
mkdir -p \$DIR, \
END_LINE,\
cp \$TMP_DIR/FAMILY_FACTOR.svmLib $OUTPUT_FILE, \
END_LINE,\
echo \"File created \: $OUTPUT_FILE\", \
END_LINE,\
else, \
END_LINE,\
echo \"ERROR File NOT created \: $OUTPUT_FILE\", \
END_LINE,\
fi, \
END_LINE \
\)  \
-posPost \( \
echo \"LOG::END::FAMILY_FACTOR\", \
BOTTOM rm -rf \$TMP_DIR, \
date \
\) \
-commandParameters  \( bash \)
