#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use SVM::libsvm;
use SVM::svmlight;
use Util::Number;
use Util::Array;
use SVM::svm;

my $PROG_NAME = "PERLLib::SVM::createFoldSVMLib.pl";


my $attributesFilePosTrain = "";
my $attributesFileNegTrain = "";


my $outputFile = "";
my $verbose    	= "false";
my $tmpDir = "";
my $class = "1";
my $attributesFile = "";
my $ids = "";
my $seq = "1";

my $POS_CLASS = 1;
my $NEG_CLASS = -1;
my $MIN_POS = 6;
my $NUMBER_ATT = 5;

my $parametersFileTrain = "";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-attributesFile"){
			$attributesFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-tmpDir"){
			$tmpDir = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-class"){
			$class = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-ids"){
			$ids = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-seq"){
			$seq = $ARGV[$counter+1];
		}											
	}
}
############################ sub checkParameters ##################################
sub checkParameters {

	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";

	String->isEmpty($attributesFile, "ERROR::".$PROG_NAME.":: Parameter -$attributesFile is required!");
	FilesIO->checkFile($attributesFile, "ERROR::".$PROG_NAME.":: File NOT found ".$attributesFile);
	String->isEmpty($class, "ERROR::".$PROG_NAME.":: Parameter -class having temporary directory is required!");	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false! ");
	String->isEmpty($tmpDir, "ERROR::".$PROG_NAME.":: Parameter -tmpDir having temporary directory is required!");
	
	print "-attributesFile = $attributesFile\n";
	print "-outputFile = $outputFile\n";
	print "-class = $class\n";
	print "-verbose = $verbose\n";
	print "-tmpDir = $tmpDir\n";
	
	if ($seq eq "1"){
		$seq =  "\t";
	}elsif ($seq eq "2"){
		$seq =  " +";
	}
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my $train_file = $tmpDir."train.txt";
	my @arrayIds = ();				my @atts = ();
	my $info = "";
	
	@atts = FilesIO->fileToArray2d($attributesFile, $seq);
	#print Array->printMatrix2(":", "\n", \@atts);
	
	if ($ids ne ""){
		@atts = Array->removeColsMatriz($ids, \@atts);		
	}
	$NUMBER_ATT = $#{$atts[0]} + 1;
	#print scalar(@atts)."\t".$NUMBER_ATT."\n";
	
	#setting class
	for (my $i=0; $i < scalar(@atts); $i++){
		for (my $j=0; $j < $NUMBER_ATT; $j++){
			$info .=$atts[$i][$j]."\t";
		}
		$info .="$class\n";
	}
	#print $info;
	FilesIO->saveFile($train_file, $info, $verbose);
	
	my $info_train = LIBSVM->createDataset($train_file);
	#print $info_train;
	FilesIO->saveFile($outputFile, $info_train, $verbose);
	
}

