#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use SVM::libsvm;
use SVM::svmlight;
use Util::Number;
use Util::Array;
use SVM::svm;

my $PROG_NAME = "CASH_27::scripts::ensemble::formatLibOutput.pl";


my $idFile = "";
my $classOutputTest = "";
my $kind = "1";
my $outputFile = "";
my $verbose    	= "false";
my $sep = "_";
my $colsIds = 0;#sep=:

&getParameters;
&checkParameters;
&main;



############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-classOutput"){
			$classOutputTest = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-idFile"){
			$idFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-kind"){
			$kind = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-colsIds"){
			$colsIds = $ARGV[$counter+1];
		}									
	}
}
############################ sub checkParameters ##################################
sub checkParameters {

	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";

	String->isEmpty($classOutputTest, "ERROR::".$PROG_NAME.":: Parameter -classOutputTest is required!");
	FilesIO->checkFile($classOutputTest, "ERROR::".$PROG_NAME.":: File NOT found ".$classOutputTest);
	String->isEmpty($idFile, "ERROR::".$PROG_NAME.":: Parameter -idFile is required!");
	FilesIO->checkFile($idFile, "ERROR::".$PROG_NAME.":: File NOT found ".$idFile);
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required!");
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false! ");
	
	
	print "-idFile = $idFile\n";
	print "-classOutput = $classOutputTest\n";
	print "-outputFile = $outputFile\n";
	print "-verbose = $verbose\n";
	print "-kind = $kind\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my @array = FilesIO->fileToArray2d($idFile, "\t", " ");
	#my @array_aux = Array->copyColMatrixToArray2(0, \@array);
	my @array_aux = Array->copyColsToArray($colsIds, $sep, \@array);
	my @classOut = FilesIO->fileToArray2d($classOutputTest, " +", " ");
	my $info = ""; my $prob;
	#print Array->printMatrix2("\t", "\n", \@classOut);
	
	
	for (my $i=0; $i < scalar(@classOut); $i++){
		if ($classOut[$i][0] == 1 && $classOut[$i][1] == 1){
			$prob = $classOut[$i][2]; 
		}elsif ($classOut[$i][0] == 1 && $classOut[$i][1] == -1){
			$prob = 1-$classOut[$i][2];
		}elsif ($classOut[$i][0] == -1 && $classOut[$i][1] == -1){
			$prob = 1-$classOut[$i][2];
		}elsif ($classOut[$i][0] == -1 && $classOut[$i][1] == 1){
			$prob = $classOut[$i][2]; 
		}
		#print $array_aux[$i]."\t".$prob."\n"; 
		$info .=$array_aux[$i]."\t".$prob."\n"; 
		
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
	
}
