package SVMLIGHT;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Util::Array;

my $PROG_NAME = "perlLib::SVM::svmlight.pm::";
my $TRAIN_PROGRAM = "svm-train";
my $PREDICT_PROGRAM = "svm-predict";
my $SCALE_PROGRAM = "svm-scale";



############################ sub lineFileToArray ###################################
sub createDatasetWeight {
	my ($lixo, $datasetFile, $weights) = @_;
	
	my @lweights = @{$weights};
	
	my $info = "";			my $last;
	my $label;				my $value;
	my $cost;
		
	my @array = FilesIO->fileToArray2d($datasetFile, "\t");	

	
  for (my $i=0; $i < scalar(@array); $i++){
                $last = $#{$array[$i]};
                $label = $array[$i][$last];
                $info .= $label."  ";
                $cost = "cost:".$lweights[$i]." ";
                $info .=$cost;
                for (my $j=0; $j <= $last-1; $j++){
                        if ($array[$i][$j] ne "NA"){
                                $value = $array[$i][$j];
                                $info .= ($j+1).":".$value;
                                if ($j != $last-1){
                                        $info .= " ";
                                }       
                        }       
                }
                $info .= "\n";
        }
	
	return $info;	
}

############################ sub lineFileToArray ###################################
sub train {
	my $train_file 	= $_[1];
    my $svmModel	= $_[2];
    my $parameters	= $_[3];
    my $verbose		= $_[4];
    
    my $cmd = "svm_learn $parameters $train_file $svmModel";
    
    if ($verbose eq "true"){
    	print $cmd."\n";
    }
    system($cmd);
    
    if (FilesIO->isFile($svmModel) eq "false"){
    	print $PROG_NAME. "::ERROR:: File $svmModel NOT created\n";
    	exit;
    }
}

############################ sub lineFileToArray ###################################
sub classify {
	my $svmModel 	= $_[1];
    my $testFile	= $_[2];
    my $parameters	= $_[3];
    my $resultFile	= $_[4];
    my $verbose		= $_[5];
    
    my $cmd = "svm_classify $parameters $testFile  $svmModel  $resultFile";
    
    if ($verbose eq "true"){
    	print $cmd."\n";
    }
    system($cmd);
    
    if (FilesIO->isFile($resultFile) eq "false"){
    	print $PROG_NAME. "::ERROR:: File $resultFile NOT created\n";
    	exit;
    }
}

############################ sub lineFileToArray ###################################
sub getResults {
	my ($lixo, $rConfFile, $outputFile, $array) = @_;
	my @larray = @{$array};	
	
	my @array_cv = FilesIO->fileToArray2d($rConfFile, " +");
	
	my @array_aux;			my $conf_value;
	my @array_results = ();
	my $small;
	my $bigger;
	my $absValue;
	
	if (scalar(@larray) != scalar(@array_cv)){
		print $PROG_NAME."::ERROR:: Conf file has more rows than testFile\n";
		exit;
	}
	
	for (my $i=0; $i < scalar(@array_cv); $i++){
		$conf_value = $array_cv[$i][0];
		$id = $larray[$i];
		$array_results[$i][0] = $id;
		$array_results[$i][1] = $conf_value;						
	}
	my $info = Array->printMatrix("\t", scalar(@array_results), 2,  \@array_results);
	FilesIO->saveFile($outputFile, $info, "false");
}


1