package Domain;
use strict;


if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use File::Files;
use Database::PFAM;


############################ sub getSequencesFromFasta ####################################
sub calculateCoverage {
  
  my $startDomain 	= $_[1];	
  my $endDomain 	= $_[2];
  my $startHit 		= $_[3];	
  my $endEnd 		= $_[4];
  
 # print "$startDomain $endDomain $startHit $endEnd\n";
  
  my $len_domain = $endDomain - $startDomain + 1;
  my $len_hit = $endEnd - $startHit + 1;
  
  my $domain_cov = ($len_hit/$len_domain)*100;
  if ($domain_cov > 100){
  	$domain_cov = "100";
  }
  $domain_cov = sprintf("%.2f", $domain_cov);
  
  return $domain_cov;
}

############################ sub main ##################################
sub domainCombination{   
	my ($lixo, $tmpDir, $info_DomainIds, $number_comb, $verbose) = @_;
	my $comb_file = $tmpDir."combs.txt" ;
	my @array_aux;
	
	my $cmd_gereral = $ENV{'PERL_LIB'}."/run/./combinatoria.bin ";			   
	my $cmd = $cmd_gereral. $number_comb. " ".$info_DomainIds." > ". $comb_file;
	if ($verbose eq "true") {print "cmd".$cmd."\n";}
	system($cmd);
	
	my @array_comb = FilesIO->lineFileToArray($comb_file);
	#print Array->printArray(" ", \@array_comb);
	for (my $i = 0; $i < scalar(@array_comb); $i++){
		@array_aux = String->StringToArray($array_comb[$i], " +");
		@array_aux = sort (@array_aux);
		$array_comb[$i] = Array->printArray(" ", \@array_aux);
	}
	
	return @array_comb;
}

############################ sub main ##################################
sub domainALLCombination{   
	my ($lixo, $tmpDir, $info_DomainIds, $start_comb, $end_comb, $verbose) = @_;
	my @domains = ();		my @array_ret = ();

	for (my $i = $start_comb; $i <= $end_comb; $i++){
		@domains = Domain->domainCombination($tmpDir, $info_DomainIds, $i, $verbose);
		if ($verbose eq "true") {print Array->printArray("\n", \@domains);}
		push(@array_ret, @domains);
	}
	return @array_ret;
		
}

############################ sub main ##################################
sub isSameDomainArchs{
	my $arch1 	= $_[1];
	my $arch2 	= $_[2];
	
		
	my $count_same = 0;
	
	my @archArray1 = String->StringToArray($arch1, " +");
	my @archArray2 = String->StringToArray($arch2, " +");
	@archArray1 = sort(@archArray1);
	@archArray2 = sort(@archArray2);
	
	@archArray1 = Array->removeRepeated(\@archArray1);
	@archArray2 = Array->removeRepeated(\@archArray2);
	
	#print "arch 1 ". Array->printArray(" ", \@archArray1)."\n";
	#print "arch 2 ". Array->printArray(" ", \@archArray2)."\n";
	
	if (scalar(@archArray1) != scalar(@archArray2)){
		return "false";
	}
	
	for (my $j = 0; $j < scalar(@archArray1); $j++){					
		for (my $k = 0; $k < scalar(@archArray2); $k++){
			if ($archArray2[$k] eq $archArray1[$j]){
				$count_same++;
				$k = scalar(@archArray2);
			}
		}	
	}
	
	#print ">>> ". $count_same. " ". scalar(@archArray1)."\n";
	if ($count_same == scalar(@archArray1)){
		return "true";
	}
	return "false";
}


############################ sub main ##################################
sub clearArchToArray{
	my $arch1 	= $_[1];
	
	my @archArray1 = String->StringToArray($arch1, " +");

	@archArray1 = sort(@archArray1);

	@archArray1 = Array->removeRepeated(\@archArray1);

	return @archArray1;
}
############################ sub main ##################################
sub arch1IsIntoArch2{
	my $arch1 	= $_[1];
	my $arch2 	= $_[2];
	
		
	my $count_same = 0;
	
	my @archArray1 = String->StringToArray($arch1, " +");
	my @archArray2 = String->StringToArray($arch2, " +");
	@archArray1 = sort(@archArray1);
	@archArray2 = sort(@archArray2);
	
	@archArray1 = Array->removeRepeated(\@archArray1);
	@archArray2 = Array->removeRepeated(\@archArray2);
	
	#print "arch 1 ". Array->printArray(" ", \@archArray1)."\n";
	#print "arch 2 ". Array->printArray(" ", \@archArray2)."\n";
	

	for (my $j = 0; $j < scalar(@archArray1); $j++){					
		for (my $k = 0; $k < scalar(@archArray2); $k++){
			if ($archArray2[$k] eq $archArray1[$j]){
				$count_same++;
				$k = scalar(@archArray2);
			}
		}	
	}
	
	#print ">>> ". $count_same. " ". scalar(@archArray1)."\n";
	if ($count_same == scalar(@archArray1)){
		return "true";
	}
	return "false";
}
############################ sub main ##################################
sub compareDomainArchs{
	my $arch1 	= $_[1];
	my $arch2 	= $_[2];
	
	my $count_same = 0;
	
	
	
	my @archArray1 = String->StringToArray($arch1, " +");
	my @archArray2 = String->StringToArray($arch2, " +");
	
	$arch1 =~ s/\n/ /g;
	$arch2 =~ s/\n/ /g;
	#print ">>compare\n$arch1\n\n$arch2\n\n";
	
	for (my $j = 0; $j < scalar(@archArray1); $j++){					
		for (my $k = 0; $k < scalar(@archArray2); $k++){
			if ($archArray2[$k] eq $archArray1[$j]){
				$count_same++;
				$k = scalar(@archArray2);
			}
		}	
	}
	if ($count_same == (scalar(@archArray1))){
		#print "Archs are equals\n";
		return "true";
	}
	#print "Archs NOT are equals\n";
	return "false";

}

############################ sub main ##################################
sub compareDomainArchsByPosition{
	
	my ($lixo, $arrayArch1, $arrayArch2) = @_;
	my $overlapAA;
	my @larrayArch1 = @{$arrayArch1};
	my @larrayArch2 = @{$arrayArch2};
	
	#print "Arch1 ". Array->printMatrix2("\t", "\n", \@larrayArch1)."\n";
	#print "Arch2 ". Array->printMatrix2("\t", "\n", \@larrayArch2)."\n";
		
	for (my $k=0; $k< scalar(@larrayArch1); $k++){
		#print "Domain 1 ==> ".$larrayArch1[$k][0]."\n";
		for (my $i=0; $i< scalar(@larrayArch2); $i++){		
			#print $larrayArch1[$k][1]."\t". $larrayArch1[$k][2]."\t". $larrayArch2[$i][1]."\t". $larrayArch2[$i][2]	."\n";		
			$overlapAA = Domain->calculateOverlapPerc($larrayArch2[$i][1], $larrayArch2[$i][2], $larrayArch1[$k][1], $larrayArch1[$k][2]);
			#print "overlapAA = $overlapAA\n";
			if ($overlapAA > 0.5 ){
				#print "Domain 2 ==> ".$larrayArch2[$i][0]." overlapAA= $overlapAA\n";
				if (($larrayArch1[$k][0] eq $larrayArch2[$i][0]) || ($larrayArch1[$k][3] ne "None" && $larrayArch1[$k][3] eq $larrayArch2[$i][3])){
					#print "Remove\t".  $larrayArch2[$i][0]."\n";
					@larrayArch2 = Array->removeRowsMatriz($i, \@larrayArch2);	
					$i = scalar(@larrayArch2);		
				}			
			}
		}
	}
	return @larrayArch2;
}


############################ sub main ##################################
sub isDomainArchsOverlappingByPosition{
	
	my ($lixo, $arrayArch1, $arrayArch2) = @_;
	my $overlapAA;
	my @larrayArch1 = @{$arrayArch1};
	my @larrayArch2 = @{$arrayArch2};
	#print "Arch1 ". Array->printMatrix2("\t", "\n", \@larrayArch1)."\n";
	#print "Arch2 ". Array->printMatrix2("\t", "\n", \@larrayArch2)."\n";
	my @overlappins = ();
		
	for (my $k=0; $k< scalar(@larrayArch1); $k++){
		#print "Domain 1 ==> ".$larrayArch1[$k][0]."\n";
		for (my $i=0; $i< scalar(@larrayArch2); $i++){	
			#print "Domain 2 ==> ".$larrayArch2[$i][0]."\n";		
			$overlapAA = Domain->calculateOverlapPerc($larrayArch2[$i][1], $larrayArch2[$i][2], $larrayArch1[$k][1], $larrayArch1[$k][2]);
			#print "overlapAA = $overlapAA\n";
			if ($overlapAA > 0.5 ){
				push(@overlappins, $larrayArch2[$i]);
				$i = scalar(@larrayArch2);			
			}
		}
	}
	return @overlappins;
}

############################ sub main ##################################
sub isDomainArchsNoOverlappingByPosition{
	
	my ($lixo, $arrayArch1, $arrayArch2) = @_;
	my $overlapAA;
	my @larrayArch1 = @{$arrayArch1};
	my @larrayArch2 = @{$arrayArch2};
	#print "Arch1 ". Array->printMatrix2("\t", "\n", \@larrayArch1)."\n";
	#print "Arch2 ". Array->printMatrix2("\t", "\n", \@larrayArch2)."\n";
	my @overlappins = ();
	my $overlapping = "false";
	for (my $k=0; $k< scalar(@larrayArch1); $k++){
		$overlapping = "false";
		#print "Domain 1 ==> ".$larrayArch1[$k][0]."\n";
		for (my $i=0; $i< scalar(@larrayArch2); $i++){	
			#print "Domain 2 ==> ".$larrayArch2[$i][0]."\n";		
			$overlapAA = Domain->calculateOverlapPerc($larrayArch2[$i][1], $larrayArch2[$i][2], $larrayArch1[$k][1], $larrayArch1[$k][2]);
			#print "overlapAA = $overlapAA\n";
			if ($overlapAA > 0.5 ){
				$overlapping = "true";
				$i = scalar(@larrayArch2);			
			}
		}
		if ($overlapping eq "false"){
			push(@overlappins, $larrayArch1[$k]);
		}		
	}
	return @overlappins;
}



############################ sub main ##################################
sub arch1MinusArch2Exact{
	my $arch1 	= $_[1];
	my $arch2 	= $_[2];
	
	my $found = "false";		my $info = "";
	my @array_ret =();			my $initial = 0;
	
	
	my @archArray1 = String->StringToArray($arch1, " +");
	my @archArray2 = String->StringToArray($arch2, " +");
	
	@archArray1 = sort(@archArray1);
	@archArray2 = sort(@archArray2);

	#print ">>compare\n$arch1\n\n$arch2\n\n";
	
	for (my $j = 0; $j < scalar(@archArray1); $j++){	
		$found = "false";				
		for (my $k = $initial; $k < scalar(@archArray2); $k++){
			if ($archArray2[$k] eq $archArray1[$j]){
				$found = "true";
				$initial = $k+1;
				$k = scalar(@archArray2);				
			}
		}
		if ($found eq "false"){
			push(@array_ret, $archArray1[$j]);
		}	
		
	}
	
	if (scalar(@array_ret) > 0){
		$info = Array->printArray(" ", \@array_ret);
	}
	return $info;

}

############################ sub main ##################################
sub arch1MinusArch2{
	my $arch1 	= $_[1];
	my $arch2 	= $_[2];
	
	my $found = "false";		my $info = "";
	my @array_ret =();
	
	
	my @archArray1 = String->StringToArray($arch1, " +");
	my @archArray2 = String->StringToArray($arch2, " +");
	
	$arch1 =~ s/\n/ /g;
	$arch2 =~ s/\n/ /g;
	#print ">>compare\n$arch1\n\n$arch2\n\n";
	
	for (my $j = 0; $j < scalar(@archArray1); $j++){	
		$found = "false";				
		for (my $k = 0; $k < scalar(@archArray2); $k++){
			if ($archArray2[$k] eq $archArray1[$j]){
				$found = "true";
				$k = scalar(@archArray2);				
			}
		}
		if ($found eq "false"){
			push(@array_ret, $archArray1[$j]);
		}	
		
	}
	
	if (scalar(@array_ret) > 0){
		$info = Array->printArray(" ", \@array_ret);
	}
	return $info;

}

############################ sub main ##################################
sub arch1MinusArch2Clan{
	my ($lixo, $arch1, $arch2) = @_;
	
	my @larch1 = @{$arch1};
	my @larch2 = @{$arch2};
	
	
	
	my $found = "false";		my $info = "";
	my @array_ret =();
	
	
	for (my $j = 0; $j < scalar(@larch1); $j++){	
		$found = "false";				
		for (my $k = 0; $k < scalar(@larch2); $k++){
			
			if ($larch2[$k][1] ne "None" && $larch2[$k][1] eq $larch1[$j][1]){
					$found = "true";
					$k = scalar(@larch2);		
			}
		}
		if ($found eq "false"){
			push(@array_ret, $larch1[$j][0]);
		}	
		
	}
	
	if (scalar(@array_ret) > 0){
		$info = Array->printArray(" ", \@array_ret);
	}
	return $info;

}

############################ sub main ##################################
sub hasMDO{
	my $arch					= $_[1];
	my $domainOrgFile			= $_[2];
	my $tmpDir					= $_[3];
	my $verbose					= $_[4];
  	
  	my $valid_info;				my $protein_valid;
  	my @array_aux = ();
  	
	my $info_domains 	= $arch;
	$info_domains 		=~ s/PF//g;
	#print $info_domains."\n";
	
	$valid_info = FilesIO->getLinesInFileCascade($domainOrgFile, $info_domains, $verbose);
	#print "--".$valid_info."==";
	$protein_valid = Domain->searchFullArch($valid_info, $info_domains);
	#print "--".$protein_valid."==";
	if ($protein_valid ne ""){
		@array_aux = split(/ +/, $info_domains);
		#print "MDCO = ".scalar(@array_aux)."\n";
		return scalar(@array_aux);
	}
	else{
		return 0;
	}
	
}

############################ sub main ##################################
sub searchFullArch{

  	my $info_archs 			= $_[1];
  	my $domains				= $_[2];
 	my $verbose				= $_[3];
 		
 	my $info_domains;
 	my @archs = String->StringToArray2d($info_archs, "\n", "\t"); 	
 	
 	#print scalar(@archs);
 	
 	
 	my $i =-1;			my $arch_found = "false";
 	while ($i < scalar(@archs) -1 && $arch_found eq "false"){
 		$i++;
 		
 		$info_domains 	= $archs[$i][0];
 		#print "info_domains\t". $info_domains. "\n";
 		$info_domains 	=~ s/-/ /g;
 		#print "====>".$domains."\t".$info_domains. "\n";
 		
 		$arch_found = Domain->compareDomainArchs($info_domains, $domains);		
 		
 	}

 	if ($arch_found eq "true"){
 		#print $domains."\t".$archs[$i][1]."\n";
 		return $archs[$i][1];
 	}
 	return "";
}

############################ sub main ##################################
sub getMaxMDO{

    my $num_combs				= $_[1];
    my $info_domains_comb		= $_[2];
    my $domainOrgFile			= $_[3];
    my $tmpDir					= $_[4];
    my $verbose					= $_[5];
    
    my $valid_info;				my @array_aux;
    my $combination;			my @array_domains = ();
	my $stop = "false";			my $total_domain_validate =	0;
	my $i;						my @array_comb = ();
	my $info_domains;			my $protein_valid;
	
	#print "total_domain =$total_domain num_combs=$num_combs info_domains_comb=$info_domains_comb\n";
	push (@array_comb, $info_domains_comb);
	

	while ($num_combs > 1){
		if (scalar(@array_comb) > 0){
			$info_domains 	= pop(@array_comb);
			#print ">>> $info_domains\n";
			@array_domains 	= split(/ +/, $info_domains);
			
			#$info_domains 	=~ s/ /:/g;
			
			$valid_info = FilesIO->getLinesInFileCascade($domainOrgFile, $info_domains, $verbose);
			#print $valid_info;
			
			$protein_valid = Domain->searchFullArch($valid_info, $info_domains);
			#print "protein_valid\t$protein_valid\n";
		
			if ($protein_valid ne ""){
				return (scalar(@array_domains));
			}
		}
		else{
			$num_combs--;
			@array_comb = Domain->domainCombination($tmpDir, $info_domains_comb, $num_combs, $verbose);
			#print Array->printArray("\n", \@array_comb)."\n";	
			
		}
	}
	return 0;
}



############################ sub runFormatFiletoSam ##################################
sub calculateOverlapPerc{
	my $startHit_i			= $_[1];
	my $endHit_i 			= $_[2];
	my $startHit_j			= $_[3];
	my $endHit_j			= $_[4];
	
	my $overlapAA = Domain->calculateOverlapSize($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	my $size_i = ($endHit_i - $startHit_i) + 1;
	my $perc_overlap = $overlapAA/$size_i;
	return $perc_overlap;
}

############################ sub runFormatFiletoSam ##################################
sub calculateOverlapSize{
	my $startHit_i			= $_[1];
	my $endHit_i 			= $_[2];
	my $startHit_j			= $_[3];
	my $endHit_j			= $_[4];
	
	my $overlapAA = 0;
	
	if ($startHit_i <= $startHit_j && $startHit_i <= $endHit_j && $endHit_i >= $startHit_j && $endHit_i >= $endHit_j){
		$overlapAA = ($endHit_j - $startHit_j) + 1;
	} 
	elsif($startHit_i >= $startHit_j && $startHit_i <= $endHit_j && $endHit_i >= $startHit_j && $endHit_i <= $endHit_j){
		$overlapAA = ($endHit_i - $startHit_i) + 1;
	} 
	elsif ( ($startHit_i >= $startHit_j && $startHit_i <= $endHit_j)){
		$overlapAA = ($endHit_j - $startHit_i) + 1;
	}
	elsif($endHit_i >= $startHit_j && $endHit_i <= $endHit_j){
		$overlapAA = ($endHit_i - $startHit_j) + 1;	
	}	
	return $overlapAA;
}


############################ sub runFormatFiletoSam ##################################
sub isOverlapHitClan{
	my $startHit_i			= $_[1];
	my $endHit_i 			= $_[2];
	my $startHit_j			= $_[3];
	my $endHit_j			= $_[4];
	my $overlapAA_alowed  	= $_[5];
	my $perc_overlap_alowed	= $_[6];
	my $domains_overlap		= $_[7];
	my $domain_i			= $_[8];
	my $domain_j			= $_[9];
	my $clanFile			= $_[10];
	
	#print "startHit_i = $startHit_i\nendHit_i = $endHit_i\nstartHit_j = $startHit_j\nendHit_j = $endHit_j\noverlapAA_alowed = $overlapAA_alowed\nperc_overlap_alowed = $perc_overlap_alowed\n";
	#print "domains = \n$domain_i\n$domain_j\n";
	my $overlapAA = 0;			my $perc_overlap_i = 0;
	my $perc_overlap_j = 0;
	
	#print "size_i = $size_i\n";
	
	$overlapAA = Domain->calculateOverlapSize($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	
	#print "overlapAA = $overlapAA\n";
	if ($domains_overlap ne ""){
		#print "\nentrou1\n";
		my $domain_i_j = $domain_i.":".$domain_j;
		my $domain_j_i = $domain_j.":".$domain_i;		
		if (index($domains_overlap, $domain_i_j) >= 0 || index($domains_overlap, $domain_j_i) >= 0){
			#print "\nentrou2\n";
			if ($overlapAA > 0){
				return "false";
			}
		}
		
	}
	
	if ($overlapAA_alowed == 0 && $perc_overlap_alowed == 0){
		if ($overlapAA == 0){
			return "false";
		}else{
			return "true";
		}		
	}
	$perc_overlap_i = Domain->calculateOverlapPerc($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	$perc_overlap_j = Domain->calculateOverlapPerc($startHit_j, $endHit_j, $startHit_i, $endHit_i);
	#print "overlapAA = $overlapAA\tperc_overlap = $perc_overlap_i\n";
	#print "overlapAA = $overlapAA\tperc_overlap = $perc_overlap_j\n";
	#print $perc_overlap_alowed."\n\n";
	
	if ($overlapAA ==0){
		return "false";
	}elsif ($overlapAA <= $overlapAA_alowed && $perc_overlap_i <= $perc_overlap_alowed && $perc_overlap_j <= $perc_overlap_alowed){
		#print "overlap false1\n\n";
		return "false";
	}else{
		my $clan_i = PFAM->getOneClan($clanFile, $domain_i, "false");
		my $clan_j = PFAM->getOneClan($clanFile, $domain_j, "false");
		#if ($clan_i ne "None" &&  $clan_j ne "None" && $clan_i ne $clan_j){
		if ($clan_i ne $clan_j){
			return "false";
		}
	}
	#if ($perc_overlap_i <= $perc_overlap_alowed || $perc_overlap_j <= $perc_overlap_alowed){
	#	print "overlap false2\n\n";
	#	return "false";
	#}
	
	#print "overlap true\n\n";
	return "true";
}

############################ sub runFormatFiletoSam ##################################
sub removeOverlapSameClan{
	my ($lixo, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $clanFile, $matrix) = @_;
	my @lmatrix = @{$matrix};
	
	@lmatrix = Array->sortArray2dDesc(0, \@lmatrix);
	
	my $startHit_i; 			my $endHit_i;
	my $startHit_j; 			my $endHit_j;
	my $domain_i; 				my $domain_j;
	my $save;					my @array_ret = ();
	
	for (my $i=0; $i< scalar(@lmatrix); $i++){
			$startHit_i = $lmatrix[$i][1];
			$endHit_i	= $lmatrix[$i][2];
			$domain_i	= $lmatrix[$i][4];
			$save =  "true";
			for (my $j=$i+1; $j< scalar(@lmatrix); $j++){
				$startHit_j = $lmatrix[$j][1];
				$endHit_j	= $lmatrix[$j][2];
				$domain_j	= $lmatrix[$j][4];
				if (Domain->isOverlapHitClan($startHit_i, $endHit_i, $startHit_j, $endHit_j,  $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j, $clanFile) eq "true"){
					$save = "false";
					$j = scalar(@lmatrix);
					#print "removed $startHit_i $endHit_i $domain_i ". $lmatrix[$i][3]."\n";
				}
			}
			if ($save eq "true"){
				push(@array_ret, $lmatrix[$i]);
			}
	}
	return @array_ret;

}

############################ sub runFormatFiletoSam ##################################
sub removeOverlapHit{
	my ($lixo, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $matrix) = @_;
	my @lmatrix = @{$matrix};
	
	@lmatrix = Array->sortArray2dDesc(0, \@lmatrix);
	
	my $startHit_i; 			my $endHit_i;
	my $startHit_j; 			my $endHit_j;
	my $domain_i; 				my $domain_j;
	my $save;					my @array_ret = ();
	
	for (my $i=0; $i< scalar(@lmatrix); $i++){
			$startHit_i = $lmatrix[$i][1];
			$endHit_i	= $lmatrix[$i][2];
			$domain_i	= $lmatrix[$i][4];
			$save =  "true";
			for (my $j=$i+1; $j< scalar(@lmatrix); $j++){
				$startHit_j = $lmatrix[$j][1];
				$endHit_j	= $lmatrix[$j][2];
				$domain_j	= $lmatrix[$j][4];
				#print Domain->isOverlapHit($startHit_i, $endHit_i, $startHit_j, $endHit_j,  $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j)."\n";
				if (Domain->isOverlapHit($startHit_i, $endHit_i, $startHit_j, $endHit_j,  $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j) eq "true"){
					$save = "false";
					$j = scalar(@lmatrix);
					#print "removed $startHit_i $endHit_i $domain_i ". $lmatrix[$i][3]."\n";
				}
			}
			if ($save eq "true"){
				push(@array_ret, $lmatrix[$i]);
			}
	}
	return @array_ret;

}


############################ sub runFormatFiletoSam ##################################
sub removePartialOverlapHit{
	my ($lixo, $startHit, $endHit, $domain, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $array) = @_;
	
	my @localArray = @{$array};
	@localArray = Array->sortArray2d(1, \@localArray);
	
	my $startHit_j;				my $endHit_j;
	my $save;					my @array_ret = ();
	my $domain_j;
	
	#print "Remove overlap with $startHit $endHit\n";
	for (my $j =0; $j < scalar(@localArray); $j++) {
		$startHit_j = $localArray[$j][1];
		$endHit_j 	= $localArray[$j][2];
		$domain_j	= $localArray[$j][4];
		$save = "true";	
		#print ">>>> $startHit_j $endHit_j $domain_j\n";
		if (Domain->isOverlapHit($startHit, $endHit, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain, $domain_j) eq "true" ){
			$save = "false";
			#print "overlap\n";
		}
		if ($save eq "true"){
			#print "===> SAVE  $startHit_j $endHit_j \n";
			push(@array_ret, $localArray[$j]);
		}
	}
	return @array_ret;
}



############################ sub runFormatFiletoSam ##################################
sub removePartialOverlapHitClan{
	my ($lixo, $startHit, $endHit, $domain, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $clanFile, $CONF_EVALUE, $array) = @_;
	
	my @localArray = @{$array};
	@localArray = Array->sortArray2d(1, \@localArray);
	
	my $startHit_j;				my $endHit_j;
	my $save;					my @array_ret = ();
	my $domain_j;				my $evalue_j;
	
	#print "Remove overlap with $domain $startHit $endHit\n";
	for (my $j =0; $j < scalar(@localArray); $j++) {
		$evalue_j   = $localArray[$j][0];
		$startHit_j = $localArray[$j][1];
		$endHit_j 	= $localArray[$j][2];
		$domain_j	= $localArray[$j][4];
		$save = "true";	
		if ($evalue_j <= $CONF_EVALUE){
			#print ">>>> $startHit_j $endHit_j $domain_j\n";
			if (Domain->isOverlapHitClan($startHit, $endHit, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain, $domain_j, $clanFile) eq "true" ){
				$save = "false";
				#print "overlap\n";
			}
			if ($save eq "true"){
				#print "===> SAVE  $startHit_j $endHit_j \n";
				push(@array_ret, $localArray[$j]);
			}
		}
	}
	return @array_ret;
}

	
############################ sub runFormatFiletoSam ##################################
sub isOverlapHit{
	my $startHit_i			= $_[1];
	my $endHit_i 			= $_[2];
	my $startHit_j			= $_[3];
	my $endHit_j			= $_[4];
	my $overlapAA_alowed  	= $_[5];
	my $perc_overlap_alowed	= $_[6];
	my $domains_overlap		= $_[7];
	my $domain_i			= $_[8];
	my $domain_j			= $_[9];
	
	#print "startHit_i = $startHit_i\nendHit_i = $endHit_i\nstartHit_j = $startHit_j\nendHit_j = $endHit_j\noverlapAA_alowed = $overlapAA_alowed\nperc_overlap_alowed = $perc_overlap_alowed\n";
	#print "domains = \n$domain_i\n$domain_j\n";
	my $overlapAA = 0;			my $perc_overlap_i = 0;
	my $perc_overlap_j = 0;
	
	#print "size_i = $size_i\n";
	
	$overlapAA = Domain->calculateOverlapSize($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	
	#print "overlapAA = $overlapAA\n";
	if ($domains_overlap ne ""){
		#print "\nentrou1\n";
		my $domain_i_j = $domain_i.":".$domain_j;
		my $domain_j_i = $domain_j.":".$domain_i;		
		if (index($domains_overlap, $domain_i_j) >= 0 || index($domains_overlap, $domain_j_i) >= 0){
			#print "\nentrou2\n";
			if ($overlapAA > 0){
				return "false";
			}
		}
		
	}
	
	if ($overlapAA_alowed == 0 && $perc_overlap_alowed == 0){
		if ($overlapAA == 0){
			return "false";
		}else{
			return "true";
		}		
	}
	$perc_overlap_i = Domain->calculateOverlapPerc($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	$perc_overlap_j = Domain->calculateOverlapPerc($startHit_j, $endHit_j, $startHit_i, $endHit_i);
	#print "overlapAA = $overlapAA\tperc_overlap = $perc_overlap_i\n";
	#print "overlapAA = $overlapAA\tperc_overlap = $perc_overlap_j\n";
	#print $perc_overlap_alowed."\n\n";
	
	if ($overlapAA ==0){
		return "false";
	}elsif ($overlapAA <= $overlapAA_alowed && $perc_overlap_i <= $perc_overlap_alowed && $perc_overlap_j <= $perc_overlap_alowed){
		#print "overlap false1\n\n";
		return "false";
	}
	#if ($perc_overlap_i <= $perc_overlap_alowed || $perc_overlap_j <= $perc_overlap_alowed){
	#	print "overlap false2\n\n";
	#	return "false";
	#}
	
	#print "overlap true\n\n";
	return "true";
}


############################ sub runFormatFiletoSam ##################################
sub removeOverlapHitMax{
	my ($lixo, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap,  $array) = @_;
	my @localArray = @{$array};
	@localArray = Array->sortArray2dDesc(0, \@localArray);

	
	my $startHit_i;				my $startHit_j;
	my $endHit_i;				my $endHit_j;
	my $evalue_i;				my $evalue_j;
	my $save = "true";			my $domain_i;
	my $info = "";				my $domain_j;
	my @array_ret = ();			my $stop;
	my $i =0;					my  $j;
	while ( $i < scalar(@localArray)) {
		$startHit_i = $localArray[$i][1];
		$endHit_i = $localArray[$i][2];
		$evalue_i = $localArray[$i][0];
		$domain_i = $localArray[$i][4];
		$save = "true";
		$stop = "false";
		
		$j = 0;
		#print "\n\nNEW $i == > $startHit_i $endHit_i $evalue_i j=$j\n";
		while ($j <= ($i -1)) {
			$startHit_j = $localArray[$j][1];
			$endHit_j = $localArray[$j][2];	
			$evalue_j = $localArray[$j][0];		
			$domain_j = $localArray[$j][4];
			
			#print "J = $j $startHit_j $endHit_j $evalue_j\n";
			
			if (Domain->isOverlapHit($startHit_i, $endHit_i, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j) eq "true" ){				
				if ($evalue_i < $evalue_j){
					$save = "false";					
					#print "found better\n";
				}
			}				
			$j++;					
		}
		if ($save eq "true"){
			#print "===> SAVE  $startHit_i $endHit_i $evalue_i\n";
			push(@array_ret, $localArray[$i]);				
		}
		
		$i++;
		
			
	}
	return @array_ret;
}


############################ sub runFormatFiletoSam ##################################
sub getHitsWithOverlap{
	my ($lixo, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $startHit, $endHit, $array) = @_;
	
	my @localArray = @{$array};
	
	my $startHit_j;				my $endHit_j;
	my $save;					my @array_ret = ();
	my $domain_j;
	
	#print "Remove overlap with $startHit $endHit\n";
	for (my $j =0; $j < scalar(@localArray); $j++) {
		$startHit_j = $localArray[$j][1];
		$endHit_j 	= $localArray[$j][2];
		$domain_j 	= $localArray[$j][4];
		$save = "false";	
		#print "$startHit_j $endHit_j\n";
		if (Domain->isOverlapHit($startHit, $endHit, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j) eq "true"){
				$save = "true";
				#print "overlap\n";
		}
		if ($save eq "true"){
			#print "===> SAVE  $startHit_j $endHit_j \n";
			push(@array_ret, $localArray[$j]);
		}
	}
	return @array_ret;
}
############################ sub runFormatFiletoSam ##################################
sub getMDOArchs{		
	my $columnAcc			= $_[1];
	my $columnDom			= $_[2];
	my $domainOrgFile		= $_[3];
	my $archFile			= $_[4];
	my $tmpDir				= $_[5];
	my $verbose				= $_[6];
	
	my @array_domains= ();		my @array_arch;				
	my $info_domain = "";		my $info_domain_real;
	my $total_domains;			my $combs;
	my $mdco = 0;				my $MAX_DOM = 6;
	
	my %hash = FilesIO->fileToHash($archFile, "\t", $columnAcc);
	my @array_mdco = ('2','3','4','5','6');	
	my @matrixSta = Analisys->initMatrixStaRow(2, \@array_mdco);
	my $i = 0;
	while ( my ($key, $value) = each(%hash) ) {
		#print $value."\n";
		$i++;
		print "======> $i $key\n";
		@array_arch = String->StringToArray2d($value, "\n", "\t");
		@array_domains = Array->copyColMatrixToArray2($columnDom, \@array_arch);
		
		$info_domain =  Array->printArray(":", \@array_domains); 
		$info_domain =~ s/PF//g;
		@array_domains = String->StringToArray($info_domain, ":");
		if (scalar(@array_domains) > 1){
			$info_domain_real = Array->printArray(" ", \@array_domains); 
			$total_domains = scalar(@array_domains);
			if ($total_domains > $MAX_DOM){
				$combs = $MAX_DOM;
			}else{
				$combs = $total_domains;
			}
			#print $info_domain."\n";
			$mdco =  Domain->getMaxMDO($combs, $info_domain_real, $domainOrgFile, $tmpDir, $verbose);
			@matrixSta = Analisys->fillMatrixStaBigger(1, $mdco, \@matrixSta);	
			
		}
	}
	@matrixSta = Array->copyColMatrixToArray2(1, @matrixSta);
	return Array->printArray("\t", \@matrixSta)."\n";
	
}

1