package Sequences;
use strict;


if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use File::Files;
use Sequence::sequence;
use Sequence::protein;
use String::StringUtil;
use Align::Primary::clustalw;
use Align::Primary::alignment;

############################ sub getSequencesFromFasta ####################################
sub getSequencesFromFasta {
  
  my $path 	 = $_[1];
    
  my %hash_seq   = ();  
  my @array_file = ();
  my $line; 
  my $entry_file;  
  my $annotation;
  my $sequence;
  my $all;
  
   if (open(FILE, "$path")){
       @array_file = <FILE>;
	
	foreach $line (@array_file) {
		if ($line ne "\n"){
			$all .= $line;
		}	
	}
	
	my @sequence_file = split (/>/, $all);
	
	foreach $entry_file (@sequence_file) {
		if($entry_file	=~ /(.+)\n((.+\n)+)/ ) {
	       		$annotation 	= $1;
                        $sequence 	= $2;
                        $hash_seq{$annotation} = $sequence;	
		}
	}
        return %hash_seq;
   }   
   else {
    print "Sequence::Sequences::getSequencesFromFasta Could not open file $path  to read !\n";
    exit;
  } 
}

############################ sub getSequencesFromFasta ####################################
sub getSequenceFromFastaArray {
  
  my $path 	 = $_[1];
    
  my @sequences   = ();  
  my @array_seq = ();  
  my $i  = 0;
  my $j  = 0;
  my $annotation;
  my $sequence;
   
   
   if (FilesIO->isFile($path) eq "true"){
	
		@sequences = FilesIO->lineFileToArray($path);
		
		#print "total". scalar(@sequences)."\n";
		while ($i < scalar(@sequences)){
			
				if (index($sequences[$i],">") == 0){
					$annotation 	= $sequences[$i];
				}
	       		$i++;
	       		#print "i = $i \n";
	       		$sequence = "";
	       		while ($i < scalar(@sequences) && (index($sequences[$i],">") != 0)){
	       			$sequence.= $sequences[$i];
                	$i++;
                	#print "i = $i \n";
                }      		
               	
                $array_seq[$j]  = $annotation.$sequence;
                #print   $array_seq[$j];
                $j++;
				
		}
		return @array_seq;
	}        
    else {
    	print "Sequence::Sequences::getSequencesFromFasta Could not open file $path  to read !\n";
    	exit;
  } 
}

############################ sub getSequencesFromFasta ####################################
sub getSequenceFromFastaArray2D {
  
  my $path 	 = $_[1];
  my $keepBreakLine	 = $_[2];
  
  if (!defined($keepBreakLine)){
  		$keepBreakLine = "false";
  }
  
  my @sequences   = ();  
  my @array_seq = ();  
  my $i  = 0;
  my $j  = 0;
  my $annotation;
  my $sequence;
  my $start =  "false";
   
   
   if (FilesIO->isFile($path) eq "true"){
	
		@sequences = FilesIO->lineFileToArray($path);
		
		
		
		#print "total". scalar(@sequences)."\n";
		while ($i < scalar(@sequences)){
			
				if (index($sequences[$i],">") == 0){
					$annotation 	= $sequences[$i];
				}
	       		$i++;
	       		#print "i = $i \n";
	       		$sequence = "";
	       		while ($i < scalar(@sequences) && (index($sequences[$i],">") != 0)){
	       			if ($keepBreakLine eq "true"){
	       				$sequence.=  $sequences[$i];
	       			}else{
	       				$sequence.=  String->removeCaracter($sequences[$i],"\n");
	       			}
	       			
                	$i++;
                	#print "i = $i \n";
                }      		
               	
                $array_seq[$j][0]  = $annotation;
                $array_seq[$j][1]  = $sequence;
                #print   $array_seq[$j];    
                $j++;
        
				
		}
		return @array_seq;
	}        
    else {
    	print "Sequence::Sequences::getSequencesFromFasta Could not open file $path  to read !\n";
    	exit;
  } 
}

############################ sub getSequencesFromFasta ####################################
sub getSequenceFromFastaHash {
  
  my $path 	 = $_[1];
    
  my @sequences   = ();  
  my %array_seq = ();  
  my $i  = 0;
  my $j  = 0;
  my $annotation;
  my $sequence;
   
   
   if (FilesIO->isFile($path) eq "true"){
	
		@sequences = FilesIO->lineFileToArray($path);
		
		#print "total". scalar(@sequences)."\n";
		while ($i < scalar(@sequences)){
			
				if (index($sequences[$i],">") == 0){
					$annotation 	= $sequences[$i];
					$annotation = String->removeCaracter($annotation, "\n");
				}
	       		$i++;
	       		#print "i = $i \n";
	       		$sequence = "";
	       		while ($i < scalar(@sequences) && (index($sequences[$i],">") != 0)){
	       			$sequence.=  String->removeCaracter($sequences[$i],"\n");
                	$i++;
                	#print "i = $i \n";
                }      		
               	
                $array_seq{$annotation} = $sequence;
                #print   $array_seq[$j];
                $j++;
				
		}
		return %array_seq;
	}        
    else {
    	print "Sequence::Sequences::getSequencesFromFasta Could not open file $path  to read !\n";
    	exit;
  } 
}


############################ sub getSequencesFromFasta ####################################
sub divideSeq {
  
  my $seq	 = $_[1];
  my $len	 = $_[2];

  my $entry;
  my $i = 0;
  my $info ="";

  my @array = split(//,$seq);
  
  foreach $entry (@array) {
	if ($i ==$len){
		$info .= "\n";
		$i=0;
	}
  	$info .= $entry;
	$i++;
  }
  return $info;

}

############################ sub removeCaracter ####################################
sub removeCaracter {
  
  my $seq	 = $_[1];
  my $car	 = $_[2];

  my $entry;
  my $info ="";

  my @array = split(//,$seq);
  
  foreach $entry (@array) {
	if ($entry ne $car){
		$info .=$entry;
	}
  }
  return $info;
}

############################ sub removeCaracter ####################################
sub getSequenceN {
  
  my $file	 				= $_[1];
  my $sequenceNumber	 	= $_[2];
  my $count = 0;
  my $seq = "";
  
	if (open(FILEIN, "$file")){
		while (my $line = <FILEIN>) {
			if (index($line, ">") ==0 && $seq ne ""){
				$count++;
				if ($count == $sequenceNumber){
					close FILEIN;
					return $seq;
				}				
				$seq = ""; 
			}
			$seq .=$line;		
		}	
		$count++;
		if ($count == $sequenceNumber){
			close FILEIN;
			return $seq;
		}else{
			close FILEIN;
		}        
	}
	else{
		print "ERROR::perlLib::sequence.pm:: $file is NOT a file\n";
		exit;
	}
			
	
  	print "ERROR::perlLib::sequence.pm:: There is NOT sequence of number $sequenceNumber \n";
  	exit;
}


############################ sub removeCaracter ####################################
sub createSequences {
  
  my $file	 				= $_[1];
  my $dir_out 				= $_[2];
  my $name_sequence_field	= $_[3];
  my $sep	 				= $_[4];
  my $verbose	 			= $_[5];
 
  my $count = 0;
  my $seq = "";
  my $name_sequence;
  my @array = ();
  
	if (open(FILEIN, "$file")){
		while (my $line = <FILEIN>) {
			if (index($line, ">") == 0 && $seq ne ""){
				if (FilesIO->isFile($dir_out.$name_sequence.".seq") eq "false"){
					#FilesIO->saveFile($dir_out.$name_sequence.".seq", $seq, $verbose);
				}	
				$count++;
				$seq = ""; 
			}
			if (index($line, ">") == 0){
				@array = split(/$sep/, $line);
				$name_sequence = $array[$name_sequence_field];		
				$name_sequence = String->removeCaracter($name_sequence,">");		
			}
			$seq .=$line;		
		}	
		$count++;
		if (FilesIO->isFile($dir_out.$name_sequence.".seq") eq "false"){
			FilesIO->saveFile($dir_out.$name_sequence.".seq", $seq, $verbose);
		}	
		close FILEIN;
		return $count;		    
	}
	else{
		print "ERROR::perlLib::sequence.pm:: $file is NOT a file\n";
		exit;
	}  
}

############################ sub removeCaracter ####################################
sub getOneSequenceFromDatabase {
  
  my $file	 				= $_[1];
  my $sequence_out 			= $_[2];
  my $name_sequence_field	= $_[3];
  my $verbose	 			= $_[4];
 
  my $save_seq = "false";
  my $count = 0;
  my $seq = "";
  my $name_sequence;
  my @array = ();
  
  #print $name_sequence_field."\n";
  
  if (open(FILEIN, "$file")){
		while (my $line = <FILEIN>) {
			if (index($line, ">") == 0 && $seq ne ""){				
				if ($save_seq eq "true"){
					#print $seq;
					FilesIO->saveFile($sequence_out, $seq, $verbose);
					return "true";
				}
				$seq = ""; 
			}
			if (index($line, ">") == 0 && index($line, $name_sequence_field) >= 0){
				$save_seq = "true";					
			}
			$seq .=$line;		
		}	
		$count++;
		if (index($seq, $name_sequence_field) >= 0){
			FilesIO->saveFile($sequence_out, $seq, $verbose);
			return "true";		
		}	
		close FILEIN;
		return "false";		    
	}
	else{
		print "ERROR::perlLib::sequence.pm:: $file is NOT a file\n";
		exit;
	}  
}

############################ sub create ####################################
sub getPercentGroup{
	my $sequence		 = $_[1];
	my $set	 			 = $_[2];
  	
  	my $entry_seq;
  	my $entry_set;
  	my $count = 0;
  	my $perc = 0;
  	my $info = "";
  	
  	my $len_seq = length($sequence);
  	my @array_seq = split(//, $sequence);
  	my @array_set = split(//, $set);
  	
  	foreach $entry_set (@array_set){
  		foreach $entry_seq (@array_seq){
  			if (uc($entry_seq) eq uc($entry_set)){
  				$count++;
  			}  		
  		}  		
  	}
  	
  	if ($count != 0){
  		$perc = ($count / $len_seq) * 100;
   	}
  	return $perc;
}

############################ sub create ####################################
sub lengthSequence{
	my $sequence		 = $_[1];

	
	my $len_seq = length($sequence);	
	return $len_seq ;
}


############################ sub create ####################################
sub getInterval{
	my $sequence		 = $_[1];
	my $startHit		 = $_[2];
	my $endHit		 	 = $_[3];
	
	my $start = $startHit -1;
	my $length_dom = $endHit - $startHit + 1;
	my $sequence_interval = substr($sequence, $start, $length_dom);
	#print "$startHit $endHit $length_dom\n";

	#print $sequence."\n";
	#print $sequence_interval."\n";
	return $sequence_interval ;
}


############################ sub create ####################################
sub lengthSequenceByFile{
	my $sequenceFile		 = $_[1];

	my @array_seqs = Sequences->getSequenceFromFastaArray2D($sequenceFile); 
  	my $sequence = $array_seqs[0][1];
	my $len_seq = length($sequence);	
	return $len_seq ;
}

############################ sub createPredBySequence ##################################
sub findIdentityFromPair {
	  
	my $sequence1 	= $_[1];    
  	my $sequence2 	= $_[2];
  	my $tmpDir		= $_[3];
  	my $verbose 	= $_[4];
  	
  	
  	my $input_clustal 	= $tmpDir."seq_aln.txt"; 
  	my $output_clustal 	= $tmpDir."seq_aln.clustalw";
  	my $identity;

	FilesIO->saveFile($input_clustal, $sequence1."\n".$sequence2, $verbose);
	Clustalw->runAlign($input_clustal, $output_clustal, $verbose);
	
	FilesIO->checkFile($output_clustal,"ERROR::runClustalw:: Output file $output_clustal NOT created!\n");
	$identity = Alignment->getIdentity($output_clustal);
	#print "identity = ".$identity."\n";
	FilesIO->removeFile($output_clustal, $verbose);
	FilesIO->removeFile($input_clustal, $verbose);
	#FilesIO->saveFile($file_1_2,$identity, $verbose);
	return $identity;
}

############################ sub createPredBySequence ##################################
sub generateSequenceShuffled {
	  
	my $sequence 	= $_[1];  #only sequence without annotation  
  	my $number	 	= $_[2];
  	my $verbose 	= $_[3];
  	
  	my $random_number;				my $shuffled = 	"";
  	
  	my @aminos = Protein->getAmino1d();
  
   	my $range = scalar(@aminos);

	for (my $i = 0; $i < $number; $i++){
  		$random_number = int(rand($range));
  		$shuffled .= $aminos[$random_number];
	}
  
	return lc($sequence.$shuffled);
}

############################ sub createPredBySequence ##################################
sub sequenceStringToArray {
	  
	my $sequence 	= $_[1];    
  	my $verbose 	= $_[2];
  	
  	my $sequence_info = "";
  	
  	my @array_seq = split(/\n/, $sequence);  	
  	my $annotation = $array_seq[0];
  	
  	for (my $i = 1; $i < scalar(@array_seq); $i++){
  		$sequence_info .= $array_seq[$i];
  	}
  	
  	my @array_ret = ();
  	$array_ret[0] = $annotation;
  	$array_ret[1] = $sequence_info;
}

############################ sub createPredBySequence ##################################
sub getAverageSize {
	  
	my $sequenceFile 	= $_[1];    
  	my $verbose 		= $_[2];
  	
  	my $len_seq;			my $sum = 0;
  	
  	my @sequences = Sequences->getSequenceFromFastaArray2D($sequenceFile);
  	for (my $i = 0; $i < scalar(@sequences); $i++){
  		$len_seq = Sequences->lengthSequence($sequences[$i][1]);
  		$sum = $sum + $len_seq;
  	}
  	return ($sum/scalar(@sequences));
}

############################ sub createPredBySequence ##################################
sub getNumberOfSequence {
	  
	my $sequenceFile 	= $_[1];    
  	my $verbose 		= $_[2];
  	
  
  	my @sequences = Sequences->getSequenceFromFastaArray2D($sequenceFile);
  	return (scalar(@sequences));
}
	
 
############################ sub createPredBySequence ##################################
sub createHashSequence {
	  
	my $sequence	= $_[1];
	my $mer			= $_[2];    
  	my $verbose 	= $_[3];
  	
  	my $i = 0;			my %hash_seq = ();
  	my $count=0;		my $aux;
  	
  	my @chars = split(//, $sequence);
  	
  	while ($i < scalar(@chars)){
  		$aux = "";
  		for (my $j=0; $j<$mer && ($j+$i < scalar(@chars)); $j++){
  			$aux .=$chars[$j+$i];
  		}
  		$hash_seq{$count} = $aux;
  		$count++;
  		$i=$i + $mer;
  	}  	
  	return %hash_seq;
}
	
############################ sub createPredBySequence ##################################
sub createSequenceArray {
	  
	my $sequence	= $_[1];
	my $mer			= $_[2];    
  	my $verbose 	= $_[3];
  	
  	my $i = 0;			my @array = ();
  	my $count=0;		my $aux;
  	
  	my @chars = split(//, $sequence);
  	
  	while ($i < scalar(@chars)){
  		$aux = "";
  		for (my $j=0; $j<$mer && ($j+$i < scalar(@chars)); $j++){
  			$aux .=$chars[$j+$i];
  		}
  		$array[$count] = $aux;
  		$count++;
  		$i=$i + $mer;
  	}  	
  	return @array;
}



############################ sub getSequencesFromFasta ####################################
sub getSizeSequence {
  
  	my $input 	 = $_[1];
  	my $output 	 = $_[2];
 	my $verbose	 = $_[3];
 
 	my $info = "";				my $name = "";
 	my $len_seq = "";
 	
 	my @sequences = Sequences->getSequenceFromFastaArray2D($input);
  	for (my $i = 0; $i < scalar(@sequences); $i++){
  		$len_seq = Sequences->lengthSequence($sequences[$i][1]);
  		$name = $sequences[$i][0];
  		$name = String->removeCaracter($name, ">");
  		$name = String->removeCaracter($name, "\n");
  		$info .= $name."\t". $len_seq."\n";
  	}
  	
	FilesIO->saveFile($output, $info, $verbose);
  	
}

	
1
