package Array;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use String::StringUtil;
use Util::Number;
use Util::Array;

my $PROG_NAME = "PERL_LIB::Util::Array::";


############################ sub loadAlign1d ####################################
sub initMatrixValue{
	my ($lixo, $rows, $cols, $value) = @_;
	
	my @matrix = ();
	
	for (my $i = 0; $i < $rows; $i++){
		for (my $j = 0; $j <$cols; $j++){
			$matrix[$i][$j] = $value;
		}
	}
	return @matrix;
}

############################ sub loadAlign1d ####################################
sub initArray{
	my ($lixo, $rows, $value) = @_;
	
	my @matrix = ();
	
	for (my $i = 0; $i < $rows; $i++){
		$matrix[$i] = $value;
	}
	return @matrix;
}

############################ sub loadAlign1d ####################################
sub initMatrixColValue{
	my ($lixo, $cols, $value, $matrix) = @_;
	
	my @lmatrix = @{$matrix};
	
    my @array_cols = split(/:/, $cols);
	
	
	for (my $i = 0; $i < scalar(@lmatrix); $i++){
		for (my $j = 0; $j < scalar(@array_cols); $j++){
			$lmatrix[$i][$array_cols[$j]] = $value;
		}
	}
	return @lmatrix;
}



############################ sub loadAlign1d ####################################
sub removeRepeatedColMatrix {
	my ($lixo, $col, $array) = @_;
	
	my @lArray = @{$array};
	my @array_ret = ();
    my $info = "";
    my $found = "false";    
    
	for (my $i = 0; $i < scalar(@lArray); $i++){
		$found = "false";
  		for (my $j = $i + 1; $j < scalar(@lArray); $j++){
  			if ($lArray[$i][$col] eq $lArray[$j][$col]){
  				$found = "true";
  				$j = scalar(@lArray);
  			}
 		}
 		if ($found eq "false"){
 			push(@array_ret, $lArray[$i]);
 		}
 	}
  	return @array_ret;
}


############################ sub loadAlign1d ####################################
sub removeRepeatedMultipleColMatrix {
	my ($lixo, $col, $array) = @_;
	
	my @lArray = @{$array};
	my @array_ret = ();
    my $info = "";
    my $count_equals = 0;
    my $found = "false";  
    my @array_cols = split(/:/, $col);
    
	for (my $i = 0; $i < scalar(@lArray); $i++){
		$found = "false";
  		for (my $j = $i + 1; $j < scalar(@lArray); $j++){
  			$count_equals = 0;
  			for (my $k = 0; $k < scalar(@array_cols); $k++){
  				if ($lArray[$i][$array_cols[$k]] eq $lArray[$j][$array_cols[$k]]){
  					$count_equals++;
  				}else{
  					$k = scalar(@array_cols);
  				}
  			}
  			if ($count_equals eq scalar(@array_cols)){
  				$found = "true";
  				$j = scalar(@lArray);
  			}
 		}
 		if ($found eq "false"){
 			push(@array_ret, $lArray[$i]);
 		}
 	}
  	return @array_ret;
}



############################ sub loadAlign1d ####################################
sub removeRepeated {
	my ($lixo, $array) = @_;
	
	my @lArray = @{$array};
	my @array_ret = ();
    my $info = "";
    my $found = "false";    
    
	for (my $i = 0; $i < scalar(@lArray); $i++){
		$found = "false";
  		for (my $j = $i + 1; $j < scalar(@lArray); $j++){
  			if ($lArray[$i] eq $lArray[$j]){
  				$found = "true";
  				$j = scalar(@lArray);
  			}
 		}
 		if ($found eq "false"){
 			push(@array_ret, $lArray[$i]);
 		}
 	}
  	return @array_ret;
}


############################ sub loadAlign1d ####################################
sub removeRepeatedKeepOrder {
	my ($lixo, $array) = @_;
	
	my @lArray = @{$array};
	my @array_ret = ();
    my $info = "";
    my $found = "false";  
    push(@array_ret, $lArray[0]);  
    
	for (my $i = 1; $i < scalar(@lArray); $i++){
		$found = "false";
  		for (my $j = 0; $j < scalar(@array_ret); $j++){
  			if ($lArray[$i] eq $array_ret[$j]){
  				$found = "true";
  				$j = scalar(@array_ret);
  			}
 		}
 		if ($found eq "false"){
 			push(@array_ret, $lArray[$i]);
 		}
 	}
  	return @array_ret;
}

############################ sub loadAlign1d ####################################
sub countRepeated {
	my ($lixo, $array) = @_;
	
	my @lArray = @{$array};
	my @array_ret = ();
    my $info = "";
    my $count = 0;   
    my %hash = (); 
    
	for (my $i = 0; $i < scalar(@lArray); $i++){
		$count = 0; 
  		for (my $j = 0; $j < scalar(@lArray); $j++){
  			if ($lArray[$i] eq $lArray[$j]){
  				$count++;
  			}
 		}
 		$hash{$lArray[$i]} = $count;
 	}
  	return %hash;
}



############################ sub loadAlign1d ####################################
sub countGreaterSmallerThan {#only number vectors
	my ($lixo, $kind, $value, $array) = @_;
	
	my @lArray = @{$array};
    my $count = 0;   
   
	for (my $i = 0; $i < scalar(@lArray); $i++){
		if ($kind eq "greater"){
			if ($lArray[$i] > $value){
  				$count++;
  			}
		}elsif ($kind eq "smaller"){
			if ($lArray[$i] < $value){
  				$count++;
  			}
		}elsif ($kind eq "smallerEqual"){
			if ($lArray[$i] <= $value){
  				$count++;
  			}
		}elsif ($kind eq "greaterEqual"){
			if ($lArray[$i] >= $value){
  				$count++;
  			}
		}
  		
  	}
  	return $count;
}

############################ sub loadAlign1d ####################################
sub countRepeatedPattern {
	my ($lixo, $pattern, $array) = @_;
	
	my @lArray = @{$array};
	my @array_ret = ();
    my $info = "";
    my $count = 0;   
    
    
	for (my $i = 0; $i < scalar(@lArray); $i++){
  		if ($lArray[$i] eq $pattern){
  			$count++;
  		}
 		
 	}
  	return $count;
}


############################ sub loadAlign1d ####################################
sub removeRowsMatriz {
	my ($lixo, $rows, $matrix) = @_;
	
	my @lMatrix = @{$matrix};
	my @matrix_ret = ();
    my $count = 0;
    
    my @array_rows = split(/:/, $rows);
    
	for (my $i = 0; $i < scalar(@lMatrix); $i++){
		if (Array->isInArray($i, \@array_rows) eq "false"){
			for (my $j = 0; $j < $#{$lMatrix[$i]} + 1; $j++){
  				$matrix_ret[$count][$j] = $lMatrix[$i][$j];  				
  			}
  			$count++;
		}
 	}
  	return @matrix_ret;
}



############################ sub loadAlign1d ####################################
sub removeColsMatriz {
	my ($lixo, $cols, $matrix) = @_;
	
	my @lMatrix = @{$matrix};
	my @matrix_ret = ();
    my $count = 0;
    
    my @array_cols = split(/:/, $cols);
    
	for (my $i = 0; $i < scalar(@lMatrix); $i++){
		$count = 0;
		for (my $j = 0; $j < $#{$lMatrix[$i]} + 1; $j++){
  			if (Array->isInArray($j, \@array_cols) eq "false"){
  				$matrix_ret[$i][$count] = $lMatrix[$i][$j];  
  				$count++;				
  			}  			
		}
 	}
  	return @matrix_ret;
}



############################ sub loadAlign1d ####################################
sub removePositions {
	my ($lixo, $arrayPosRM, $matrix) = @_;
	
	my @lArrayPosRM = @{$arrayPosRM};
	my @lMatrix = @{$matrix};
	my @matrix_ret = ();
    my $info = "";
    
	for (my $j = 0; $j < scalar(@lMatrix); $j++){
  		if (Array->isInArray($j, \@lArrayPosRM) eq "false"){
  			push(@matrix_ret, $lMatrix[$j]);
  		}
 	}
  	return @matrix_ret;
}


############################ sub loadAlign1d ####################################
sub getPositionsArray {
	my ($lixo, $infoPos, $array) = @_;
	
	my @lArrayPos = split(/:/, $infoPos);
	my @larray = @{$array};
	my @array_ret = ();
  
    
	for (my $j = 0; $j < scalar(@lArrayPos); $j++){
			#print $larray[$lArrayPos[$j]]."\n";
  			push(@array_ret, $larray[$lArrayPos[$j]]);
 	}
  	return @array_ret;
}

############################ sub loadAlign1d ####################################
sub printArray {
	my ($lixo, $sep, $array) = @_;
    my $info = "";
    my @localArray = @{$array};
   
  	for (my $i = 0; $i < scalar(@localArray); $i++){
  		$info .= $localArray[$i];
  		if ($i != scalar(@localArray)-1){
  			$info .= $sep;
  		}  		 
  	}
  	return $info;
}

############################ sub loadAlign1d ####################################
sub printMatrix {
	my ($lixo, $sep, $row, $col, $array) = @_;
	
	my @localArray = @{$array};
	
    my $info = "";
  	for (my $i = 0; $i < $row; $i++){
  		for (my $j = 0; $j < $col; $j++){
  			$info .=String->removeCaracter($localArray[$i][$j], "\n");
  			if ($j != $col-1){
  				$info .= $sep;
  			}   		 		 
  		}
  		$info .= "\n";
  	}
  	if ($info eq ""){
  		@localArray = ();
  	}
  	return $info;
}


############################ sub loadAlign1d ####################################
sub printMatrix2 {
	my ($lixo, $sepCol, $sepRow, $array) = @_;
	
	my @localArray = @{$array};
	
    my $info = "";
    my $col;
    
  	for (my $i = 0; $i < scalar(@localArray); $i++){
  		$col =  $#{$localArray[$i]} + 1;
  		for (my $j = 0; $j < $col; $j++){
  			$info .=String->removeCaracter($localArray[$i][$j], "\n");
  			if ($j != $col-1){
  				$info .= $sepCol;
  			}   		 		 
  		}
  		$info .= $sepRow;
  	}
  	if ($info eq ""){
  		@localArray = ();
  	}
  	return $info;
}


############################ sub loadAlign1d ####################################
sub printMatrixRow {
	my ($lixo, $sep, $row, $array) = @_;
	
	my @localArray = @{$array};
	
    my $info = "";
    my $col;
    
	$col =  $#{$localArray[$row]} + 1;
	for (my $j = 0; $j < $col; $j++){
		$info .=String->removeCaracter($localArray[$row][$j], "\n");
  		if ($j != $col-1){
  			$info .= $sep;
  		}   		 		 
  	}
  	if ($info eq ""){
  		@localArray = ();
  	}
  	return $info;
}


############################ sub loadAlign1d ####################################
sub printColMatrix {
	my ($lixo, $col, $sep, $array) = @_;
	
	my @localArray = @{$array};
	
	if (scalar(@localArray) == 0){
		return "";
	}
    my $info = "";
    
  	for (my $i = 0; $i < scalar(@localArray); $i++){
  		$info .= $localArray[$i][$col];
  		if ($i != scalar(@localArray)-1){
  			$info .= $sep;
  		}   		 		 
  	}
  	return $info;
}





############################ sub loadAlign1d ####################################
sub arrayToHash {
	my ($lixo, $sep, $field, $row, $col, $array) = @_;
    my $info = "";		my $key;
    my %hash = ();
    my @localArray = @{$array};
  	for (my $i = 0; $i < $row; $i++){
  		$info = "";
  		$key = $localArray[$i][$field];
  		for (my $j = 0; $j < $col; $j++){
  			$info .=String->removeCaracter($localArray[$i][$j], "\n");
  			if ($j != $col-1){
  				$info .= $sep;
  			}   		 		 
  		}
  		$info .= "\n";
  		if (!exists($hash{$key})){
  			$hash{$key} = $info;
  		}else{
  			$hash{$key} .= $info;
  		}
  	}
  	return %hash;
}


############################ sub loadAlign1d ####################################
sub readFileToMat {
	my $file	= $_[1];
  	my $sep		= $_[2];
  	
  	my @mat = ();
  	my @rows_mat = ();
 	my @cols_mat = ();
  	my $datas = "";
  	my $line;
  
  	
 	if (FilesIO->isFile($file) eq "true"){
  		@rows_mat = FilesIO->lineFileToArray($file);
  		
  		for (my $i = 0; $i < scalar(@rows_mat); $i++){#i = row
  			$line = String->removeCaracter($rows_mat[$i],"\n");
  			@cols_mat = split(/$sep/,$line);
  			
  			for (my $j = 0; $j < scalar(@cols_mat); $j++){#j = column
  				if ($cols_mat[$j] ne " "){
  					$mat[$i][$j] = String->trim($cols_mat[$j]);  
  				}
  				 						
  			}
  		}
  		return @mat;
 	}
  	else{
  		print "ERROR Util::Array.pm File $file not found\n";
  		
  	}
  	
}

############################ sub loadAlign1d ####################################
sub writeArrayToFile {
	my ($lixo, $fileName, $verbose,  $array) = @_;
  	
  	
  	my $data = "";
	my @localArray = @{$array};
  
  	for (my $i = 0; $i < scalar(@localArray); $i++){
  		$data .= $localArray[$i]. "\n";
  	}  	
  	FilesIO->saveFile($fileName, $data, $verbose);  	
}

############################ sub loadAlign1d ####################################
sub writeMatrixToFile {
	my ($lixo, $fileName, $sepCol, $sepRow, $verbose,  $matrix) = @_;
  	
  	
  	my $data = "";
  	my $cols;
	my @lMatrix = @{$matrix};
  
  	for (my $i = 0; $i < scalar(@lMatrix); $i++){
  		$cols =  $#{$lMatrix[$i]} + 1;
  		for (my $j = 0; $j < $cols; $j++){
  			$data .= $lMatrix[$i][$j];
  			if ($j < $cols-1){
  				$data .= $sepCol;
  			}
  		}
  		$data .= $sepRow;
  	}  	
  	FilesIO->saveFile($fileName, $data, $verbose);  	
}

############################ sub loadAlign1d ####################################
sub showhas1D(\%) {
	my(%mat) = %_ ;

 	print  $mat{0}."\t";
  		
  	
	print "\n"	

}

############################ sub loadAlign1d ####################################
sub lineStringToArray {
	
	my $line	= $_[1];
	
	my @array = split(/\n/, $line);
	
	return @array;	
}



############################ sub loadAlign1d ####################################
sub subtractionMatrix {
	my ($lixo, $field_compare, $cols, $matrix1, $matrix2) = @_; #matrix1 - matrix2

	my @localmatrix1 = @{$matrix1};
	my @localmatrix2 = @{$matrix2};
	my $found = "false";
	my @matrix_ret = ();
	my $count = 0;
	
	for (my $i = 0; $i <scalar(@localmatrix1); $i++){	
		
		$found = "false";	
		for (my $j = 0; $j <scalar(@localmatrix2); $j++){
			#print "comparing M1 ". $localmatrix1[$i][$field_compare]."\tM2 ". $localmatrix2[$j][$field_compare]."\n";
			if ($localmatrix1[$i][$field_compare] eq $localmatrix2[$j][$field_compare]){
				$found = "true";
				$j = scalar(@localmatrix2);
			}		
		}
		if ($found eq "false"){
			for (my $j = 0; $j <$cols; $j++){
				$matrix_ret[$count][$j] = $localmatrix1[$i][$j];
			}
			$count++;
		}
	}
	return @matrix_ret;	
}
############################ sub loadAlign1d ####################################
sub subtractionArray {
	my ($lixo, $array1, $array2) = @_; #array1- array2

	my $found = "false";
	my @array_ret = ();
	my $count = 0;
	
	my @localArray1 = @{$array1};
	my @localArray2 = @{$array2};
	
	for (my $i = 0; $i <scalar(@localArray1); $i++){	
		
		$found = "false";	
		for (my $j = 0; $j <scalar(@localArray2); $j++){
			if ($localArray1[$i] eq $localArray2[$j]){
				$found = "true";
				$j = scalar(@localArray2);
			}		
		}
		if ($found eq "false"){
			$array_ret[$count] = $localArray1[$i];
			$count++;
		}
	}
	return @array_ret;	
}

############################ sub loadAlign1d ####################################
sub intersectionArray {
	my ($lixo, $array1, $array2) = @_; #matrix1 intersection matrix2

	my @array_ret = ();
	my $count = 0;
	
	my @localArray1 = @{$array1};
	my @localArray2 = @{$array2};
	
	for (my $i = 0; $i <scalar(@localArray1); $i++){		
		for (my $j = 0; $j <scalar(@localArray2); $j++){
			if ($localArray1[$i] eq $localArray2[$j]){				
				push(@array_ret, $localArray1[$i]);
			}		
		}
	}
	return @array_ret;	
}

############################ sub loadAlign1d ####################################
sub subtractionElementArray {
	my ($lixo, $array1, $array2) = @_; #matrix1 - matrix2

	my @localArray1 = @{$array1};
	my @localArray2 = @{$array2};

	my $found = "false";
	my @array_ret = ();
	my $count = 0;
	
	for (my $i = 0; $i <scalar(@localArray1); $i++){	
		$array_ret[$i] = $localArray1[$i] - $localArray2[$i];
	}
	return @array_ret;	
}


############################ sub loadAlign1d ####################################
sub logMatrizByCol {
	my ($lixo, $logBase, $col, $matrix) = @_; #matrix1 - matrix2
	my @localmatrix = @{$matrix};

	for (my $i = 0; $i <scalar(@localmatrix); $i++){	
		#print "before matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
		if ($localmatrix[$i][$col] < 1e-200){
			$localmatrix[$i][$col] = "1e-200";
		}		
		$localmatrix[$i][$col] =  Number->log($localmatrix[$i][$col], $logBase);
		#print "after matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
	}
	return @{$matrix};	
}

############################ sub loadAlign1d ####################################
sub subtractionValueMatrizByCol {
	my ($lixo, $value, $col, $matrix) = @_; #matrix1 - matrix2
	my @localmatrix = @{$matrix};

	for (my $i = 0; $i <scalar(@localmatrix); $i++){	
		#print "before matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
		$localmatrix[$i][$col] = $localmatrix[$i][$col] - $value;
		#print "after matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
	}
	return @{$matrix};	
}

############################ sub loadAlign1d ####################################
sub divideValueMatrizByCol {
	my ($lixo, $value, $col, $matrix) = @_; #matrix1 - matrix2
	my @localmatrix = @{$matrix};

	for (my $i = 0; $i <scalar(@localmatrix); $i++){	
		#print "before matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
		$localmatrix[$i][$col] = $localmatrix[$i][$col]/$value;
		#print "after matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
	}
	return @{$matrix};	
}

############################ sub loadAlign1d ####################################
sub divideMatrizValueByCol {
	my ($lixo, $value, $col, $matrix) = @_; #matrix1 - matrix2
	my @localmatrix = @{$matrix};

	for (my $i = 0; $i <scalar(@localmatrix); $i++){	
		#print "before matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
		$localmatrix[$i][$col] = $value/$localmatrix[$i][$col];
		#print "after matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
	}
	return @{$matrix};	
}

############################ sub loadAlign1d ####################################
sub multiplyValueMatrizByCol {
	my ($lixo, $value, $col, $matrix) = @_; #matrix1 - matrix2
	my @localmatrix = @{$matrix};	

	for (my $i = 0; $i <scalar(@localmatrix); $i++){	
		#print "before matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
		$localmatrix[$i][$col] = $localmatrix[$i][$col]*$value;
		#print "after matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
	}
	return @{$matrix};	
}

############################ sub loadAlign1d ####################################
sub multiplyMatrixOnlyRows {
	my ($lixo, $matrix1, $matrix2) = @_; #matrix1 - matrix2
	my @lmatrix1 = @{$matrix1};	
	my @lmatrix2 = @{$matrix2};	
	
	if (scalar(@lmatrix1) != scalar(@lmatrix2)){
		print "ERROR::".$PROG_NAME." Matrix 1 and Matrix 2 have differents size\n";
	}
	
	my @matrix_ret = ();
	
	for (my $i = 0; $i <scalar(@lmatrix1); $i++){	
		for (my $j = 0; $j <$#{$lmatrix1[$i]}+1; $j++){
			$matrix_ret[$i][$j] = $lmatrix1[$i][$j]*$lmatrix2[$i][$j];
		}
	}
	return @matrix_ret;	
}


############################ sub loadAlign1d ####################################
sub multiplyArray{
	my ($lixo, $array1, $array2) = @_; #matrix1 - matrix2
	my @larray1 = @{$array1};	
	my @larray2 = @{$array2};	
	
	if (scalar(@larray1) != scalar(@larray2)){
		print "ERROR::".$PROG_NAME." Array 1 and Array 2 have differents size\n";
	}
	
	my @array_ret = ();
	
	for (my $i = 0; $i <scalar(@larray1); $i++){	
		$array_ret[$i] = $larray1[$i]*$larray2[$i];
	}
	return @array_ret;	
}



############################ sub loadAlign1d ####################################
sub compareArray{
	my ($lixo, $array1, $array2) = @_; #matrix1 - matrix2
	my @larray1 = @{$array1};	
	my @larray2 = @{$array2};	
	
	if (scalar(@larray1) != scalar(@larray2)){
		print "ERROR::".$PROG_NAME." Array 1 and Array 2 have differents size\n";
		exit;
	}
	
	my @array_ret = ();
	my $count = 0;
	
	for (my $i = 0; $i <scalar(@larray1); $i++){	
		if ($larray1[$i] == $larray2[$i]){
			$count++;
		}
	}
	
	if ($count == scalar(@larray1)){
		return "true";	
	}
	return "false";	
}



############################ sub loadAlign1d ####################################
sub sumValueMatrizByCol {
	my ($lixo, $value, $col, $matrix) = @_; #matrix1 - matrix2
	my @localmatrix = @{$matrix};	

	for (my $i = 0; $i <scalar(@localmatrix); $i++){	
		#print "before matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
		$localmatrix[$i][$col] = $localmatrix[$i][$col] + $value;
		#print "after matrix[$i][$col] = ".$localmatrix[$i][$col]."\n";
	}
	return @{$matrix};	
}

############################ sub loadAlign1d ####################################
sub sortArray2dbyNumCols {
	my ($lixo, $matrix) = @_;
	my @new_array = ();
	my @array_ret2 = ();
	my @localmatrix = @{$matrix};
	
	for (my $i = 0; $i < scalar(@localmatrix); $i++){
		$new_array[$i][0] = $i;
		$new_array[$i][1] = $#{ $localmatrix[$i] };
	}
	my @a = @new_array;
	my @b = sort {
      $a->[1] <=> $b->[1];
	}@a;
	my $j = 0;
	
	for (my $i = scalar(@b) -1; $i >=0; $i--){
		#print "$i b[$i][0] = $b[$i][0]\n ";
		#print $#{ $localmatrix[3] };
		
		$array_ret2[$j] = $localmatrix[$b[$i][0]];
		$j++;
	}
	return @array_ret2;
}


############################ sub loadAlign1d ####################################
sub getSmallerMatrix {
	my ($lixo, $row, $col, $matrix) = @_;
	my $smaller = 1000000;
	my @localmatrix = @{$matrix};
	
	for (my $i = 0; $i <$row; $i++){#i = row
		for (my $j = 0; $j <$col; $j++){	
			if ($localmatrix[$i][$j] < $smaller){
				$smaller = $localmatrix[$i][$j];
			}			
		}
	}
	return $smaller;
}


############################ sub loadAlign1d ####################################
sub getSmallerMatrixIgnore {
	my ($lixo, $rowsIgnore, $colsIgnore, $matrix) = @_;
	my $smaller = 1000000;
	my @localmatrix = @{$matrix};
	
	
	my @array_rows_ignore = split(/:/, $rowsIgnore);
	my @array_cols_ignore = split(/:/, $colsIgnore);
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if (Array->isInArray($i, \@array_rows_ignore) eq "false"){
			for (my $j = 0; $j < $#{$localmatrix[$i]} + 1; $j++){
				if (Array->isInArray($j, \@array_cols_ignore) eq "false"){
					if ($localmatrix[$i][$j] < $smaller){
						$smaller = $localmatrix[$i][$j];
					}	
				}
			}
		}		
	}
	return $smaller;
}



############################ sub loadAlign1d ####################################
sub getBiggerMatrixIgnore {
	my ($lixo, $rowsIgnore, $colsIgnore, $matrix) = @_;
	my $bigger = -1000000;
	my @localmatrix = @{$matrix};
	
	
	my @array_rows_ignore = split(/:/, $rowsIgnore);
	my @array_cols_ignore = split(/:/, $colsIgnore);
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if (Array->isInArray($i, \@array_rows_ignore) eq "false"){
			for (my $j = 0; $j < $#{$localmatrix[$i]} + 1; $j++){
				if (Array->isInArray($j, \@array_cols_ignore) eq "false"){
					if ($localmatrix[$i][$j] > $bigger){
						$bigger = $localmatrix[$i][$j];
					}	
				}
			}
		}		
	}
	return $bigger;
}

############################ sub loadAlign1d ####################################
sub getSmallerMatrixIndex {
	my ($lixo, $row, $col, $matrix) = @_;
	my $smaller = 1000000;
	my @localmatrix = @{$matrix};
	my $index = -1;
	
	for (my $i = 0; $i <$row; $i++){#i = row
		if ($localmatrix[$i][$col] < $smaller){
			$smaller = $localmatrix[$i][$col];
			$index = $i;
		}			
	}
	return $index;
}


############################ sub loadAlign1d ####################################
sub getBiggerMatrixIndex {
	my ($lixo, $row, $col, $matrix) = @_;
	my $bigger = -1000000;
	my @localmatrix = @{$matrix};
	my $index = -1;
	
	for (my $i = 0; $i <$row; $i++){#i = row
		if ($localmatrix[$i][$col] > $bigger){
			$bigger = $localmatrix[$i][$col];
			$index = $i;
		}			
	}
	return $index;
}


############################ sub loadAlign1d ####################################
sub transladeMatrixIgnore {
	my ($lixo, $value, $rowsIgnore, $colsIgnore, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my @array_rows_ignore = split(/:/, $rowsIgnore);
	my @array_cols_ignore = split(/:/, $colsIgnore);
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if (Array->isInArray($i, \@array_rows_ignore) eq "false"){
			for (my $j = 0; $j < $#{$localmatrix[$i]} + 1; $j++){
				if (Array->isInArray($j, \@array_cols_ignore) eq "false"){
					$localmatrix[$i][$j] = $localmatrix[$i][$j] + $value;
				}
			}
		}		
	}
	
	return @{$matrix};
}


############################ sub loadAlign1d ####################################
sub transladeMatrix {
	my ($lixo, $value, $elem, $matrix) = @_;
	my @localmatrix = @{$matrix};

	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		$localmatrix[$i][$elem] = $localmatrix[$i][$elem] + $value;
	}
	
	return @{$matrix};
}

############################ sub loadAlign1d ####################################
sub isInArray {
	my ($lixo, $value, $matrix) = @_;
	my @localmatrix = @{$matrix};	
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if ($value eq $localmatrix[$i]){
			return "true";
		}
	}
	return "false";
}

############################ sub loadAlign1d ####################################
sub isInArray2 {
	my ($lixo, $value, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if ($value eq $localmatrix[$i]){
			return $i;
		}
	}
	return -1;
}

############################ sub loadAlign1d ####################################
sub isInArrayIndex {
	my ($lixo, $value, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if (index($localmatrix[$i], $value) >= 0){
			return $i;
		}
	}
	return -1;
}

############################ sub loadAlign1d ####################################
sub isInMatrixIndex {
	my ($lixo, $col, $value,  $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if (index($localmatrix[$i][$col], $value) >= 0){
			return $i;
		}
	}
	return -1;
}


############################ sub loadAlign1d ####################################
sub isInMatrix2 {
	my ($lixo, $value, $matrix) = @_;
	my $col;
	my @localmatrix = @{$matrix};	

	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row scalar(@speciesReplace), $#{ $speciesReplace[0] } + 1
		$col = $#{ $localmatrix[$i] } + 1;
		for (my $j = 0; $j <$col; $j++){
			if ($value eq $localmatrix[$i][$j]){
				return $i;
			}
		}
	}
	return -1;
}

############################ sub loadAlign1d ####################################
sub isInColMatrix {
	my ($lixo, $col, $value, $matrix) = @_;
	
	my @localmatrix = @{$matrix};	

	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row scalar(@speciesReplace), $#{ $speciesReplace[0] } + 1
		if ($value eq $localmatrix[$i][$col]){
				return $i;
		}
	}
	return -1;
}


############################ sub loadAlign1d ####################################
sub isInMatrix {
	my ($lixo, $value, $matrix) = @_;
	my $col;
	my @localmatrix = @{$matrix};	

	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row scalar(@speciesReplace), $#{ $speciesReplace[0] } + 1
		$col = $#{ $localmatrix[$i] } + 1;
		for (my $j = 0; $j <$col; $j++){
			if ($value eq $localmatrix[$i][$j]){
				return "true";
			}
		}
	}
	return "false";
}

############################ sub loadAlign1d ####################################
sub createArrayInterval {
	my ($lixo, $start, $end, $interval, $type) = @_;
	#$type = 1 (sum); 2 (multiply)
	my @array_ret = ();			my $value = $start;
	
	while ($value <= $end){
		push(@array_ret, $value);
		if ($type == 1){
			$value = $value + $interval;
		}elsif ($type == 2){
			$value = $value * $interval;
		}				
	}
	
	return @array_ret;
}


############################ sub loadAlign1d ####################################
sub arrayIsInMatrix {
	my ($lixo, $array, $matrix) = @_;
	
	my @array_aux = ();			my $index = 0;
	my @larray = @{$array};
	my @lmatrix = @{$matrix};	
	
	#print "array size ". scalar(@larray)."\n";
	#print "matrix size ". scalar(@lmatrix)."\n";
	
	for (my $j = 0; $j < scalar(@larray); $j++){
		if (Array->isInMatrix2($larray[$j], \@lmatrix) != -1){
				$index++;
		}
	}
	if ($index == (scalar(@larray))){
		return "true";
	}
	return "false";
}

############################ sub loadAlign1d ####################################
sub arrayIsInRowMatrix {
	my ($lixo, $array, $matrix) = @_;
	
	my @array_aux = ();			my $index = 0;
	my @larray = @{$array};
	my @lmatrix = @{$matrix};	
	my @array_index = ();
	
	#print "array size ". scalar(@larray)."\n";
	#print "matrix size ". scalar(@lmatrix)."\n";
	@larray = sort @larray;
	
	for (my $i = 0; $i < scalar(@lmatrix); $i++){
		@array_aux = Array->copyRowMatrixToArray(scalar(@lmatrix), $#{$lmatrix[$i]} + 1, $i, \@lmatrix);
		@array_aux = sort @array_aux;
		$index = 0;	
		if (scalar(@array_aux) != scalar(@larray)){
			print "ERROR::Array::arrayIsInRowMatrix:: dimention of array and matrix are diferente\n";
			exit;
		} 
		for (my $j = 0; $j < scalar(@larray); $j++){
			if ($larray[$j] eq $array_aux[$j]){
				$index++;
			}
		}		
		if ($index == scalar(@larray)){
			return "true";
		}
	}	
	return "false";
}



############################ sub loadAlign1d ####################################
sub readMatrixToString {
	my ($lixo, $row, $col, $sep, $matrix) = @_;
	my $info = "";
	my @localmatrix = @{$matrix};
	
	for (my $i = 0; $i <$row; $i++){#i = row
		for (my $j = 0; $j <$col; $j++){	
			$info .= $localmatrix[$i][$j];
			if ($j != $col -1){
				$info .= $sep;	
			}								
		}
		$info .= "\n";
	}
	return $info;
}



############################ sub loadAlign1d ####################################
sub countCaracterInColumnMatrix {
	my ($lixo, $row, $col, $car, $matrix) = @_;
	my $count = 0;
	my @localmatrix = @{$matrix};	
	
	for (my $i = 0; $i <$row; $i++){#i = row
		if ($localmatrix[$i][$col] eq $car){
			$count++;
		}	
	}
	return $count;
}


############################ sub loadAlign1d ####################################
sub reduceMatrix {
	my ($lixo, $colCompare, $valueCompare, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if ($localmatrix[$i][$colCompare] eq $valueCompare){
			$newMatrix[$count] = $localmatrix[$i];
			#print "DEBUG ".$count."\n";
			$count++;
		}				
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub reduceMatrixDiffValue {
	my ($lixo, $colCompare, $valueCompare, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if ($localmatrix[$i][$colCompare] ne $valueCompare){
			$newMatrix[$count] = $localmatrix[$i];
			#print "DEBUG ".$count."\n";
			$count++;
		}				
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub reduceMatrixSmaller {
	my ($lixo, $row, $col, $colCompare, $valueCompare, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	
	for (my $i = 0; $i <$row; $i++){#i = row
		if ($localmatrix[$i][$colCompare] <= $valueCompare){
			$newMatrix[$count] = $localmatrix[$i];
			#print "DEBUG ".$count."\n";
			$count++;
		}				
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub reduceMatrixSmaller2 {
	my ($lixo,  $colCompare, $valueCompare, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if ($localmatrix[$i][$colCompare] <= $valueCompare){
			$newMatrix[$count] = $localmatrix[$i];
			#print "DEBUG ".$count."\n";
			$count++;
		}				
	}
	return @newMatrix;
}



############################ sub loadAlign1d ####################################
sub removeValueArray {
	my ($lixo, $value, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if ($localmatrix[$i] ne $value){
			$newMatrix[$count] = $localmatrix[$i];
			#print "DEBUG ".$count."\n";
			$count++;
		}				
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub removeValueFirstOcurrenceArray {
	my ($lixo, $value, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;				my $isFirst = "false";
	my @newMatrix = ();
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if ($localmatrix[$i] eq $value && $isFirst eq "false"){
			$isFirst = "true";
		}else{
			$newMatrix[$count] = $localmatrix[$i];
			#print "DEBUG ".$count."\n";
			$count++;
		}				
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub compareMatrixCol {
	my ($lixo, $row, $col, $colCompare, $matrix1, $matrix2) = @_;
	my @lmatrix1 = @{$matrix1};
	my @lmatrix2 = @{$matrix2};
	
	my $count = 0;

	for (my $i = 0; $i <$row; $i++){#i = row
		if ($lmatrix1[$i][$colCompare] == $lmatrix2[$i][$colCompare]){
			$count++;
		}				
	}
	if ($count == $row){
		return "true";
	}
	return "false";
}

############################ sub loadAlign1d ####################################
sub copyRowMatrixToArray {
	my ($lixo, $row, $col, $rowToCopy, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	
	for (my $j = 0; $j <$col; $j++){#i = row
		$newMatrix[$j] = $localmatrix[$rowToCopy][$j];	
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub copyRowMatrixToArray2 {
	my ($lixo, $rowToCopy, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	
	for (my $j = 0; $j <$#{$localmatrix[$rowToCopy]} + 1; $j++){#i = row
		$newMatrix[$j] = $localmatrix[$rowToCopy][$j];	
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub copyRowMatrixToArrayInterval {
	my ($lixo, $rowToCopy, $interval, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my @array_interval = split(/:/, $interval);
	my $start 	= $array_interval[0];
	my $end 	= $array_interval[1];
	my $count = 0;
	my @newMatrix = ();
	
	for (my $j = $start; $j < $end; $j++){#i = row
		$newMatrix[$count] = $localmatrix[$rowToCopy][$j];
		$count++;	
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub reduceArrayInterval {
	my ($lixo, $interval, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my @array_interval = split(/:/, $interval);
	my $start 	= $array_interval[0];
	my $end 	= $array_interval[1];
	my $count = 0;
	my @newMatrix = ();
	
	for (my $j = $start; $j < $end; $j++){#i = row
		$newMatrix[$count] = $localmatrix[$j];
		$count++;	
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub removeRowArray {
	my ($lixo, $row, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	
	for (my $j = 0; $j < scalar(@localmatrix); $j++){#i = row
		if ($j != $row){
			$newMatrix[$count] = $localmatrix[$j];
			$count++;	
		}		
	}
	return @newMatrix;
}


############################ sub loadAlign1d ####################################
sub copyRowsMatrixToStringSep {
	my ($lixo, $sep, $rowToCopy, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $info = "";
	my @newMatrix = ();
	
	for (my $j = 0; $j < $#{$localmatrix[$rowToCopy]} + 1; $j++){
		$info .= $localmatrix[$rowToCopy][$j];	
		if ($j < ($#{$localmatrix[$rowToCopy]})){
			$info .= $sep;
		}
	}
	return $info;
}


############################ sub loadAlign1d ####################################
sub copyRowsMatrixToString {
	my ($lixo, $rowToCopy, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $info = "";
	my @newMatrix = ();
	
	for (my $j = 0; $j < $#{$localmatrix[$rowToCopy]} + 1; $j++){
		$info .= $localmatrix[$rowToCopy][$j];	
	}
	return $info;
}

############################ sub loadAlign1d ####################################
sub copyColsToArray {
	my ($lixo, $colsToCopy, $sep, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $info = "";
	my @newArray = ();
	my @arrayCols = split(/:/, $colsToCopy);
	
	
	for (my $j = 0; $j < scalar(@localmatrix); $j++){
		$info = "";
		for (my $k = 0; $k < scalar(@arrayCols); $k++){
			$info .= $localmatrix[$j][$arrayCols[$k]];	
			if ($k < (scalar(@arrayCols) -1)){
				$info .= $sep;
			}
		}
		#print $info."\n";
		
		$newArray[$j] = $info;
	}
	return @newArray;
}


############################ sub loadAlign1d ####################################
sub normalize{
	my ($lixo, $bound, $upper, $rowsIgnore, $colsIgnore, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	my $delta = $upper - $bound;
	my $MinXo = Array->getSmallerMatrixIgnore($rowsIgnore, $colsIgnore, $matrix);
	my $MaxXo = Array->getBiggerMatrixIgnore($rowsIgnore, $colsIgnore, $matrix);
	my $deltaxo = $MaxXo - $MinXo;
	
	
	my @array_rows_ignore = split(/:/, $rowsIgnore);
	my @array_cols_ignore = split(/:/, $colsIgnore);
	
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		if (Array->isInArray($i, \@array_rows_ignore) eq "false"){
			for (my $j = 0; $j < $#{$localmatrix[$i]} + 1; $j++){
				if (Array->isInArray($j, \@array_cols_ignore) eq "false"){
					$localmatrix[$i][$j] = $bound + (($localmatrix[$i][$j] - $MinXo)*$delta/$deltaxo);
				}
			}
		}		
	}	
	return @localmatrix;
}


############################ sub loadAlign1d ####################################
sub normalizeByColuns{
	my ($lixo, $bound, $upper, $rowsIgnore, $colsIgnore, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	my $MinXo; 				my $MaxXo;
	my @array_aux;
	
	my $delta = $upper - $bound;	
	my $deltaxo;	
	my @array_rows_ignore = split(/:/, $rowsIgnore);
	my @array_cols_ignore = split(/:/, $colsIgnore);
	
	my $rows = scalar(@localmatrix);
	my $cols =  $#{$localmatrix[0]} + 1;
	
	my @array_aux_local = Array->removeRowsMatriz($rowsIgnore, \@localmatrix);
	
	for (my $j = 0; $j < $cols; $j++){
		if (Array->isInArray($j, \@array_cols_ignore) eq "false"){
			@array_aux = Array->copyColMatrixToArray($rows-(scalar(@array_rows_ignore)), $cols, $j, \@array_aux_local);
			$MinXo = Array->getSmallerIgnoreValue("NA",\@array_aux);
			$MaxXo = Array->getBiggerIgnoreValue("NA", \@array_aux);
			$deltaxo = $MaxXo - $MinXo;
			for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
				if (Array->isInArray($i, \@array_rows_ignore) eq "false"){
					if ($deltaxo != 0){
						if ($localmatrix[$i][$j] ne "NA"){
							$localmatrix[$i][$j] = $bound + (($localmatrix[$i][$j] - $MinXo)*$delta/$deltaxo);
						}						
					}else{
						$localmatrix[$i][$j] = 0;
					}					
				}
			}
		}
	}
	return @localmatrix;
}


############################ sub loadAlign1d ####################################
sub replaceValueMatrix{
	my ($lixo, $value, $valueReplace, $rowsIgnore, $colsIgnore, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	my @array_aux;
	my @array_rows_ignore = split(/:/, $rowsIgnore);
	my @array_cols_ignore = split(/:/, $colsIgnore);
	
	my $rows = scalar(@localmatrix);
	my $cols =  $#{$localmatrix[0]} + 1;
	
	my @array_aux_local = Array->removeRowsMatriz($rowsIgnore, \@localmatrix);
	
	for (my $j = 0; $j < $cols; $j++){
		if (Array->isInArray($j, \@array_cols_ignore) eq "false"){
			for (my $i = 0; $i <scalar(@array_aux_local); $i++){#i = row
				if ($array_aux_local[$i][$j] eq $value){
					$array_aux_local[$i][$j] = $valueReplace;
				}
			}
		}
	}
	return @array_aux_local;
}



############################ sub loadAlign1d ####################################
sub normalizeByColunsMinMax{
	my ($lixo, $bound, $upper, $MinXo, $MaxXo, $rowsIgnore, $colsIgnore, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	my @array_aux;
	
	my $delta = $upper - $bound;	
	my $deltaxo;	
	my @array_rows_ignore = split(/:/, $rowsIgnore);
	my @array_cols_ignore = split(/:/, $colsIgnore);
	
	my $rows = scalar(@localmatrix);
	my $cols =  $#{$localmatrix[0]} + 1;
	
	my @array_aux_local = Array->removeRowsMatriz($rowsIgnore, \@localmatrix);
	$deltaxo = $MaxXo - $MinXo;
	
	for (my $j = 0; $j < $cols; $j++){
		if (Array->isInArray($j, \@array_cols_ignore) eq "false"){
			@array_aux = Array->copyColMatrixToArray($rows-(scalar(@array_rows_ignore)), $cols, $j, \@array_aux_local);			
			for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
				if (Array->isInArray($i, \@array_rows_ignore) eq "false"){
					if ($deltaxo != 0){
						#print "value = ".$localmatrix[$i][$j]."\t$bound\t$MinXo\t$delta\t$deltaxo\n";
						$localmatrix[$i][$j] = $bound + (($localmatrix[$i][$j] - $MinXo)*$delta/$deltaxo);
					}else{
						$localmatrix[$i][$j] = 0;
					}
					
				}
			}
		}
	}
	return @localmatrix;
}


############################ sub loadAlign1d ####################################
sub normalizeByColunsMinMaxCol{
	my ($lixo, $bound, $upper, $MinXo, $MaxXo, $col, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	my @array_aux;
	
	my $delta = $upper - $bound;	
	my $deltaxo;	

	my $rows = scalar(@localmatrix);
	my $cols =  $#{$localmatrix[0]} + 1;
	
	
	$deltaxo = $MaxXo - $MinXo;
	
			
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
			$localmatrix[$i][$col] = $bound + (($localmatrix[$i][$col] - $MinXo)*$delta/$deltaxo);
	}
	return @localmatrix;
}


############################ sub loadAlign1d ####################################
sub copyRowMatrixToString {
	my ($lixo, $sep, $rowToCopy, $matrix) = @_;
	my @localmatrix = @{$matrix};
	my $info = "";
	my $count = 0;
	my @newMatrix = ();
	$col =  $#{$localmatrix[$rowToCopy]} + 1;
	for (my $j = 0; $j <$col; $j++){#i = row
		$info .= $localmatrix[$rowToCopy][$j];
		if ($j < ($col-1)){
			$info .= $sep;
		}	
	}
	return $info;
}

############################ sub loadAlign1d ####################################
sub copyRowMatrixToStringIgnoreCol {
	my ($lixo, $sep, $rowToCopy, $colIgnore, $matrix) = @_;
	my @localmatrix = @{$matrix};
	my $info = "";			my $last;
	my $count = 0;
	my @newMatrix = ();
	my @array_cols_ignore = split(/:/, $colIgnore);
	
		
	$col =  $#{$localmatrix[$rowToCopy]} + 1;
	for (my $j = 0; $j <$col; $j++){#i = row
		if (Array->isInArray($j, \@array_cols_ignore) eq "false"){
			$info .= $localmatrix[$rowToCopy][$j];
			if ($j < ($col-1)){
				$info .= $sep;
			}	
		}		
	}
	$last = substr($info,-1,1); 
	if ($last eq $sep){
		chop($info);
	}
	
	return $info;
}
############################ sub loadAlign1d ####################################
sub copyColMatrixToArray {
	my ($lixo, $row, $col, $colToCopy, $matrix) = @_;
	my @localmatrix = @{$matrix};	

	my $count = 0;
	my @newMatrix = ();
	
	for (my $i = 0; $i <$row; $i++){#i = row
		$newMatrix[$i] = $localmatrix[$i][$colToCopy];	
	}
	return @newMatrix;
}


############################ sub loadAlign1d ####################################
sub copyColMatrixToArray2 {
	my ($lixo, $colToCopy, $matrix) = @_;
	my @localmatrix = @{$matrix};	

	my $count = 0;
	my @newMatrix = ();
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		$newMatrix[$i] = $localmatrix[$i][$colToCopy];	
	}
	return @newMatrix;
}

############################ sub loadAlign1d ####################################
sub getSomeColsMatrix {
	my ($lixo, $row, $col, $colsToCopy, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	my @array_cols = split(/:/, $colsToCopy);
	
	for (my $i = 0; $i <$row; $i++){#i = row
		for (my $j = 0; $j <scalar(@array_cols); $j++){#i = row
			$newMatrix[$i][$j] = $localmatrix[$i][$array_cols[$j]];	
		}
	}
	return @newMatrix;
}


############################ sub loadAlign1d ####################################
sub getSomeColsMatrix2 {
	my ($lixo, $colsToCopy, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	my @array_cols = split(/:/, $colsToCopy);
	
	for (my $i = 0; $i <scalar(@localmatrix); $i++){#i = row
		for (my $j = 0; $j <scalar(@array_cols); $j++){#i = row
			$newMatrix[$i][$j] = $localmatrix[$i][$array_cols[$j]];	
		}
	}
	return @newMatrix;
}


############################ sub loadAlign1d ####################################
sub getIntervalRowsMatrix {
	my ($lixo, $intervalRows, $matrix) = @_;
	my @localmatrix = @{$matrix};

	my $count = 0;
	my @newMatrix = ();
	my @array_rows = split(/:/, $intervalRows);
	
	for (my $i = $array_rows[0]; $i <= $array_rows[1]; $i++){
		for (my $j = 0; $j < $#{$localmatrix[0]} + 1; $j++){
			$newMatrix[$i][$j] = $localmatrix[$i][$j];	
		}
	}
	return @newMatrix;
}
############################ sub loadAlign1d ####################################
sub lineStringToMatriz {
	
	my $line	= $_[1];
	my $sep		= $_[2];
	my $caracterRemove = $_[3];
	my @array_aux;
	
	my @array = split(/\n/, $line);
	my @array_ret;
	for (my $i = 0; $i <scalar(@array); $i++){
		@array_aux = split(/$sep/, $array[$i]);
		for (my $j = 0; $j <scalar(@array_aux); $j++){
			if (defined($caracterRemove)){
				$array_aux[$j] =  String->removeCaracter($array_aux[$j], $caracterRemove);		
			}
			$array_ret[$i][$j] = $array_aux[$j];			
		}
	}	
	return @array_ret;	
}

############################ sub loadAlign1d ####################################
sub sortArray2d {
	my ($lixo, $field, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	my @sorted = sort {$a->[$field] <=> $b->[$field];} @localmatrix; 
	return @sorted;
}


############################ sub loadAlign1d ####################################
sub sortArray2dDesc {
	my ($lixo, $field, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	my @sorted = sort {  $b->[$field] <=> $a->[$field]; } @localmatrix; 
	return @sorted;
}



############################ sub loadAlign1d ####################################
sub getRandon {
	
	my ($lixo, $amount, $array) = @_;
	my %repeat_hash = ();
	my @array_ret = ();
	my $count = 0;
	my $stop = "false";
	my $random_number;

	my @localArray = @{$array};
	
	while ($stop eq "false"){
		$random_number = int(rand(scalar(@localArray)));
		if (!exists($repeat_hash{$random_number})){
			$array_ret[$count] = $localArray[$random_number];
			$count++;
			$repeat_hash{$random_number} = $random_number;
		}		
		if ($count == $amount){
			return @array_ret;
		}		
	}	
}


############################ sub loadAlign1d ####################################
sub getRandonWithReplacement {
	
	my ($lixo, $amount, $array) = @_;
	my %repeat_hash = ();
	my @array_ret = ();
	my $count = 0;
	my $stop = "false";
	my $random_number;

	my @localArray = @{$array};
	
	while ($stop eq "false"){
		$random_number = int(rand(scalar(@localArray)));
		$array_ret[$count] = $localArray[$random_number];
		$count++;
		if ($count == $amount){
			return @array_ret;
		}		
	}	
}

############################ sub loadAlign1d ####################################
sub getSmallerNOZero {
	my ($lixo, $array) = @_;
	my $smaller = 1000000;
	my @localArray = @{$array};
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		if ($localArray[$i] !=0 && $localArray[$i] < $smaller){
			$smaller = $localArray[$i];
		}			
	}
	return $smaller;
}

############################ sub loadAlign1d ####################################
sub getSmaller {
	my ($lixo, $array) = @_;
	my $smaller = 1000000;
	my @localArray = @{$array};	
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		if ($localArray[$i] < $smaller){
			$smaller = $localArray[$i];
		}			
	}
	return $smaller;
}
############################ sub loadAlign1d ####################################
sub getSmallerIgnoreValue {
	my ($lixo, $value, $array) = @_;
	my $smaller = 1000000;
	my @localArray = @{$array};	
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row	
		if ($localArray[$i] ne $value && $localArray[$i] < $smaller){
			$smaller = $localArray[$i];
		}			
	}
	return $smaller;
}
############################ sub loadAlign1d ####################################
sub getMediana {
	my ($lixo, $array) = @_;
	my @localArray = @{$array};	
	
	my @sorted = sort { $a <=> $b } @{$array}; 
	
	my $size = scalar(@sorted);
	my $x = $size % 2;
	
	if ($x == 1){
		$x = ($size + 1)/ 2;
	}else{
		my $n_2 = $size/2;
		my $n_2_1 = ($size/2) + 1;
		
		$x =  int(($n_2 + $n_2_1)/2);
	}	
	return $sorted[$x-1];
}

############################ sub loadAlign1d ####################################
sub getSTD {
	my ($lixo, $array) = @_;
	my @localArray = @{$array};	
	
	my $x = 0;	my $sum = 0;
	my $mean = Array->getAverage(\@localArray);
	#print "mean = $mean\n";
	for (my $i=0; $i<scalar(@localArray); $i++){
		$x = ($localArray[$i] - $mean)**2;
		$sum += $x;
		
	}
	
	return sqrt($sum/scalar(@localArray));
	
}

############################ sub loadAlign1d ####################################
sub getIndexMediana {
	my ($lixo, $array) = @_;
	my @localArray = @{$array};	
	
	my @sorted = sort { $a <=> $b } @{$array}; 
	
	my $size = scalar(@sorted);
	my $x = $size % 2;
	
	if ($x == 1){
		$x = ($size + 1)/ 2;
	}else{
		my $n_2 = $size/2;
		my $n_2_1 = ($size/2) + 1;
		
		$x =  int(($n_2 + $n_2_1)/2);
	}	
	return ($x-1);
}

############################ sub loadAlign1d ####################################
sub getSmallerIndex {
	my ($lixo, $array) = @_;
	my @localArray = @{$array};

	my $smaller = 1000000;
	my $index = -1;
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		if ($localArray[$i] < $smaller){
			$smaller = $localArray[$i];
			$index = $i;
		}			
	}
	return $index;
}

############################ sub loadAlign1d ####################################
sub getBigger {
	my ($lixo, $array) = @_;
	my @localArray = @{$array};	
	
	my $bigger = -100000;
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		if ($localArray[$i] > $bigger){
			$bigger = $localArray[$i];
		}			
	}
	return $bigger;
}

############################ sub loadAlign1d ####################################
sub getBiggerIgnoreValue {
	my ($lixo, $value, $array) = @_;
	my @localArray = @{$array};	
	
	my $bigger = -100000;
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		if ($localArray[$i] ne $value && $localArray[$i] > $bigger){
			$bigger = $localArray[$i];
		}			
	}
	return $bigger;
}

############################ sub loadAlign1d ####################################
sub getAverage {
	my ($lixo, $array) = @_;
	my @localArray = @{$array};

	my $sum = 0;
	
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		#print "arg".$localArray[$i]."fim\n";
		$sum += $localArray[$i];			
	}
	
	return ($sum/scalar(@localArray));
}

############################ sub loadAlign1d ####################################
sub getHarmonicMean {
	my ($lixo, $array) = @_;
	my @localArray = @{$array};

	my $sum = 0;
	
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		$sum += (1/$localArray[$i]);			
	}
	
	return (scalar(@localArray)/$sum);
}




############################ sub loadAlign1d ####################################
sub getAverageWeigth {
	my ($lixo, $arrayWeight, $array) = @_;
	
	my @localArrayW = @{$arrayWeight};
	my @localArray = @{$array};
	
	my $sum = 0;			my $sumW = 0;
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		#print "arg".$localArrayW[$i]."fim\n";
		$sum += $localArrayW[$i]*$localArray[$i];	
		$sumW += $localArrayW[$i];		
	}
	
	return ($sum/$sumW);
}

############################ sub loadAlign1d ####################################
sub getAverageMatrixByColumns {
	my ($lixo, $colsIgnore, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	
	my @array_cols_ignore = split(/:/, $colsIgnore);

	my @array_ret = ();			my $count = 0;
	
	for (my $i = 0; $i < $#{$localmatrix[0]} + 1; $i++){#i = row
		if (Array->isInArray($i, \@array_cols_ignore) eq "false"){
			@localArray = Array->copyColMatrixToArray2($i, \@localmatrix);
			$avg = Array->getAverage(\@localArray);
			$array_ret[$count] = $avg;
			$count++;
		}				
	}	
	return (@array_ret);
}


############################ sub loadAlign1d ####################################
sub getSum {
	my ($lixo, $array) = @_;
	my @localArray = @{$array};

	my $sum = 0;
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		#print "arg".$localArray[$i]."fim\n";
		$sum += $localArray[$i];			
	}
	return $sum;
}

############################ sub loadAlign1d ####################################
sub getLogSum {
	my ($lixo, $array) = @_;
	my @localArray = @{$array};

	my $sum = 0;
	
	for (my $i = 0; $i <scalar(@localArray); $i++){#i = row
		#print "arg".$localArray[$i]."fim\n";
		if ($localArray[$i] == 0){
			$localArray[$i] = "1e-200";
		}
		$sum += log($localArray[$i]);			
	}
	
	return $sum;
}

############################ sub loadAlign1d ####################################
sub readArrayToString {
	my ($lixo, $row, $sep, $array) = @_;
	my @localArray = @{$array};

	my $info = "";
	
	for (my $i = 0; $i <$row; $i++){#i = row
		$info .= $localArray[$i];
		if ($i != $row -1){
			$info .= $sep;	
		}
	}
	if ($sep ne ""){
		$info .= "\n";
	}
	
	return $info;
}


1