package SVGSequence;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}


use String::StringUtil;
use File::Files;
use Align::Primary::blast;
use Sequence::Domain;
use Util::HTML;

my $BR = "</br>";
my $SPACE = "&nbsp;";

my @colors  = ('red',  'blue', 'green',  'black', 'orange',  'yellow',  'saddlebrown', 'goldenrod', 'fuchsia', 'coral', 'linen',   'mediumspringgreen', 'lightseagreen', 
			   'violet', 'steelblue','dimgray', 'darkorchid', 'maroon',  'paleturquoise', 'darkgreen', 'yellowgreen', 'purple', 'slateblue', 'aqua', 'turquoise', 'plum',
			   'salmon', 'tomato', 'midnightblue', 'peachpuff', 'deepskyblue', 'aliceblue', 'darkgray', 'palevioletred', 'forestgreen', 'darkorange', 'peachpuff', 'chartreuse');
			   
############################ sub getCSS ##################################
sub getColors{
	return @colors;
}

############################ sub runBlastHitBySpecie ####################################
sub representLengthSequence {
	my $seqLengh   	= $_[1];
	my $totalLengh  = $_[2];
	my $numberPoints= $_[3];
	my $frameW		= $_[4];
	my $frameH		= $_[5];
	
	my $factorText; 			my $factor;
	my $factorNumber;

	my $info = "<svg height=\"$frameH\" width=\"$frameW\">\n";
	my $range = int($seqLengh/$numberPoints);
	my $size = int($totalLengh/$numberPoints);
	
	
	for (my $i = 0; $i < $numberPoints; $i++){
		$factor = $i*$size;
		$factorNumber = $i*$range;
		$factorText = $factor + 3;
		if ($factor == 0){
			$factor = 1;
			$factorNumber = 1;
		}
		
		$info .= "<text x=\"$factorText\" y=\"15\" fill=\"black\">$factorNumber</text>\n";
		$info .= "<line x1=\"$factor\" y1=\"0\" x2=\"$factor\" y2=\"15\" style=\"stroke:rgb(0,0,0);stroke-width:2\"/>\n"; 	
		
	}
	$info .="</svg>\n";	
	return $info;
}

############################ sub runFormatFiletoSam ##################################
sub representQuery {

    my $lenTotal			= $_[1];
    my $frameW				= $_[2];
	my $frameH				= $_[3];
    
    my $info = "<svg height=\"$frameH\" width=\"$frameW\">\n";
	$info .= "<line x1=\"1\" y1=\"1\" x2=\"$lenTotal\" y2=\"1\" stroke=\"#D8D8D8\" stroke-width=\"10\" stroke-linecap=\"butt\" />\n";
	$info .="</svg>\n";	
	
	return $info;
	
}
############################ sub runFormatFiletoSam ##################################
sub showMultDomainsGraphicallyTip {
   
	my ($lixo, $sequenceLength, $lenTotal, $frameW, $frameH, $array_hits) = @_;
	

	my $scale = $lenTotal/$sequenceLength;
	
	my $info = "<svg height=\"$frameH\" width=\"$frameW\" style=\"border:1px dashed #ccc\">\n";
	
	my $startHit;				my $endHit;					
	my $startHitScale;			my $endHitScale;
	my $color;					my $tip;
	
	my @sorted = sort {  $a->[0] <=> $b->[0]; } @{$array_hits}; 
	
	for (my $i = 0; $i < scalar(@sorted); $i++){
		$startHit 	= $sorted[$i][0];
		$endHit 	= $sorted[$i][1];	
		$color 		= $sorted[$i][2];
		$linecap	= $sorted[$i][3];
		$link 		= $sorted[$i][4];	
		$tip 		= $sorted[$i][5];	
		
		$startHitScale = int($startHit*$scale);
		$endHitScale = int($endHit*$scale);
		
	
		$info .= "<a xlink:href=\"$link\">\n"; 
		$info .= "<line x1=\"$startHitScale\" y1=\"20\" x2=\"$endHitScale\" y2=\"20\" stroke=\"$color\" stroke-width=\"20\" stroke-linecap=\"$linecap\" id=\"d$i\" onmouseover=\"$tip\" onmouseout=\"UnTip();\"/>\n";
		$info .= "</a>\n"; 
	}
	$info .="</svg>\n";	
	return $info;	
}
############################ sub runFormatFiletoSam ##################################
sub showMultAllDomainsGraphicallyTip {
   
	my ($lixo, $sequenceLength, $lenTotal, $frameW, $frameH, $array_hits) = @_;
	
	my @larray_hits = @{$array_hits};	
	
	my $scale = $lenTotal/$sequenceLength;
	my $info = "";
	
	my $startHit;				my $endHit;					
	my $startHitScale;			my $endHitScale;
	my $color;					my $tip;
	my $score;					my $clan;
	my @array_included = ();	my $overlapAA;
	my $y = 20;					my $y_add = 30;
	my @queue = ();				my $wasQueued = "false";
	my $count = 0;				my $info_aux = "";
	my $frameHPlus;
	
	my @sorted = sort {  $a->[0] <=> $b->[0] ||  $b->[5] <=> $a->[5] } @larray_hits ; 
	
	
	#print Array->printMatrix2("\t", "\n", \@sorted);
	$y_pos = $y; $frameHPlus = 0;
	do{		
		for (my $i = 0; $i < scalar(@sorted); $i++){
			$startHit 	= $sorted[$i][0];
			$endHit 	= $sorted[$i][1];	
			$color 		= $sorted[$i][2];
			$link 		= $sorted[$i][3];	
			$tip 		= $sorted[$i][5];	
			$score		= $sorted[$i][6];
			$clan		= $sorted[$i][7];
			
			
			$startHitScale = int($startHit*$scale);
			$endHitScale = int($endHit*$scale);
		
			
			$wasQueued = "false";
			#print "i = ". $i."\n size =". scalar(@array_included)."\n";	
			for (my $j = 0; $j < scalar(@array_included); $j++){
				#print "$j $startHit, $endHit, ".$array_included[$j][0]. "," .$array_included[$j][1]." \n";
				$overlapAA = Domain->calculateOverlapSize($startHit, $endHit, $array_included[$j][0], $array_included[$j][1]);
				#print " overlapping = $overlapAA \n";
				if ($overlapAA > 10){
					push(@queue, $sorted[$i]);
					$j = scalar(@array_included);
					$wasQueued = "true";
				}
			}	
							
			if ($wasQueued eq "false"){
				$info_aux .= "<a xlink:href=\"$link\">\n"; 
				$info_aux .= "<line x1=\"$startHitScale\" y1=\"$y_pos\" x2=\"$endHitScale\" y2=\"$y_pos\" stroke=\"$color\" stroke-width=\"20\" stroke-linecap=\"butt\" id=\"d$i\" onmouseover=\"$tip\" onmouseout=\"UnTip();\"/>\n";
				$info_aux .= "</a>\n"; 
				$array_included[$count][0] = $startHit;
				$array_included[$count][1] = $endHit;
				$array_included[$count][2] = $y_pos;
				$count++;
			}
		}
		@sorted = @queue;
		@array_included = ();	$count = 0;
		@queue = ();
		$y_pos = $y_pos + $y_add;
		$frameHPlus += $frameH - 8;
	}while(scalar(@sorted) > 0);
	#$frameHPlus -=20;
	$info = "<svg height=\"$frameHPlus\" width=\"$frameW\" style=\"border:1px dashed #ccc\">\n";
	$info .= $info_aux;
	$info .="</svg>\n";	
	return $info;	
}

############################ sub runFormatFiletoSam ##################################
sub showSubtitleDomais {
	my ($lixo, $array_hits) = @_;
	my @larray_hits = @{$array_hits};	
	
	my $domainACC;			my $domainName;
	my $color;				my $link;
	my $col =1;				my @arrayRet = ();
	my $row = 0;			my $checkBox;
	
	$arrayRet[$row][0] = HTML->getSPACE(); $arrayRet[$row][1] = HTML->getSPACE(); $arrayRet[$row][2] = HTML->getSPACE();
	for (my $i = 0; $i < scalar(@larray_hits); $i++){
		$domainACC 	= $larray_hits[$i][0];
		$domainName= $larray_hits[$i][1];	
		$color 		= $larray_hits[$i][2];
		$link 		= $larray_hits[$i][3];	
		
		$checkBox = "<div id=\"mydiv\" width=\"20\" style=\"background:$color\"><input type=\"checkbox\" value=\"$domainACC\" style=\"background-color:$color; border: solid 1px #006699; border-bottom: dashed 3px; #000;\"/></div> ";
		
		$arrayRet[$row][$col-1] = HTML->tableOne($checkBox, 0, "left", 20).HTML->link("$domainACC-$domainName", $link);
		if ($col%3 == 0){
			$col = 1;
			$row++;
			$arrayRet[$row][0] = HTML->getSPACE(); $arrayRet[$row][1] = HTML->getSPACE(); $arrayRet[$row][2] = HTML->getSPACE();
		}else{
			$col++;
		}		
	}
	
	return HTML->tableFromArra2d(0, "left", "100%", 0, 0, scalar(@arrayRet), 3, \@arrayRet);
}

1