package SequenceHTML;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}


use String::StringUtil;
use File::Files;
use Align::Primary::blast;

my $BR = "</br>";
my $SPACE = "&nbsp;";

############################ sub runBlastHitBySpecie ####################################
sub representLengthSequence {
	my $seqLengh   	= $_[1];
	my $totalLengh  = $_[2];
	my $numberPoints= $_[3];
	
	my $range = int($seqLengh/$numberPoints);
	my $size = int($totalLengh/$numberPoints);
	my $info = "<table><tr>\n";
	$info .= "<td width=\"$size\" align=\"left\" >|<font size=\"1\">1</font></td>\n";
	for (my $i = 1; $i < $numberPoints; $i++){
			$info .= "<td width=\"$size\" align=\"left\" >|<font size=\"1\">". ($range)*$i . "</font></td>\n";
		
	}
	$info .= "</tr></table>";	
	return $info;
}

############################ sub runFormatFiletoSam ##################################
sub representQuery {
	my $queryId				= $_[1];
    my $lenQueryReal	   	= $_[2];
    my $img				   	= $_[3];
    my $lenTotal			= $_[4];
    
    my $lenQuery;
	my $info = "";
	my @array_ret2 = ();
	
	
	
	if (!defined($lenTotal)){
		$lenQuery = $lenQueryReal;
	}else{
		$lenQuery = $lenTotal;
	}
	
	
	#$info =  $queryId. " ($lenQuery)" ."\t";
	$array_ret2[0] =  $queryId. " ($lenQueryReal)" ;
	$array_ret2[1] = HTML->createImg("", "0", "4",  $img, $lenQuery);
	
	return @array_ret2;
	
}

############################ sub runFormatFiletoSam ##################################
sub showHitsGraphically {

    
    my $startHit			= $_[1];
    my $endHit				= $_[2];
    my $score				= $_[3];
    my $evalue				= $_[4];
    my $sequenceLength   	= $_[5];
    my $lenTotal			= $_[6];
    my $path				= $_[7];
    
	
	my $scale = $lenTotal/$sequenceLength;
	my $imghit; my $lenHitImg; my $lenCompHit; my $rest;
	my @arrayImg = ();
	my $info = "";
	my $lenHit;
	
	$lenHit = $endHit - $startHit + 1;
	$lenHitImg = $lenHit*$scale;
	$imghit =  HTML->createImg($evalue, "0", "4",  Blast->findColorScore($score,$path), $lenHitImg);
	if ($endHit == $sequenceLength){
		$arrayImg[0] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), ($lenTotal-$lenHitImg)/2);
		$arrayImg[1] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), ($lenTotal-$lenHitImg)/2);
		$arrayImg[2] = $imghit;
	}elsif ($startHit == 1){
		$arrayImg[0] = $imghit;
		$arrayImg[1] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), ($lenTotal-$lenHitImg)/2);
		$arrayImg[2] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), ($lenTotal-$lenHitImg)/2);
	}else{
		$arrayImg[1] = $imghit;
		$lenCompHit = ($sequenceLength - $endHit + 1)*$scale;
		$arrayImg[2] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), $lenCompHit);
		$rest = $lenTotal - ($lenCompHit + $lenHitImg);
		$arrayImg[0] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), $rest);	
	}
	$info .= HTML->tableFromArray("0", "left", "","0", "0", \@arrayImg);
	return $info;	
}


############################ sub runFormatFiletoSam ##################################
sub showMultHitsGraphically {
   
	my ($lixo, $sequenceLength, $lenTotal, $path, $array_hits) = @_;
	
	my $scale = $lenTotal/$sequenceLength;
	my $info = "";
	
	my $startW = 1;
	my $endW = $sequenceLength;
	my $lenImgW;				my $startHit;
	my $endHit;					my $lenHit;
	my $score;					my $evalue;
	
	my @sorted = sort {  $a->[1] <=> $b->[1]; } @{$array_hits}; 
	
	for (my $i = 0; $i < scalar(@sorted); $i++){
		$evalue		= $sorted[$i][0];
		$startHit 	= $sorted[$i][1];
		$endHit 	= $sorted[$i][2];		
		$score		= $sorted[$i][3];
		
		$lenHit = ($endHit - $startHit + 1);
		$lenHit = $lenHit*$scale;
		$lenImgW = ($startHit - $startW + 1);
		$lenImgW = $lenImgW*$scale;
		
		if ($score <= 0){
			$score = 1;
		}
		$info .= HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), $lenImgW);
		$info .= HTML->createImg("$evalue", "0", "4",  Blast->findColorScore($score, $path), $lenHit);		
		$startW = $endHit;
	}
	$lenImgW = ($endW - $startW + 1);
	$lenImgW = $lenImgW *$scale;
	$info .= HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), $lenImgW);
	#print $info;
	return $info;	
}


############################ sub runFormatFiletoSam ##################################
sub showMultDomainsGraphically {
   
	my ($lixo, $sequenceLength, $lenTotal, $pathIMG, $array_hits) = @_;
	my @larray_hits = @{$array_hits};
	
	
	my $scale = $lenTotal/$sequenceLength;
	my $info = "<table border=\"0\" align=\"left\" width=\"$lenTotal\"  cellpadding=\"0\" cellspacing=\"0\">\n<tr>\n";
	
	my $startW = 1;
	my $endW = $sequenceLength;
	my $lenImgW;				my $startHit;
	my $endHit;					my $lenHit;
	my $color;
	
	my @sorted = sort {  $a->[0] <=> $b->[0]; } @larray_hits; 
	
	for (my $i = 0; $i < scalar(@sorted); $i++){
		$startHit 	= $sorted[$i][0];
		$endHit 	= $sorted[$i][1];	
		
		$lenHit = ($endHit - $startHit + 1);
		$lenHit = $lenHit*$scale;
		$lenImgW = ($startHit - $startW + 1);
		$lenImgW = $lenImgW*$scale;
		$color = $sorted[$i][2];
		$info .= "<td width=\"$lenImgW\">". HTML->createImg("", "0", "4", $pathIMG, $lenImgW). "</td>\n";
		$info .= "<td width=\"$lenHit\" bgcolor=\"$color\" align=\"center\">&nbsp;</td>\n";		
		$startW = $endHit;
	}
	$lenImgW = ($endW - $startW + 1);
	$lenImgW = $lenImgW *$scale;
	$info .= "<td width=\"$lenImgW\">". HTML->createImg("", "0", "4", $pathIMG, $lenImgW). "</td>\n</tr>\n</table>";
	#print $info;
	return $info;	
}


############################ sub runFormatFiletoSam ##################################
sub showMultSpaceBetweenDomains {
   
	my ($lixo, $sequenceLength, $lenTotal, $pathIMG, $array_hits) = @_;
	my @larray_hits = @{$array_hits};
	
	
	my $scale = $lenTotal/$sequenceLength;
	my $info = "<table border=\"0\" align=\"left\" width=\"$lenTotal\"  cellpadding=\"0\" cellspacing=\"0\">\n<tr>\n";
	
	my $startW = 1;
	my $endW = $sequenceLength;
	my $lenImgW;				my $startHit;
	my $endHit;					my $lenHit;
	my $color;					my $startHit_previous = 0;
	my $endHit_previous = 0;	my $spacing;
	my $total;
	
	my @sorted = sort {  $a->[0] <=> $b->[0]; } @larray_hits; 
	
	for (my $i = 0; $i < scalar(@sorted); $i++){
		$startHit 	= $sorted[$i][0];
		$endHit 	= $sorted[$i][1];	
		
		$lenHit = ($endHit - $startHit + 1);
		$lenHit = $lenHit*$scale;
		$lenImgW = ($startHit - $startW + 1);
		$lenImgW = $lenImgW*$scale;
		$color = $sorted[$i][2];
		
		if ($endHit_previous != 0){
			$spacing = $startHit - $endHit_previous;			
			if ($spacing > 10){
				$total = $lenImgW - 2;
				$info .= "<td width=\"$lenImgW\">";		
				$info .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"$lenImgW\">";
				$info .= "<td width=\"1\" align=\"right\">|</td><td width=\"$total\" align=\"center\">";
				$info .= HTML->fontSize($spacing, 1);			
				$info .="</td><td width=\"1\" align=\"left\">|</td></table>"."</td>\n";
			}else{
				$info .= "<td width=\"$lenImgW\"></td>\n";
			}
			$info .= "<td width=\"$lenHit\" bgcolor=\"white\" align=\"center\">&nbsp;</td>\n";		
		}else{
			$info .= "<td width=\"$lenImgW\"></td>\n";
			$info .= "<td width=\"$lenHit\" bgcolor=\"white\" align=\"center\">&nbsp;</td>\n";		
		}		
		
		$startW = $endHit;
		$endHit_previous = $endHit;
	}
	$lenImgW = ($endW - $startW + 1);
	$lenImgW = $lenImgW *$scale;
	$info .= "<td width=\"$lenImgW\">". "</td>\n</tr>\n</table>";
	#print $info;
	return $info;	
}

sub showMultDomainsGraphicallyTip {
   
	my ($lixo, $sequenceLength, $lenTotal, $pathIMG, $pathIMGTriangle, $array_hits) = @_;
	
	my $scale = $lenTotal/$sequenceLength;
	my $info = "<table border=\"0\" align=\"left\" width=\"$lenTotal\"  cellpadding=\"0\" cellspacing=\"0\">\n<tr>\n";
	
	my $startW = 1;
	my $endW = $sequenceLength;
	my $lenImgW;				my $startHit;
	my $endHit;					my $lenHit;
	my $color;					my $tip;
	my $link;					my $img_triangle;
	
	my @sorted = sort {  $a->[0] <=> $b->[0]; } @{$array_hits}; 
	
	for (my $i = 0; $i < scalar(@sorted); $i++){
		$startHit 	= $sorted[$i][0];
		$endHit 	= $sorted[$i][1];	
		
		$lenHit = ($endHit - $startHit + 1);
		$lenHit = $lenHit*$scale;
		$lenImgW = ($startHit - $startW + 1);
		$lenImgW = $lenImgW*$scale;
		$color = $sorted[$i][2];
		$tip = $sorted[$i][3];
		$link= $sorted[$i][4];
		$info .= "<td width=\"$lenImgW\">". HTML->createImg("", "0", "4", $pathIMG, $lenImgW). "</td>\n";
		$info .= "<td height=\"18\" width=\"$lenHit\" bgcolor=\"$color\" align=\"center\" class=\"noiraud\" onmouseover=\"Tip('$tip');\" onmouseout=\"UnTip();\">";
		if ($link eq ""){
			$info .= "&nbsp;";
		}else{
			$img_triangle = HTML->createImg("", "0", "10", $pathIMGTriangle, "10");
			$info .= HTML->link($img_triangle, $link);
		}
		$info .= "</td>\n";		
		$startW = $endHit;
	}
	$lenImgW = ($endW - $startW + 1);
	$lenImgW = $lenImgW *$scale;
	$info .= "<td width=\"$lenImgW\">". HTML->createImg("", "0", "4", $pathIMG, $lenImgW). "</td>\n</tr>\n</table>";
	#print $info;
	return $info;	
}

1