package DecisionTree;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

my $programName = "weka.classifiers.trees.J48";
my $START_TREE = "------------------";
my $STOP_TREE = "Number of Leaves  : ";

my @array_results  =();
my $index_results;
my %hash = ();

############################ sub loadAlign1d ####################################
sub run {
	
	my $classpath    = $_[1];
  	my $trainFile	 = $_[2];
  	my $testFile	 = $_[3];
  	my $output  	 = $_[4];
  	my $parameters   = $_[5];
  	my $verbose  	 = $_[6];
  	
	my $cmd = "java  -classpath $classpath $programName -t $trainFile -T $testFile $parameters > $output";
	 print $cmd."\n";
	system($cmd);
	FilesIO->checkFile($output, "File NOT created = $output");		
}


############################ sub loadAlign1d ####################################
sub classifyFromTree{
	my $resultFile	 = $_[1];
  	my $outputFile	 = $_[2];
  	my $numPosTrain	 = $_[3];
  	my $numNegTrain  = $_[4];
  	my $verbose  	 = $_[5];
  	my $info;  my $info_result = "";
  	@array_results = FilesIO->lineFileToArrayWithTokenStarStop($resultFile, $START_TREE, $STOP_TREE);
  	
  	$info = "my \$class; my \$p;\n";
  	for (my $i = 1; $i < scalar(@array_results) -1; $i++){
  		$array_results[$i] = String->removeCaracter($array_results[$i], "\|");
  		$array_results[$i] = String->removeSpaceExcess($array_results[$i]);
  		$info_result .= $array_results[$i];  		
  	}
 	$info .= createProgram($info_result, $numPosTrain, $numNegTrain)."\n";
 	$info .= "print \$class.\"\\t\".\$p.\"\\n\";\n";
  	return $info;  
}

############################ sub loadAlign1d ####################################
sub createProgram{
	my $info_result	 = $_[0];
  	my $numPosTrain	 = $_[1];
  	my $numNegTrain  = $_[2];
  	
  	my $info = "";  my $newHead = ""; my $rule; my $left = "false";
  	my @array = split(/\n/, $info_result);
  	
  	if (scalar(@array) > 0){
  		my $head_rigth = String->removeCaracter($array[0], "\n");
  		#print "head_rigth\t $head_rigth\n";
  		my $rule_rigth = getRule($head_rigth);
  		#print "rule_rigth\t$rule_rigth\n";
  		my $rule_left = ""; my $head_left;
  		my $info_rigth = ""; my $info_left ="";
  		for (my $i = 1; $i < scalar(@array); $i++){
  			$rule = getRule($array[$i]);
  		#	print "$rule\n";
  			if ($left eq "true"){
  				$info_left .= $array[$i]."\n";
  			}elsif ($rule ne $rule_rigth){
  				$info_rigth .= $array[$i]."\n";
  			}else{
  				$left = "true";
  				$rule_left .= $array[$i];
  				$head_left = $array[$i];
  			}
  		}
  		
  		#print "====>info_rigth\n$info_rigth\n"; 
  		#print "====>info_left\n$info_left\n"; 
  		if ($info_rigth eq ""){
  			$info .= createClausuleTerminal($head_rigth, $numPosTrain, $numNegTrain);
  		}else{
  			$info .= "if ($head_rigth) {\n";	
  			$info .= createProgram($info_rigth, $numPosTrain, $numNegTrain);	
  			$info .= "}\n"
  		}
  		if ($info_left eq ""){
  			$info .= "els". createClausuleTerminal($head_left, $numPosTrain, $numNegTrain);
  		}else{
  			$info .= "elsif ($head_left) {\n";	
  			$info .= createProgram($info_left, $numPosTrain, $numNegTrain);	
  			$info .= "}\n"
  		} 
  		
  		#print "rule_rigth => ".$rule_rigth."\n";
  		#print "\ninfo_rigth => ".$info_rigth;
  		#print "rule_left => ".$rule_left."\n";
  		#print "\ninfo_left => ".$info_left;
  	}	
}
############################ sub loadAlign1d ####################################
sub getRule{
	my $head    	 = $_[0];	
	@array_aux = split(/ +/, $head);
	my $entry = "";
	
	foreach $entry (@array_aux){
		if ($entry ne ""){
			return $entry;
		}		
	}
	return $entry;		
}

############################ sub loadAlign1d ####################################
sub clearHead{
	my $head    	 = $_[0];	
	my $new_head = String->removeCaracter($head, "\n");
	$new_head = String->removeCaracter($new_head, "\|");
	#print "$head\t$new_head\n";
	return $new_head;
	
}
############################ sub loadAlign1d ####################################
sub createClausuleTerminal{
	
	my $clear_head   = $_[0];	
	my $numPosTrain	 = $_[1];
  	my $numNegTrain  = $_[2];
  	
	my $info = "";
	my $p; my $class; my $value;
	#my @array_aux = split(/ +/, $clear_head);
	#my $newHead = $array_aux[0];
	my @array_aux = split(/:/, $clear_head);
	$array_aux[0] = clearHead($array_aux[0]);		
	$info .= "if ($array_aux[0]) {\n";
	@array_aux = split(/\(/, $array_aux[1]);
	$class = String->removeCaracter($array_aux[0], " ");
	$value = String->removeCaracter($array_aux[1], ")");
	@array_aux = split(/\//, $value);
	$value = $array_aux[0];
	$info .= "\t\$class =\"". $class. "\";\n";		
	if ($class eq "false"){
		$p = $value/$numNegTrain;
	}else{
		$p = $value/$numPosTrain;
	}	
	$info .= "\t\$p = $p;\n";
	$info .= "}\n";
	return $info;
}



1