package AUC;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Util::Array;

my $PRE_RECAL= "Area Under the Curve for Precision - Recall is";
my $ROC = "Area Under the Curve for ROC is";

##################################### sub readTrueIds ##################################
sub calcAUC{
	my $fileMeasure			= $_[1];
	my $totalTruePositives	= $_[2];
	my $totalTrueNegatives	= $_[3];
	my $kindAuc				= $_[4];
	my $output				= $_[5];
	my $verbose				= $_[6];
	my $info_roc; my $info_pr; my @array_aux;
	#$verbose = "true";
	$kindAuc = uc($kindAuc);
	
	chdir($ENV{'PROG_DIR'});
	print "prog_dir ".$ENV{'PROG_DIR'}."\n";
	my $cmd = "java -jar auc.jar $fileMeasure $kindAuc $totalTruePositives $totalTrueNegatives > $output";
	
	if ($verbose eq "true"){
		print $cmd."\n";
	}
	system $cmd;
	
	if (FilesIO->isFile($output) eq "false"){
		print "ERROR::AUC.pm:: File $output NOT created\n";
		$info_pr = 0;
		$info_roc =0;
	}
	else{
		my @array = FilesIO->lineFileToArrayWithToken($output, $PRE_RECAL);
		@array_aux = split(/$PRE_RECAL/, $array[0]);
		$info_pr = String->removeCaracter($array_aux[1], " ");
		$info_pr = String->removeCaracter($info_pr, "\n");	
	
		@array_aux = split(/$ROC/, $array[1]);
		$info_roc = String->removeCaracter($array_aux[1], " ");
		$info_roc = String->removeCaracter($info_roc, "\n");
	}
	if ($kindAuc eq "ROC"){
		if ($verbose eq "true"){
			print "AUC ROC= ".$info_roc."\n";
		}
		return $info_roc;
	}else{
		if ($verbose eq "true"){
			print "AUC PR = ".$info_pr."\n";
		}
		return $info_pr;
	}	
	
}

##################################### sub readTrueIds ##################################
sub createRocPRFile{

	my ($lixo, $totalTrueNegatives, $totalTruePositives, $kind_curve, $ROC_Boundary, $verbose, $arrayPositives, $arrayResult) = @_; 
	my $found = "false"; my $i;
	my $count_tp =0;
	my $count_fp =0;
	my $count_tn =0;
	my $count_fn =0;
	my $tp_rate; my $fp_rate;my $precision; my $recall;
    my $info_roc = ""; my $info_pr = "";
	
	for (my $j=0; $j< scalar(@{$arrayResult}); $j++) {
		$i = 0; 
		$found = "false";
		while ($found eq "false" && $i < scalar(@{$arrayPositives})){			
			#print "result ".@{$arrayResult}->[$j]->[0]."\t"."\tTP ".String->removeCaracter(@{$arrayPositives}->[$i],"\n")."\n";
			if (@{$arrayResult}->[$j]->[0] eq String->removeCaracter(@{$arrayPositives}->[$i],"\n")){
				$found = "true"
			}
			$i++;
			#print $found."\n";
		}
		if ($found eq "true"){
			$count_tp++;
		}else{
			$count_fp++;
		}
		
		$count_tn = $totalTrueNegatives - $count_fp;
		$count_fn = $totalTruePositives	- $count_tp;
		
		if ($count_fp == $ROC_Boundary){
			if (uc($kind_curve) eq "ROC"){
				return $info_roc;
			}
			else{
				return $info_pr;
			}
		}
		
		if (uc($kind_curve) eq "ROC"){
			$tp_rate = $count_tp/($count_tp + $count_fn);
			$fp_rate = $count_fp/($count_fp + $count_tn);
			$info_roc .=  $fp_rate."\t".$tp_rate."\n";	
			if ($verbose eq "true"){
				print  "TP = ".$count_tp."\tTN = ". $count_tn."\tFP = ". $count_fp."\tFN = ". $count_fn."\n";
				print $fp_rate."\t".$tp_rate."\n\n";
			}	
		}
		else{
			$precision = $count_tp/($count_tp + $count_fp);
			$recall = $count_tp/($count_tp + $count_fn);
			$info_pr .=  $recall."\t".$precision."\n";
			if ($verbose eq "true"){
				print  "TP = ".$count_tp."\tTN = ". $count_tn."\tFP = ". $count_fp."\tFN = ". $count_fn."\n";
				print $recall."\t".$precision."\n\n";
			}				
		}			
	}	
	if (uc($kind_curve) eq "ROC"){
		return $info_roc;
	}
	else{
		return $info_pr;
	}		
}

##################################### sub readTrueIds ##################################
sub findBestMMC{ #Matthews correlation coefficient

	my ($lixo, $totalTrueNegatives, $totalTruePositives, $verbose, $arrayPositives, $arrayResult) = @_; 
	my $found = "false"; my $i;
	my $count_tp =0;
	my $count_fp =0;
	my $count_tn =0;
	my $count_fn =0;
	my $mmc = 0;
	my $mmc_max = -1000; my $square_root;
	
	for (my $j=0; $j< scalar(@{$arrayResult}); $j++) {
		$i = 0; 
		$found = "false";
		while ($found eq "false" && $i < scalar(@{$arrayPositives})){			
			#print "result ".@{$arrayResult}->[$j]->[0]."\t"."\tTP ".String->removeCaracter(@{$arrayPositives}->[$i],"\n")."\n";
			if (@{$arrayResult}->[$j]->[0] eq String->removeCaracter(@{$arrayPositives}->[$i],"\n")){
				$found = "true"
			}
			$i++;
			#print $found."\n";
		}
		if ($found eq "true"){
			$count_tp++;
		}else{
			$count_fp++;
		}
		
		$count_tn = $totalTrueNegatives - $count_fp;
		$count_fn = $totalTruePositives	- $count_tp;
		
		$mmc = ($count_tp*$count_tn - $count_fp*$count_fn);
		$square_root = sqrt(($count_tp+$count_fp) * ($count_tp+$count_fn) * ($count_tn+$count_fp) * ($count_tn+$count_fn));	
		if ($square_root == 0){
			print "$j TP = ".$count_tp."\tTN = ". $count_tn."\tFP = ". $count_fp."\tFN = ". $count_fn."\n";
		}else{
			$mmc = $mmc/$square_root;
			#print  "TP = ".$count_tp."\tTN = ". $count_tn."\tFP = ". $count_fp."\tFN = ". $count_fn."\n";
			#print "MMC $mmc\n";
			if ($mmc > $mmc_max){
				$mmc_max = $mmc;
			}
		}	
		
	}
	return $mmc_max;
}

1