package RejectModel;
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use String::StringUtil;
use Align::Primary::blast;
use Util::Array;
use Sequence::sequence;
use PSSM::psi_blast;



my $evalueNegCutOff = 0.001;
my $diffEvPosNeg    = 0.1;
my $averageCutOff   = 10;
my $evaluePosCutOff = 1;

sub verify {
  my $trash = $_[0];
  my $ref1  = $_[1];
  my $ref2  = $_[2];
  
  # do something with your data
  print $ref1->{'username'}."\n";
  print $ref2->{'username'};

}

########################### sub main ####################################
sub classify { 
	
	my $seqFile  			= $_[1];
	my $databaseTrainPos	= $_[2];
	my $databaseTrainNeg	= $_[3];
	my $tmpDir				= $_[4];
	my $verbose				= $_[5];
	
	
	my $output = $tmpDir."output.blast";
	my $info = "";
	
	Blast->run($databaseTrainPos, "", $seqFile, $output, $verbose);
	my @evalues = Blast->getAllEvalue($output);
	my $evalue_pos = Array->getSmaller(\@evalues);
	my $average = RejectModel->searchAverage($seqFile, $databaseTrainPos, $tmpDir, $verbose);
	
	Blast->run($databaseTrainNeg, "", $seqFile, $output, $verbose);		
	@evalues = Blast->getAllEvalue($output);
	my $evalue_neg = Array->getSmaller(\@evalues);
	if (RejectModel->selectModel($evalue_pos, $evalue_neg, $average) eq "true"){
		$info .= $seqFile.";".$evalue_pos.";".$evalue_neg.";".$average."\n";	
	}
	#print "DEBUG ". $seqFile.";".$evalue_pos.";".$evalue_neg.";".$average."\n";	 	
	return $info;	
}
########################### sub main ####################################
sub classifyByPsiBlast { 
	
	my $seqFile  			= $_[1];
	my $databaseTrainPos	= $_[2];
	my $databaseTrainNeg	= $_[3];
	my $tmpDir				= $_[4];
	my $pathPsiBlastData	= $_[5];
	my $verbose				= $_[6];
	
	#print "path data classifyByPsiBlast " . $pathPsiBlastData."\n";
	
	my $output = $tmpDir."output.blast";
	my $info = "";
	
	PSIBLAST->buildPSSM($seqFile, $databaseTrainPos, "", $pathPsiBlastData, "", $output,"", $verbose);
	my @evalues = Blast->getAllEvalue($output);
	my $evalue_pos = Array->getSmaller(\@evalues);
	my $average = RejectModel->searchAverage($seqFile, $databaseTrainPos, $tmpDir, $pathPsiBlastData, $verbose);
	
	Blast->run($databaseTrainNeg, "", $seqFile, $output, $verbose);		
	@evalues = Blast->getAllEvalue($output);
	my $evalue_neg = Array->getSmaller(\@evalues);
	$info .= $seqFile.";".$evalue_pos.";".$evalue_neg.";".$average."\n";	
	#print "DEBUG ". $seqFile.";".$evalue_pos.";".$evalue_neg.";".$average."\n";	 	
	return $info;	
}
########################### sub main ####################################
sub classifyBeforeFormated { 
	
	my $seqFile  			= $_[1];
	my $databaseTrainPos	= $_[2];
	my $databaseTrainNeg	= $_[3];
	my $tmpDir				= $_[4];
	my $scop_id				= $_[5];
	my $family				= $_[6];
	my $verbose				= $_[7];
	
	
	my $output = $tmpDir."output.blast";
	my $info = "";
	
	Blast->run($databaseTrainPos, "", $seqFile, $output, $verbose);
	my @evalues = Blast->getAllEvalue($output);
	my $evalue_pos = Array->getSmaller(\@evalues);
	my $average = RejectModel->searchAverage($seqFile, $databaseTrainPos, $tmpDir, $verbose);
	
	Blast->run($databaseTrainNeg, "", $seqFile, $output, $verbose);		
	@evalues = Blast->getAllEvalue($output);
	my $evalue_neg = Array->getSmaller(\@evalues);
	print $scop_id.";".$family.";".$evalue_pos.";".$evalue_neg.";".$average."\n";
	if (RejectModel->selectModel($evalue_pos, $evalue_neg, $average) eq "true"){
		$info .= $scop_id.";".$family.";".$evalue_pos.";".$evalue_neg.";".$average."\n";	
	}	
	return $info;	
}


########################### sub main ####################################
sub classifySimple { 
	
	my $seqFile  			= $_[1];
	my $join_database		= $_[2];
	my $hash_pos			= $_[3];
	my $hash_neg			= $_[4];
	my $tmpDir				= $_[5];
	my $scop_id			    = $_[6];
	my $family				= $_[7];
	my $verbose				= $_[8];
	
	
	my $output = $tmpDir."output.blast";
	my $info = "";
	
	Blast->run($join_database, "", $seqFile, $output, $verbose);
	my $name_seq_best = Blast->getBestHit($output);
	print $name_seq_best."\n";
	exit;
	#my @evalues = Blast->getAllEvalue($output);
	#my $evalue_pos = Array->getSmaller(\@evalues);
	#my $average = RejectModel->searchAverage($seqFile, $databaseTrainPos, $tmpDir, $verbose);
	
	#Blast->run($databaseTrainNeg, "", $seqFile, $output, $verbose);		
	#@evalues = Blast->getAllEvalue($output);
	#my $evalue_neg = Array->getSmaller(\@evalues);
	#print $scop_id.";".$family.";".$evalue_pos.";".$evalue_neg.";".$average."\n";
	#if (selectModel($evalue_pos, $evalue_neg, $average) eq "true"){
	#	$info .= $scop_id.";".$family.";".$evalue_pos.";".$evalue_neg.";".$average."\n";	
	#}	
	return $info;	
}

############################ sub main ##################################
sub searchAverage {
		my $sequencia			= $_[1];
		my $databaseTrainPos 	= $_[2];
		my $tmpDir				= $_[3];
		my $pathPsiBlastData	= $_[4];
		my $verbose				= $_[5];
			
		my $output = $tmpDir."output.blast";
		my @array_sequences = Sequences->getSequenceFromFastaArray2D($databaseTrainPos);
		
		my $evalue; my $lower_evalue = 1000; my $seq;
		my $sum = 0; 
		#print "sequencia base = ".$sequencia."\n";
		for (my $i=0; $i<scalar(@array_sequences); $i++){	
			$output = $tmpDir."$i.output.blast";
			$seq = $array_sequences[$i][0].Sequences->divideSeq($array_sequences[$i][1], 60)."\n";
			#print  "database = ".$array_sequences[$i][0]."\n";
			FilesIO->saveFile($tmpDir."database.$i.txt", $seq, $verbose);
			Blast->formatdb($tmpDir."database.$i.txt", "", $verbose);
			#Blast->run($tmpDir."database.$i.txt", "", $sequencia, $output, $verbose);
			PSIBLAST->buildPSSM($sequencia, $tmpDir."database.$i.txt", "", $pathPsiBlastData, "", $output,"", $verbose);
			#read Blast results
			$evalue = Blast->getEvalue($output);
			#print $evalue."\n";
			$sum += $evalue;
			
		}	
		my $average = 	$sum/scalar(@array_sequences);					
		return $average;
}

############################ sub main ##################################
sub selectModel {
	my $evalue_pos 	= $_[1];
	my $evalue_neg 	= $_[2];
	my $average 	= $_[3];
	my $diff;

	if ($evalue_pos > $evalue_neg){
		$diff = $evalue_pos - $evalue_neg;
	}else{
		$diff = $evalue_neg - $evalue_pos;
	}
	
	if ($evalue_pos < $evalue_neg && $evalue_pos < $evaluePosCutOff){
			return "true";
			#print "Acepted ".$info. " ev+ = $evalue_pos ev-= $evalue_neg  \n";
	}elsif ($evalue_neg < $evalueNegCutOff){
			return "false";
	}elsif ($evalue_pos > $evaluePosCutOff){
			return "false";
	}elsif ($average <= $averageCutOff){
		return "true";
	}#elsif ($diff <= $diffEvPosNeg){
	#		return "true";
	#}
	return "false";
		
}




1
