package Analisys;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Util::Array;

##################################### sub readTrueIds ##################################
sub readTrueIds{
		my $path	= $_[1];
		
		my @true_ids = ();
	
		my @lines_file = ();
		my $line;	
		my @align		= ();	
		my @true_positives = ();
	
		my %hash_seq	= ();
		my $value = "";
		if (open(FILESEQ,"$path")){
			@lines_file = <FILESEQ>;		
			foreach $line (@lines_file){
				if (index($line, ">") >=0){
					@true_positives = split (/\t/, $line);
					push(@true_ids,  String->removeCaracter($true_positives[0],">"));					
				}				
			}
			close FILESEQ;
		}
		else{
			print "ERROR::analisysHmmer.pl:: File $path not found!\n";
			exit;
		}
		return @true_ids;
}


##################################### sub readTrueIds ##################################
sub removeDuplicate{
		my $info_array	= $_[1];
		
		my @array_line;
		my $item;
		my @array_result =();
		my @array_hash =();
		my $evalue;
		
		my @array = Array->lineStringToArray($info_array);
		my %hash = ();
		
		foreach $item (@array){
			@array_line = split (/\t/, $item);
			if (exists($hash{$array_line[0]})){
				@array_hash = split(/\t/, $hash{$array_line[0]});
				$evalue = $array_hash[2];
				if ($evalue > $array_line[2]){
					$hash{$array_line[0]} = $item;
				}
			}else{
				$hash{$array_line[0]} = $item;
			} 
		}
		my $key; my $value;
		
		while (($key, $value) = each(%hash)){
			push(@array_result, $value);
			#print $value;
		}
		return @array_result;
}
		
##################################### sub readTrueIds ##################################
sub calculeFMeasure{
		my $truePos		= $_[1];
		my $falsePos	= $_[2];
		my $falseNeg	= $_[3];
		
		my $fmeasure = 0;			my $precision= 0;
		my $recall = 0;
		
		if (($truePos + $falsePos) > 0){
			$precision = $truePos/ ($truePos + $falsePos);
		}
		if (($truePos + $falseNeg) > 0){
			$recall    = $truePos/ ($truePos + $falseNeg);
		}
		
		if ($precision + $recall > 0){
			 $fmeasure = (2*$precision*$recall)/($precision + $recall);
		}
	
		return $fmeasure;
}

	
##################################### sub readTrueIds ##################################
sub calculeSensitivity{
		my $truePos		= $_[1];
		my $trueNeg		= $_[2];
		my $falsePos	= $_[3];
		my $falseNeg	= $_[4];
		
		if ( ($truePos + $falseNeg) <= 0 ){
			return 1;
		}
		my $acc = ($truePos)/($truePos + $falseNeg);
		$acc = sprintf("%.2f", $acc);
		
		return $acc;
}


##################################### sub readTrueIds ##################################
sub calculeSensitivity2{
		my $truePos		= $_[1];
		my $falsePos	= $_[2];
		my $falseNeg	= $_[3];
		
		my $acc = ($truePos)/($truePos + $falseNeg);
		$acc = sprintf("%.2f", $acc);
		
		return $acc;
}

##################################### sub readTrueIds ##################################
sub calculeSpecificity2{
		my $truePos		= $_[1];
		my $falsePos	= $_[2];
		my $falseNeg	= $_[3];
				
		my $acc = ($trueNeg)/($trueNeg + $falsePos);
		$acc = sprintf("%.2f", $acc);
		
		return $acc;
}

##################################### sub readTrueIds ##################################
sub calculeSpecificity{
		my $truePos		= $_[1];
		my $trueNeg		= $_[2];
		my $falsePos	= $_[3];
		my $falseNeg	= $_[4];
		
		my $acc = ($trueNeg)/($trueNeg + $falsePos);
		$acc = sprintf("%.2f", $acc);
		
		return $acc;
}

##################################### sub readTrueIds ##################################
sub calculePPV{
		my $truePos		= $_[1];
		my $trueNeg		= $_[2];
		my $falsePos	= $_[3];
		my $falseNeg	= $_[4];
		
		if ( ($truePos + $falsePos) <= 0 ){
			return 1;	
		}
		my $acc = ($truePos)/($truePos + $falsePos);
		$acc = sprintf("%.2f", $acc);
		
		return $acc;
}	
##################################### sub readTrueIds ##################################
sub calculePPV2{
		my $truePos		= $_[1];
		my $falsePos	= $_[2];
		my $falseNeg	= $_[3];
		
		
		my $acc = ($truePos)/($truePos + $falsePos);
		$acc = sprintf("%.2f", $acc);
		
		return $acc;
}	
##################################### sub readTrueIds ##################################
sub calculeAcuracy{
		my $truePos		= $_[1];
		my $trueNeg		= $_[2];
		my $falsePos	= $_[3];
		my $falseNeg	= $_[4];
		
		my $acc = ($truePos + $trueNeg)/($truePos + $trueNeg + $falsePos + $falseNeg);
		$acc = sprintf("%.2f", $acc);
		
		return $acc;
}
############################ sub main ##################################
sub initMatrixStaRow{
	my ($lixo, $cols, $arrayInit) = @_;
	my @larrayInit = @{$arrayInit};	
	
	my @matrix = ();
	
	for (my $i = 0; $i <scalar(@larrayInit); $i++){
		$matrix[$i][0] = $larrayInit[$i];
		for (my $j = 1; $j <$cols; $j++){
			$matrix[$i][$j] = 0;
		}
	}
	return @matrix;
}

############################ sub main ##################################
sub initMatrixStaRowValue{
	my ($lixo, $cols, $value, $arrayInit) = @_;
	my @larrayInit = @{$arrayInit};	
	
	my @matrix = ();
	
	for (my $i = 0; $i <scalar(@larrayInit); $i++){
		$matrix[$i][0] = $larrayInit[$i];
		for (my $j = 1; $j <$cols; $j++){
			$matrix[$i][$j] = $value;
		}
	}
	return @matrix;
}

############################ sub main ##################################
sub fillMatrixSta{
	my ($lixo, $col, $evalue, $sta_matrix) = @_;
	my @larray = @{$sta_matrix};
	
	for (my $i = 0; $i < scalar(@larray); $i++){
		#print "compare $evalue ".$larray[$i][0]."\n";
		
		if ($evalue <= $larray[$i][0]){
			$larray[$i][$col] = $larray[$i][$col] + 1;
			#print "====> $evalue smaller than ".$larray[$i][0]."\n";
		}
	}
	#print Array->printMatrix2("\t", "\n", \@larray);

	return @larray;
	
}



############################ sub main ##################################
sub fillMatrixStaBigger{
	my ($lixo, $col, $evalue, $sta_matrix) = @_;
	my @larray = @{$sta_matrix};
	
	for (my $i = 0; $i < scalar(@larray); $i++){
		#print "compare $evalue ".$larray[$i][0]."\n";
		
		if ($evalue >= $larray[$i][0]){
			$larray[$i][$col] = $larray[$i][$col] + 1;
		#	print "====> $evalue smaller than ".$larray[$i][0]."\n";
		}
	}
	return @larray;
}



############################ sub main ##################################
sub fillMatrixStaValue{
	my ($lixo, $col, $evalue, $value, $sta_matrix) = @_;
	my @larray = @{$sta_matrix};
	
	for (my $i = 0; $i < scalar(@larray); $i++){
		#print "compare $evalue ".$larray[$i][0]."\n";
		
		if ($evalue <= $larray[$i][0]){
			$larray[$i][$col] = $value;
		#	print "====> $evalue smaller than ".$larray[$i][0]."\n";
		}
	}
	return @larray;
}
############################ sub main ##################################
sub fillMatrixIntervalSta{
	my ($lixo, $col, $evalue, $value, $sta_matrix) = @_;
	my @larray = @{$sta_matrix};
	
	for (my $i = 0; $i < scalar(@larray); $i++){
		#print "compare $evalue ".$larray[$i][0]."\n";		
		if ($i==0){
			if ($evalue <= $larray[$i][0]){
				$larray[$i][$col] = $value;
				#print "====> $evalue smaller than ".$larray[$i][0]."\n";
			}
		}elsif($evalue <= $larray[$i][0] && $evalue > $larray[$i-1][0]){
			$larray[$i][$col] = $value;
		}
	}
	return @larray;
}


############################ sub main ##################################
sub fillMatrixIntervalStaInc{
	my ($lixo, $col, $evalue, $sta_matrix) = @_;
	my @larray = @{$sta_matrix};
	
	for (my $i = 0; $i < scalar(@larray); $i++){
		#print "compare $evalue ".$larray[$i][0]."\n";		
		if ($i==0){
			if ($evalue <= $larray[$i][0]){
				$larray[$i][$col] = $larray[$i][$col] + 1;
				#print "====> $evalue smaller than ".$larray[$i][0]."\n";
			}
		}elsif($evalue <= $larray[$i][0] && $evalue > $larray[$i-1][0]){
			$larray[$i][$col] = $larray[$i][$col] + 1;
		}
	}
	return @larray;
}
########################### sub main ####################################
sub initialArrayCountHistogram { 
	my $biggest		= $_[1];
	my $smallest	= $_[2];
	my $QTD_POINTS  = $_[3];
	
	my @arrayCountFamily = ();
	print $biggest." big\n";
	print $smallest." small\n";
	my $value = ($biggest - $smallest)/($QTD_POINTS);
	#print $value." value\n";
	for (my $i = 0; $i <= $QTD_POINTS; $i++){
		$arrayCountFamily[$i][0] = int($smallest + ($value*$i));
		$arrayCountFamily[$i][1] = 0;	
		$arrayCountFamily[$i][2] = int($arrayCountFamily[$i][0]).":".int($smallest + ($value*($i+1)));	
		print "$i\t" .$arrayCountFamily[$i][0]."\n";
	}
	return @arrayCountFamily;	
}


########################### sub main ####################################
sub initialArrayCountHistogramIntervalSize { 
	my $biggest		= $_[1];
	my $smallest	= $_[2];
	my $intervalSize  = $_[3];
	
	my @arrayCountFamily = ();
	#print $biggest." big\n";
	#print $smallest." small\n";
	my $value =  0;
	my $i = 0;
	#print $value." value\n";
	while ($value < $biggest) {
		$value = $intervalSize*$i;
		$arrayCountFamily[$i][0] = int($smallest + $value);
		$arrayCountFamily[$i][1] = 0;	
		$arrayCountFamily[$i][2] = int($arrayCountFamily[$i][0]).":".int($smallest + ($intervalSize*($i+1)));	
		#print "$i\t" .$arrayCountFamily[$i][0]."\n";
		$i++;
	}
	return @arrayCountFamily;	
}


########################### sub main ####################################
sub initialArrayCountHistogramFloat { 
	my $biggest		= $_[1];
	my $smallest	= $_[2];
	my $QTD_POINTS  = $_[3];
	
	my @arrayCountFamily = ();
	#print $biggest." big\n";
	#print $smallest." small\n";
	my $value = ($biggest - $smallest)/($QTD_POINTS);
	#print $value." value\n";
	for (my $i = 0; $i <= $QTD_POINTS; $i++){
		$arrayCountFamily[$i][0] = $smallest + ($value*$i);
		$arrayCountFamily[$i][1] = 0;	
		$arrayCountFamily[$i][2] = $arrayCountFamily[$i][0].":".($smallest + ($value*($i+1)));	
		#print $arrayCountFamily[$i][2]."\n";
	}
	return @arrayCountFamily;	
}


########################### sub main ####################################
sub initialArrayCountHistogramFloatJumpLog { 
	my $biggest		= $_[1];
	my $smallest	= $_[2];
	my $jump		= $_[3];
	
	my @arrayCountFamily = ();
	my $previous;
	
	#print $biggest." big\n";
	#print $smallest." small\n";
	my $value = $smallest ;
	my $i = 0;
	#print $value." value\n";


	while ($biggest > ($value*$jump)){
		if ($i == 0){
			$previous = $smallest
		}else{
			$previous = $arrayCountFamily[$i-1][0];
		}	
		
		if ($value >=1){
			$value = $previous+ 10;
		}else{
			$value = $previous*$jump;
		}
		
		#print "previous = $previous value = $value jump = $jump\n";
		$arrayCountFamily[$i][0] = $value;
		$arrayCountFamily[$i][1] = 0;	
		if ($biggest < ($value*$jump)){
			$value = $biggest;
		}
		$arrayCountFamily[$i][2] = sprintf("%.1e", $previous).":".sprintf("%.1e", $value);	
		#print $arrayCountFamily[$i][2]. "\n";
	
		$i++;		
		#print "$value\n";
	}
	$arrayCountFamily[$i][0] = 10;
	$arrayCountFamily[$i][1] = 0;
	$previous = $arrayCountFamily[$i-1][0];	
	$arrayCountFamily[$i][2] = sprintf("%.1e", $previous).":".sprintf("%.1e", $biggest);	
	$i++;
	$arrayCountFamily[$i][0] = $biggest;
	$arrayCountFamily[$i][1] = 0;
	$previous = $arrayCountFamily[$i-1][0];	
	$arrayCountFamily[$i][2] = sprintf("%.1e", $previous).":".sprintf("%.1e", $biggest);	

	return @arrayCountFamily;	
}



########################### sub main ####################################
sub initialArrayCountHistogramFloatJump { 
	my $biggest		= $_[1];
	my $smallest	= $_[2];
	my $jump		= $_[3];
	
	my @arrayCountFamily = ();
	my $previous;
	
	print $biggest." big\n";
	print $smallest." small\n";
	my $value = $smallest ;
	my $i = 0;
	print $value." value\n";
		
	while ($biggest > ($value + $jump)){
		if ($i == 0){
			$previous = $smallest
		}else{
			$previous = $arrayCountFamily[$i-1][0];
		}		
		$value = $previous + $jump;
		$arrayCountFamily[$i][0] = $value;
		$arrayCountFamily[$i][1] = 0;	
		$arrayCountFamily[$i][2] = $previous.":".$value;	
		print "$previous + $jump ". $arrayCountFamily[$i][2]. "\n";
		$i++;		
	}
	return @arrayCountFamily;	
}
########################### sub main ####################################
sub countArrayCountHistogram { 
	my ($lixo, $QTD_POINTS, $arrayCount, $arrayData) = @_;
	my @larrayCount = @{$arrayCount};
	my @larrayData = @{$arrayData};
	my $mesure;
	
	for (my $k =0; $k< scalar(@larrayData); $k++){
		$mesure = $larrayData[$k];
		print $mesure."\n";		
		for (my $i = 0; $i < $QTD_POINTS; $i++){
			print "interval ".$arrayCountFamily[$i][0]."\n";
			if ($i < $QTD_POINTS -1){
				if ($mesure >= $larrayCount[$i][0] && $mesure < $larrayCount[$i + 1][0] ){
					$larrayCount[$i][1] += 1;
					print "interval found ".$arrayCountFamily[$i][2]."\n";
					$i = $QTD_POINTS;
				}
			}elsif ($mesure >= $larrayCount[$i][0]){
				$larrayCount[$i][1] += 1;
				print "interval found ".$arrayCountFamily[$i][2]."\n";
				$i = $QTD_POINTS;			
			}
		}
	}
	return @larrayCount;
}


########################### sub main ####################################
sub countArrayHistogramInterval { 
	my ($lixo, $QTD_POINTS, $arrayCount, $arrayData) = @_;
	my @larrayCount = @{$arrayCount};
	my @larrayData = @{$arrayData};
	my $mesure;	my @array_aux = ();
	my $upper;	my $lower;
	

	for (my $k =0; $k< scalar(@larrayData); $k++){
		$mesure = $larrayData[$k];		
		for (my $i = 0; $i < scalar(@larrayCount); $i++){
			@array_aux = split(/:/,$larrayCount[$i][2]);
			$lower = $array_aux[0];
			$upper = $array_aux[1];
			#print "$lower $upper $mesure\n";
		
			if ($mesure > $lower && $mesure <= $upper){
					$larrayCount[$i][1] += 1;		
			}
		}
		#exit;
	}
	return @larrayCount;
}

########################### sub main ####################################
sub StaMatrixIsDifferent { 
	my ($lixo, $evalue1, $evalue2, $arrayEvInit) = @_;
	my @larrayEvInit = @{$arrayEvInit};	
	
	my @matrixSta1 = Analisys->initMatrixStaRow(2, \@larrayEvInit);
	my @matrixSta2 = Analisys->initMatrixStaRow(2, \@larrayEvInit);
	
	@matrixSta1 = Analisys->fillMatrixSta(1, $evalue1, \@matrixSta1);	
	@matrixSta2 = Analisys->fillMatrixSta(1, $evalue2, \@matrixSta2);
	
	#print  Array->printMatrix("\t", scalar(@matrixSta1), $#{$matrixSta1[0]} + 1, \@matrixSta1);
	#print  Array->printMatrix("\t", scalar(@matrixSta2), $#{$matrixSta2[0]} + 1, \@matrixSta2);
	
	if (Array->compareMatrixCol(scalar(@matrixSta1),  $#{$matrixSta1[0]} + 1, 1, \@matrixSta1, \@matrixSta2) eq "true"){
		return "false";
	}
	return "true";
}



########################### sub main ####################################
sub initialArrayCountPerformance { 
	my $QTD_POINTS 	= $_[1];
	my $interval	= $_[2];
	my $start		= $_[3];	

	my @arrayCount =();
	
	for (my $i = 0; $i <= $QTD_POINTS; $i++){
		$arrayCount[$i][0] = $start + $i*$interval;
		$arrayCount[$i][1] = 0;
	}
	return @arrayCount;
}


########################### sub main ####################################
sub countArrayCountPerformance { 
	my ($lixo, $arrayData, $arrayCount) = @_;
	my @larrayData = @{$arrayData};	
	my @larrayCount = @{$arrayCount};	
	my $value;
	
	for (my $j = 0; $j < scalar(@larrayData); $j++){
		$value = $larrayData[$j];
		for (my $i = 0; $i < scalar(@larrayCount); $i++){
			#print $accuracy."\n";
			#print $arrayCountFamily[$i][0]."\n";
		
			if ($value <= $larrayCount[$i][0]){
				$larrayCount[$i][1] += 1;
			}
		}
	}
	return @larrayCount;
	
}


1