#!/usr/bin/perl -w
use strict;

use strict;
use lib "/home/jsilva/programs/bioperl-1.5.2_102";
use Bio::SearchIO;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file;
my $set_file;

my @sam_ids 		= ();
my @true_ids 		= ();

my @sam_ids_tp 	= ();#sam ids true positive
my @sam_ids_fp 	= ();#sam ids false positive
my @sam_ids_fn	= ();#sam ids false negatives

my @sam_info_parsed = ();#result file sam
my $info_statistics = "";

my $alin_er   = "mammoth";
my $calibrate = "calibrated";
my $work_fold = "sam_prior_fssp";
my $dir;
my $dir_seq = "/home/jsilva/projetos/projeto_align/datas/sequences/";

my $info_count = "";
my $count = 0;
#my $alin_er   = "";
#my $calibrate = "";

&getParameters;
&readParametersFile;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		} 		
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}
	unless (open(SETFILE, "$set_file")) {
   		print "Could not open file $set_file !\n";
     		exit;
   	}
	
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     		exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)==2){
			$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			#print $value."\n";
			if ($array_settings[0] eq "p_alin_er"){
				$alin_er = $value;					
			}elsif ($array_settings[0] eq "p_calibrate"){
				$calibrate = $value;				
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;				
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;				
			}elsif ($array_settings[0] eq "p_dir"){
				$dir = $value;				
			}
		}
	}
}
#################################### sub main ##################################
sub main {

	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = substr($family[0], 0, index($family[0],"\n"));
		print $new_sample ."\n";
		
		if ($new_sample ne $old_sample){
			#$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&getTruePositivesFound($new_sample,$dir); 
			&writeFileHitsFound($new_sample,$dir);
			&writeFileHitsNotFound($new_sample,$dir);	

			@sam_ids 		= ();
			@true_ids 		= ();
			@sam_ids_tp 	= ();
			@sam_ids_fp 	= ();	
			@sam_info_parsed = ();
			@sam_ids_fn	= ();
		}
		$old_sample = $new_sample;					
	}
	#print $info_statistics;
	#&writeStatistics($info_statistics);
	close FAMILYFILE;
}

############################ sub getTruePositivesFound ##################################
sub getTruePositivesFound{
	my $sample		= $_[0];
	#my $dir			= $_[1];
	#my $work_fold	= "sam";
	
	my $pattern = &getPattern(3, ".", $sample);	

	my $dir_result 	= $dir."HMMs/SAM/$alin_er/results/$pattern/";
	my $dir_result_sam = $dir_result;
	my $result_file_name = "$sample.result.dist";
	my $real_true_positive_file = $dir_seq. $pattern. "/".$pattern."true";

	my $item_true_id;
	my $item_sam_id;
	my $count_true_positive_found	= 0;
	my $count_false_positive	= 0;
	my $found = "false";


	&readsamIds($dir_result_sam.$result_file_name, $sample);
	&readTrueIds($real_true_positive_file);

	foreach $item_sam_id (@sam_ids){
		#print $item_sam_id;		
		my @ids_seq_sam = split (/\t/, $item_sam_id); 
		my $sample_sam = substr($ids_seq_sam[1], 0, index($ids_seq_sam[1],"\n"));
		
		foreach $item_true_id (@true_ids){	
			if ($item_true_id eq $ids_seq_sam[0] && $sample eq $sample_sam){
				push(@sam_ids_tp, $item_true_id);
				$count_true_positive_found++;
				$found = "true";	
			}
		}
		
		if ($found eq "false" && &getPattern(3, ".", $sample_sam) ne $pattern){
			push(@sam_ids_fp, $ids_seq_sam[0]);
			$count_false_positive++;
		}
		$found = "false";
	}

	#print $sample. "\t";
	$count++;
	#print $count . "\t". $count_true_positive_found . "\n";
	print $count_false_positive . "\t". $count_true_positive_found . "\n";
	#exit;
	
  my $key_aln; 
 my $value_aln;
  
 #while (($key_aln, $value_aln) = each(%hash_homol)){
  #		if ($value_aln eq $sample){
#				print $key_aln.">>>>>\t".$value_aln."\n" ;    
#		}
#}
	

	#$count_false_positive = scalar(@sam_ids) - $count_true_positive_found;
	$info_statistics .= "$sample FP $count_false_positive TP $count_true_positive_found";	
	
}

##################################### sub writeFileHitsFound ##############################
sub writeFileHitsFound{
	
	my $sample		= $_[0];
	#my $dir			= $_[1];
	my $pattern = &getPattern(3, ".", $sample);		

	my $path_tp_file = $dir."HMMs/SAM/$alin_er/results/$pattern/$sample"."_true_positives_found.txt";
	my $path_fp_file = $dir."HMMs/SAM/$alin_er/results/$pattern/$sample"."_false_positives_found.txt";
	
	my $item;
	my $i = 0;

	my @result = ();
	my $found  = "false";
	my $info_true = "";
	my $info_false = "";
	
	

   	foreach $item (@sam_info_parsed){
		@result	= split(/ +/,$item);		
		#print $item."\n";
		while ($i < scalar(@sam_ids_tp) && $found eq "false"){
			#print $sam_ids_tp[$i].$result[0]."\n";
			
			if ($sam_ids_tp[$i] eq $result[0]){
				$info_true.= $item;
				$found = "true";	
			}
			$i++;	
		}		
		$i = 0;
		$found = "false";			
	}
	#print $sample."\n";
	#print $info_true."\n";

	foreach $item (@sam_info_parsed){
		@result	= split(/ +/,$item);		
		#print $item."\n";
		while ($i < scalar(@sam_ids_fp) && $found eq "false"){
			#print $sam_ids_fp[$i].$result[0]."\n";
			
			if ($sam_ids_fp[$i] eq $result[0]){
				$info_false.= $item;
				$found = "true";	
			}
			$i++;	
		}		
		$i = 0;
		$found = "false";
	}
	
	#

	&saveFile($path_tp_file, $info_true);
	&saveFile($path_fp_file, $info_false);
	
}

##################################### sub writeFileHitsNotFound ##############################
sub writeFileHitsNotFound{
	
	my $sample		= $_[0];
	#my $dir			= $_[1];
	my $pattern = &getPattern(3, ".", $sample);		

	my $path_fn_file = $dir."HMMs/SAM/$alin_er/results/$pattern/$sample"."_false_negatives_found.txt";
	
		
	my $item_true_id;
	my $item_sam_id;
		
	my $found  = "false";
	my $info_false_neg = "";
	my $count_false_negative = 0;

  	foreach $item_true_id (@true_ids){
		foreach $item_sam_id (@sam_ids_tp){	
			if ($item_true_id eq $item_sam_id){
				$found = "true";				
			}
		}
		if($found eq "false"){
			$info_false_neg.= $item_true_id ."\n";
			$count_false_negative++;
		}
		$found = "false";
	}
	#$info_statistics .= " FN $count_false_negative\n";
	&saveFile($path_fn_file, $info_false_neg);
}

############################ sub writeStatistics ##################################
sub writeStatistics{

	my @infos = split(/\n/,$info_statistics);
	my @each_info  = ();
	my $old_pattern = "";
	my $new_pattern = "";
	my $new_sample = "";
	my $info_file ="";

	my $item;
	my $sum_tp = 0;
	my $sum_fp = 0;
	my $sum_fn = 0;
	my $num_same_samples = 0;

	foreach $item (@infos){
		@each_info 	= split(/ +/,$item); 
		$new_sample = $each_info[0];
		$new_pattern = &getPattern(3, ".", $new_sample);

		if ($old_pattern ne $new_pattern && $old_pattern ne ""){			
			$info_file.= &calcTx($num_same_samples,$sum_tp,$sum_fp,$sum_fn,$old_pattern);
			$num_same_samples = 0;
			$sum_tp = 0;
			$sum_fp = 0;
			$sum_fn = 0;
		}
		$sum_fp += $each_info[2];
		$sum_tp += $each_info[4];
		$sum_fn += $each_info[6];
		$num_same_samples++;
		$old_pattern = $new_pattern;		
	}
	$info_file.= &calcTx($num_same_samples,$sum_tp,$sum_fp,$sum_fn,$old_pattern);
	&sepInfo($info_file);
	#&saveFile("sam_statistics.txt",$info_file);
}

############################ sub calcTx ##################################
sub calcTx{
	my $num_same_samples	= $_[0];
	my $sum_tp	= $_[1];
	my $sum_fp	= $_[2];
	my $sum_fn	= $_[3];
	my $old_pattern = $_[4]; 

	my $num_tp;
	my $num_fp;
	my $num_fn;

	my $precision;
	my $recall;
	my $tx;

	if ($num_same_samples == 0){
				$num_same_samples = 1;
	}
	$num_tp = $sum_tp / $num_same_samples;
	$num_fp = $sum_fp / $num_same_samples;
	$num_fn = $sum_fn / $num_same_samples;
	if ($num_tp == 0){
		$precision = 0;
		$recall	= 0;
	}else{
		$precision = $num_tp /($num_tp + $num_fn);
		$recall =  $num_tp /($num_tp + $num_fp);
	}
	#$tx = $precision/(1-$recall);
	return "$old_pattern $num_tp $num_fp $num_fn $precision $recall\n";
		
}
############################ sub calcTx ##################################
sub sepInfo{
	my $info_ent	= $_[0];

	my $item;
	my	@infos = ();
	my @info = ();
	my $info_recall_pre = "";
	my $info_fp_tp = "";

	@infos = split(/\n/,$info_ent);
	foreach $item (@infos){
		@info = split(/ +/,$item);
		$info_recall_pre .= $info[4]. "\t".$info[5]."\n";
		$info_fp_tp .= $info[2]. "\t".$info[1]."\n";
	}
	#&saveFile("sam_recallPrec.txt",$info_recall_pre);
	#&saveFile("sam_fpTp.txt",$info_fp_tp);
}
##################################### sub readsamIds ##################################
sub readsamIds {
	my $path			= $_[0];

	my $sam_file_parsed = $path.".parsed";

	my $item;
	my	@sam_file = ();
	my	@sam_info = ();
	my $i;

	if (open(samRESFILE,$path)){
		&parsersamResults($path);
		close samRESFILE;
		#print "path $sam_file_parsed\n";
		if (open(samPARFILE,$sam_file_parsed)){
			@sam_file = <samPARFILE>;
			$i = 0;
			foreach $item (@sam_file){
				$sam_info_parsed[$i++] = $item;
				@sam_info	= split(/\t/,$item);
				my @sam_desc1 = split(/ +/,$sam_info[0]);
				my @sam_desc2 = split(/ +/,$sam_info[1]);
				
				my $info = substr($sam_desc2[0], index($sam_desc2[0], ":")+1,  length($sam_desc2[0]));
							
				$info =  $sam_desc1[0]."\t".$info."\n";
				#print $info ."\n\n\n";	
				push(@sam_ids, $info);				
			}
			close samPARFILE;
		}
		else{
			print "ERROR : file $sam_file_parsed not found\n";
		}
		
	}
	else{
		print "ERROR : file $path not found\n";
	}
}
##################################### sub readTrueIds ##################################
sub readTrueIds{
		my $path	= $_[0];
	
		my @lines_file = ();
		my $line;	
		my @align		= ();	
		my @true_positives = ();
	
		my %hash_seq	= ();
		my $value = "";
		if (open(FILESEQ,"$path")){
			@lines_file = <FILESEQ>;		
			foreach $line (@lines_file){
				@true_positives = split (/ +/, $line);
				push(@true_ids, $true_positives[0]);
				#$hash_homol{$true_positives[0]} =$true_positives[1];  			
			}
			close FILESEQ;
		}
		else{
			print "File $path not found!\n";
		}
}
#################################### sub parsersamResults ##################################
sub parsersamResults {
		my $path			= $_[0];

		my $outfileName = $path.".parsed";

		my $maxEvalue = "10";
		my $minScore = "-100";
		
		my @sam_file = ();
		my @sam_info = ();
		my $info = "";
		my $item;

		unless (open(PARSEDFILE, ">$outfileName")) {
                print "Could not open file $outfileName !\n";
                exit;
       }
		if (open(SAMFILE,$path)){
			@sam_file = <SAMFILE>;
			foreach $item (@sam_file){
				if (index($item,"%") != 0){
					$info.= $item;
				}				
			}
		}
		&saveFile($outfileName, $info);
		
		
		close (PARSEDFILE);
}
############################ sub getPattern ##################################
sub getPattern {
	my $num 		= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}

############################ sub saveFile ###################################
sub saveFile{
	my $path 	= $_[0];
	my $info  	= $_[1];

	if (open(FILESEQ,">$path")){
		print FILESEQ $info;
		#print "file $path was created\n";
	}
	else{
		print "file $path not found\n";
	}
	close FILESEQ;
}
