#!/usr/bin/perl -w
use strict;
use POSIX qw(log10);
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use File::Files;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file;
my $set_file;
my $kind_align   = "mammoth";
my $kind_calib = "calibrated";
my $work_fold = "hmmerStruct";

#my $dir_stat = "/usr/local/juliana_testes/statistics/$kind_align/$kind_calib/prec_recall/$work_fold/";

#my %hash_interval_ev	= ();
my @count_ev_tp		= ([],[]);
my @count_ev_fp		= ([],[]);
my @count_ev_fn		= ([],[]);
my @count_ev_tp_aux  = ([],[]);

my @precisions = ();
my @recalls = ();
my @numTp = ();
my @numFp = ();
my @count_families = ();

my $value	   = 10;
my $high_lim	= 100;
my $low_lim		= 1e-100;


my $col 			 = 2;
my $row			   = 88;
my $row_more   = $row + 10;
my $row_tot = 0;

my $info_rec_pre = "";

&getParameters;
&readParametersFile;
&inicialize;
&inicializePR;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		} 		
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}
	unless (open(SETFILE, "$set_file")) {
   	print "Could not open file $set_file !\n";
     	exit;
   }
	
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     	exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)==2){
			$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			print $value."\n";
			if ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;					
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;				
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;				
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;				
			}
		}
	}
	#$dir_stat = "/usr/local/juliana_testes/statistics/$kind_align/$kind_calib/prec_recall/$work_fold/";
	#FilesIO->createDirectory($dir_stat);
}
#################################### sub inicialize ##################################
sub inicialize{
		my $i = 0; my $j = 0; my $count = 0.01;
		for ($i = 1; $i < $row; $i++){
			for ($j = 0; $j < $col; $j++){
				if ($j == 0){
					$count_ev_tp[$i][$j] = &power(13,$i)*$low_lim ;
					$count_ev_fp[$i][$j] = &power(13,$i)*$low_lim ;
					$count_ev_fn[$i][$j] = &power(13,$i)*$low_lim ;
				}
				else{
					$count_ev_tp[$i][$j] = 0;
					$count_ev_fp[$i][$j] = 0;
					$count_ev_fn[$i][$j] = 0;
				}
				
			}
			
		}

		for ($i = $row; $i < $row_more; $i++){
			for ($j = 0; $j < $col; $j++){
				if ($j == 0){
					$count_ev_tp[$i][$j] = $count;
					$count_ev_fp[$i][$j] = $count;
					$count_ev_fn[$i][$j] = $count;
					$count += 0.01;
				}else{
					$count_ev_tp[$i][$j] = 0;
					$count_ev_fp[$i][$j] = 0;
					$count_ev_fn[$i][$j] = 0;
				}
				
			}
		
		}
		$count_ev_tp[$i][1] = 0;
		$count_ev_fp[$i][1] = 0;
		$count_ev_fn[$i][1] = 0;

		$count_ev_tp[$i][0] = 1;
		$count_ev_fp[$i][0] = 1;
		$count_ev_fn[$i][0] = 1;	

		$row_tot =  $row_more + 1;
		
		#&printArrayTp;		
}
#################################### sub inicializePR ##################################
sub inicializePR{
	my $i = 1;
	for ($i = 1; $i < $row_tot; $i++){
		$precisions[$i] = 0;
		$recalls[$i] = 0;
		$numTp[$i] = 0;
		$numFp[$i] = 0;
	}
}
#################################### sub inicializePR ##################################
sub inicializeCountFamilies{
	my $i = 1;
	for ($i = 1; $i < $row_tot; $i++){
		$count_families[$i] = 0;
	}
}
#################################### sub inicializeTp_aux ##################################
sub inicializeTp_aux{
		my $i = 0; my $j = 0; my $count = 0.01;
		for ($i = 1; $i < $row; $i++){
			for ($j = 0; $j < $col; $j++){
				if ($j == 0){
					$count_ev_tp_aux[$i][$j] = &power(13,$i)*$low_lim ;
					
				}
				else{
					$count_ev_tp_aux[$i][$j] = 0;
					
				}
			}
		}
		for ($i = $row; $i < $row_more; $i++){
			for ($j = 0; $j < $col; $j++){
				if ($j == 0){
					$count_ev_tp_aux[$i][$j] = $count;
					$count += 0.01;
				}else{
					$count_ev_tp_aux[$i][$j] = 0;
				}
			}
		}
		$count_ev_tp_aux[$i][0] = 1;
		$count_ev_tp_aux[$i][1] = 0;
		$row_tot =  $row_more +1;
		#&printArrayTp;		
}
#################################### sub printArrayTp ##################################
sub printArrayPR {
		my $i = 1;
		for ($i = 1; $i < $row_tot ; $i++){
			print "$recalls[$i]\t$precisions[$i]\n";			
			#print "$numFp[$i]\t$numTp[$i]\n";			
		}		
		
}
#################################### sub saveArrayTp ##################################
sub saveArrayFT {
		my $i = 1;
		my $info = "";
		for ($i = 1; $i < $row_tot ; $i++){
			$info .=  "$numFp[$i]\t$numTp[$i]\n";								
		}		
		return $info;		
}
#################################### sub saveArrayTp ##################################
sub saveArrayPR {
		my $i = 1;
		my $info = "";
		for ($i = 1; $i < $row_tot ; $i++){
			$info .=  "$recalls[$i]\t$precisions[$i]\n";								
		}		
		return $info;		
}
#################################### sub printArrayTp ##################################
sub printArrayTp {
		my $i = 0; my $j = 0;
		for ($i = 1; $i < $row_tot ; $i++){
			print " $i ";
			for ($j = 0; $j < $col; $j++){
				print	$count_ev_tp[$i][$j]." ";
			}
			print "\n";
		}		
		
}

#################################### sub printArrayTp ##################################
sub printArrayFp {
		my $i = 0; my $j = 0;
		for ($i = 1; $i < $row_tot ; $i++){
			print " $i ";
			for ($j = 0; $j < $col; $j++){
				print	$count_ev_fp[$i][$j]." ";
			}
			print "\n";
		}		
}
#################################### sub printArrayTp ##################################
sub printArrayFn {
		my $i = 0; my $j = 0;
		for ($i = 1; $i < $row_tot ; $i++){
			print " $i ";
			for ($j = 0; $j < $col; $j++){
				print	$count_ev_fn[$i][$j]." ";
			}
			print "\n";
		}		
}
#################################### sub main ##################################
sub main {

	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $new_pattern   = "";
	my $old_pattern   = "";
	my $dir;
	my $count_super = 0;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       	print "Could not open file $in_file !\n";
        	exit;
    }
	@families = <FAMILYFILE>;
	
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		
		if ($new_sample ne $old_sample){
			$new_pattern = &getPattern(3, ".", $new_sample);
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;
			#print "ent $old_pattern $new_pattern \n ";
			if (($old_pattern ne $new_pattern) && ($old_pattern ne "")){
					&divideArrayTp($count_super);
					&divideArrayFp($count_super);
					&divideArrayFn($count_super);
					#print  $old_pattern;
					&calcPrecisionRecall($old_pattern);
					#&printArrayTp;
					$count_super = 0;
					&inicialize;
			}
			
					
			&getIntervalTruePositivesFound($new_sample,$dir);
			&getIntervalFalsePositivesFound($new_sample,$dir);
			#&printArrayFp;
			&getIntervalFalseNegativesFound($new_sample,$dir);
			$old_pattern = $new_pattern;
			$count_super++;
		}
		$old_sample = $new_sample;					
	}
	&divideArrayTp($count_super);
	&divideArrayFp($count_super);
	&divideArrayFn($count_super);
	&calcPrecisionRecall($old_pattern);
	print  $old_pattern;
	&divideArrayPR;
	&printArrayPR;
	#&printArrayTp;
	&saveFile($work_fold."_".$kind_align."_".$kind_calib."_"."PR.sta", &saveArrayPR);
	&saveFile($work_fold."_".$kind_align."_".$kind_calib."_"."FT.sta", &saveArrayFT);
	close FAMILYFILE;
}

############################ sub getIntervalTruePositivesFound ##################################
sub getIntervalTruePositivesFound{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $dir_result 		= $dir.$sample."/result/$kind_align/$kind_calib/$work_fold/";
	my $file_name_tp		= "hmmpfam_true_positives_found.txt";

	my @data_file			= ();
	my @data_result		= ();
	my $line;
	

	if (open(RESFILE, $dir_result.$file_name_tp)){
		@data_file = <RESFILE>;
		foreach $line (@data_file){
			@data_result = split(/\t/, $line);
			&compareToArrayTp($data_result[3]);			
		}
		#&printArrayTp
	} 
	else{
		print "ERROR File $dir_result$file_name_tp not found\n";
	}
}
############################ sub getIntervalFalseNegativesFound ##################################
sub getIntervalFalseNegativesFound{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $dir_result 		= $dir.$sample."/result/$kind_align/$kind_calib/$work_fold/";
	my $file_name_fn		= "hmmpfam_false_negatives_found.txt";
	my $file_name_tp		= "hmmpfam_true_positives_found.txt";


	my @data_file			= ();
	my @data_result		= ();
	my $line;
	my $num_fn = 0;
	my $num_tp = 0;
	

	my $i = 0;
	&inicializeTp_aux;

	if (open(RESFILE, $dir_result.$file_name_fn)){
			@data_file = <RESFILE>;
			$num_fn = scalar(@data_file);
			close RESFILE;
	}


	if (open(RESFILE, $dir_result.$file_name_tp)){
		@data_file = <RESFILE>;
		$num_tp = scalar (@data_file);

		foreach $line (@data_file){
			@data_result = split(/\t/, $line);
#			@data_result = split(/ +/, $line);
			&compareToArrayTp_aux($data_result[3]);			
		}
		close RESFILE;
		for ($i = 1; $i < $row_tot; $i++){
			$count_ev_fn[$i][1] += ($num_tp - $count_ev_tp_aux[$i][1]) + $num_fn;			
		}		
	} 
	else{
		print "ERROR File $dir_result$file_name_tp not found\n";
	}
}

############################ sub getIntervalTruePositivesFound ##################################
sub getIntervalFalsePositivesFound{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $dir_result 		= $dir.$sample."/result/$kind_align/$kind_calib/$work_fold/";
	my $file_name_tp		= "hmmpfam_false_positives_found.txt";

	my @data_file			= ();
	my @data_result		= ();
	my $line;
	

	if (open(RESFILE, $dir_result.$file_name_tp)){
		@data_file = <RESFILE>;
		foreach $line (@data_file){
			@data_result = split(/\t/, $line);
			#@data_result = split(/ +/, $line);
			&compareToArrayFp($data_result[3]);	
		}
		close RESFILE;
		#print $sample . "===========\n";
		#&printArrayFp;
	} 
	else{
		print "ERROR File $dir_result$file_name_tp not found\n";
	}
}
############################ sub getPattern ##################################
sub calcPrecisionRecall{
		my $old_pattern 		= $_[0];
		my $info = "";my $info_tp_fp = "";
		#my $path = $dir_stat.$old_pattern."pre_rec";
		#my $path_tp_fp = $dir_stat.$old_pattern."tp_fp";
		my $pre;
		my $rec;
		my $tp;
		my $fp;

		my $i;
		print $old_pattern."\n";
		#$info.= "\tRecall\tPrecision\n";
		for ($i = 1; $i < $row_tot; $i++){
			if ($count_ev_tp[$i][1]==0){
				$rec = 0;
				$pre = 0;
				$tp  = 0;
				$fp  = 0;
			}
			else{
				$rec = ($count_ev_tp[$i][1]/($count_ev_tp[$i][1] + $count_ev_fn[$i][1]));
				$pre = ($count_ev_tp[$i][1]/($count_ev_tp[$i][1] + $count_ev_fp[$i][1]));
				$tp  = $count_ev_tp[$i][1];
				$fp  = $count_ev_fp[$i][1];
				$count_families[$i] += 1;
			}
			$info.= $rec;			
			$recalls[$i] += $rec;			
			$info.=  "\t". $pre;
			$precisions[$i] += $pre;
			$info.=  "\n";
			$info_tp_fp .=$fp."\t". $tp."\n";
			$numTp[$i] += $tp;
			$numFp[$i] += $fp;
		}
		#print "oi ".$path;
		#&saveFile($path, $info);
		#&saveFile($path_tp_fp, $info_tp_fp);
}
############################ sub getPattern ##################################
sub divideArrayPR{
		my $i;
		for ($i = 1; $i < $row_tot; $i++){
			$precisions[$i] = $precisions[$i]/$count_families[$i];
			$recalls[$i] = $recalls[$i]/$count_families[$i];
			$numTp[$i] = $numTp[$i]/$count_families[$i];
			$numFp[$i] = $numFp[$i]/$count_families[$i];
		}
}
############################ sub getPattern ##################################
sub divideArrayFn{
		my $num 		= $_[0];
		my $i; my $j =1; 

		for ($i = 1; $i < $row_tot; $i++){
			$count_ev_fn[$i][$j] = $count_ev_fn[$i][$j]/$num;
		}
}
############################ sub getPattern ##################################
sub divideArrayTp{
		my $num 		= $_[0];
		my $i; my $j =1; 

		for ($i = 1; $i < $row_tot; $i++){
			$count_ev_tp[$i][$j] = $count_ev_tp[$i][$j]/$num;
		}
}
############################ sub divideArrayFp ##################################
sub divideArrayFp{
		my $num 		= $_[0];
		my $i; my $j =1; 

		for ($i = 1; $i < $row_tot; $i++){
			$count_ev_fp[$i][$j] = $count_ev_fp[$i][$j]/$num;
		}
}

############################ sub compareToArrayTp ##################################
sub compareToArrayTp{
	my $e_value 		= $_[0];
	my $i = 1;
	my $j = 0;

	while ($i <$row_tot){
		if($e_value < $count_ev_tp[$i][$j]){
			$count_ev_tp[$i][$j+1] += 1;
		}	
		$i++;		
	}	
}
############################ sub compareToArrayTp_aux ##################################
sub compareToArrayTp_aux{
	my $e_value 		= $_[0];
	my $i = 1;
	my $j = 0;

	while ($i <$row_tot){
		if($e_value < $count_ev_tp_aux[$i][$j]){
			$count_ev_tp_aux[$i][$j+1] += 1;
		}	
		$i++;		
	}	
}
############################ sub compareToArrayFp ##################################
sub compareToArrayFp{
	my $e_value 		= $_[0];
	my $i = 1;
	my $j = 0;

	while ($i <$row_tot){
		if($e_value < $count_ev_fp[$i][$j]){
			$count_ev_fp[$i][$j+1] = $count_ev_fp[$i][$j+1]+ 1;
		}	
		$i++;		
	}	
}
############################ sub compareToArrayFn ##################################
sub compareToArrayFn{
	my $e_value 		= $_[0];
	my $i = 1;
	my $j = 0;

	while ($i <$row_tot){
		if($e_value < $count_ev_fn[$i][$j]){
			$count_ev_fn[$i][$j+1] = $count_ev_fn[$i][$j+1]+ 1;
		}	
		$i++;		
	}	
}
############################ sub getPattern ##################################
sub getPattern {
	my $num 		= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}

############################ sub power ##################################
sub power {
	my $base		= $_[0];
	my $exp		= $_[1];

	my $i;
	my $result =$base;
	for ($i = 1; $i<$exp; $i++){
		$result *= $base;	
	}
	return $result;
}
############################ sub saveFile ###################################
sub saveFile{
	my $path 	= $_[0];
	my $info  	= $_[1];

	if (open(FILESEQ,">$path")){
		print FILESEQ $info;
		print "file $path was created\n";
	}
	else{
		print "file $path not found\n";
	}
	close FILESEQ;
}

