#!/usr/bin/perl -w
use strict;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file;

#my %hash_interval_ev	= ();
my @count_ev_tp		= ();
my @count_ev_fp		= ();
my @count_ev_fn		= ();
my $value	= 10;


&getParameters;
&inicializeTp;
&inicializeFp;
&inicializeFn;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		} 		
	}
}
#################################### sub inicializeTp ##################################
sub inicializeFn{
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			$count_ev_fn[$i] = 0;
		}
}
#################################### sub inicializeTp ##################################
sub inicializeTp {
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			$count_ev_tp[$i] = 0;
		}
}
#################################### sub inicializeFp ##################################
sub inicializeFp {
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			$count_ev_fp[$i] = 0;
		}
}
#################################### sub printArrayTp ##################################
sub printArrayTp {
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			print " $i " . $count_ev_tp[$i]." ";
		}
		print "\n";
}

#################################### sub printArrayTp ##################################
sub printArrayFp {
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			print " $i " . $count_ev_fp[$i]." ";
		}
		print "\n";
}
#################################### sub printArrayTp ##################################
sub printArrayFn {
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			print " $i " . $count_ev_fn[$i]." ";
		}
		print "\n";
}
#################################### sub main ##################################
sub main {

	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $new_pattern   = "";
	my $old_pattern   = "";
	my $dir;
	my $count_super = 0;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       	print "Could not open file $in_file !\n";
        	exit;
    }
	@families = <FAMILYFILE>;
	
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		
		if ($new_sample ne $old_sample){
			$new_pattern = &getPattern(3, ".", $new_sample);
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;
			if (($old_pattern ne $new_pattern) && ($old_pattern ne "")){
					&divideArrayTp($count_super);
					&divideArrayFp($count_super);
					&divideArrayFn($count_super);
					print  $old_pattern;
					&calcPrecisionRecall($old_pattern);
					#&printArrayTp;
					#&printArrayFp;
					#&printArrayFn;
					$count_super = 0;
					&inicializeTp;&inicializeFp;&inicializeFn;
			}
			
					
			&getIntervalTruePositivesFound($new_sample,$dir);
			&getIntervalFalsePositivesFound($new_sample,$dir);
			&getIntervalFalseNegativesFound($new_sample,$dir);
			$old_pattern = $new_pattern;
			$count_super++;
		}
		$old_sample = $new_sample;					
	}
	&divideArrayTp($count_super);
	&divideArrayFp($count_super);
	&divideArrayFn($count_super);
	&calcPrecisionRecall($old_pattern);
	#print  $old_pattern;
	#&printArrayTp;
	close FAMILYFILE;
}

############################ sub getIntervalTruePositivesFound ##################################
sub getIntervalTruePositivesFound{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $dir_result 		= $dir.$sample."/result/mammoth/calibrated/sam/";
	my $file_name_tp		= "true_positives_found.txt";

	my @data_file			= ();
	my @data_result		= ();
	my $line;
	
	my @ev = ();
	

	if (open(RESFILE, $dir_result.$file_name_tp)){
		@data_file = <RESFILE>;
		foreach $line (@data_file){
			@data_result = split(/ +/, $line);
			@ev = split(/\t/,$data_result[4]);
			if($ev[0] < 1){
				$count_ev_tp[0]+= 1;
			}
			if ($ev[0] < 2){
				$count_ev_tp[1]+= 1;
			}
			if ($ev[0] < 3){
				$count_ev_tp[2]+= 1;
			}
			if ($ev[0] < 4){
				$count_ev_tp[3]+= 1;
			}
			if ($ev[0] < 5){
				$count_ev_tp[4]+= 1;
			}
			if ($ev[0] < 6){
				$count_ev_tp[5]+= 1;
			}
			if ($ev[0] < 7){
				$count_ev_tp[6]+= 1;
			}
			if ($ev[0] < 8){
				$count_ev_tp[7]+= 1;
			}
			if ($ev[0] < 9){
				$count_ev_tp[8]+= 1;
			}
			if ($ev[0] < 10){
				$count_ev_tp[9]+= 1;
			}			
		}
		#&printArrayTp
	} 
	else{
		print "ERROR File $dir_result$file_name_tp not found\n";
	}
}
############################ sub getIntervalTruePositivesFound ##################################
sub getIntervalFalseNegativesFound{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $dir_result 		= $dir.$sample."/result/mammoth/calibrated/sam/";
	my $file_name_fn		= "false_negatives_found.txt";
	my $file_name_tp		= "true_positives_found.txt";
	my @ev = ();

	my @data_file			= ();
	my @data_result		= ();
	my $line;
	my $num_fn = 0;
	my $num_tp = 0;
	my @count_ev_tp_aux		= ();

	my $i = 0;
	for ($i = 0; $i < $value; $i++){
			$count_ev_tp_aux[$i] = 0;
	}

	if (open(RESFILE, $dir_result.$file_name_fn)){
			@data_file = <RESFILE>;
			$num_fn = scalar(@data_file);
			close RESFILE;
	}


	if (open(RESFILE, $dir_result.$file_name_tp)){
		@data_file = <RESFILE>;
		$num_tp = scalar (@data_file);

		foreach $line (@data_file){
			@data_result = split(/ +/, $line);
			@ev = split(/\t/,$data_result[4]);
			if($ev[0] < 1){
				$count_ev_tp_aux[0]+= 1;
			}
			if ($ev[0] < 2){
				$count_ev_tp_aux[1]+= 1;
			}
			if ($ev[0] < 3){
				$count_ev_tp_aux[2]+= 1;
			}
			if ($ev[0] < 4){
				$count_ev_tp_aux[3]+= 1;
			}
			if ($ev[0] < 5){
				$count_ev_tp_aux[4]+= 1;
			}
			if ($ev[0] < 6){
				$count_ev_tp_aux[5]+= 1;
			}
			if ($ev[0] < 7){
				$count_ev_tp_aux[6]+= 1;
			}
			if ($ev[0] < 8){
				$count_ev_tp_aux[7]+= 1;
			}
			if ($ev[0] < 9){
				$count_ev_tp_aux[8]+= 1;
			}
			if ($ev[0] < 10){
				$count_ev_tp_aux[9]+= 1;
			}			
		}
		close RESFILE;
		for ($i = 0; $i < $value; $i++){
			$count_ev_fn[$i] = ($num_tp - $count_ev_tp_aux[$i]) + $num_fn;
		}
		
	} 
	else{
		print "ERROR File $dir_result$file_name_tp not found\n";
	}
}

############################ sub getIntervalTruePositivesFound ##################################
sub getIntervalFalsePositivesFound{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $dir_result 		= $dir.$sample."/result/mammoth/calibrated/sam/";
	my $file_name_tp		= "false_positives_found.txt";

	my @data_file			= ();
	my @data_result		= ();
	my $line;
	
	my @ev = ();
	if (open(RESFILE, $dir_result.$file_name_tp)){
		@data_file = <RESFILE>;
		foreach $line (@data_file){
			@data_result = split(/ +/, $line);
			@ev = split(/\t/,$data_result[4]);
			if($ev[0] < 1){
				$count_ev_fp[0]+= 1;
			}
			if($ev[0] < 2){
				$count_ev_fp[1]+= 1;
			}
			if ($ev[0] < 3){
				$count_ev_fp[2]+= 1;
			}
			if ($ev[0] < 4){
				$count_ev_fp[3]+= 1;
			}
			if ($ev[0] < 5){
				$count_ev_fp[4]+= 1;
			}
			if ($ev[0] < 6){
				$count_ev_fp[5]+= 1;
			}
			if ($ev[0] < 7){
				$count_ev_fp[6]+= 1;
			}
			if ($ev[0] < 8){
				$count_ev_fp[7]+= 1;
			}
			if ($ev[0] < 9){
				$count_ev_fp[8]+= 1;
			}
			if ($ev[0] < 10){
				$count_ev_fp[9]+= 1;
			}			
		}
		#&printArrayFp;
	} 
	else{
		print "ERROR File $dir_result$file_name_tp not found\n";
	}
}
############################ sub getPattern ##################################
sub calcPrecisionRecall{
		my $old_pattern 		= $_[0];
		
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			print " $i Pre ". ($count_ev_tp[$i]/($count_ev_tp[$i] + $count_ev_fn[$i]));
			print " $i Rec ". ($count_ev_tp[$i]/($count_ev_tp[$i] + $count_ev_fp[$i]));
		}
		print "\n";

}

############################ sub getPattern ##################################
sub divideArrayFn{
		my $num 		= $_[0];
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			$count_ev_fn[$i] = $count_ev_fn[$i]/$num;
		}
}
############################ sub getPattern ##################################
sub divideArrayTp{
		my $num 		= $_[0];
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			$count_ev_tp[$i] = $count_ev_tp[$i]/$num;
		}
}
############################ sub divideArrayFp ##################################
sub divideArrayFp{
		my $num 		= $_[0];
		my $i = 0;
		for ($i = 0; $i < $value; $i++){
			$count_ev_fp[$i] = $count_ev_fp[$i]/$num;
		}
}

############################ sub getPattern ##################################
sub getPattern {
	my $num 		= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}

