#!/usr/bin/perl -w
use strict;
use POSIX qw(log10);


#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file;

my $alin_er   = "mammoth";
my $calibrate = "calibrated";
my $work_fold = "sam";

my $dir_stat = "/home/juliana/tese/testes/scop40-teste/test_set/teste_familias/statistics/$alin_er/$calibrate/prec_recall/sam/";

#my %hash_interval_ev	= ();
my @count_ev_tp		= ([],[]);
my @count_ev_fp		= ([],[]);
my @count_ev_fn		= ([],[]);
my @count_ev_tp_aux  = ([],[]);

my @precisions = ();
my @recalls = ();
my @count_families = ();
my @numTp = ();
my @numFp = ();

my %hash_FP = ();

my $value	   = 10;
my $high_lim	= 100;
my $low_lim		= 1e-25;

my $col 			= 2;
my $row			= 92;
my $row_more   = $row + 10;
my $row_tot = 0;

&getParameters;
&inicialize;
&inicializePR;
#&inicializeFp;
#&inicializeFn;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		} 		
	}
}
#################################### sub inicialize ##################################
sub inicialize{
		my $i = 0; my $j = 0; my $count = 1;
		for ($i = 1; $i < $row; $i++){
			for ($j = 0; $j < $col; $j++){
				if ($j == 0){
					$count_ev_tp[$i][$j] = &power(1.88,$i)*$low_lim ;
					$count_ev_fp[$i][$j] = &power(1.88,$i)*$low_lim ;
					$count_ev_fn[$i][$j] = &power(1.88,$i)*$low_lim ;
				}
				else{
					$count_ev_tp[$i][$j] = 0;
					$count_ev_fp[$i][$j] = 0;
					$count_ev_fn[$i][$j] = 0;
				}
			}
		}
		for ($i = $row; $i < $row_more; $i++){
			for ($j = 0; $j < $col; $j++){
				if ($j == 0){
					$count_ev_tp[$i][$j] = $count;
					$count_ev_fp[$i][$j] = $count;
					$count_ev_fn[$i][$j] = $count;
					$count++;
				}else{
					$count_ev_tp[$i][$j] = 0;
					$count_ev_fp[$i][$j] = 0;
					$count_ev_fn[$i][$j] = 0;
				}
			}
		}
		$row_tot =  $row_more;
		#&printArrayTp;		
}
#################################### sub inicializePR ##################################
sub inicializePR{
	my $i = 1;
	for ($i = 1; $i < $row_tot; $i++){
		$precisions[$i] = 0;
		$recalls[$i] = 0;
		$numTp[$i] = 0;
		$numFp[$i] = 0;
	}
}
#################################### sub inicializePR ##################################
sub inicializeCountFamilies{
	my $i = 1;
	for ($i = 1; $i < $row_tot; $i++){
		$count_families[$i] = 0;
	}
}
#################################### sub inicializeTp_aux ##################################
sub inicializeTp_aux{
		my $i = 0; my $j = 0; my $count = 1;
		for ($i = 1; $i < $row; $i++){
			for ($j = 0; $j < $col; $j++){
				if ($j == 0){
					$count_ev_tp_aux[$i][$j] = &power(1.88,$i)*$low_lim ;
					
				}
				else{
					$count_ev_tp_aux[$i][$j] = 0;
					
				}
			}
		}
		for ($i = $row; $i < $row_more; $i++){
			for ($j = 0; $j < $col; $j++){
				if ($j == 0){
					$count_ev_tp_aux[$i][$j] = $count;
					$count++;
				}else{
					$count_ev_tp_aux[$i][$j] = 0;
				}
			}
		}
		$row_tot =  $row_more;
		#&printArrayTp;		
}
#################################### sub printArrayTp ##################################
sub printArrayPR {
		my $i = 1;
		for ($i = 1; $i < $row_tot ; $i++){
			#print "$recalls[$i]\t$precisions[$i]\n";		
			print "$numFp[$i]\t$numTp[$i]\n";		
		}		
		
}
#################################### sub printArrayTp ##################################
sub printArrayTp {
		my $i = 0; my $j = 0;
		for ($i = 1; $i < $row_tot ; $i++){
			print " $i ";
			for ($j = 0; $j < $col; $j++){
				print	$count_ev_tp[$i][$j]." ";
			}
			print "\n";
		}		
		
}
#################################### sub saveArrayTp ##################################
sub saveArrayFT {
		my $i = 1;
		my $info = "";
		for ($i = 1; $i < $row_tot ; $i++){
			$info .=  "$numFp[$i]\t$numTp[$i]\n";								
		}		
		return $info;		
}
#################################### sub saveArrayTp ##################################
sub saveArrayPR {
		my $i = 1;
		my $info = "";
		for ($i = 1; $i < $row_tot ; $i++){
			$info .=  "$recalls[$i]\t$precisions[$i]\n";								
		}		
		return $info;		
}
#################################### sub printArrayTp ##################################
sub printArrayFp {
		my $i = 0; my $j = 0;
		for ($i = 1; $i < $row_tot ; $i++){
			print " $i ";
			for ($j = 0; $j < $col; $j++){
				print	$count_ev_fp[$i][$j]." ";
			}
			print "\n";
		}		
}
#################################### sub printArrayTp ##################################
sub printArrayFn {
		my $i = 0; my $j = 0;
		for ($i = 1; $i < $row_tot ; $i++){
			print " $i ";
			for ($j = 0; $j < $col; $j++){
				print	$count_ev_fn[$i][$j]." ";
			}
			print "\n";
		}		
}
#################################### sub main ##################################
sub main {

	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $new_pattern   = "";
	my $old_pattern   = "";
	my $dir;
	my $count_super = 0;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       	print "Could not open file $in_file !\n";
        	exit;
    }
	@families = <FAMILYFILE>;
	
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		
		if ($new_sample ne $old_sample){
			$new_pattern = &getPattern(3, ".", $new_sample);
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;
			#print "ent $old_pattern $new_pattern \n ";
			if (($old_pattern ne $new_pattern) && ($old_pattern ne "")){
					#&divideArrayTp($count_super);
					#&divideArrayFp($count_super);
					#&divideArrayFn($count_super);
					#print  $old_pattern;
					&calcPrecisionRecall($old_pattern);
					#&printArrayTp;
					$count_super = 0;
					&inicialize;
			}
			#if(&getPattern(3, ".",$new_sample) ne &getPattern(3, ".",$old_sample) ){
			#	%hash_FP = ();
			#}
					
			&getIntervalTruePositivesFound($new_sample,$dir);
			&getIntervalFalsePositivesFound($new_sample,$dir);
			#&printArrayFp;
			&getIntervalFalseNegativesFound($new_sample,$dir);
			$old_pattern = $new_pattern;
			$count_super++;
		}
		$old_sample = $new_sample;					
	}
	#&divideArrayTp($count_super);
	#&divideArrayFp($count_super);
	#&divideArrayFn($count_super);
	&calcPrecisionRecall($old_pattern);
	#print  $old_pattern;
	#&divideArrayPR;
	&printArrayPR;
	&saveFile("sam"."_".$alin_er."_".$calibrate."_"."PR.sta", &saveArrayPR);
	&saveFile("sam"."_".$alin_er."_".$calibrate."_"."FT.sta", &saveArrayFT);
	#&printArrayTp;
	close FAMILYFILE;
}

############################ sub getIntervalTruePositivesFound ##################################
sub getIntervalTruePositivesFound{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $dir_result 		= $dir.$sample."/result/$alin_er/$calibrate/$work_fold/";
	my $file_name_tp		= "true_positives_found.txt";

	my @data_file			= ();
	my @data_result		= ();
	my $line;
	
	my @ev = ();

	if (open(RESFILE, $dir_result.$file_name_tp)){
		@data_file = <RESFILE>;
		foreach $line (@data_file){
			@data_result = split(/ +/, $line);
			@ev = split(/\t/,$data_result[4]);
			&compareToArrayTp($ev[0]);			
		}
		#&printArrayTp
	} 
	else{
		print "ERROR File $dir_result$file_name_tp not found\n";
	}
}
############################ sub getIntervalFalseNegativesFound ##################################
sub getIntervalFalseNegativesFound{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $dir_result 		= $dir.$sample."/result/$alin_er/$calibrate/$work_fold/";
	my $file_name_fn		= "false_negatives_found.txt";
	my $file_name_tp		= "true_positives_found.txt";


	my @data_file			= ();
	my @data_result		= ();
	my $line;
	my $num_fn = 0;
	my $num_tp = 0;
	
	my @ev = ();

	my $i = 0;
	&inicializeTp_aux;

	if (open(RESFILE, $dir_result.$file_name_fn)){
			@data_file = <RESFILE>;
			$num_fn = scalar(@data_file);
			close RESFILE;
	}


	if (open(RESFILE, $dir_result.$file_name_tp)){
		@data_file = <RESFILE>;
		$num_tp = scalar (@data_file);

		foreach $line (@data_file){
			@data_result = split(/ +/, $line);
			@ev = split(/\t/,$data_result[4]);
			&compareToArrayTp_aux($ev[0]);			
		}
		close RESFILE;
		for ($i = 1; $i < $row_tot; $i++){
			$count_ev_fn[$i][1] += ($num_tp - $count_ev_tp_aux[$i][1]) + $num_fn;			
		}		
	} 
	else{
		print "ERROR File $dir_result$file_name_tp not found\n";
	}
}

############################ sub getIntervalTruePositivesFound ##################################
sub getIntervalFalsePositivesFound{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $dir_result 		= $dir.$sample."/result/$alin_er/$calibrate/$work_fold/";
	my $file_name_tp		= "false_positives_found.txt";

	my @data_file			= ();
	my @data_result		= ();
	my $line;
	
	my @ev = ();
	if (open(RESFILE, $dir_result.$file_name_tp)){
		@data_file = <RESFILE>;
		foreach $line (@data_file){
			@data_result = split(/ +/, $line);
			@ev = split(/\t/,$data_result[4]);
			if (exists($hash_FP{$data_result[0]})){
				#print "exit $hash_FP{$data_result[0]}\n";
			}	
			else{
				&compareToArrayFp($ev[0]);	
				$hash_FP{$data_result[0]}= $ev[0];
			}	



		}
		close RESFILE;
		#print $sample . "===========\n";
		#&printArrayFp;
	} 
	else{
		print "ERROR File $dir_result$file_name_tp not found\n";
	}
}
############################ sub getPattern ##################################
sub calcPrecisionRecall{
		my $old_pattern 		= $_[0];
		my $info = "";
		my $path = $dir_stat.$old_pattern."pre_rec";
		my $pre;
		my $rec;
		my $tp;
		my $fp;
		
		my $i;
		print $old_pattern."\n";
		$info.= "\tRecall\tPrecision\n";
		for ($i = 1; $i < $row_tot; $i++){
			if ($count_ev_tp[$i][1]==0){
				$rec = 0;
				$pre = 0;
				$tp  = 0;
				$fp  = 0;
			}
			else{
				$rec = ($count_ev_tp[$i][1]/($count_ev_tp[$i][1] + $count_ev_fn[$i][1]));
				$pre = ($count_ev_tp[$i][1]/($count_ev_tp[$i][1] + $count_ev_fp[$i][1]));
				$tp  = $count_ev_tp[$i][1];
				$fp  = $count_ev_fp[$i][1];
				$count_families[$i] += 1;
			}
			$info.= $rec;			
			$recalls[$i] += $rec;			
			$info.=  "\t". $pre;
			$precisions[$i] += $pre;
			$info.=  "\n";
			$numTp[$i] += $tp;
			$numFp[$i] += $fp;
		}
		#print "oi ".$path;
		&saveFile($path, $info);
}
############################ sub getPattern ##################################
sub divideArrayPR{
		
		my $i;
		for ($i = 1; $i < $row_tot; $i++){
			$precisions[$i] = $precisions[$i]/$count_families[$i];
			$recalls[$i] = $recalls[$i]/$count_families[$i];
			$numTp[$i] = $numTp[$i]/$count_families[$i];
			$numFp[$i] = $numFp[$i]/$count_families[$i];
		}
}
############################ sub getPattern ##################################
sub divideArrayFn{
		my $num 		= $_[0];
		my $i; my $j =1; 

		for ($i = 1; $i < $row_tot; $i++){
			$count_ev_fn[$i][$j] = $count_ev_fn[$i][$j]/$num;
		}
}
############################ sub getPattern ##################################
sub divideArrayTp{
		my $num 		= $_[0];
		my $i; my $j =1; 

		for ($i = 1; $i < $row_tot; $i++){
			$count_ev_tp[$i][$j] = $count_ev_tp[$i][$j]/$num;
		}
}
############################ sub divideArrayFp ##################################
sub divideArrayFp{
		my $num 		= $_[0];
		my $i; my $j =1; 

		for ($i = 1; $i < $row_tot; $i++){
			$count_ev_fp[$i][$j] = $count_ev_fp[$i][$j]/$num;
		}
}

############################ sub compareToArrayTp ##################################
sub compareToArrayTp{
	my $e_value 		= $_[0];
	my $i = 1;
	my $j = 0;

	while ($i <$row_tot){
		if($e_value < $count_ev_tp[$i][$j]){
			$count_ev_tp[$i][$j+1] += 1;
		}	
		$i++;		
	}	
}
############################ sub compareToArrayTp_aux ##################################
sub compareToArrayTp_aux{
	my $e_value 		= $_[0];
	my $i = 1;
	my $j = 0;

	while ($i <$row_tot){
		if($e_value < $count_ev_tp_aux[$i][$j]){
			$count_ev_tp_aux[$i][$j+1] += 1;
		}	
		$i++;		
	}	
}
############################ sub compareToArrayFp ##################################
sub compareToArrayFp{
	my $e_value 		= $_[0];
	my $i = 1;
	my $j = 0;

	while ($i <$row_tot){
		if($e_value < $count_ev_fp[$i][$j]){
			$count_ev_fp[$i][$j+1] = $count_ev_fp[$i][$j+1]+ 1;
		}	
		$i++;		
	}	
}
############################ sub compareToArrayFn ##################################
sub compareToArrayFn{
	my $e_value 		= $_[0];
	my $i = 1;
	my $j = 0;

	while ($i <$row_tot){
		if($e_value < $count_ev_fn[$i][$j]){
			$count_ev_fn[$i][$j+1] = $count_ev_fn[$i][$j+1]+ 1;
		}	
		$i++;		
	}	
}
############################ sub getPattern ##################################
sub getPattern {
	my $num 		= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}

############################ sub power ##################################
sub power {
	my $base		= $_[0];
	my $exp		= $_[1];

	my $i;
	my $result =$base;
	for ($i = 1; $i<$exp; $i++){
		$result *= $base;	
	}
	return $result;
}
############################ sub saveFile ###################################
sub saveFile{
	my $path 	= $_[0];
	my $info  	= $_[1];

	if (open(FILESEQ,">$path")){
		print FILESEQ $info;
		print "file $path was created\n";
	}
	else{
		print "file $path not found\n";
	}
	close FILESEQ;
}

