use strict;
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use Align::Struct::Mammoth;
use Align::Struct::Joy;
use Align::Struct::Pdb;
use String::StringUtil;
use File::Files;

#use Util::Hash;

my $in_file 		= "";
my $set_file;
my $kind_align          = "mammoth";
my $kind_calib          = "calibrated";
my $work_fold           = "hmmer_prior_fssp";
my $ext_align		= "";
my $ext_pdb		= "";
my $ext_mat		= "";
my $file_log = "";
my $info_log = "";

my %hash_sec = ();



&getParameters;
&readParametersFile;
&main;
############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		} 		
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}
	unless (open(SETFILE, "$set_file")) {
   	print "Could not open file $set_file !\n";
     	exit;
   }
	
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     	exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)==2){
			$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			print $value."\n";
			if ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;					
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;				
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;				
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;				
			}elsif ($array_settings[0] eq "p_ext_align"){
				$ext_align = $value;
			}elsif ($array_settings[0] eq "p_ext_pdb"){
				$ext_pdb = $value;
			}elsif ($array_settings[0] eq "p_ext_mat"){
				$ext_mat = $value;
			}elsif ($array_settings[0] eq "p_file_log"){
				$file_log = $value;
			}
		}
	}
}
########################### sub main ####################################
sub main { 
  
  my @families 		= ();
  my @family 		= ();
  my $entry;
  my $old_sample		= "";
  my $new_sample		= "";
  my $dir;
		
	#read family file
  unless (open(FAMILYFILE, "$in_file")) {
    print "Could not open file $in_file !\n";
    exit;
  }
  @families = <FAMILYFILE>;
	
  foreach $entry (@families) {
    @family	= split(/ +/,$entry);
    $new_sample = $family[0];
    if ($new_sample ne $old_sample){
		 $dir = substr($family[4],0,index($family[4],"\n")). "/";
       system ("date");
       %hash_sec = ();
       &createSecMatriz($new_sample,$dir);
       &createAccSolMatriz($new_sample,$dir);
       &createOiNumberMatriz($new_sample,$dir);
      system ("date");
    }
    $old_sample = $new_sample;	
  }
  close FAMILYFILE;
}
########################### sub createMatrizGroup ####################################
sub createMatrizGroup { 
  
  my $sample		= $_[0];
  my $dir		= $_[1];
  my @gruop_ids_file	= ();
  my @gruop_ids		= ();
  my $item 		= "";
  my $info_file		= "";
  my $chain		= "";
  my $id_pdb		= "";
  my $sample_id		= "";
  my $qtd_seq		= 0;
	
  my $dir_pdb = $dir . $sample."/pdb/";
  my $path    = $dir_pdb.$sample.".groups";
	
  if (open(FILEG,"$path")){
  #print $path;
    @gruop_ids_file = <FILEG>;
    #@gruop_ids = split(/\n/,$gruop_ids_file);
	foreach $item (@gruop_ids_file){
          @gruop_ids = split(/ +/, $item); 
          $qtd_seq = substr($gruop_ids[1],0,index($gruop_ids[1],"\n"));
          if ($qtd_seq >1){
            system ("date");
            %hash_sec = ();
            &createSecMatriz($sample,$dir,$gruop_ids[0]);
            #&createAccSolMatriz($sample,$dir,$gruop_ids[0]);
            #&createOiNumberMatriz($sample,$dir,$gruop_ids[0]);
            system ("date");
          }
	}
	#&saveFile($dir_pdb.$sample.".pdb",$info_file);	
	close FILEG;
  }	
  else{
	print "ERROR: file $path not found\n";
  }
}

########################### sub createSecMatriz ####################################
sub createSecMatriz { 
 
  
  my $sample		= $_[0];
  my $dir		= $_[1];

  
  
  
  my $dir_files_pdb     = $dir. "pdb_files/";
  my $dir_group         = $dir. "$sample/pdb/";
  my $dir_aln           = $dir. "$sample/alignment/$kind_align/";
  my $dir_joy; 
  
  my $line          = "";
  my $sequenceJoy   = "";
  my $struct2dJoy   = "";
  my $start_pos;
  my $aux;
  my $new_seq;
  my $fileJoy      = "";
  my $key_aln      = "";
  my $value_aln    = "";
  my $key_sec      = "";
  my $value_sec    = "";
  my %hash_aln     = ();  
  my $found_info   = "false";
  my $pdb_id       = "";
  my $info_aln = "CLUSTAL W (1.82) multiple sequence alignment\n";
  my $info_sec = "";
  
  my @array_file = ();
  
  print $dir_group.$sample."\n";
  if (open(FILE,$dir_group.$sample.".ids")){
    @array_file = <FILE>;
    close FILE;
  }
  else{
    exit;
  }
  my @array_group = split(/ +/, $array_file[0]);
  my @array_info  = ();
  
  %hash_aln = Mammoth->loadAlign1d($dir_aln."$sample$ext_align");
  
  foreach $line (@array_group){
    @array_info = split(/:/, $line);
    FilesIO->copyFile($dir_files_pdb."pdb$array_info[0]".".ent", $dir_files_pdb."$array_info[0]".".pdb");
    $fileJoy = $dir_files_pdb."$array_info[0]".".tem";    
    Joy->run($dir_files_pdb."$array_info[0]".".pdb",$fileJoy);
    print $fileJoy."\n";
    $sequenceJoy = Joy->getSequence($fileJoy);
    $struct2dJoy = Joy->getSecundaryStruct($fileJoy);
    
    while (($key_aln, $value_aln) = each(%hash_aln)){
      $aux = String->removeCaracter($value_aln,"-");
      $aux = uc($aux);
      $new_seq =String->removeCaracter($sequenceJoy,"-"); 
      $new_seq = uc($new_seq);
   
      if (index($new_seq, $aux) >= 0) {
        $found_info = "true";
        $start_pos = index(uc($new_seq), $aux); 
        my $sec = Joy->getSecundaryAlign($value_aln, $struct2dJoy, $start_pos);
        my $info_struc = Joy->convertSecundaryToNumbers($sec);
        $hash_sec{$key_aln} = $info_struc; 
      }      
    }
    if ($found_info eq "false"){
        $info_log .= "Lost $sample $array_info[0]\n";
      }
      $found_info = "false";          
  }
  #Building secundary matriz
  $dir_joy = $dir_aln."joy/";
  if (FilesIO->isDirectory($dir_joy) eq "false"){
    mkdir($dir_joy);
  }
  
  &saveStructMatriz($dir_joy."$sample.2d");
  FilesIO->sortFile($dir_joy."$sample.2d",$dir_joy."$sample.2dsort", 0);
  my @array_sec = FilesIO->lineFileToArray($dir_joy."$sample.2dsort");
  FilesIO->copyFile($dir_joy."$sample.2dsort", $dir_joy."$sample.2d");
  FilesIO->removeFile($dir_joy."$sample.2dsort");
  
  foreach $line (@array_sec){
    @array_info = split(/\t/,$line);    
    while (($key_aln, $value_aln) = each(%hash_aln)){
       if ($array_info[0] eq $key_aln){
         $info_aln .= $key_aln."     ".$value_aln."\n";       
       }
    }    
  }
  FilesIO->saveFile($dir_joy."$sample$ext_align.2d",$info_aln);
  $info_aln = Mammoth->formatAlign1d($dir_joy."$sample$ext_align.2d", 60);
  
  FilesIO->saveFile($dir_joy."$sample$ext_align.2d",$info_aln);
  
  if ($file_log ne "") {
    FilesIO->apendFile($file_log,$info_log);
  } 
}

########################### sub createAccSolMatriz ####################################
sub createAccSolMatriz { 
 
  
  my $sample		= $_[0];
  my $dir		= $_[1];
  
  
  
  
  my $dir_files_pdb     = $dir. "pdb_files/";
  my $dir_group         = $dir. "$sample/pdb/";
  my $dir_aln           = $dir. "$sample/alignment/$kind_align/";
  my $dir_joy; 
  
  my $line          = "";
  my $sequenceJoy   = "";
  my $struct2dJoy   = "";
  my $start_pos;
  my $aux;
  my $new_seq;
  my $fileJoy      = "";
  my $key_aln      = "";
  my $value_aln    = "";
  my $key_sec      = "";
  my $value_sec    = "";
  my %hash_aln     = ();  
  my $found_info   = "false";
  my $pdb_id       = "";
  my $info_sec = "";
    
  my @array_file = ();
  if (open(FILE,$dir_group.$sample.".ids")){
    @array_file = <FILE>;
    close FILE;
  }
  else{
    print "$dir_group$sample.ids saiu";
    exit;
  }
  my @array_group = split(/ +/, $array_file[0]);
  my @array_info  = ();
  
  
  %hash_aln = Mammoth->loadAlign1d($dir_aln."$sample$ext_align");
  
  foreach $line (@array_group){
    @array_info = split(/:/, $line);
    $fileJoy = $dir_files_pdb."$array_info[0]".".tem";    
    $sequenceJoy = Joy->getSequence($fileJoy);
    $struct2dJoy = Joy->getSolventAccessibility($fileJoy);
    
    while (($key_aln, $value_aln) = each(%hash_aln)){
      $aux = String->removeCaracter($value_aln,"-");
      $aux = uc($aux);
      $new_seq =String->removeCaracter($sequenceJoy,"-"); 
      $new_seq = uc($new_seq);
   
      if (index($new_seq, $aux) >= 0) {
        $found_info = "true";
        $start_pos = index(uc($new_seq), $aux); 
        my $sec = Joy->getAccessibilityAlign($value_aln, $struct2dJoy, $start_pos);
        my $info_struc = Joy->convertAccessibilityToNumbers($sec);
        #print $value_aln."\n";
        #print $info_struc."\n";
        $hash_sec{$key_aln} = $info_struc; 
      }      
    }
    if ($found_info eq "false"){
        $info_log .= "Lost ACC $sample $array_info[0] \n";
      }
      $found_info = "false";          
  }
  
  #Building Accessibility matriz
  $dir_joy = $dir_aln."joy/";
  if (FilesIO->isDirectory($dir_joy) eq "false"){
    mkdir($dir_joy);
  }
  
  &saveStructMatriz($dir_joy."$sample.acc");
  FilesIO->sortFile($dir_joy."$sample.acc",$dir_joy."$sample.accsort", 0);
  my @array_sec = FilesIO->lineFileToArray($dir_joy."$sample.accsort");
  FilesIO->copyFile($dir_joy."$sample.accsort", $dir_joy."$sample.acc");
  FilesIO->removeFile($dir_joy."$sample.accsort");
  
  if ($file_log ne "") {
    FilesIO->apendFile($file_log,$info_log);
  }
}
########################### sub createOiNumberMatriz ####################################
sub createOiNumberMatriz { 
 
  
  my $sample		= $_[0];
  my $dir		= $_[1];
  
  
  
  
  my $dir_files_pdb     = $dir. "pdb_files/";
  my $dir_group         = $dir. "$sample/pdb/";
  my $dir_aln           = $dir. "$sample/alignment/$kind_align/";
  my $dir_joy; 
  
  my $line          = "";
  my $sequenceJoy   = "";
  my $struct2dJoy   = "";
  my $start_pos;
  my $aux;
  my $new_seq;
  my $fileJoy      = "";
  my $key_aln      = "";
  my $value_aln    = "";
  my $key_sec      = "";
  my $value_sec    = "";
  my %hash_aln     = ();  
  my $found_info   = "false";
  my $pdb_id       = "";
  my $info_sec = "";
    
   my @array_file = ();
  if (open(FILE,$dir_group.$sample.".ids")){
    @array_file = <FILE>;
    close FILE;
  }
  else{
    exit;
  }
  my @array_group = split(/ +/, $array_file[0]);
  my @array_info  = ();
  
  
  %hash_aln = Mammoth->loadAlign1d($dir_aln."$sample$ext_align");
  
  foreach $line (@array_group){
    @array_info = split(/:/, $line);
    $fileJoy = $dir_files_pdb."$array_info[0]".".tem";    
    $sequenceJoy = Joy->getSequence($fileJoy);
    $struct2dJoy = Joy->getOoiNumber($fileJoy);
    
    while (($key_aln, $value_aln) = each(%hash_aln)){
      $aux = String->removeCaracter($value_aln,"-");
      $aux = uc($aux);
      $new_seq =String->removeCaracter($sequenceJoy,"-"); 
      $new_seq = uc($new_seq);
   
      if (index($new_seq, $aux) >= 0) {
        $found_info = "true";
        $start_pos = index(uc($new_seq), $aux); 
        my $sec = Joy->getOiNumberAlign($value_aln, $struct2dJoy, $start_pos);
        my $info_struc = Joy->convertOiNumberToNumbers($sec);
        #print $value_aln."\n";
        #print $info_struc."\n";
        $hash_sec{$key_aln} = $info_struc; 
      }      
    }
    if ($found_info eq "false"){
        $info_log .= "Lost ACC $sample $array_info[0]\n";
      }
      $found_info = "false";          
  }
  
  #Building Accessibility matriz
  $dir_joy = $dir_aln."joy/";
  if (FilesIO->isDirectory($dir_joy) eq "false"){
    mkdir($dir_joy);
  }
  
  &saveStructMatriz($dir_joy."$sample.oi");
  FilesIO->sortFile($dir_joy."$sample.oi",$dir_joy."$sample.oisort", 0);
  my @array_sec = FilesIO->lineFileToArray($dir_joy."$sample.oisort");
  FilesIO->copyFile($dir_joy."$sample.oisort", $dir_joy."$sample.oi");
  FilesIO->removeFile($dir_joy."$sample.oisort");
  
  if ($file_log ne "") {
    FilesIO->apendFile($file_log,$info_log);
  }
}

########################### sub saveStructMatriz ####################################
sub saveStructMatriz { 
  my $sec_file		= $_[0];
  my $key_sec;
  my $value_sec;
  my $info = "";
  
  while (($key_sec, $value_sec) = each(%hash_sec)){
     $info .=$key_sec."\t". $value_sec."\n";   
   }
   #print $info;
   FilesIO->saveFile($sec_file,$info);
 }
