#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Array;
use analisys::analisys;

my $sta_file = "";
my $outputFile = "";
my $col = "";
my $jump = 1;
my $verbose = "false";
my $QTD_POINTS;
my @arrayCountFamily = ();
my $start = "";
my $end = "";
my $float = "false";
my $only_first = "false";
my $logScale = "true";

my $PROG_NAME = "PERL_LIB::analisys::analisys::getDistributionJump.pl";

#my @matrix = Analisys->initialArrayCountHistogramFloatJumpLog(1, 1e-20, 1e5 );
#print Array->printMatrix2("\t", "\n", \@matrix);

#my @array_data = (1e-12, 1e-13, 1e-4, 1e-8);

#@matrix = Analisys->countArrayHistogramInterval(scalar(@matrix), \@matrix, \@array_data);
#print "\n\n".Array->printMatrix2("\t", "\n", \@matrix);
#exit;

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-staFile"){
			$sta_file = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-jump"){
			$jump = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-logScale"){
			$logScale = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-start"){
			$start = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-end"){
			$end = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-float"){
			$float = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-only_first"){
			$only_first = $ARGV[$counter+1];		
		}  		
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for: ".$PROG_NAME."\n" ;
	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false");
	String->isEmpty($sta_file, "ERROR::".$PROG_NAME.":: File with $sta_file values is required");
	FilesIO->checkFile($sta_file, "ERROR::".$PROG_NAME.":: $sta_file NOT Found");	
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: File to save output is required");
	String->isEmpty($col, "ERROR::".$PROG_NAME.":: col is empty");
	String->isEmpty($jump, "ERROR::".$PROG_NAME.":: $jump is empty");
	
	print "-sta_file = $sta_file\n";	
	print "-outputFile = $outputFile\n";	
	print "-col = $col\n";
	print "-jump = $jump\n";
	print "-verbose = $verbose\n";		
	print "ok\n";
}

########################### sub main ####################################
sub main { 
	my $entry;
	my @array_file_line;
	my $count = 0;
	my $mesure;
	my $sum_mesure = 0; 
	my @arrayCount;
	
	my @array_file = FilesIO->fileToArray2d($sta_file, "\t");
	@array_file = Array->copyColMatrixToArray(scalar(@array_file), $#{$array_file[0]}, $col, \@array_file);
	
	my $biggest = $end;
	if ($end eq ""){
		$biggest = Array->getBigger(\@array_file);
	}
	my $smallest = $start;
	if ($start eq ""){
		$smallest = Array->getSmaller(\@array_file);
	}
	if ($logScale eq "true"){
		@arrayCount = Analisys->initialArrayCountHistogramFloatJumpLog($biggest, $smallest, $jump);
	}else{
		@arrayCount = Analisys->initialArrayCountHistogramFloatJump($biggest, $smallest, $jump);
	}
	#print Array->printMatrix2("\t", "\n", \@arrayCount);

	
	@arrayCount = Analisys->countArrayHistogramInterval(scalar(@arrayCount), \@arrayCount, \@array_file);
	print Array->printMatrix2("\t", "\n", \@arrayCount);
	$QTD_POINTS = scalar(@arrayCount);
	&savecountArrayFamily(\@arrayCount);
}


########################### sub main ####################################
sub savecountArrayFamily { 
	my ($arrayCount) = @_;
	my @larrayCount = @{$arrayCount};
	my $info = "";
	my $range;
	my @array_aux = ();
	
	for (my $i = 0; $i < $QTD_POINTS; $i++){
		$range = $larrayCount[$i][2];
		@array_aux = split(/:/, $range);
		
		if ($float eq "true"){
			if ($only_first eq "true"){
				$range =  sprintf("%.2f", $array_aux[0]);
			}else{
				$range =  sprintf("%.2f", $array_aux[0])."-".sprintf("%.2f", $array_aux[1]);
			}			
		}elsif ($only_first eq "true"){
			$range =  $array_aux[0];
		}
		$info .=  $range."\t".$larrayCount[$i][1]."\n";
	}
	FilesIO->saveFile($outputFile, $info);	
}


########################### sub main ####################################
sub countArrayFamily { 
	my $accuracy		= $_[0];
	#print "mesure ".$accuracy."\n";
	for (my $i = 0; $i < $QTD_POINTS; $i++){
	
		#print "interval ".$arrayCountFamily[$i][0]."\n";
		if ($i < $QTD_POINTS -1){
			if ($accuracy >= $arrayCountFamily[$i][0] && $accuracy < $arrayCountFamily[$i + 1][0] ){
				$arrayCountFamily[$i][1] += 1;
				#print "interval found ".$arrayCountFamily[$i][2]."\n";
				$i = $QTD_POINTS;
			}
		}elsif ($accuracy >= $arrayCountFamily[$i][0]){
			$arrayCountFamily[$i][1] += 1;
			#print "interval found ".$arrayCountFamily[$i][2]."\n";
			$i = $QTD_POINTS;
			
		}
	}
	
}



	


