#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Array;
use analisys::analisys;

my $sta_file = "";
my $outputFile = "";
my $col = "";
my $points = 50;
my $verbose = "false";
my $QTD_POINTS;
my @arrayCountFamily = ();
my $start = "";
my $end = "";
my $float = "false";
my $only_first = "false";
my $labels = "";
my @arrayLabels = ();

my $PROG_NAME = "PERL_LIB::analisys::analisys::getDistributionLabeled.pl";

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-staFile"){
			$sta_file = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-labels"){
			$labels = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for: ".$PROG_NAME."\n" ;
	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false");
	String->isEmpty($sta_file, "ERROR::".$PROG_NAME.":: File with -sta_file values is required");
	FilesIO->checkFile($sta_file, "ERROR::".$PROG_NAME.":: $sta_file NOT Found");	
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: File to save output is required");
	String->isEmpty($col, "ERROR::".$PROG_NAME.":: col is empty");
	
	
	print "-sta_file = $sta_file\n";	
	print "-outputFile = $outputFile\n";	
	print "-col = $col\n";
	print "-labels = $labels\n";
	print "-verbose = $verbose\n";		
	print "ok\n";
}

########################### sub main ####################################
sub main { 
	my $entry;
	my @array_file_line;
	my $info = "";
	my $mesure;
	my $sum_mesure = 0; 
	my @arrayCount = ();
	
	
	
	my @array_file = FilesIO->fileToArray2d($sta_file, "\t");
	@array_file = Array->copyColMatrixToArray(scalar(@array_file), $#{$array_file[0]}, $col, \@array_file);
	
	if ($labels ne ""){
		@arrayLabels = split(/:/, $labels);
	}else{
		@arrayLabels = Array->removeValueArray("-1", \@array_file);
		@arrayLabels = Array->removeRepeated(\@arrayLabels);
		#print Array->printArray("\n", \@arrayCount);
	}
	@arrayCount = Array->initArray(scalar(@arrayLabels), 0);
	
	
	
	
	for (my $i = 0; $i < scalar(@arrayLabels); $i++){	
		for (my $j = 0; $j < scalar(@array_file); $j++){
			if ($array_file[$j] eq $arrayLabels[$i]){
				$arrayCount[$i] = $arrayCount[$i]+1;
			}	
		}	
	}
	for (my $i = 0; $i < scalar(@arrayLabels); $i++){	
		$info .= $arrayLabels[$i]."\t".$arrayCount[$i]."\n";
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
	
}

