#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Array;
use analisys::analisys;


my $sta_file = "";
my $outputFile = "";
my $col = "";
my $verbose = "false";
my $points  = "";
my $jump	="1e20";
my $scale = "";
my $biggest	 = "";;
my $smallest  = "";;

my @arrayCountFamily = ();
my $start = "";
my $end = "";

my $PROG_NAME = "PERL_LIB::analisys::analisys::getHistCumulative.pl";

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-staFile"){
			$sta_file = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-points"){
			$points = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-scale"){
			$scale = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-smallest"){
			$smallest = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-biggest"){
			$biggest = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-jump"){
			$jump = $ARGV[$counter+1];		
		}
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
print "\n=============================================\n";
	print "Cheking Parameters\n";
	
	String->isEmpty($sta_file, "ERROR::".$PROG_NAME.":: File with STA values is required");
	FilesIO->checkFile($sta_file, "ERROR::".$PROG_NAME.":: File $sta_file NOT Found");	
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Output File is required");
	String->isEmpty($col, "ERROR::".$PROG_NAME.":: Parameter  -col is required");
	
	
	print "-sta_file = $sta_file\n";	
	print "-outputFile = $outputFile\n";	
	print "-col = $col\n";
	print "-points = $points\n";
	
	if ($verbose ne "true" && $verbose ne "false"){
		print "ERROR::readResult:: Parameter -verbose must be true or false!\n";
		exit;
	}	
	print "-verbose = $verbose\n";		
	print "ok\n";
}

########################### sub main ####################################
sub main { 
	my @array_file;				
	my @array_sta;				
	my $info = "";
	
	@array_file = FilesIO->fileToArray2d($sta_file, "\t");
	@array_file = Array->copyColMatrixToArray2($col, \@array_file);
	if ($biggest eq ""){
		$biggest = Array->getBigger(\@array_file);
	}
	if ($smallest eq ""){
		$smallest = Array->getSmaller(\@array_file);
	}
	
	if ($points eq ""){		
		@array_sta = Analisys->initMatrixStaRowValueRemoveRepeated(2, 0, \@array_file);
		#print  Array->printMatrix2("\t", "\n", \@array_sta)."\n";
		@array_sta = Array->sortArray2d(0, \@array_sta);
		
	}else{
		if ($scale eq "log"){
			@array_sta = Analisys->initialArrayCountHistogramFloatJumpLog($biggest, $smallest, $jump);
		}else{
			@array_sta = Analisys->initialArrayCountHistogramFloat($biggest, $smallest, $points);
		}				
	}
	


	for (my $i = 0; $i <scalar(@array_file); $i++){
		#print $array_file[$i]."\n";
		@array_sta = Analisys->fillMatrixStaBigger(1, $array_file[$i], \@array_sta)
	}
	@array_sta = Array->getSomeColsMatrix2("0:1", \@array_sta);
	
	$info =  Array->printMatrix2("\t", "\n", \@array_sta);
	FilesIO->saveFile($outputFile, $info, $verbose);
	
}

	


