#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Array;
use analisys::analisys;


my $sta_file = "";
my $outputFile = "";
my $col = "";
my $points = 50;
my $verbose = "false";
my $removeValue = "";

my @arrayCountFamily = ();
my $start = "";
my $end = "";

my $PROG_NAME = "PERL_LIB::analisys::analisys::getPerformance.pl";

my $QTD_POINTS ;
&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-staFile"){
			$sta_file = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-points"){
			$points = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-start"){
			$start = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-end"){
			$end = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-removeValue"){
			$removeValue = $ARGV[$counter+1];		
		}  		
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
print "\n=============================================\n";
	print "Cheking Parameters\n";
	
	String->isEmpty($sta_file, "ERROR::".$PROG_NAME.":: File with STA values is required");
	FilesIO->checkFile($sta_file, "ERROR::".$PROG_NAME.":: File $sta_file NOT Found");	
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Output File is required");
	String->isEmpty($col, "ERROR::".$PROG_NAME.":: Parameter  -col is required");
	
	
	print "-sta_file = $sta_file\n";	
	print "-outputFile = $outputFile\n";	
	print "-col = $col\n";
	print "-points = $points\n";
	print "-removeValue = $removeValue\n";
	
	if ($verbose ne "true" && $verbose ne "false"){
		print "ERROR::readResult:: Parameter -verbose must be true or false!\n";
		exit;
	}	
	print "-verbose = $verbose\n";		
	print "ok\n";
}

########################### sub main ####################################
sub main { 
	my $entry;
	my @array_file_line;
	my $count = 0;
	my $mesure;
	my $accuracy; my $precision; my $recall;
	
	my @array_file = FilesIO->fileToArray2d($sta_file, "\t");
	@array_file = Array->copyColMatrixToArray(scalar(@array_file), $#{$array_file[0]}, $col, \@array_file);
	if ($removeValue ne ""){
		@array_file = Array->removeValueArray($removeValue, \@array_file);
	}
	
	my $biggest = $end;
	if ($end eq ""){
		$biggest = Array->getBigger(\@array_file);
	}
	
	my $smallest = $start;
	if ($start eq ""){
		$smallest = Array->getSmaller(\@array_file);
	}	
	
	my $interval = ($biggest - $smallest)/$points;
	#$interval =  sprintf("%.2f", $interval);
	my @array_sta = Analisys->initialArrayCountPerformance($points, $interval, $start);
	@array_sta = Analisys->countArrayCountPerformance(\@array_file, \@array_sta);
	print  Array->printMatrix("\t", scalar(@array_sta), $#{$array_sta[0]} + 1, \@array_sta);
	
}

	


