#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Array;
use analisys::analisys;

my $sta_file = "";
my $outputFile = "";
my $col = 0;
my $jump = 1;
my $verbose = "false";
my $QTD_POINTS;
my @arrayCountFamily = ();
my $start = "";
my $end = "";
my $float = "false";
my $only_first = "false";
my $logScale = "true";
my $value = "0";


my $PROG_NAME = "PERL_LIB::analisys::analisys::getStatistics.pl";

#my @matrix = Analisys->initialArrayCountHistogramFloatJumpLog(1, 1e-20, 1e5 );
#print Array->printMatrix2("\t", "\n", \@matrix);

#my @array_data = (1e-12, 1e-13, 1e-4, 1e-8);

#@matrix = Analisys->countArrayHistogramInterval(scalar(@matrix), \@matrix, \@array_data);
#print "\n\n".Array->printMatrix2("\t", "\n", \@matrix);
#exit;

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-staFile"){
			$sta_file = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-start"){
			$start = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-end"){
			$end = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-value"){
			$value = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for: ".$PROG_NAME."\n" ;
	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false");
	String->isEmpty($sta_file, "ERROR::".$PROG_NAME.":: File with $sta_file values is required");
	FilesIO->checkFile($sta_file, "ERROR::".$PROG_NAME.":: $sta_file NOT Found");	
	
	
	print "-sta_file = $sta_file\n";	
	print "-col = $col\n";
	print "-verbose = $verbose\n";		
	print "ok\n";
}

########################### sub main ####################################
sub main { 
	my $biggest;
	my @array_file_line;
	my $smallest = 0;
	my $avg;
	my $count1 = 0; 
	my $count2 = 0; 
	my @arrayCount;
	my $sum;
	my $greater = "";
	
	my @array_file = FilesIO->fileToArray2d($sta_file, "\t");
	@array_file = Array->copyColMatrixToArray(scalar(@array_file), $#{$array_file[0]}, $col, \@array_file);
	
	$biggest = $end;
	if ($end eq ""){
		$biggest = Array->getBigger(\@array_file);
	}
	
	$smallest = $start;
	if ($start eq ""){
		$smallest = Array->getSmaller(\@array_file);
	}
	
	$avg = Array->getAverage(\@array_file);
	
	for (my $i = 0; $i <scalar(@array_file); $i++){
		if ($array_file[$i] <= $smallest){
			$count1++;
		}
		if ($array_file[$i] >= $biggest){
			$count2++;
		}	
	}
	
	$sum = Array->getSum(\@array_file);
	$greater = Array->countGreaterSmallerThan("greater", $value, \@array_file);
	
	print "Total = ". scalar(@array_file)."\n";
	print "biggest = $biggest\n";
	print "smallest = $smallest\n";
	print "avg = $avg\n";
	print "sum = $sum\n";
	print "greater $value = $greater\n";
	print "smaller or equal to $smallest = $count1\n";
	print "smaller or equal to $biggest = $count2\n";
  
}



	


