#!/usr/bin/perl -w
use strict;

use strict;
use lib "/usr/local/bioperl-1.5.1/";
use Bio::SearchIO;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file;
my $set_file;

my @hmmer_ids 		= ();
my @true_ids 		= ();

my @hmmer_ids_tp 	= ();#hmmer ids true positive
my @hmmer_ids_fp 	= ();#hmmer ids false positive
my @hmmer_ids_fn	= ();#hmmer ids false negatives

my @hmmer_info_parsed = ();#result file hmmer
my $info_statistics = "";

my $alin_er   = "mammoth";
my $calibrate = "calibrated";
my $work_fold = "hmmer_prior_fssp";
my $dir;
my $mat_ext   = "";
my $dir_seq = "/home/jsilva/projetos/projeto_align/datas/sequences/";

my $info_count = "";
my $count = 0;
#my $alin_er   = "";
#my $calibrate = "";

&getParameters;
&readParametersFile;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		} 		
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}
	unless (open(SETFILE, "$set_file")) {
   		print "Could not open file $set_file !\n";
     		exit;
   	}
	
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     		exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)==2){
			$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			#print $value."\n";
			if ($array_settings[0] eq "p_alin_er"){
				$alin_er = $value;					
			}elsif ($array_settings[0] eq "p_calibrate"){
				$calibrate = $value;				
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;				
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;				
			}elsif ($array_settings[0] eq "p_dir"){
				$dir = $value;				
			}elsif ($array_settings[0] eq "p_mat_ext"){
				$mat_ext = $value;				
			}
		}
	}
}
#################################### sub main ##################################
sub main {

	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = substr($family[0], 0, index($family[0],"\n"));
		
		if ($new_sample ne $old_sample){
			#$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&getTruePositivesFound($new_sample,$dir); 
			&writeFileHitsFound($new_sample,$dir);
			&writeFileHitsNotFound($new_sample,$dir);	

			@hmmer_ids 		= ();
			@true_ids 		= ();
			@hmmer_ids_tp 	= ();
			@hmmer_ids_fp 	= ();	
			@hmmer_info_parsed = ();
			@hmmer_ids_fn	= ();
		}
		$old_sample = $new_sample;					
	}
	#print $info_statistics;
	#&writeStatistics($info_statistics);
	close FAMILYFILE;
}

############################ sub getTruePositivesFound ##################################
sub getTruePositivesFound{
	my $sample		= $_[0];
	#my $dir			= $_[1];
	#my $work_fold	= "hmmer";
	
	my $pattern = &getPattern(3, ".", $sample);	

	my $dir_result 	= $dir."HMMs/$work_fold/$alin_er/results/$pattern/";
	my $dir_result_hmmer = $dir_result;
	my $result_file_name = "$sample$mat_ext.result";
	my $real_true_positive_file = $dir_seq. $pattern. "/".$pattern."true";

	my $item_true_id;
	my $item_hmmer_id;
	my $count_true_positive_found	= 0;
	my $count_false_positive	= 0;
	my $found = "false";


	&readHmmerIds($dir_result_hmmer.$result_file_name, $sample);
	&readTrueIds($real_true_positive_file);

	foreach $item_hmmer_id (@hmmer_ids){
		my @ids_seq_hmmer = split (/\t/, $item_hmmer_id); 
		my $sample_hmmer = substr($ids_seq_hmmer[1], 0, index($ids_seq_hmmer[1],"\n"));
		
		foreach $item_true_id (@true_ids){	
			if ($item_true_id eq $ids_seq_hmmer[0] && $sample eq $sample_hmmer){
				push(@hmmer_ids_tp, $item_true_id);
				$count_true_positive_found++;
				$found = "true";	
			}
		}
		
		if ($found eq "false" && &getPattern(3, ".", $sample_hmmer) ne $pattern){
			push(@hmmer_ids_fp, $ids_seq_hmmer[0]);
			$count_false_positive++;
		}
		$found = "false";
	}

	#print $sample. "\t";
	$count++;
	print $count . "\t". $count_true_positive_found . "\n";
	#print $count_false_positive . "\t". $count_true_positive_found . "\n";

	
  my $key_aln; 
 my $value_aln;
  
 #while (($key_aln, $value_aln) = each(%hash_homol)){
  #		if ($value_aln eq $sample){
#				print $key_aln.">>>>>\t".$value_aln."\n" ;    
#		}
#}
	

	#$count_false_positive = scalar(@hmmer_ids) - $count_true_positive_found;
	$info_statistics .= "$sample FP $count_false_positive TP $count_true_positive_found";	
	
}

##################################### sub writeFileHitsFound ##############################
sub writeFileHitsFound{
	
	my $sample		= $_[0];
	#my $dir			= $_[1];
	my $pattern = &getPattern(3, ".", $sample);		

	my $path_tp_file = $dir."HMMs/$work_fold/$alin_er/results/$pattern/$sample".$mat_ext."_true_positives_found.txt";
	my $path_fp_file = $dir."HMMs/$work_fold/$alin_er/results/$pattern/$sample".$mat_ext."_false_positives_found.txt";
	
	my $item;
	my $i = 0;

	my @result = ();
	my $found  = "false";
	my $info_true = "";
	my $info_false = "";
	
	

   	foreach $item (@hmmer_info_parsed){
		@result	= split(/\t/,$item);		
		#print $item."\n";
		while ($i < scalar(@hmmer_ids_tp) && $found eq "false"){
			#print $hmmer_ids_tp[$i].$result[0]."\n";
			
			if ($hmmer_ids_tp[$i] eq $result[0]){
				$info_true.= $item;
				$found = "true";	
			}
			$i++;	
		}		
		$i = 0;
		$found = "false";			
	}
	#print $info_false."\n";

	foreach $item (@hmmer_info_parsed){
		@result	= split(/\t/,$item);		
		#print $item."\n";
		while ($i < scalar(@hmmer_ids_fp) && $found eq "false"){
	#		print $hmmer_ids_fp[$i].$result[0]."\n";
			
			if ($hmmer_ids_fp[$i] eq $result[0]){
				$info_false.= $item;
				$found = "true";	
			}
			$i++;	
		}		
		$i = 0;
		$found = "false";
	}
	#print $info_false."\n";
	

	&saveFile($path_tp_file, $info_true);
	&saveFile($path_fp_file, $info_false);

}

##################################### sub writeFileHitsNotFound ##############################
sub writeFileHitsNotFound{
	
	my $sample		= $_[0];
	#my $dir			= $_[1];
	my $pattern = &getPattern(3, ".", $sample);		

	my $path_fn_file = $dir."HMMs/$work_fold/$alin_er/results/$pattern/$sample".$mat_ext."_false_negatives_found.txt";
	
		
	my $item_true_id;
	my $item_hmmer_id;
		
	my $found  = "false";
	my $info_false_neg = "";
	my $count_false_negative = 0;

  	foreach $item_true_id (@true_ids){
		foreach $item_hmmer_id (@hmmer_ids_tp){	
			if ($item_true_id eq $item_hmmer_id){
				$found = "true";				
			}
		}
		if($found eq "false"){
			$info_false_neg.= $item_true_id ."\n";
			$count_false_negative++;
		}
		$found = "false";
	}
	#$info_statistics .= " FN $count_false_negative\n";
	&saveFile($path_fn_file, $info_false_neg);
}

############################ sub writeStatistics ##################################
sub writeStatistics{

	my @infos = split(/\n/,$info_statistics);
	my @each_info  = ();
	my $old_pattern = "";
	my $new_pattern = "";
	my $new_sample = "";
	my $info_file ="";

	my $item;
	my $sum_tp = 0;
	my $sum_fp = 0;
	my $sum_fn = 0;
	my $num_same_samples = 0;

	foreach $item (@infos){
		@each_info 	= split(/ +/,$item); 
		$new_sample = $each_info[0];
		$new_pattern = &getPattern(3, ".", $new_sample);

		if ($old_pattern ne $new_pattern && $old_pattern ne ""){			
			$info_file.= &calcTx($num_same_samples,$sum_tp,$sum_fp,$sum_fn,$old_pattern);
			$num_same_samples = 0;
			$sum_tp = 0;
			$sum_fp = 0;
			$sum_fn = 0;
		}
		$sum_fp += $each_info[2];
		$sum_tp += $each_info[4];
		$sum_fn += $each_info[6];
		$num_same_samples++;
		$old_pattern = $new_pattern;		
	}
	$info_file.= &calcTx($num_same_samples,$sum_tp,$sum_fp,$sum_fn,$old_pattern);
	&sepInfo($info_file);
	#&saveFile("hmmer_statistics.txt",$info_file);
}

############################ sub calcTx ##################################
sub calcTx{
	my $num_same_samples	= $_[0];
	my $sum_tp	= $_[1];
	my $sum_fp	= $_[2];
	my $sum_fn	= $_[3];
	my $old_pattern = $_[4]; 

	my $num_tp;
	my $num_fp;
	my $num_fn;

	my $precision;
	my $recall;
	my $tx;

	if ($num_same_samples == 0){
				$num_same_samples = 1;
	}
	$num_tp = $sum_tp / $num_same_samples;
	$num_fp = $sum_fp / $num_same_samples;
	$num_fn = $sum_fn / $num_same_samples;
	if ($num_tp == 0){
		$precision = 0;
		$recall	= 0;
	}else{
		$precision = $num_tp /($num_tp + $num_fn);
		$recall =  $num_tp /($num_tp + $num_fp);
	}
	#$tx = $precision/(1-$recall);
	return "$old_pattern $num_tp $num_fp $num_fn $precision $recall\n";
		
}
############################ sub calcTx ##################################
sub sepInfo{
	my $info_ent	= $_[0];

	my $item;
	my	@infos = ();
	my @info = ();
	my $info_recall_pre = "";
	my $info_fp_tp = "";

	@infos = split(/\n/,$info_ent);
	foreach $item (@infos){
		@info = split(/ +/,$item);
		$info_recall_pre .= $info[4]. "\t".$info[5]."\n";
		$info_fp_tp .= $info[2]. "\t".$info[1]."\n";
	}
	&saveFile("hmmer_recallPrec.txt",$info_recall_pre);
	&saveFile("hmmer_fpTp.txt",$info_fp_tp);
}
##################################### sub readHmmerIds ##################################
sub readHmmerIds{
	my $path			= $_[0];
	

	my $hmmer_file_parsed = $path.".parsed";

	my $item;
	my	@hmmer_file = ();
	my	@hmmer_info = ();
	my $i;

	if (open(HMMERRESFILE,$path)){
		print $path."\n";
		&parserHmmerResults($path);
		close HMMERRESFILE;
		#print "path $hmmer_file_parsed\n";
		if (open(HMMERPARFILE,$hmmer_file_parsed)){
			@hmmer_file = <HMMERPARFILE>;
			$i = 0;
			foreach $item (@hmmer_file){
				#print $item;
				$hmmer_info_parsed[$i++] = $item;
				@hmmer_info	= split(/\t/,$item);
				#print $hmmer_info[scalar(@hmmer_info) -1]."\n";
				my @hmmer_desc = split(/ +/,$hmmer_info[scalar(@hmmer_info) -1]);
				my $info =  $hmmer_info[0]."\t".$hmmer_desc[0]."\n";
				push(@hmmer_ids, $info);
			}
			#print @hmmer_ids;	
			close HMMERPARFILE;
		}
		else{
			print "ERROR : file $hmmer_file_parsed not found\n";
		}
		
	}
	else{
		print "ERROR : file $path not found\n";
	}
}
##################################### sub readTrueIds ##################################
sub readTrueIds{
		my $path	= $_[0];
	
		my @lines_file = ();
		my $line;	
		my @align		= ();	
		my @true_positives = ();
	
		my %hash_seq	= ();
		my $value = "";
		if (open(FILESEQ,"$path")){
			@lines_file = <FILESEQ>;		
			foreach $line (@lines_file){
				@true_positives = split (/ +/, $line);
				push(@true_ids, $true_positives[0]);
				#$hash_homol{$true_positives[0]} =$true_positives[1];  			
			}
			close FILESEQ;
		}
		else{
			print "File $path not found!\n";
		}
}
#################################### sub parserHmmerResults ##################################
sub parserHmmerResults{
		my $path			= $_[0];

		my $outfileName = $path.".parsed";

		my $maxEvalue = "10";
		my $minScore = "-100";

		unless (open(FILE, "$path")) {
                	print "Could not open file $path !\n";
                	exit;
      		}

		unless (open(OUTFILE, ">$outfileName")) {
                	print "Could not open file $outfileName !\n";
                	exit;
      		}
		
		my @datas = <FILE>;
		close FILE;
		
		my $start_line = "-------- -----------                                    -----    ------- ---";
		my $empty_result = "[no hits above thresholds]";
		my $start = "false";
		my $stop  = "false";
		my $line;
		my $iten;
		my @line_result;
		my $i = 0;
		my $info = "";

		while ($i < scalar(@datas) && $stop ne "true"){
			if (index($datas[$i],$start_line) >=0){
				$start = "true";				
			}elsif (index($datas[$i], $empty_result) >=0){
				$stop = "true";
				$start = "true"
			}elsif ($datas[$i] eq "\n" && $start eq "true"){
				$stop = "true";
			}elsif ($start eq "true"){
				@line_result = split (/ +/, $datas[$i]);
				$info .= $line_result[0]."\t";				 
				for (my $j = scalar(@line_result) - 3; $j < scalar(@line_result) -1; $j++){
					$info .= $line_result[$j] . "\t";
				}
				for (my $j = 1; $j < scalar(@line_result)-3; $j++){
					$info .= $line_result[$j] . " ";
				}
				$info .= "\n";
			}
			$i++;
		}
		print OUTFILE $info;
		close OUTFILE;
		
}

############################ sub getPattern ##################################
sub getPattern {
	my $num 		= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}

############################ sub saveFile ###################################
sub saveFile{
	my $path 	= $_[0];
	my $info  	= $_[1];

	if (open(FILESEQ,">$path")){
		print FILESEQ $info;
		print "file $path was created\n";
	}
	else{
		print "file $path not found\n";
	}
	close FILESEQ;
}
