use strict;

use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use Align::Struct::Mammoth;
use File::Files;
use String::StringUtil;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $set_file		= "";
my $on_resume		= "no";

my $kind_align		= "";
my $ext_align		= "";
my $ext_pdb		= "";
my $ext_mat		= "";
my $kind_calib		= "";	
my $work_fold		= "";

my $mid_value           = 0.4;


&getParameters;
&readParametersFile;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		}
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}

	unless (open(SETFILE, "$set_file")) {
   		print "oiCould not open file $set_file !\n";
     		exit;
   	}
	#print "oi $set_file";
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";
	my $i;

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     		exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)> 1){
			#$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			$value = "";
			for ($i=1; $i<scalar(@array_settings); $i++){
				if (index($array_settings[$i],"\n") < 0){
					$value .=$array_settings[$i];
				}
				else{
					$value .= substr($array_settings[$i],0,index($array_settings[1],"\n"));
				}
				if ($i<scalar(@array_settings)-1){$value .=" ";}
			}
						
			if ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;
			}elsif ($array_settings[0] eq "p_ext_align"){
				$ext_align = $value;
			}elsif ($array_settings[0] eq "p_ext_pdb"){
				$ext_pdb = $value;
			}elsif ($array_settings[0] eq "p_ext_mat"){
				$ext_mat = $value;
			}elsif ($array_settings[0] eq "p_on_resume"){
				$on_resume  = $value;
			}										
		}
	}	
	
	close SETFILE;
}

############################ sub main ##################################
sub main {
	my @families 		= ();
	my @family 		= ();
	my $entry		= "";
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir			= "";
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	print "\n";
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
                
               #print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&getStructMotifGroup($new_sample,$dir); 
		}
		$old_sample = $new_sample;
	}
	system ("date");
	close FAMILYFILE;
}

############################ sub getStructMotifGroup ##################################
sub getStructMotifGroup {
        my $sample		= $_[0];
	my $dir			= $_[1];
	my @gruop_ids_file	= ();
	my @gruop_ids		= ();
	my $item 		= "";
	my $info_file		= "";
	my $chain		= "";
	my $id_pdb		= "";
	my $group_id		= "";
	my $qtd_seq		= 0;
	
	my $dir_pdb  = $dir . $sample."/pdb/";
	my $path     = $dir_pdb.$sample.".groups";
        my $db_motif_file = $dir."$sample/alignment/$kind_align/$sample.dbm";
        
        my $info_motif = "";
	
	if (open(FILEG,"$path")){
		#print $path."\n";
		@gruop_ids_file = <FILEG>;
		#@gruop_ids = split(/\n/,$gruop_ids_file);
		foreach $item (@gruop_ids_file) {
			@gruop_ids = split(/ +/, $item); 
			$qtd_seq = substr($gruop_ids[1],0,index($gruop_ids[1],"\n"));
			if ($qtd_seq > 1){
				system ("date");
                                $info_motif.= &getStructMotif($sample,$dir,$gruop_ids[0]);
                                $info_motif.= &get3DMotif($sample,$dir,$gruop_ids[0]);
                                print "\n\n\n";
				system ("date");
			}
		}
		FilesIO->saveFile($db_motif_file, $info_motif);	
		close FILEG;
	}	
	else{
		print "ERROR: file $path not found\n";
	}	


}
############################ sub getStructMotif ##################################
sub get3DMotif {
    my $sample	  = $_[0];
    my $dir	  = $_[1];
    my $group_id  = $_[2];

    my $dir = $dir."$sample/alignment/$kind_align/";
    my $aln_file_3d = "$group_id$ext_mat";
    my $aln_seq     = "$group_id$ext_align";
    
        
    my @sequences = Mammoth->getSeqAln1d($dir.$aln_seq);
    my %hash_aln  = Mammoth->loadAlign1d($dir.$aln_seq);
    
    my @mat_3d    = ([],[]);
    my $start_pos = 0;
    my $end_pos = 0;
    my $count_motif;
    my $info_db_motif = "";
    my $sum           = 0;
    
    @mat_3d       = Mammoth->get2dAln($dir.$aln_file_3d);
    
    my $rows = scalar(@mat_3d);
    my $cols = $#{@mat_3d[0]}; 
      
    #Find motifs and save them
    for (my $i = 0; $i < $rows; $i++){
      $count_motif = 0;
      $start_pos   = 0;
      $end_pos     = 0;
        
      for (my $j = 0; $j < $cols; $j++){
        if ($mat_3d[$i][$j] >= $mid_value){
          if ($start_pos == 0){
            $start_pos = $j;
          } 
          $count_motif++;
        }
        else{
          #verify next position 
          if ($j-1 > 0 && (($mat_3d[$i][$j] + $mat_3d[$i][$j-1])/2 >= $mid_value)){
            $count_motif++;
          }
          elsif ($count_motif >0 ){
            $end_pos = $j -1;
            if ($count_motif >=3 ){
              print "$start_pos $end_pos $count_motif $sequences[$i]\n";
              my $motif = substr($hash_aln{$sequences[$i]},$start_pos,$count_motif);
              $motif = String->removeCaracter($motif,"-");
              #Finding a weight to motif
              $sum = 0;
              for (my $k=$start_pos; $k <= $end_pos; $k++){
                $sum += $mat_3d[$i][$k];
              }
              $sum *=100;
              $info_db_motif .= $motif." ".$sum."\n";
            }        
            $start_pos   = 0;
            $end_pos     = 0;
            $count_motif = 0;        
        }    
      }    
    }  
  }
  return $info_db_motif;
        
}

############################ sub getStructMotif ##################################
sub getStructMotif {
    my $sample	  = $_[0];
    my $dir	  = $_[1];
    my $group_id  = $_[2];

    my $dir = $dir."/$sample/alignment/$kind_align/joy/";
    my $aln_file_2d = "$group_id.2d";
    my $aln_file_acc = "$group_id.acc";
    my $aln_file_oi = "$group_id.oi";
    my $aln_seq     = "$group_id$ext_align.2d";

    my @sequences = Mammoth->getSeqAln($dir.$aln_file_2d);
    my %hash_aln  = Mammoth->loadAlign1d($dir.$aln_seq);
    
    my @mat_2d        = ([],[]);
    my @mat_acc       = ([],[]);
    my @mat_oi        = ([],[]);
    my @mat_motif     = ([],[]);
    my @vet_2d        = ();
    my @vet_acc       = ();
    my @vet_oi        = ();
    my @vet_sum       = ();
    my @vet_med       = ();
    my @vet_motif_ind = ();
    my @vet_aux       = ();
    my $sum           = 0;
    my $med_value     = 0;
    my $start_pos = 0;
    my $end_pos = 0;
    my $count_motif;
    my $info_db_motif = "";
        
    @mat_2d = Mammoth->get2dAln($dir.$aln_file_2d);
    @mat_acc = Mammoth->get2dAln($dir.$aln_file_acc);
    @mat_oi = Mammoth->get2dAln($dir.$aln_file_oi);
    
    
    my $rows = scalar(@mat_2d);
    my $cols = $#{@mat_2d[0]};

    #Inicialization of array
    for (my $i=0; $i < $cols; $i++){
      $vet_2d[$i] = 0; $vet_acc[$i] = 0; $vet_oi[$i] = 0; $vet_sum[$i] = 0;
    }
    
    #Finding middle value
    for (my $i = 0; $i < $rows; $i++){
      $sum = 0;
      for (my $j = 0; $j < $cols; $j++){
        $mat_motif[$i][$j] = $mat_2d[$i][$j] + $mat_acc[$i][$j] + $mat_oi[$i][$j];    
        $sum += $mat_motif[$i][$j];
      }  
      $vet_med[$i] = $sum/$cols; 
    }
    #Find motifs and save them
    for (my $i = 0; $i < $rows; $i++){
      $count_motif = 0;
      $start_pos   = 0;
      $end_pos     = 0;
        
      for (my $j = 0; $j < $cols; $j++){
        if ($mat_motif[$i][$j] >= $vet_med[$i]){
          if ($start_pos == 0){
            $start_pos = $j;
          } 
          $count_motif++;
        }
        else{
          #verify next position 
          if ($j-1 > 0 && (($mat_motif[$i][$j] + $mat_motif[$i][$j-1])/2 >= $vet_med[$i])){
            $count_motif++;
          }
          elsif ($count_motif >0 ){
            $end_pos = $j -1;
            if ($count_motif >=3 ){
              my $motif = substr($hash_aln{$sequences[$i]},$start_pos,$count_motif);
              $motif = String->removeCaracter($motif,"-");
              #Finding a weight to motif
              $sum = 0;
              for (my $k=$start_pos; $k <= $end_pos; $k++){
                $sum += $mat_motif[$i][$k];
              }
              $info_db_motif .= $motif." ".$sum."\n";
            }        
            $start_pos   = 0;
            $end_pos     = 0;
            $count_motif = 0;        
        }    
      }    
    }  
  }
  return   $info_db_motif;  
}