

my $in_file 		= "";
my $set_file;
my $kind_align          = "mammoth";
my $kind_calib          = "calibrated";
my $work_fold           = "hmmer_prior_fssp";
my $ext_align		= "";
my $ext_pdb		= "";
my $ext_mat		= "";
my $file_log = "";
my $info_log = "";


&getParameters;
&readParametersFile;
&main;
############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		} 		
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}
	unless (open(SETFILE, "$set_file")) {
   	print "Could not open file $set_file !\n";
     	exit;
   }
	
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     	exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)==2){
			$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			print $value."\n";
			if ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;					
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;				
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;				
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;				
			}elsif ($array_settings[0] eq "p_ext_align"){
				$ext_align = $value;
			}elsif ($array_settings[0] eq "p_ext_pdb"){
				$ext_pdb = $value;
			}elsif ($array_settings[0] eq "p_ext_mat"){
				$ext_mat = $value;
			}elsif ($array_settings[0] eq "p_file_log"){
				$file_log = $value;
			}
		}
	}
}
########################### sub main ####################################
sub main { 
  
  my @families 		= ();
  my @family 		= ();
  my $entry;
  my $old_sample		= "";
  my $new_sample		= "";
  my $dir;
		
	#read family file
  unless (open(FAMILYFILE, "$in_file")) {
    print "Could not open file $in_file !\n";
    exit;
  }
  @families = <FAMILYFILE>;
	
  foreach $entry (@families) {
    @family	= split(/ +/,$entry);
    $new_sample = $family[0];
    if ($new_sample ne $old_sample){
		 $dir = substr($family[4],0,index($family[4],"\n")). "/";
       system ("date");
       &normalize($new_sample,$dir,".2d");
       &normalize($new_sample,$dir,".acc");
       &normalize($new_sample,$dir,".oi");
       &normalize3d($new_sample,$dir,"-FINAL.mat");
#        exit;
       system ("date");
    }
    $old_sample = $new_sample;	
  }
  close FAMILYFILE;
}


########################### sub createSecMatriz ####################################
sub normalize { 
 
  
  my $sample		= $_[0];
  my $dir		= $_[1];
  my $end_mat           = $_[2];

  
  my @mat               = ([],[]);
  my $rows              = 0;  
  my $cols              = 0;
  
  my $dir_files_pdb     = $dir. "pdb_files/";
  my $dir_group         = $dir. "$sample/pdb/";
  my $dir_aln           = $dir. "$sample/alignment/$kind_align/";
  my $dir_joy           = $dir_aln. "joy/" ;
  my @array_file        = ();
  my $item;
  my $file              = $dir_joy.$sample.$end_mat;
  
  if (open(FILE,$file)){
    @array_file = <FILE>;
    my $i = 0;
    my $j = 0;
    my $data;
    foreach $item (@array_file){
      my @array_data = split(/\t/, $item);
      for ($j = 0; $j < scalar(@array_data); $j++){
        $data = $array_data[$j];
        if (index($data,"\n") >= 0){
          $data = substr($data,0,index($data, "\n"))
        }
        $mat[$i][$j] = $data;
      }
      $i++;    
    }
    $rows = $i;
    $cols = $j;
    
    
    my $count_zero = 0;
    my $sum = 0;
    
    my $alpha = 0;

    for ($j = 1; $j < $cols; $j++){
      $count_zero = 0;
      $sum = 0;
      for ($i = 0; $i < $rows; $i++){
        if ($mat[$i][$j] == 0){
#            print $mat[$i][$j]. " $i $j \n";
          $count_zero++;
        }
        else{
          $sum += $mat[$i][$j];
        }
      }
      if ($sum == 0){ $sum = 1;}
      $alpha = ($rows -  $count_zero)/ $sum;
      
      
      for ($i = 0; $i < $rows; $i++){
        $mat[$i][$j] *= $alpha; 
      }      
    }
   my $info ="";
   close FILE;
   
   if (open(FILE,">$file")){
     for ($i = 0; $i < $rows; $i++){
       for ($j = 0; $j < $cols; $j++){
          print FILE $mat[$i][$j]. "\t";
        }   
        print FILE "\n"; 
     }
    }
    close FILE;  
    
  }  
}

########################### sub createSecMatriz ####################################
sub normalize3d { 
 
  
  my $sample		= $_[0];
  my $dir		= $_[1];
  my $end_mat           = $_[2];

  
  my @mat               = ([],[]);
  my $rows              = 0;  
  my $cols              = 0;
  
  my $dir_files_pdb     = $dir. "pdb_files/";
  my $dir_group         = $dir. "$sample/pdb/";
  my $dir_aln           = $dir. "$sample/alignment/$kind_align/";
  my @array_file        = ();
  my $item;
  my $file              = $dir_aln.$sample.$end_mat;
  
  if (open(FILE,$file)){
    @array_file = <FILE>;
    my $i = 0;
    my $j = 0;
    my $data;
    foreach $item (@array_file){
      my @array_data = split(/\t/, $item);
      for ($j = 0; $j < scalar(@array_data); $j++){
        $data = $array_data[$j];
        if (index($data,"\n") >= 0){
          $data = substr($data,0,index($data, "\n"))
        }
        $mat[$i][$j] = $data;
      }
      $i++;    
    }
    $rows = $i;
    $cols = $j;
    
    
    my $count_zero = 0;
    my $sum = 0;
    
    my $alpha = 0;

    for ($j = 0; $j < $cols; $j++){
      $count_zero = 0;
      $sum = 0;
      for ($i = 0; $i < $rows; $i++){
        if ($mat[$i][$j] == 0){
#            print $mat[$i][$j]. " $i $j \n";
          $count_zero++;
        }
        else{
          $sum += $mat[$i][$j];
        }
      }
      if ($sum == 0){ $sum = 1;}
      $alpha = ($rows -  $count_zero)/ $sum;
      
      $sum =0;
      for ($i = 0; $i < $rows; $i++){
        $mat[$i][$j] *= $alpha; 
        $sum +=$mat[$i][$j];
        
      } 
#       print $sum." ";
     
      
    }
   my $info ="";
   close FILE;
   
   if (open(FILE,">$file")){
     for ($i = 0; $i < $rows; $i++){
       for ($j = 0; $j < $cols; $j++){
          print FILE $mat[$i][$j]. "\t";
        }   
        print FILE "\n"; 
     }
    }
    close FILE;  
    
  }  
}