use strict;
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use Align::Struct::Mammoth;
use Scop::ScopPattern;

my %hash_sec = ();
my @mat  = ([],[]);
my %hash_aln = ();
my $rows  = 0;
my $cols;
my $gap = "-";

my $in_file 		= "";
my $set_file;
my $kind_align          = "mammoth";
my $kind_calib          = "calibrated";
my $work_fold           = "hmmer_prior_fssp";
my $ext_align		= "";
my $ext_pdb		= "";
my $ext_mat		= "";
my $file_log = "";
my $info_log = "";




&getParameters;
&readParametersFile;
&main;
############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		} 		
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}
	unless (open(SETFILE, "$set_file")) {
   	print "Could not open file $set_file !\n";
     	exit;
   }
	
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     	exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)==2){
			$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			print $value."\n";
			if ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;					
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;				
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;				
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;				
			}elsif ($array_settings[0] eq "p_ext_align"){
				$ext_align = $value;
			}elsif ($array_settings[0] eq "p_ext_pdb"){
				$ext_pdb = $value;
			}elsif ($array_settings[0] eq "p_ext_mat"){
				$ext_mat = $value;
			}elsif ($array_settings[0] eq "p_file_log"){
				$file_log = $value;
			}
		}
	}
}

########################### sub main ####################################
sub main { 
  
  my @families 		= ();
  my @family 		= ();
  my $entry;
  my $old_sample	= "";
  my $new_sample	= "";
  my $dir;
  my $pattern           = "";
  my $pattern_old       = "";
  my $average_sum_score;
  my $count_fam        = 0;
  my $core_supFam      = 0;
		
	#read family file
  unless (open(FAMILYFILE, "$in_file")) {
    print "Could not open file $in_file !\n";
    exit;
  }
  @families = <FAMILYFILE>;
  my $core_supFam = 0;	
  foreach $entry (@families) {
    @family	= split(/ +/,$entry);
    $new_sample = $family[0];
    if ($new_sample ne $old_sample){
      $dir = substr($family[4],0,index($family[4],"\n")). "/";
       
       %hash_aln = ();
       @mat  = ([],[]);
       $rows = 0;
       $cols = 0;
       $count_fam++;
       $pattern = ScopPattern->getPattern(3,".",$new_sample);
       
       if ($pattern ne $pattern_old && $pattern_old ne ""){
         $average_sum_score = $core_supFam/$count_fam;
         print $pattern_old. "\t". $average_sum_score."\n";
         $count_fam = 0;
         $core_supFam = 0;
       }
       $core_supFam += &scoringAlign($dir, $new_sample);
       $pattern_old = $pattern;       
    }
    $old_sample = $new_sample;	
  }
  $average_sum_score = $core_supFam/$count_fam;
  print $pattern_old. "\t". $average_sum_score."\n";
  close FAMILYFILE;
}

#for (my $i = 0; $i < $rows; $i++){
 # for (my $j = 0; $j < $cols; $j++){
  #   print $mat[$i][$j]. " ";
  #}      
  #print "\n";
#}
  


##############################################################################################################
sub scoringAlign{
  my $dir  =  $_[0];
  my $sample = $_[1];
  
  my $dir_aln = $dir.$sample."/alignment/".$kind_align."/" ;
  
  my $aln_file = $dir_aln. $sample.$ext_align;
  #print $aln_file."\n";
  
  %hash_aln = Mammoth->loadAlign1d($dir_aln."$sample$ext_align");

  my $key_aln; 
  my $value_aln;
 
  while (($key_aln, $value_aln) = each(%hash_aln)){
     &loadMat($value_aln);
     $rows += 1; 
  }

  return &findQualityAlign;  
}

##############################################################################################################
sub loadMat{
  my $word = $_[0];
  my $i;
    
  for($i = 0 ; $i < length($word) ; $i++){
	my $car = substr($word,$i,1);
        $mat[$rows][$i] = $car; 
  }
  $cols =  length($word)
}

##############################################################################################################
sub findQualityAlign{
  my $score_col = 0;
  my $score_col_tot = 0;
  my $score_align = 0;
  
  for (my $j = 0; $j < $cols; $j++){
    $score_col_tot = 0;
    for (my $i = 0; $i < $rows; $i++){
        $score_col = 0;
        for (my $k = $i; $k < $rows; $k++){
            $score_col +=  &calcScore($mat[$i][$j], $mat[$k][$j]);
        }
        $score_col_tot +=  $score_col/ ($rows-1);
    }      
    $score_align += $score_col_tot;
  }
  $score_align = $score_align/$cols;
  return $score_align;
}

##############################################################################################################
sub calcScore{
  my $aa1 = $_[0];
  my $aa2 = $_[1];
  
  if ($aa1 eq $aa2){
    return 3;
  }elsif ($aa1 ne $gap && $aa2 ne $gap){
    return 2;
  }else{
    return -1;
  }  
}


