#!/usr/bin/perl -w
use strict;

use strict;
use lib "/usr/local/bioperl14/";
use Bio::SearchIO;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file;
my $set_file;

my @hmmer_ids 		= ();
my @true_ids 		= ();

my @hmmer_ids_tp 	= ();#hmmer ids true positive
my @hmmer_ids_fp 	= ();#hmmer ids false positive
my @hmmer_ids_fn	= ();#hmmer ids false negatives

my @mat_TP  = ([],[]);
my $rows_TP = 0;
my $cols_TP = 6;

my @mat_FP  = ([],[]);
my $rows_FP = 0;
my $cols_FP = 6;


my @hmmer_info_parsed = ();#result file hmmer
my $info_statistics = "";

my $alin_er   = "mammoth";
my $calibrate = "calibrated";
my $work_fold = "hmmer";

my $count_homol = 0;
my %hash_homol = ();
#my $alin_er   = "";
#my $calibrate = "";



unless (open(FILE, ">homology_dist_false.txt")) {
       	print "Could not open file $in_file !\n";
        	exit;
 }

&getParameters;
&readParametersFile;
&main;
close FILE;



############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		} 		
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}
	unless (open(SETFILE, "$set_file")) {
   	print "Could not open file $set_file !\n";
     	exit;
   }
	
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     	exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)==2){
			$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			print $value."\n";
			if ($array_settings[0] eq "p_alin_er"){
				$alin_er = $value;					
			}elsif ($array_settings[0] eq "p_calibrate"){
				$calibrate = $value;				
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;				
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;				
			}
		}
	}
}
#################################### sub main ##################################
sub main {

	my @families 		= ();
	my @family 			= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       	print "Could not open file $in_file !\n";
        	exit;
    }
	@families = <FAMILYFILE>;
	my $count_teste = 0;
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		if ($new_sample ne $old_sample){
			$count_teste++;
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&getTrueModel($new_sample,$dir);                         
			#&writeFileHitsFound($new_sample,$dir);                        
			#&writeFileHitsNotFound($new_sample,$dir);	
			%hash_homol = ();
			@hmmer_ids 		= ();
			@true_ids 		= ();
			@hmmer_ids_tp 	= ();
			@hmmer_ids_fp 	= ();	
			@hmmer_info_parsed = ();
			@hmmer_ids_fn	= ();
		}
		$old_sample = $new_sample;					
	}
	print "\n\n\n\n".$count_teste . "  ". $count_homol. "\n";
	#print $info_statistics;
	&writeStatistics($info_statistics);
	close FAMILYFILE;
}

############################ sub getTrueModel ##################################
sub getTrueModel {
	my $sample		= $_[0];
	my $dir			= $_[1];
      	
        $rows_TP = 0;
        $rows_FP = 0;
        
        my $kind_result;
        #my $work_fold	= "hmmer";
        my $real_true_positive_file = &getPattern(3, ".", $sample)."true";
	my $dir_result 		    = $dir.$sample."/result/$alin_er/$calibrate/";
	my $dir_result_hmmer        = $dir_result."$work_fold/";
        my $result_hmmer            = $dir_result_hmmer."hmmpfam_$sample.clear";
	my $path_tp_file = $dir.$sample."/result/$alin_er/$calibrate/$work_fold/true_positives_found.txt";
	my $path_fp_file = $dir.$sample."/result/$alin_er/$calibrate/$work_fold/false_positives_found.txt";
        
        
        #my $result_file_name        = "$sample"."_".$kind_result.".result";	
        &readTrueIds($dir.$real_true_positive_file, $sample);
        
        &getTruePositivesFound($sample, $result_hmmer, "$sample.hmm", 1);
        &getTruePositivesFound($sample, $result_hmmer, "$sample"."_2d.hmm", 2);
        &getTruePositivesFound($sample, $result_hmmer, "$sample"."_3d.hmm", 3);
        &getTruePositivesFound($sample, $result_hmmer, "$sample"."_acc.hmm", 4);
        &getTruePositivesFound($sample, $result_hmmer, "$sample"."_oi.hmm", 5);
      
        #&getTruePositivesFound($sample, $dir_result_hmmer."$sample"."_2d.result", 2);
        #&getTruePositivesFound($sample, $dir_result_hmmer."$sample"."_3d.result", 3);
        #&getTruePositivesFound($sample, $dir_result_hmmer."$sample"."_acc.result", 4);
        #&getTruePositivesFound($sample, $dir_result_hmmer."$sample"."_oi.result", 5);
        
       # print FILE $sample."\n";
        
       for (my $i = 0; $i < $rows_FP; $i++){
            for (my $j = 0; $j < $cols_FP ; $j++){
           print FILE $mat_FP[$i][$j]. "\t";              
           }
          print FILE "\n";
          }
        
        #&saveFileTruePositive($path_tp_file);
        #&saveFileFalsePositive($path_fp_file);

}

############################ sub getTrueModel ##################################
sub saveFileTruePositive {
	my $file		= $_[0];
        my $info = "";
        my $ev = 1000;
        my $model = 0;
        
        for (my $i = 0; $i < $rows_TP; $i++){
          $ev = 1000;
          $model = 0;
          for (my $j = 1; $j < $cols_TP ; $j++){
            if ($mat_TP[$i][$j] < $ev && $mat_TP[$i][$j] !=0){
              $ev = $mat_TP[$i][$j];
              $model = $j;
            }
          }
          $info .= $mat_TP[$i][0]. " ". $ev." ".$model."\n";
         }
         
         &saveFile($file,  $info);
        
        
}

############################ sub getTrueModel ##################################
sub saveFileFalsePositive {
	my $file		= $_[0];
        my $info = "";
        my $ev = 1000;
        my $model = 0;
        
        for (my $i = 0; $i < $rows_FP; $i++){
          $ev = 1000;
          $model = 0;
          for (my $j = 1; $j < $cols_FP ; $j++){
            if ($mat_FP[$i][$j] < $ev && $mat_FP[$i][$j] !=0){
              $ev = $mat_FP[$i][$j];
              $model = $j;
            }
          }
          if ($ev < 1) {
#             print FILE $mat_FP[$i][0]. " ". $ev." ".$model."\n";
          }
          $info .= $mat_FP[$i][0]. " ". $ev." ".$model."\n";
         }         
         &saveFile($file,  $info); 
        
}

############################ sub getTrueModel ##################################
sub getTruePositivesFound {
	my $sample		= $_[0];
	my $result_file		= $_[1];
        my $result_kind		= $_[2];
        my $pos_ev	= $_[3]; 
	#my $work_fold	= "hmmer";

	
	my $item_true_id;
	my $item_hmmer;
	my $count_true_positive_found	= 0;
	my $count_false_positive	= 0;
	my $found = "false";
        
       &readHmmerIds($result_file);
       
	
        my $count_total = 0;
	foreach $item_hmmer(@hmmer_ids){
		$count_total = 0;
                my @hmmer_info	= split(/\t/, $item_hmmer);
		foreach $item_true_id (@true_ids){	
			$count_total++;
                        #print $item_true_id. " ". $hmmer_info[4]. "\n";
			if ($item_true_id eq $hmmer_info[0] && $hmmer_info[1] eq $result_kind){
				&putMatTP($item_hmmer, $pos_ev);
				$count_true_positive_found++;
				$found = "true";	
			}
		}
                my $family = substr($hmmer_info[4],0,index($hmmer_info[4], " "));
                if ($hmmer_info[1] eq $result_kind){
                 # print $hmmer_info[1]. " $result_kind $found ". &getPattern(3, ".",$family). " " . &getPattern(3, ".", $sample)." \n";
                 }
                if ($found eq "false" &&  &getPattern(3, ".",$family) ne &getPattern(3, ".", $sample) && $hmmer_info[1] eq $result_kind){
			#print $hmmer_info[1]. " $result_kind  \n";
                        &putMatFP($item_hmmer, $pos_ev);
			$count_false_positive++;
		}
		$found = "false";
	}
       
         
  
      	#$count_false_positive = scalar(@hmmer_ids) - $count_true_positive_found;
	$info_statistics .= "$sample FP $count_false_positive TP $count_true_positive_found";	
	
}

##################################### sub readTrueIds ##################################
sub putMatTP {
   my $item	= $_[0]; 
   my $pos_ev	= $_[1]; 
   
   my @array = split(/\t/, $item);
   my $ind = -1;
    #print "antes". $rows_TP." ";
  for (my $i = 0; $i < $rows_TP; $i++){
       if ($mat_TP[$i][0] eq $array[0]){
         $ind = $i;
       }
     }
     if ($ind != -1){
        $mat_TP[$ind][$pos_ev] = $array[3];
     }  
     else{
       
       $mat_TP[$rows_TP][0] = 0;
       $mat_TP[$rows_TP][1] = 0;
       $mat_TP[$rows_TP][2] = 0;
       $mat_TP[$rows_TP][3] = 0;
       $mat_TP[$rows_TP][4] = 0;
       $mat_TP[$rows_TP][5] = 0;      
      
       $mat_TP[$rows_TP][0] = $array[0];
       $mat_TP[$rows_TP][$pos_ev] = $array[3];
       $rows_TP++;       
     }  
      #print "oi". $rows_TP." ".$array[0]. "  ". $array[4]. "\n";
} 
##################################### sub readTrueIds ##################################
sub putMatFP {
   my $item	= $_[0]; 
   my $pos_ev	= $_[1]; 
   
   my @array = split(/\t/, $item);
   my $ind = -1;
   # print "antes". $rows_FP." ";
  for (my $i = 0; $i < $rows_FP; $i++){
       if ($mat_FP[$i][0] eq $array[0]){
         $ind = $i;
       }
     }
     if ($ind != -1){
        $mat_FP[$ind][$pos_ev] = $array[3];
     }  
     else{
       
       $mat_FP[$rows_FP][0] = 0;
       $mat_FP[$rows_FP][1] = 0;
       $mat_FP[$rows_FP][2] = 0;
       $mat_FP[$rows_FP][3] = 0;
       $mat_FP[$rows_FP][4] = 0;
       $mat_FP[$rows_FP][5] = 0;
       
       
      
       $mat_FP[$rows_FP][0] = $array[0];
       $mat_FP[$rows_FP][$pos_ev] = $array[3];
       $rows_FP++;       
     }  
  #   print "oi". $rows_TP." ".$array[0]. "  ". $array[4]. "\n";

}

##################################### sub readTrueIds ##################################
sub readTrueIds {
		my $path	= $_[0];
                my $sample      = $_[1];
	
		my @lines_file = ();
		my $line;	
		my @align		= ();	
		my @true_positives = ();
	
		my %hash_seq	= ();
		my $value = "";
		if (open(FILESEQ,"$path")){
			@lines_file = <FILESEQ>;		
			foreach $line (@lines_file){
				@true_positives = split (/ +/, $line);
                                if ($true_positives[1] eq $sample){
                                  #print "homolog ".$true_positives[1]."\n"; 
				  push(@true_ids, $true_positives[0]);
                                  $hash_homol{$true_positives[0]} =$true_positives[1];
                                }
			}
                        close FILESEQ;
		}
		else{
			print "File $path not found!\n";
		}
}


##################################### sub readHmmerIds ##################################
sub readHmmerIds {
	my $path			= $_[0];
	print $path."\n";
	

	my $item;
	my	@hmmer_file = ();
	my	@hmmer_info = ();
	my $i;

	if (open(HMMERRESFILE,$path)){
		#&parserHmmerResults($path);
		
		@hmmer_file = <HMMERRESFILE>;
		$i = 0;
		foreach $item (@hmmer_file){
			push(@hmmer_ids, $item);
		}		
		close HMMERRESFILE;
		
	}
	else{
		print "ERROR : file $path not found\n";
	}
}

#################################### sub parserHmmerResults ##################################
sub parserHmmerResults {
		my $path			= $_[0];

		my $outfileName = $path.".parsed";

		my $maxEvalue = "10";
		my $minScore = "-100";

		unless (open(PARSEDFILE, ">$outfileName")) {
                print "Could not open file $outfileName !\n";
                exit;
      }
		my @datas = <PARSEDFILE>;
		if (scalar(@datas) == 0){
			 print "file empty $outfileName !\n";
                #exit;
		}

		my $in = new Bio::SearchIO(-format => 'hmmer', -file =>$path);

		my $result = $in->next_result;
		while (my $hit = $result->next_hit) {
			while (my $hsp = $hit->next_hsp ) {
	      	if ($hit->raw_score >= $minScore){
	  				if ($hit->significance <= $maxEvalue){
          			print PARSEDFILE $hit->name, " ",
			 			 $hsp->length('hit')," ",
						 $hit->raw_score," ",
						 $hit->significance," ",
						 $hit->description, "\n";
       			}
				}	
	 		}
		}
		close (PARSEDFILE);
}



############################ sub getPattern ##################################
sub getPattern {
	my $num 		= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}

############################ sub saveFile ###################################
sub saveFile {
	my $path 	= $_[0];
	my $info  	= $_[1];

	if (open(FILESEQ,">$path")){
		print FILESEQ $info;
		print "file $path was created\n";
	}
	else{
		print "file $path not found\n";
	}
	close FILESEQ;
}
