#!/usr/bin/perl -w
use strict;
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use File::Files;
use Scop::ScopPattern;
use String::StringUtil;


#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my @array_family        = ();
my $div                 = "3";

my $calib		= "yes";	
my $set_file		= "";
my $file_log		= "";
my $on_resume		= "no";

my $path_program  	= "";

my $kind_align		= "clustalw";
my $kind_calib		= "calibrated";	
my $work_fold		= "hmmer_atp";

my $ev_cutoff		= 0.01;

my @mat_hits		= ([],[]);

&getParameters;
&readParametersFile;
&main;
############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		}
	}
}
############################ sub readParametersFile #############################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}

	unless (open(SETFILE, "$set_file")) {
   		print "oiCould not open file $set_file !\n";
     		exit;
   	}
	#print "oi $set_file";
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";
	my $i;

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     		exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)> 1){
			#$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			$value = "";
			for ($i=1; $i<scalar(@array_settings); $i++){
				if (index($array_settings[$i],"\n") < 0){
					$value .=$array_settings[$i];
				}
				else{
					$value .= substr($array_settings[$i],0,index($array_settings[1],"\n"));
				}
				if ($i<scalar(@array_settings)-1){$value .=" ";}
			}
						
			if ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;
			}elsif ($array_settings[0] eq "p_on_resume"){
				$on_resume  = $value;
			}										
		}
	}	
	
	close SETFILE;
}
################################# sub main ######################################
sub main {
	my @families 		= ();
	my @family 		= ();
	my $entry		= "";
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir			= "";
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	print "\n";
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		if ($new_sample ne $old_sample){
			system ("date");
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&clearHmmPfamOut($new_sample,$dir); 
			system ("date");
		}
		$old_sample = $new_sample;					
	}
	system ("date");
	close FAMILYFILE;
}

############################ sub clearHmmPfamOut ##############################
sub clearHmmPfamOut {
	my $sample		= $_[0];
	my $dir			= $_[1];
	
	my $result_dir		= $dir.$sample."/result/$kind_align/$kind_calib/$work_fold/";
	my $result_file		= "hmmpfam_$sample.result";
	my $clear_file		= "hmmpfam_$sample.clear";
	
	my @results		= ();
	my $item 		= "";
	my $qtd_results		= 0;
	my $count		= 0;
	my $hit			= "false";
	
	my $ind_seq		= 0;
	my $ind_des		= 1;
	my $ind_model		= 2;
	my $ind_score		= 3;	
	my $ind_evalue		= 4;
	my $count_hits		= 0;
	my $sequence		= "";
	my $description		= "";
	
	my @array_aux		= ();
	my $info;
	
	if (open(FILEG,"$result_dir$result_file")){
		@results = <FILEG>;
		$qtd_results = scalar(@results);
		print $qtd_results . "\n";
		while ($count < $qtd_results){
			if ($results[$count]=~ /^Query sequence/){
				@array_aux = split(/:/,$results[$count]);
				if (scalar(@array_aux) == 2){
					$sequence = String->removeCaracter(substr($array_aux[1],0,index($array_aux[1],"\n"))," ");
				}
				else{
					print "Error bad format\n"; exit;
				}
			}
			elsif ($results[$count]=~ /^Description:/) {
				$description = substr($results[$count],index($results[$count],":")+1, length($results[$count]));
				$description = substr($description,0,index($description,"\n"));
				$description = String->trim($description);
			}elsif ($results[$count]=~ /^Model         Description/){
				$count +=2;
				if (index($results[$count],"no hits above thresholds") < 0){
					@array_aux = split(/ +/,$results[$count]);
					while (scalar(@array_aux) == 4){
						$mat_hits[$ind_seq][$count_hits] = $sequence;
						$mat_hits[$ind_des][$count_hits] = $description;
						$mat_hits[$ind_model][$count_hits] = $array_aux[0];
						$mat_hits[$ind_score][$count_hits] = $array_aux[1];
						$mat_hits[$ind_evalue][$count_hits] = $array_aux[2];
						$count++;$count_hits++;
						@array_aux = split(/ +/,$results[$count]);
					}	
				}
			}
			$count++;
		}
		$info = printMat(5,$count_hits);
		FilesIO->saveFile($result_dir.$clear_file,$info);		
		close FILEG;
	}	
	else{
		print "ERROR: file $result_dir$result_file not found\n";
	}	
}

############################ sub clearHmmPfamOut ##############################
sub printMat {
	my $cols	= $_[0];
	my $rows	= $_[1];
	
	my $seq_new 	= "";
	my $seq_old	= "";
	my $ev;
	my $info	= "";
	
	my $i = 0;
	my $j = 0;
	
	for ($i = 0; $i < $rows; $i++){
		$seq_new = $mat_hits[0][$i];
		$ev	 = $mat_hits[4][$i];
		
		if ($ev < $ev_cutoff) {
			for ($j = 0; $j < $cols; $j++){
				if ($seq_new ne $seq_old && $j==0){
					$info.= $mat_hits[0][$i]. "\t";
				}
				elsif ($j == 0){$info.= "\t\t\t";}
				else{
					$info.= $mat_hits[$j][$i]. "\t";
				}
			}
			$seq_old = $seq_new;
			$info.= "\n";
		}
	}
	return $info;
}