#!/usr/bin/perl -w
use strict;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";

&getParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}			
	}
}

############################ sub main ##################################
sub main {
	my @families 		= ();
	my @family 			= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       	print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&formatFile($new_sample,$dir); 
		}
		$old_sample = $new_sample;					
	}
	system ("date");
	close FAMILYFILE;
}

############################ sub formatFile #####################################
sub formatFile {
	my $sample	= $_[0];
	my $dir		= $_[1];
	my $info = "";

	$info = &formatAlnFile($dir.$sample."/alignment/".$sample."-FINAL.aln");
	&saveFile($dir.$sample."/alignment/".$sample."-FINAL.aln",$info);

	$info = &formatPdbFile($dir.$sample."/alignment/".$sample."-FINAL.pdb");
	&saveFile($dir.$sample."/alignment/".$sample."-FINAL.pdb",$info);
	

}
############################ sub readAlnFile #####################################
sub formatAlnFile {
		my $path	= $_[0];
	
		my @lines_file = ();
		my $line;
		my @align		= ();
		my $info_file = "";
		my $cabecalho_clustal = "CLUSTAL W (1.82) multiple sequence alignment\n";
		
		
		my $i = 0;
		if (open(FILEALN,"$path")){
			@lines_file = <FILEALN>;
			foreach $line (@lines_file){
				print $line;
				if ($i == 0){
						print "passou"; $i++;
						$info_file.=$cabecalho_clustal;
				}
				else{
					$info_file.=$line;
				}
			}
			close FILEALN;
		}
		else{
			print "File $path not found!\n";
		}
		return $info_file;
}
############################ sub formatPdbFile #####################################
sub formatPdbFile {
		my $path	= $_[0];
	
		my @lines_file = ();
		my $line;
		my @align		= ();
		my $info_file = "";
		my $tag = "REMARK";		
		
		my $i = 0;
		if (open(FILEALN,"$path")){
			@lines_file = <FILEALN>;
			foreach $line (@lines_file){
				
				if (index($line, $tag)>=0){
					if (index($line, "pdb")>=0){
							$info_file.=$line;
					}						
				}
				else{
					$info_file.=$line;
				}
			}
			close FILEALN;
		}
		else{
			print "File $path not found!\n";
		}
		return $info_file;
}
############################ sub saveFile ###################################
sub saveFile {
	my $path 	= $_[0];
	my $info  	= $_[1];

	if (open(FILESEQ,">$path")){
		print FILESEQ $info;
		print "file $path was created\n";
	}
	else{
		print "file $path not found\n";
	}
	close FILESEQ;
}
