#!/usr/bin/perl -w
use strict;
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use File::Files;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";

&getParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}			
	}
}
############################ sub main ##################################
sub main {
	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	print "\n";
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&formatFileToGroup($new_sample,$dir); 
		}
		$old_sample = $new_sample;					
	}
	system ("date");
	close FAMILYFILE;
}
############################ sub formatFileToGroup ################################
sub formatFileToGroup {
	my $sample		= $_[0];
	my $dir			= $_[1];
	my @gruop_ids_file	= ();
	my @gruop_ids		= ();
	my $item 		= "";
	my $info_file		= "";
	my $chain		= "";
	my $id_pdb		= "";
	my $group_id		= "";
	my $qtd_seq		= 0;
	
	my $dir_pdb = $dir . $sample."/pdb/";
	my $path    = $dir_pdb.$sample.".groups";
	
	if (open(FILEG,"$path")){
		#print $path;
		@gruop_ids_file = <FILEG>;
		#@gruop_ids = split(/\n/,$gruop_ids_file);
		foreach $item (@gruop_ids_file){
			@gruop_ids = split(/ +/, $item); 
			$qtd_seq = substr($gruop_ids[1],0,index($gruop_ids[1],"\n"));
			if ($qtd_seq >1){
				system ("date");
				&formatFile($sample,$dir,$gruop_ids[0]);
				system ("date");
			}
		}
		#&saveFile($dir_pdb.$sample.".pdb",$info_file);	
		close FILEG;
	}	
	else{
		print "ERROR: file $path not found\n";
	}	
}
############################ sub formatFile #####################################
sub formatFile {
	my $sample	= $_[0];
	my $dir		= $_[1];
	my $group_id	= $_[2];
	
	my $info = "";

	$info = &formatAlnFile($dir.$sample."/alignment/mammoth/".$group_id."-FINAL.aln");
	FilesIO->saveFile($dir.$sample."/alignment/mammoth/".$group_id."-FINAL.aln",$info);

	$info = &formatPdbFile($dir.$sample."/alignment/mammoth/".$group_id."-FINAL.pdb");
	FilesIO->saveFile($dir.$sample."/alignment/mammoth/".$group_id."-FINAL.pdb",$info);
	

}
############################ sub readAlnFile #####################################
sub formatAlnFile {
		my $path	= $_[0];
	
		my @lines_file  = ();
		my $line;
		my @align	= ();
		my $info_file   = "";
		my $cabecalho_clustal = "CLUSTAL W (1.82) multiple sequence alignment\n";
		
		
		my $i = 0;
		if (open(FILEALN,"$path")){
			@lines_file = <FILEALN>;
			foreach $line (@lines_file){
				#print $line;
				if ($i == 0){
                                  #print $line."\n";
                                   #if (index($line, $cabecalho_clustal) < 0){
				      $info_file.=$cabecalho_clustal."\n";
                                   #}
                                   $i++;
				}
				else{
					$info_file.=$line;
				}
			}
			close FILEALN;
		}
		else{
			print "File $path not found!\n";
		}
		return $info_file;
}
############################ sub formatPdbFile #####################################
sub formatPdbFile {
		my $path	= $_[0];
	
		my @lines_file = ();
		my $line;
		my @align		= ();
		my $info_file = "";
		my $tag = "REMARK";		
		
		my $i = 0;
		if (open(FILEALN,"$path")){
			@lines_file = <FILEALN>;
			foreach $line (@lines_file){
				
				if (index($line, $tag)>=0){
					if (index($line, "pdb")>=0){
							$info_file.=$line;
					}						
				}
				else{
					$info_file.=$line;
				}
			}
			close FILEALN;
		}
		else{
			print "File $path not found!\n";
		}
		return $info_file;
}
