#!/usr/bin/perl -w
use strict;

use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use File::Files;
use String::StringUtil;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";

my $home_mammoth 	= "/home/juliana/tese/desenvolvimento/mammoth/./mammothmult"; 

&getParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}			
	}
}

############################ sub main #####################################
sub main {
	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	print "\n";
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&clearMammothToGroup($new_sample,$dir); 
		}
		$old_sample = $new_sample;	
	}
	system ("date");
	close FAMILYFILE;

}
############################ sub clearMammothToGroup ################################
sub clearMammothToGroup {
	my $sample		= $_[0];
	my $dir			= $_[1];
	my @gruop_ids_file	= ();
	my @gruop_ids		= ();
	my $item;
	my $info_file		= "";
	my $chain		= "";
	my $id_pdb;
	my $group_id;
	
	my $dir_pdb = $dir . $sample."/pdb/";
	my $path    = $dir_pdb.$sample.".groups";
	
	if (open(FILEG,"$path")){
		@gruop_ids_file = <FILEG>;
		foreach $item(@gruop_ids_file){
			@gruop_ids = split(/ +/, $item); 
			system ("date");
			&clearMammothFiles($sample,$dir,$gruop_ids[0]);
			system ("date");
		}
		close FILEG;
	}	
	else{
		print "ERROR: file $path not found\n";
	}	
}

############################ sub clearMammothFiles ################################
sub clearMammothFiles {
	my $sample		= $_[0];
	my $dir			= $_[1];
	my $group_id		= $_[2];
	
	my $path = $dir.$sample."/pdb/".$group_id.".pdb";
	
	my @lines_file  = ();
	my $line;
	my @info_pdb	= ();
	my $info_file   = "";
	my $i = 0; 
	my $coord;
	my $info	= "";
	
	if (open(FILEALN,"$path")){
		print "$path\n";
		@lines_file = <FILEALN>;
		foreach $line (@lines_file){
			@info_pdb = split(/ +/, $line);
			if (scalar(@info_pdb) > 1){
				$coord = $info_pdb[6];
				$info = $line;
				if ($coord =~ /^[A-Z]/){
					$coord =~ s/[A-Z]//g;
					$info  = $info_pdb[0];
					$info .= String->gap(7  - length($info_pdb[1])) . $info_pdb[1];
					$info .= String->gap(4  - length($info_pdb[2])) . $info_pdb[2];
					$info .= String->gap(5  - length($info_pdb[3])) . $info_pdb[3];
					$info .= String->gap(2  - length($info_pdb[4])) . $info_pdb[4];
					$info .= String->gap(4  - length($info_pdb[5])) . $info_pdb[5];
					$info .= String->gap(12 - length($coord)) . $coord;
					$info .= String->gap(8  - length($info_pdb[7])) . $info_pdb[7];
					$info .= String->gap(8  - length($info_pdb[8])) . $info_pdb[8];
					$info .= String->gap(6  - length($info_pdb[9])) . $info_pdb[9];
					$info .= String->gap(7  - length($info_pdb[10])) . $info_pdb[10];
				}
				$info_file.= $info;
			}
			else{			
				$info_file.= $line;
			}
		}
		#print $info_file;
		FilesIO-> saveFile($path, $info_file);
		close FILEALN;
	}
	else{
		print "File $path not found!\n";
	}
	return $info_file;
}
