#!/usr/bin/perl -w
use strict;
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use File::Files;
use Scop::ScopPattern;


#Variaveis que comportam os parametros de entrada
my $in_file 			= "";
my @array_family                = ();
my $div                         = "3";

my $calib		= "yes";	
my $set_file		= "";
my $file_log		= "";
my $on_resume		= "no";

my $path_program  = "";

my $kind_align		= "clustalw";
my $kind_calib		= "calibrated";	
my $work_fold		= "hmmer_atp";

&getParameters;
&readParametersFile;
&main;
############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		}
	}
}
############################ sub readParametersFile #############################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}

	unless (open(SETFILE, "$set_file")) {
   		print "oiCould not open file $set_file !\n";
     		exit;
   	}
	#print "oi $set_file";
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";
	my $i;

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     		exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)> 1){
			#$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			$value = "";
			for ($i=1; $i<scalar(@array_settings); $i++){
				if (index($array_settings[$i],"\n") < 0){
					$value .=$array_settings[$i];
				}
				else{
					$value .= substr($array_settings[$i],0,index($array_settings[1],"\n"));
				}
				if ($i<scalar(@array_settings)-1){$value .=" ";}
			}
						
			if ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;
			}elsif ($array_settings[0] eq "p_on_resume"){
				$on_resume  = $value;
			}										
		}
	}	
	
	close SETFILE;
}
################################# sub main ######################################
sub main {
	my @families 		= ();
	my @family 		= ();
	my $entry		= "";
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir			= "";
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	print "\n";
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&concatModelsGroup($new_sample,$dir); 
		}
		$old_sample = $new_sample;					
	}
	system ("date");
	close FAMILYFILE;
}

############################ sub concatModelsGroup ##############################
sub concatModelsGroup {
	my $sample		= $_[0];
	my $dir			= $_[1];
	my @gruop_ids_file	= ();
	my @gruop_ids		= ();
	my $item 		= "";
	my $info_file		= "";
	my $chain		= "";
	my $id_pdb		= "";
	my $group_id		= "";
	my $qtd_seq		= 0;
	
	my $dir_pdb = $dir . $sample."/pdb/";
	my $path    = $dir_pdb.$sample.".groups";
	
	if (open(FILEG,"$path")){
		#print $path;
		@gruop_ids_file = <FILEG>;
		#@gruop_ids = split(/\n/,$gruop_ids_file);
		foreach $item (@gruop_ids_file){
			@gruop_ids = split(/ +/, $item); 
			$qtd_seq = substr($gruop_ids[1],0,index($gruop_ids[1],"\n"));
			if ($qtd_seq >1){
				system ("date");
				&concatModels($sample,$dir,$gruop_ids[0]);
				system ("date");
			}
		}
		#&saveFile($dir_pdb.$sample.".pdb",$info_file);	
		close FILEG;
	}	
	else{
		print "ERROR: file $path not found\n";
	}	
}

############################ sub concatModels ###################################
sub concatModels {
	my $sample		= $_[0];
	my $dir			= $_[1];
	my $group_id		= $_[2];

	my $model_file_name		= "hmmer_$group_id.hmm";
	my $dir_model			= $dir. $sample. "/models/$kind_align/$kind_calib/$work_fold/";
	my $model_total_file_name 	= "hmmer_$sample.hmm";
	
	my @array_file			= ();
	my $line			= "";
	my $info			= "";
	
	if (open(MODELFILE, $dir_model.$model_file_name)){
		@array_file = <MODELFILE>;
		foreach $line (@array_file){
			$info.= $line
		}
		#print $info;
		FilesIO->apendFile($dir_model.$model_total_file_name, $info);
	}
	else{
		print "ERROR: file $dir_model$model_file_name not found\n";
	}	
}


