#!/usr/bin/perl -w
use strict;
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use File::Files;

#Variaveis que comportam os parametros de entrada

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file		= "";
my $calib		= "yes";	
my $set_file		= "";
my $file_log		= "";
my $on_resume		= "no";

my $path_program  = "";

my $build_program	= "hmmbuild";
my $calibrate_program 	= "hmmcalibrate";
my $search_program 	= "hmmsearch";

my $kind_align		= "clustalw";
my $ext_align		= "";
my $ext_pdb		= "";
my $ext_mat		= "";
my $kind_calib		= "calibrated";	
my $work_fold		= "hmmer_atp";
my $parameters_build	= "";
my $parameters_search	= "";


my $linker_program	= "linker_Hmmer_PDB";
&getParameters;
&readParametersFile;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		}
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}

	unless (open(SETFILE, "$set_file")) {
   		print "oiCould not open file $set_file !\n";
     		exit;
   	}
	#print "oi $set_file";
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";
	my $i;

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     		exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)> 1){
			#$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			$value = "";
			for ($i=1; $i<scalar(@array_settings); $i++){
				if (index($array_settings[$i],"\n") < 0){
					$value .=$array_settings[$i];
				}
				else{
					$value .= substr($array_settings[$i],0,index($array_settings[1],"\n"));
				}
				if ($i<scalar(@array_settings)-1){$value .=" ";}
			}
						
			if ($array_settings[0] eq "p_path_program"){
				$path_program = $value;					
			}elsif ($array_settings[0] eq "p_build_program"){
				$build_program = $value;				
			}elsif ($array_settings[0] eq "p_calibrate_program"){
				$calibrate_program = $value;
			}elsif ($array_settings[0] eq "p_search_program"){
				$search_program = $value;
			}elsif ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;
			}elsif ($array_settings[0] eq "p_parameters_build"){
				$parameters_build = $value;
			}elsif ($array_settings[0] eq "p_parameters_search"){
				$parameters_search = $value;
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;
			}elsif ($array_settings[0] eq "p_ext_align"){
				$ext_align = $value;
			}elsif ($array_settings[0] eq "p_ext_pdb"){
				$ext_pdb = $value;
			}elsif ($array_settings[0] eq "p_ext_mat"){
				$ext_mat = $value;
			}elsif ($array_settings[0] eq "p_db"){
				$db_file = $value;
			}elsif ($array_settings[0] eq "p_calib"){
				$calib  = $value;
			}elsif ($array_settings[0] eq "p_file_log"){
				$file_log  = $value;
			}elsif ($array_settings[0] eq "p_on_resume"){
				$on_resume  = $value;
			}										
		}
	}	
	
	close SETFILE;
}

############################ sub main ##################################
sub main {
	my @families 		= ();
	my @family 		= ();
	my $entry		= "";
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir			= "";
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	print "\n";
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
                
               #print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;
			&concatHMMERStruct($new_sample,$dir); 
		}
		$old_sample = $new_sample;					
	}
	system ("date");
	close FAMILYFILE;
}
############################ sub runHMMERToGroup ################################
sub concatHMMERStruct {
	my $sample		= $_[0];
	my $dir			= $_[1];

	my @gruop_ids_file	= ();
	my @gruop_ids		= ();
	my $item 		= "";
	my $info_file		= "";
	my $chain		= "";
	my $id_pdb		= "";
	my $qtd_seq		= 0;
	
   my $path_model_cat = $dir. $sample. "/models/$kind_align/$kind_calib/$work_fold/hmmer_cat_$sample.hmm";
print $path_model_cat."\n";
	my $dir_hmmer_model	= $dir. $sample. "/models/$kind_align/$kind_calib/$work_fold/";
	my $model_file_name	= "hmmer_$sample";
	
   if (FilesIO->isFile($path_model_cat) eq "true"){
        FilesIO->removeFile($path_model_cat);
   }
   &concatHmm2d($dir_hmmer_model.$model_file_name,  $sample, $path_model_cat);
   &concatHmmAcc($dir_hmmer_model.$model_file_name, $sample, $path_model_cat);
   &concatHmmOiNumber($dir_hmmer_model.$model_file_name, $sample, $path_model_cat);
   &concatHmm3d($dir_hmmer_model.$model_file_name, $sample, $path_model_cat);
   &concatHmmer($dir_hmmer_model.$model_file_name, $sample, $path_model_cat); 
	
}

############################### sub runHmm2d ####################################
sub concatHmm2d {
	my $model_file_name	= $_[0];
	my $sample		= $_[1];
   my $path_model_cat	= $_[2];

	my $model_file_2d =  $model_file_name."_2d.hmm";
        my $line;
        my $info = "";
        
        if (FilesIO->isFile($model_file_2d) eq "true"){
           my @array_file = FilesIO->lineFileToArray($model_file_2d);
	   foreach $line (@array_file){
	    my @array_name = split(/ +/, $line);
             if (scalar(@array_name) == 2 && $array_name[0] eq "NAME") {
               $info.= "NAME  $sample"."_2d.hmm\n";
             }
             else{
	       $info.= $line;
             }
	   }
	   FilesIO->apendFile($path_model_cat, $info);
        }
        else{
          print "File oi $model_file_2d not found\n";
        }       
}

############################### sub runHmm2d ####################################
sub concatHmmAcc {
	my $model_file_name	= $_[0];
	my $sample		= $_[1];
        my $path_model_cat	= $_[2];

	my $model_file_acc =  $model_file_name."_acc.hmm";
        my $line;
        my $info = "";
        
        if (FilesIO->isFile($model_file_acc) eq "true"){
           my @array_file = FilesIO->lineFileToArray($model_file_acc);
	   foreach $line (@array_file){
	    my @array_name = split(/ +/, $line);
             if (scalar(@array_name) == 2 && $array_name[0] eq "NAME") {
               $info.= "NAME  $sample"."_acc.hmm\n";
             }
             else{
	       $info.= $line;
             }
	   }
	   FilesIO->apendFile($path_model_cat, $info);
        }
        else{
          print "File $model_file_acc not found\n";
        }       
}
############################### sub runHmm2d ####################################
sub concatHmmOiNumber {
	my $model_file_name	= $_[0];
	my $sample		= $_[1];
        my $path_model_cat	= $_[2];

	my $model_file_oi =  $model_file_name."_oi.hmm";
        my $line;
        my $info = "";
        
        if (FilesIO->isFile($model_file_oi) eq "true"){
           my @array_file = FilesIO->lineFileToArray($model_file_oi);
	   foreach $line (@array_file){
	    my @array_name = split(/ +/, $line);
             if (scalar(@array_name) == 2 && $array_name[0] eq "NAME") {
               $info.= "NAME  $sample"."_oi.hmm\n";
             }
             else{
	       $info.= $line;
             }
	   }
	   FilesIO->apendFile($path_model_cat, $info);
        }
        else{
          print "File $model_file_oi not found\n";
        }       
}
############################### sub runHmm2d ####################################
sub concatHmm3d {
	my $model_file_name	= $_[0];
	my $sample		= $_[1];
        my $path_model_cat	= $_[2];

	my $model_file =  $model_file_name."_3d.hmm";
        my $line;
        my $info = "";
        
        if (FilesIO->isFile($model_file) eq "true"){
           my @array_file = FilesIO->lineFileToArray($model_file);
	   foreach $line (@array_file){
	    my @array_name = split(/ +/, $line);
             if (scalar(@array_name) == 2 && $array_name[0] eq "NAME") {
               $info.= "NAME  $sample"."_3d.hmm\n";
             }
             else{
	       $info.= $line;
             }
	   }
	   FilesIO->apendFile($path_model_cat, $info);
        }
        else{
          print "File $model_file not found\n";
        }       
}
############################### sub runHmm2d ####################################
sub concatHmmer {
	my $model_file_name	= $_[0];
	my $sample		= $_[1];
        my $path_model_cat	= $_[2];

	my $model_file =  $model_file_name.".hmm";
        my $line;
        my $info = "";
        
        if (FilesIO->isFile($model_file) eq "true"){
           my @array_file = FilesIO->lineFileToArray($model_file);
	   foreach $line (@array_file){
             my @array_name = split(/ +/, $line);
             if (scalar(@array_name) == 2 && $array_name[0] eq "NAME") {
               $info.= "NAME  $sample.hmm\n";
             }
             else{
	       $info.= $line;
             }
	   }
	   FilesIO->apendFile($path_model_cat, $info);
        }
        else{
          print "File $model_file not found\n";
        }       
}
