#!/usr/bin/perl -w
use strict;


#Variaveis que comportam os parametros de entrada
my $in_file 		= "";

#Variaveis globais
my @array_family	= ();

&getParameters;
#&movePdbFiles;
&divideSup;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}			
	}
}
############################ sub movePdbFiles #####################################
sub movePdbFiles{
	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $dir;
	my $dir_old		= "";
	my $dir_new		= "";
	my $cmd			= "";
	my $pdb_file		= "";
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
    
    	@families = <FAMILYFILE>;	
	foreach $entry (@families) {
		@family = split(/ +/,$entry);
		$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
		if ($dir ne $dir_old){
			$dir_new = $dir."pdb_files/"; 
			mkdir ($dir_new);			
		}
		$pdb_file = $family[3].".pdb1".".gz";
		print $dir.$pdb_file."\n";
		if(open(PDBFILE,"$dir$pdb_file")){
			close PDBFILE;
			$cmd = "mv $dir$pdb_file  $dir_new$pdb_file";
			system($cmd);
			print $cmd."\n";
		}
		$dir_old = $dir;
	}
	&divideSuperFamily();
	
	close FAMILYFILE;
    
	
}

############################ sub divideSup #####################################
sub divideSup{
	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $pattern;
	my $pattern_old		= "";
	my $info		= "";
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
    
	@families = <FAMILYFILE>;	
	foreach $entry (@families) {
		@family = split(/ +/,$entry);
		$pattern = &getPattern(3, ".", $family[0]);
		if ($pattern_old eq $pattern){
			push(@array_family, $info);			
		}
		else{
			&divideSuperFamily();
			@array_family = ();
		}
		$info = "$family[0] $family[1] $family[2] $family[3] $family[4]";
		$pattern_old = $pattern;
	}
	&divideSuperFamily();
	
	close FAMILYFILE;
    
	
}

############################ sub getPattern ##################################
sub divideSuperFamily {
	my @family		= ();
	my $old_sample		= "";
	my $new_sample		= "";
	my $count		= 0;
	my $entry;
	my $name_file;
	my $dir;
	
	foreach $entry (@array_family) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;
			$name_file =  &getPattern(3, ".", $family[0])."seq";
			#&createFileFamily($new_sample,$name_file, $dir);
			#&createFilePdb($new_sample,$dir); 			
		}
		$old_sample = $new_sample;					
	}
}
############################ sub createFilePdb ################################
sub createFilePdb {
	my $sample		= $_[0];
	my $dir			= $_[2];
	
	my $entry;
	my @family		= ();
	my $info_file		= "";
	my $chain;
	my $file_seq;

	$dir = $dir.$sample."/"."pdb/";
	mkdir $dir;

	foreach $entry (@array_family) {
		@family	= split(/ +/,$entry);
		if ($family[0] ne $sample) {
			if (index($family[0],$info_file) < 0){
				$info_file .= $info_file . $family[3]. ":". $chain." ";		 			
			}
			
		}
	}
	$file_seq = $dir. "$sample.ids";
	unless (open(FILESEQ, ">$file_seq")) {
       		print "Could not open file $file_seq !\n";
        	#exit;
	}
	
	print "file $file_seq created\n";
	print FILESEQ $info_file;
	close FILESEQ;
	
}
############################ sub createFileFamily #############################
sub createFileFamily {
	my $sample		= $_[0];
	my $file			= $_[1];
	my $dir			= $_[2];
	my $entry;
	my $line;
	my $all;
	my $entry_file;
	my @array_file		= ();
	my @sequence_file	= ();
	my @family		= ();
	my $sequences		= "";
	my $sequence		= "";
	my $annotation		= "";
	my $info_file		= "";
	my $file_seq;

	$file = $dir . $file;
	

	unless (open(FILE, "$file")) {
       		print "Could not open file $file !\n";
        	exit;
	}
	@array_file = <FILE>;
	
	foreach $line (@array_file) {
		if ($line ne "\n"){
			$all .= $line
		}        	
	}
	$dir = $dir.$sample."/";
	mkdir $dir;
	$dir = $dir."sequence/";
	mkdir $dir;
	
	
	$file_seq = $dir.$sample."/"."sequence/";

	@sequence_file = split (/>/, $all);
	
	foreach $entry_file (@sequence_file) {
		if( $entry_file	=~ /(.+)\n((.+\n)+)/ ) {
	       		$annotation 	= $1;
        		$sequence 	= $2;
			if (index ($annotation, $sample) < 0) {	
				$info_file = $info_file . ">". $annotation ."\n". $sequence  ."\n";
			}
		}
	}
	$file_seq = $dir. $sample.".seq";
	unless (open(FILESEQ, ">$file_seq")) {
       		print "Could not open file $file_seq !\n";
        	exit;
	}
	print "file $file_seq created\n";
	print FILESEQ $info_file;
	close FILESEQ;
	close FILE;	
}

############################ sub getPattern ##################################
sub getPattern {
	my $num 		= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}

############################ sub getCaracter ###################################
sub getCaracter{
	my $word 	= $_[0];
	my $caracter	= $_[1];

	my $indice;
	$indice = index($word, $caracter);
	
	if ($indice > 0 ){
		return substr($word, 0, $indice);
	}
	return $word;
	
}
