#!/usr/bin/perl -w
use strict;

#Variaveis que comportam os parametros de entrada
my $in_dir 		= "";
my $file_scop 		= "";
my $file_scop_pdb	= "";
my $dir_log		= "";

#Variaveis globais
my @list_resume;
my $resume_file;
my $log_file;
my $resume = "";

&getParameters();
$resume_file = $dir_log."success.log";
$log_file = $dir_log."pdbLoad.log";

unless (open(LOGFILE, ">>$log_file")) {
    exit;
}


&check_resume();
&load_files_pdb();

close LOGFILE;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-tb_scop"){
			$file_scop = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-tb_scop_pdb"){
			$file_scop_pdb = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-dir_log"){
			$dir_log = $ARGV[$counter+1];		
		}
	}
}
############################ sub check_resume  ##################################
sub check_resume{
    
  if (!open(RESUMEFILE, "$resume_file")) {
       	$resume = "off";	
  }
  else{
    @list_resume = <RESUMEFILE>;
    $resume = "on";
    close RESUMEFILE;
  }
}

############################ sub load_file_pdb ##################################
sub load_file_pdb{
    my $file_name 	= $_[0];
    my $dir_out		= $_[1];
    
    my $path =  $dir_out. "/". $file_name;
    my $cmd = "wget -d --no-http-keep-alive --ignore-length ftp://ftp.rcsb.org/pub/pdb/data/biounit/coordinates/all/$file_name -O $path";
    print $cmd;
    my $out;
    #chdir($dir_out);
    $out = system($cmd);
    if (index($out, "No such file") >= 0){
	print LOGFILE "No such file ".$file_name. "\n";   
    }
    else{
	print LOGFILE "loaded ".$file_name. "\n";   
    }    
}

############################ sub load_files_pdb ##################################
sub load_files_pdb{
    my @scop_pdb	= ();
    my @scop		= ();
    my @entries_scop_pdb= ();
    my @entries_scop	= ();
    my $line;
    my $all		= "";
    my $entry;
    my $accession_scop 	= "";
    my $accession_pdb 	= "";
    my $chain = "";
    my $id_family;
    my %table_scop;
    my $last_pdb;
    
    if ($resume eq "on"){
	$last_pdb = $list_resume[scalar @list_resume -1]; 
    }
     #read resume file
    unless (open(RESUMEFILE, ">>$resume_file")) {
       		print "Could not open file $resume_file !\n";
        	exit;
    }
    
    #read scop table file
    unless (open(SCOPFILE, "$file_scop")) {
       		print "Could not open file $file_scop !\n";
        	exit;
    }
    
    @scop = <SCOPFILE>;
    
     foreach $entry (@scop) {
	@entries_scop	= split(/ +/,$entry);
	$table_scop{$entries_scop[0]} = $entries_scop[2];
     }
    
    #read scop_pdb table file
    unless (open(SCOPPDBFILE, "$file_scop_pdb")) {
       		print "Could not open file $file_scop_pdb !\n";
        	exit;
    }
    
    @scop_pdb 	= <SCOPPDBFILE>;
    
    foreach $entry (@scop_pdb) {
	 @entries_scop_pdb	= split(/\t/,$entry);
	unless ($entries_scop_pdb[0] =~/^#/){
	    $accession_scop	= $entries_scop_pdb[0];
	    $accession_pdb 	= $entries_scop_pdb[1];
	    $chain 		= $entries_scop_pdb[2];
	    $id_family		= $entries_scop_pdb[3];
	   # if (($resume eq "on") && ($last_pdb eq $accession_pdb)){
	#	$resume = "off";
	   # }
	   # else{
		if (exists $table_scop{$accession_scop}){
		    my $dir = substr($table_scop{$accession_scop},0,index($table_scop{$accession_scop}, "\n"));
		    if (open(PDBFILE,$dir."/".$accession_pdb.".pdb1.gz")){
			#&load_file_pdb($accession_pdb.".pdb1.gz",$dir);
			print "$id_family  $accession_scop $chain  $accession_pdb $table_scop{$accession_scop}";
			
		    }
		    close PDBFILE;		    
		    print RESUMEFILE "$accession_pdb\n";		    
		}
		else{
		    #print "Not found $id_family  $accession_scop  $accession_pdb  \n";
		}
	    #}
	    
	}	
    }
  
    close SCOPFILE;
    close SCOPPDBFILE;
    close RESUMEFILE;

}
