#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}


use Database::ScopPattern;

my $PROG_NAME = "perlLib::format::formatDatabase::";

my $databaseIn = "";
my $databaseOut = "";
my $verbose = "false";
my $kindDB = "scop";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-databaseIn"){
			$databaseIn = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-databaseOut"){
			$databaseOut = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-kindDB"){
			$kindDB = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEmpty($databaseIn, $PROG_NAME. "::ERROR::Parameter -databaseIn having database in FASTA format is required");
	FilesIO->checkFile($databaseIn, $PROG_NAME."::ERROR::File $databaseIn NOT found!");
	print "-databaseIn = $databaseIn\n";
	
	String->isEmpty($databaseOut, $PROG_NAME. "::ERROR::Parameter -databaseOut having database in FASTA format is required");
	print "-databaseOut = $databaseOut\n";
	
	String->isEqual($verbose,"true,false",$PROG_NAME. "::ERROR::Parameter -verbose must be true or false!");
	print "-verbose = $verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	if ($kindDB eq "scop"){
		ScopPattern->clearDatabase($databaseIn, $databaseOut, $verbose);
	}else{
		print $PROG_NAME."::Only scop for now\n";
	}
	
}
	