#!/usr/bin/perl -w
use strict;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";

my %hash_new_aln	= ();

&getParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}			
	}
}

############################ sub main ##################################
sub main {
	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       	print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&formatFile($new_sample,$dir); 
		}
		$old_sample = $new_sample;					
	}
	system ("date");
	close FAMILYFILE;
}
############################ sub formatFile #####################################
sub formatFile{
	my $sample	= $_[0];
	my $dir		= $_[1];

	my %hash_aln		= &readAlnFile($dir.$sample."/alignment/".$sample."-FINAL.aln");
	my %hash_seq		= &readSeqFile($dir.$sample."/sequence/".$sample.".seq");

	
	my $key_aln;
	my $value_aln;
	my $key_seq;
	my $value_seq;
	my $info_file_aln;
	my $info_file_pdb;
	my $count_seq_aln = 0;
	my $count_seq = 0;
	my $found = "false";
	
	while (($key_aln, $value_aln) = each(%hash_aln)){
		$count_seq = 0;
		while (($key_seq, $value_seq) = each(%hash_seq)){
				if (index(uc $value_seq,uc $value_aln) >= 0 || index(uc $value_aln,uc $value_seq) >= 0){
					#print $key_seq ." -- ". $key_aln ."\n";
					$hash_new_aln{$key_aln} = $key_seq;
					$found = "true";
				}	
				$count_seq++;		
		}
		if ($found eq "false"){
			print $key_aln ." -- ". $value_aln ."\n";
		}
		$found = "false";
		$count_seq_aln++;	
	}
	print "\n numseqaln $count_seq_aln nunseq $count_seq\n";
	$info_file_aln =	&writeAlnFile($dir.$sample."/alignment/".$sample."-FINAL.aln");
	$info_file_pdb = &writePdbFile($dir.$sample."/alignment/".$sample."-FINAL.pdb");
	&saveFile($dir.$sample."/alignment/".$sample."-FINAL.aln", $info_file_aln);
	&saveFile($dir.$sample."/alignment/".$sample."-FINAL.pdb", $info_file_pdb);
	%hash_new_aln	= ();
	     				
}
############################ sub writePdbFile #####################################
sub writePdbFile{
		my $path	= $_[0];

		my $key_aln;
		my $key_seq;
		my $line;
		my @lines_file	= ();
		my @align 		= ();
		my $info_file 	= "";
		my $tag	=	"REMARK";

		if (open(FILEALN,"$path")){
			@lines_file = <FILEALN>;
			close FILEALN;
		}

		foreach $line (@lines_file){
				if (index($line, $tag) >=0){
					@align = split(/ +/,$line);
					if ((scalar(@align) > 1) && (index($align[1],"pdb"))>=0){
						if ($align[0] ne "" && $align[1] ne ""){
							while (($key_aln, $key_seq) = each(%hash_new_aln)){
								if ($key_aln eq  $align[1]){
										#print  $tag ." ". $key_seq."\n";
										$info_file .=  $tag ." ". $key_seq."\n";
								}
							}
						}					
					}
					else{
						#$info_file.= $line;
					}
				}
				else{
						$info_file.= $line;
				}
		}
		return $info_file;		
}
############################ sub readAlnFile #####################################
sub writeAlnFile{
		my $path	= $_[0];

		my $key_aln;
		my $key_seq;
		my $line;
		my @lines_file	= ();
		my @align 		= ();
		my $cabecalho_clustal = "CLUSTAL W (1.82) multiple sequence alignment\n";
		my $info_file 	= $cabecalho_clustal;

		if (open(FILEALN,"$path")){
			@lines_file = <FILEALN>;
			close FILEALN;
		}

		foreach $line (@lines_file){
				@align = split(/ +/,$line);
				if (scalar(@align) ==2){
					if ($align[0] ne "" && $align[1] ne ""){
						while (($key_aln, $key_seq) = each(%hash_new_aln)){
							if ($key_aln eq  $align[0]){
								$info_file .=  $key_seq ."          ". $align[1];
							}
						}
					}					
				}
				else{
						$info_file.= "\n";
				}
		}
		return $info_file;		
}
############################ sub readAlnFile #####################################
sub readAlnFile{
		my $path	= $_[0];
	
		my @lines_file = ();
		my $line;
		my @align		= ();
		my %hash_aln	= ();
		my $value = "";
		my $i = 0;
		if (open(FILEALN,"$path")){
			@lines_file = <FILEALN>;
			foreach $line (@lines_file){
				#print "$line\n";
				@align = split(/ +/,$line);
				if (scalar(@align) ==2){
					if ($align[0] ne "" && $align[1] ne ""){
						$value = 	$hash_aln{$align[0]};
						if ($value){
							$hash_aln{$align[0]} = $value. &removeCaracter(substr($align[1],0,index($align[1],"\n")),"-");				
						}
						else{
							$hash_aln{$align[0]} = &removeCaracter(substr($align[1],0,index($align[1],"\n")),"-");       				
						}
					}
				}
			}
			close FILEALN;
		}
		else{
			print "File $path not found!\n";
		}
		return %hash_aln;
}
############################ sub readAlnFile #####################################
sub readSeqFile{
		my $path	= $_[0];
	
		my @lines_file = ();
		my $line;
		my $accession;
		my $acc_family;
		my $sequence;
		my $annotation;
		my @align		= ();
		my @names		= ();
		my $all		= ();
		my %hash_seq	= ();
		my $value = "";
		if (open(FILESEQ,"$path")){
			@lines_file = <FILESEQ>;
		
			foreach $line (@lines_file) {
      		  	$all .= $line
			}
			@lines_file = split (/>/, $all);
			foreach $line (@lines_file){
				$line 		=~ /(.+)\n((.+\n)+)/;
       			$annotation 	= $1;
        			$sequence 	= $2;
				if ($annotation){
					@names 		= split(/ +/,$annotation);
					$accession 	= $names[0];
					$acc_family 	= $names[1];
					$hash_seq{$accession} = &removeCaracter($sequence,"\n");					
				}				
			}
			close FILESEQ;
		}
		else{
			print "File $path not found!\n";
		}
		return %hash_seq;
}


############################ sub removeCaracter ###################################
sub removeCaracter{
	my $word 	= $_[0];
	my $car 	= $_[1];
	
	my $new_word = "";
	my $i;
	for($i = 0 ; $i < length($word) ; $i++){
		if (substr($word,$i,1) ne $car){
			$new_word = $new_word.substr($word,$i,1);
		}
	}
	return $new_word;
}
############################ sub saveFile ###################################
sub saveFile{
	my $path 	= $_[0];
	my $info  	= $_[1];

	if (open(FILESEQ,">$path")){
		print FILESEQ $info;
		print "file $path was created\n";
	}
	else{
		print "file $path not found\n";
	}
	close FILESEQ;
}
