#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;


my $file	= "";
my $sepOld = "";
my $sepNew  = "";
my $verbose			= "false";
my $outputFile			= "";
my $beforeLine = ""; 
my $afterLine = ""; 

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-file"){
			$file = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-sepOld"){
			$sepOld = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-sepNew"){
			$sepNew = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-beforeLine"){
			$beforeLine = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-afterLine"){
			$afterLine = $ARGV[$counter+1];		
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters\n";
	
	if ($file eq ""){
		print "ERROR::prepareListDataSet:: Parameter -file having file is required!\n";
		exit;
	}
	if (FilesIO->isFile($file) eq "false"){
		print "ERROR::prepareListDataSet:: $file is NOT a File !\n";
		exit;
	}
	
	print "-file = $file\n";
	
	if ($sepOld eq ""){
		print "ERROR::prepareListDataSet:: Parameter -sepOld having old separator required!\n";
		exit;
	}
	print "-sepOld = $sepOld\n";
	
	if ($sepNew eq ""){
		print "ERROR::prepareListDataSet:: Parameter -sepNew having new separator required!\n";
		exit;
	}
	if ($sepNew eq "tab"){
		$sepNew = "\t";
	}
	print "-sepNew = $sepNew\n";	

	if ($outputFile eq ""){
		print "ERROR::$PROG_NAME:: Parameter -outputFile having a output file is required!\n";
		exit;
	}
	print "-outputFile = $outputFile\n";	
	
	if ($verbose ne "true" && $verbose ne "false"){
		print "ERROR::prepareListDataSet:: Parameter -verbose must be true or false!\n";
		exit;
	}	
	
	print "-verbose = $verbose\n";	
print "-beforeLine = $beforeLine\n";

	if ($afterLine eq "end"){
		$afterLine = "\n";
	}
	print "-afterLine = $afterLine\n";
	
	print "ok\n";
}	

################################### sub main #####################################
sub main {
	my $info	= "";	
	my $line =  FilesIO->lineFileToString($file);
	my @array_line = split(/$sepOld/, $line);
	my $size = scalar(@array_line);
	my $count = 0;
	my $entry;
	
	if ($beforeLine ne ""){
		$info = $beforeLine.$sepNew;
	} 

	foreach $entry (@array_line) {		
		$count++;
		$info .= $entry;
		if ($count != $size){
			$info .= $sepNew;
		}		
	}
	
	if ($afterLine ne ""){
		$info .= $afterLine;
	} 

	if ($info ne ""){
		FilesIO->saveFile($outputFile, $info, $verbose);	
	}else{
		print "ERROR::prepareListDataSet:: $file has a format invalid\n";
		exit;
	}
}

