#!/usr/bin/perl -w
use strict;

use strict;
use lib "/home/instalations/bioInformatics/bioperl-1.5.0/";
use Bio::SearchIO;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $div				= "";

&getParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-div"){
			$div= $ARGV[$counter+1];		
		} 			
	}
}

#################################### sub main ##################################
sub main {

	my @families 		= ();
	my @family 			= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       	print "Could not open file $in_file !\n";
        	exit;
    }
	@families = <FAMILYFILE>;
	
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&getSequences($new_sample,$dir); 
		}
		$old_sample = $new_sample;					
	}
	close FAMILYFILE;
}

############################ sub getSequences ##################################
sub getSequences{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my %hash_aln =	();

	my $dir_sequence 	=  $dir.$sample."/sequence/";
	my $dir_aln	  		=  $dir. $sample. "/alignment/mammoth/";
	my $aln_file_name =  $sample."-FINAL.aln";
	my $seq_file_name =  $sample.".clustal";

	my $item; my $value; my $key_aln;my $value_aln;
	my $tag_clustal = "CLUSTAL";
	my $info_file   = "";

	my @aln_file		= ();			
	my @aln_info		= ();

	if (open(ALNFILE,$dir_aln.$aln_file_name)){
		@aln_file = <ALNFILE>;
		foreach $item (@aln_file){
			if (index($item,$tag_clustal)< 0){
				@aln_info = split(/ +/,$item);
				if (scalar(@aln_info) >1){
					if (index($aln_info[0],"pdb") >= 0 ){ 		
						$value = 	$hash_aln{$aln_info[0]};
						if ($value){
							$hash_aln{$aln_info[0]} = $value. &removeCaracter(substr($aln_info[1],0,index($aln_info[1],"\n")),"-");				
						}
						else{
							$hash_aln{$aln_info[0]} = &removeCaracter(substr($aln_info[1],0,index($aln_info[1],"\n")),"-");       				
						}
					}						
				}
			}
		}
		
		while (($key_aln, $value_aln) = each(%hash_aln)){
				#print $key_aln."oi\n".$value_aln."oi\n" ;
				$value_aln = &divideSequence($value_aln);
				$hash_aln{$key_aln} = $value_aln;
		}
		
		while (($key_aln, $value_aln) = each(%hash_aln)){
				$info_file.=">".$key_aln."\n".$value_aln."\n\n" ;				
		}
		#print $info_file;
		&saveFile($dir_sequence.$seq_file_name, $info_file);
		close ALNFILE;
	}
	else{
		print "the file $dir_aln$aln_file_name not found";
	}
}

############################ sub removeCaracter ###################################
sub divideSequence{
	my $sequence 	= $_[0];
	
	my @seqs = split(//,$sequence);
	my $i = 0;
	my $info = "";

	for ($i = 1; $i <= scalar(@seqs); $i++){
		$info .= $seqs[$i-1];
		if ($i % $div == 0){
			$info .= "\n"			
		}
	}
	return $info;

}

############################ sub removeCaracter ###################################
sub removeCaracter{
	my $word 	= $_[0];
	my $car 	= $_[1];
	
	my $new_word = "";
	my $i;
	for($i = 0 ; $i < length($word) ; $i++){
		if (substr($word,$i,1) ne $car){
			$new_word = $new_word.substr($word,$i,1);
		}
	}
	return $new_word;
}

############################ sub saveFile ###################################
sub saveFile{
	my $path 	= $_[0];
	my $info  	= $_[1];

	if (open(FILESEQ,">$path")){
		print FILESEQ $info;
		print "file $path was created\n";
	}
	else{
		print "file $path not found\n";
	}
	close FILESEQ;
}
