#!/usr/bin/perl -w
use strict;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";

&getParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}			
	}
}

############################ sub main ################################
sub main{
	my @families 		= ();
	my @family 			= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&createFileTo3dcoffee($new_sample,$dir); 
		}
		$old_sample = $new_sample;					
	}

	close FAMILYFILE;
}

############################ sub preparePdbFiles ################################
sub createFileTo3dcoffee{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $pdb_ids_file	= ();
	my @pdb_ids			= ();
	my $item;
	my $info_file		= "";
	my $chain			= "";
	my $id_pdb;

	my $dir_pdb_files 		= $dir."pdb_files/";
	my $path_sample_pdb_ids = $dir. $sample."/pdb/".$sample.".ids";
	print $path_sample_pdb_ids."\n";

	#print $path ."\n";
	if (open(FILESEQ, "$path_sample_pdb_ids")) {
   	$pdb_ids_file = <FILESEQ>;
		@pdb_ids = split(/ +/,$pdb_ids_file);
		foreach $item (@pdb_ids){
			$chain  = substr($item, index($item,":") +1, length($item)-1);
			$id_pdb = substr($item, 0, index($item,":"));
			print $chain . " ".$id_pdb."\n";
			&clearFilePdb($dir,"pdb_files/", $id_pdb,$chain, $sample);			
		}
	}
	#&saveFile($dir_pdb.$sample.".pdb",$info_file);		
	close FILESEQ;
}

############################ sub clearFilePdb ###################################
sub clearFilePdb{
	my $dir_geral  	= $_[0];
	my $dir_pdb			= $_[1];
	my $id_pdb 			= $_[2];
	my $chain			= $_[3];
	my $sample			= $_[4];
	
	my @pdb_file			= ();
	my @coord				= ();	
	my @chains				= ();
	my @info_chains		= ();
	my @info_sub_chains	= ();
	my $line;
	my $info_pdb			= "";
	my $info_file			= "";
	my @low_limite			= ();
	my @high_limite 		= ();
	my @limits				= ();
	my $index_caracter;
	my $new_count			= 0;
	my $old_count			= -1;
	my $i						= 0;

	@info_chains = split(/,/,$chain); #divide as subcadeias
   foreach $line (@info_chains){
		if (index($line,":") >= 0){
			@info_sub_chains = split(/:/,$line);
			$chains[$i] = $info_sub_chains[0];
			print "chain $i".$chains[$i]."\n";
			if (scalar(@info_sub_chains) > 1){
				@limits = split(/-/,$info_sub_chains[1]);
				$index_caracter = index($info_sub_chains[1], "-");
				$low_limite[$i]	 = $limits[0];#substr($info_sub_chains[1], 0 , $index_caracter);
				print "1 low  $i ".$low_limite[$i]."\n";
				$high_limite[$i] = $limits[1];#substr($info_sub_chains[1], $index_caracter+1, length($info_sub_chains[1])-1);
				print "1 high $i ".$high_limite[$i]."\n";
			}
			else{
				$low_limite[$i] = 0;
				$high_limite[$i] = 0;
			}
		}
		else{
			@info_sub_chains = split(/-/,$line);
			$chains[$i] = "-";
			print "chain $i".$chains[$i]."\n";
			if (scalar(@info_sub_chains) > 1){
				$low_limite[$i]	= $info_sub_chains[0];
				$high_limite[$i] 	= $info_sub_chains[1];
				print "2 low  $i ".$low_limite[$i]."\n";
				print "2 high $i ".$high_limite[$i]."\n";
			}
			else{
				$low_limite[$i] = 0;
				$high_limite[$i] = 0;
			}			
		}
		$i = $i + 1;		
	}

	$i = 0;
	print "path ".$dir_geral.$dir_pdb."pdb".$id_pdb.".ent"."\n";
	if (open(FILESEQ, $dir_geral.$dir_pdb."pdb".$id_pdb.".ent")) {
		@pdb_file = <FILESEQ>;
		foreach $line (@pdb_file){
			if ($line =~ /^ATOM/){
				@coord = split(/ +/, $line);
				@coord = &moveCoord($line);
				#print $coord[4]." ".$coord[2]. " $i ".$chains[$i]."\n";
				#print $coord[4]." ".$coord[2]. " $i ".$chains[$i]."\n";
				if ((($coord[4] eq $chains[$i]) || ($chains[$i] eq "-") ) && ($coord[2] eq "CA")){
					$new_count = $coord[5];
					if ($new_count >= $old_count){
						if ($low_limite[$i] == 0 && $high_limite[$i] ==0){
							$info_file .= $line;
							#print "1 $info_file\n";
						}
						else{
							if ($coord[5]>=$low_limite[$i] && $coord[5]<= $high_limite[$i]){
								$info_file .= $line;
								#print "2 $info_file\n";
							}
							else{
								if ($coord[5] > $high_limite[$i] && $i < scalar(@high_limite)-1){
									$i = $i + 1;
								}
							}						
						}
						$info_pdb  = "";
						$old_count = $new_count;
					}
				}		
			}
			else {
				if (index($line,"TER") < 0){
					$info_file .= $line;
				}
			} 
		} #for
		&saveFile($dir_geral.$sample."/pdb/".$id_pdb.".pdb",$info_file);	
		#print $info_file; 
	} #if
	close FILESEQ;
}

############################ sub moveCoord ###################################
sub moveCoord{
	my $line	= $_[0];

	my @coord = ();
	
	$coord[0] = substr($line, 0 , 4);
	$coord[1] = &removeCaracter(substr($line, 4 , 7)," ");
	$coord[2] = &removeCaracter(substr($line, 11 , 6)," ");
	$coord[3] = &removeCaracter(substr($line, 17 , 3)," ");
	$coord[4] = &removeCaracter(substr($line, 20 , 2)," ");
	$coord[5] = &removeCaracter(substr($line, 22 , 4)," ");
	$coord[6] = &removeCaracter(substr($line, 26 , 12)," ");
	$coord[7] = &removeCaracter(substr($line, 38 , 8)," ");
	$coord[8] = &removeCaracter(substr($line, 46 , 8)," ");
	$coord[9] = &removeCaracter(substr($line, 54 , 6)," ");
	$coord[10] = &removeCaracter(substr($line, 60 , 6)," ");
	return @coord;	
}
############################ sub getCaracter ###################################
sub removeCaracter{
	my $word 	= $_[0];
	my $car 	= $_[1];
	
	my $new_word = "";
	my $i;
	for($i = 0 ; $i < length($word) ; $i++){
		if (substr($word,$i,1) ne $car){
			$new_word = $new_word.substr($word,$i,1);
		}
	}
	return $new_word;
}

############################ sub saveFile ###################################
sub saveFile{
	my $path 	= $_[0];
	my $info	= $_[1];

	if (open(FILEPDB, ">$path ")){
       		print FILEPDB $info;
		print "file $path created\n";       	
    	}
	else {
		print "Could not open file $path !\n";
	}
}
