#!/usr/bin/perl -w
use strict;


#Variaveis que comportam os parametros de entrada
my $in_file 		= "";

&getParameters;
&preparePdb;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}			
	}
}

############################ sub preparePdb #####################################
sub preparePdb{
	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $dir;
	my $name_file;
	my $old_name;
	my $new_name;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
    
    	@families = <FAMILYFILE>;
	foreach $entry (@families) {
		@family = split(/ +/,$entry);
		$dir = substr($family[4],0,index($family[4],"\n")). "/pdb_files/" ;
		$name_file = $family[3].".pdb1.gz";
		$old_name = $dir.$family[3].".pdb1";
		$new_name = $dir."pdb".$family[3].".ent";
		&unZipFile($dir, $name_file);
		&renameFile($old_name, $new_name);	
	}	
	close FAMILYFILE;		
}
############################ sub renameFile ##################################
sub renameFile{
	my $old_name	= $_[0];
	my $new_name	= $_[1];

	my $cmd = "mv $old_name $new_name";
 	if (open(PDBFILE,$old_name)){
		close PDBFILE;		
		system ($cmd);
		print $cmd ."\n";			
	}
	else{
		print "file $old_name not found \n";
	}
}
############################ sub unZipFile ##################################
sub unZipFile{
	my $dir 	= $_[0];
	my $name_file	= $_[1];

	my $path = $dir.$name_file;
	my $cmd = "gunzip $path";

 	if (open(PDBFILE,$path)){
		close PDBFILE;
		system ($cmd);
		print $cmd ."\n";			
	}
	else{
		print "file $path not found \n";
	}
}
############################ sub getPattern ##################################
sub getPattern {
	my $num 	= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}
