#!/usr/bin/perl -w
use strict;

#Variaveis que comportam os parametros de entrada
my $div 	= "";
my $dbin 	= "";
my $out_dir 	= "";


&getParameters();
my $log_file	= $out_dir . "log.txt";
my $info_file	= $out_dir . "info_family.txt";
&dividDatabase();
#&removeFamily();
exit;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-dbin"){
			$dbin = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-div"){
			$div = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outdir"){
			$out_dir = $ARGV[$counter+1];		
		}
	}
}

############################ sub dividDatabase ##################################
sub dividDatabase {
	my @dbfile	= ();
	my @entries	= ();
	my $entry;
	my $all		= "";
	my $line;
	my $accession;
	my $acc_family;
	my $annotation;
	my $sequence;
	my $pattern;
	my $pattern_old	= "";
	my $families 	= "";
	my $count_seq 	= 0 ;
	my $info	= "";
	

	unless (open(DBFILE, "$dbin")) {
       		print "Could not open file $dbin !\n";
        	exit;
	}
	
	open(LOGFILE, ">$log_file") or die ("Could not create file $log_file !\n");
	open(INFOFILE, ">$info_file") or die ("Could not create file $log_file !\n");

	@dbfile = <DBFILE>;
 
	foreach $line (@dbfile) {
        	$all .= $line
	}
 
	@entries = split (/>/, $all);(my $e,@entries) = @entries;
	my @names = ();
	
	print LOGFILE "Log file to unjoin  families \n";
	foreach $entry (@entries) {
		chdir($out_dir);
		$count_seq 	= $count_seq + 1; 
 		$entry 		=~ /(.+)\n((.+\n)+)/;
       		$accession 	= "";
        	$annotation 	= $1;
        	$sequence 	= $2;
		@names 		= split(/ +/,$annotation);
		$accession 	= $names[0];
		$acc_family 	= $names[1];
		
		$pattern = &getPattern($div, ".", $acc_family);
		$info =  $info . $accession. " ".$acc_family. " ".$out_dir.$pattern. "\n";
		if ($pattern_old ne $pattern){
			if ($pattern_old ne ""){
				if ($count_seq >20){
					mkdir($pattern_old);
					chdir($pattern_old);
					print LOGFILE "family $pattern_old sequences $count_seq\n";
					print INFOFILE "$info";
					&saveFile($pattern_old."seq", $families);
				}
				$families 	= "";
				$count_seq 	= 0;
				$info		= "";
			}
			$pattern_old = $pattern;
		}
		else {
			$families	=  $families . ">". $entry."\n";	
		}		
		$accession =~ s/ //g;	
	}
	if ($families ne "" && $count_seq >20){
		mkdir($pattern_old);
		chdir($pattern_old);
		&saveFile($pattern_old."seq", $families);
	}
	close LOGFILE;
	close DBFILE;
	
}

############################ sub divString ##################################
sub getPattern {
	my $num 	= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}

############################ sub saveFile ##################################
sub saveFile{
	my $file_name 	= $_[0];
	my $text 	= $_[1];	
	open(FILEOUT, ">$file_name")or die ("Could not create file $file_name!\n");
	print FILEOUT $text;
	close FILEOUT;
}

############################ sub removeFamily ##############################
sub removeFamily{
	my @dbfile	= ();
	my @entries	= ();
	my $entry;
	my $amount;
	my $name_family	= "";
	my $cmd_remove 	= ""; 

	unless (open(DBFILE, "$log_file")) {
       		print "Could not open file $log_file !\n";
        	exit;
	}
	@dbfile = <DBFILE>;
	chdir($out_dir);

	foreach $entry(@dbfile){
		@entries 	= split (/ +/, $entry);
		$name_family	= $entries[1];
		$amount 	= $entries[3];
		if ($amount >= 20){
			$cmd_remove	= "rm -rf ".$name_family;
			system ($cmd_remove);
		}		
	}
	close DBFILE;
}


