#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Array;

my $file1 = "";
my $file2 = "";
my $verbose = "false";
my $outputFile = ""; 
my $sep = "\t";
my $kind = 1;#1=subtraction 2=intersection

my $PROG_NAME = "perlLib::run::SubtLista.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-file1"){
			$file1 = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-file2"){
			$file2 = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-kind"){
			$kind = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	
	String->isEmpty($file1, "ERROR::".$PROG_NAME.":: Parameter -file1 having the first file list is required!");	
	FilesIO->checkFile($file1, "ERROR::".$PROG_NAME.":: File NOT found ".$file1);
	String->isEmpty($file2, "ERROR::".$PROG_NAME.":: Parameter -file2 having the second file list is required!");	
	FilesIO->checkFile($file2, "ERROR::".$PROG_NAME.":: File NOT found ".$file2);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required it must contain the output file! ");	
	

	print "-file1 = $file1\n";
	print "-file2 = $file2\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "-sep = $sep\n";
	print "-kind = $kind\n";
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $info = "";
	my @array3 = ();
	my @array1 = FilesIO->lineFileToArray($file1);
	my @array2 = FilesIO->lineFileToArray($file2);
	
	if ($kind == 1){
		@array3 = Array->subtractionArray(\@array1, \@array2);
	}elsif ($kind == 2){
		@array3 = Array->intersectionArray(\@array1, \@array2);
	}
	
	$info = Array->printArray("", \@array3);
	FilesIO->saveFile($outputFile, $info, $verbose);		
}
	
