#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $predList = "";
my $verbose = "false";
my $outputFile = ""; 
my $breakLine = "false";

my $PROG_NAME = "perlLib::run::concat.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-list"){
			$predList = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-breakLine"){
			$breakLine = $ARGV[$counter+1];		
		}		
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	if ($predList eq ""){
		print $PROG_NAME ."::ERROR::Parameter -list having a list of predicates for concating is required!\n";
		exit;
	}
	if (FilesIO->isFile($predList) eq "false"){
		print $PROG_NAME ."::ERROR:: $predList is NOT a File !\n";
		exit;
	}
	
	print "-list = $predList\n";
	
	if ($verbose ne "true" && $verbose ne "false"){
		print $PROG_NAME ."::ERROR:: Parameter -verbose must be true or false!\n";
		exit;
	}	
	
	print "-verbose = $verbose\n";	

	if ($outputFile eq ""){
		print $PROG_NAME ."::ERROR:: Parameter -outputFile having a output file is required!\n";
		exit;
	}
	print "-outputFile = $outputFile\n";	
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	
	my @array = FilesIO->lineFileToArray($predList);
	
	my $info1; my $info2; my $info3 = "";  
	
	for (my $i=0; $i<scalar(@array); $i++){
		$array[$i] = String->removeCaracter($array[$i], "\n");  
		$info1 = FilesIO->lineFileToString($array[$i]);
		if ($breakLine eq "true"){
			$info1 .= "\n";
		}
		$info3 .= $info1;
		
	}
	FilesIO->saveFile($outputFile, $info3, $verbose);		
}
	
