#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Hash;

my $fileList = "";
my $verbose = "false";
my $outputFile = ""; 
my $sep = "\t";

my $PROG_NAME = "perlLib::run::concatNFileByField.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-fileList"){
			$fileList = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-sep"){
			$sep = $ARGV[$counter+1];		
		}			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	
	String->isEmpty($fileList, "ERROR::".$PROG_NAME.":: Parameter -fileList having list of files is required!");	
	FilesIO->checkFile($fileList, "ERROR::".$PROG_NAME.":: File NOT found ".$fileList);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required it must contain the output file! ");	
	

	print "-fileList = $fileList\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "-sep = $sep\n";
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $info = "";					my $file_name;
	my $file_field;					my @array_file;
	my %hash;						my $info_array = "";
	my $key;
	
	my @array = FilesIO->fileToArray2d($fileList, ":");
	
	for (my $i=0; $i<scalar(@array); $i++){
		$file_name =  $array[$i][0];
		$file_field  =  $array[$i][1];
		@array_file = FilesIO->fileToArray2d($file_name, "\t");
		$info_array = "";
		for (my $j=0; $j<scalar(@array_file); $j++){
			$info_array = "";
			for (my $k=0; $k<= $#{$array_file[$j]}; $k++){
				if ($k != $file_field){
					$info_array .="\t".$array_file[$j][$k];
				}
			}
			$key = $array_file[$j][$file_field];
			if (exists($hash{$key})){
				$hash{$key} .= $info_array;
			}else{
				$hash{$key} = $info_array;
			}				
		}	
	}
	Hash->hashToFile("",$outputFile, \%hash);
}
	
