#!/usr/bin/perl -w
use strict;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $set_file		= "";

my $path_program  = "";

my $kind_align				= "clustalw";
my $ext_align				= "";
my $kind_calib				= "calibrated";	
my $work_in					= "";
my $work_out				= "hmmer_sam";
my $parameters				= "";
my $model_in				= "";
my $model_out 				= "";
my $model_ext_in			= "";
my $model_ext_out			= "";
my $program					= "";


&getParameters;

&readParametersFile;
&main;
############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		}
	}
}

############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}

	unless (open(SETFILE, "$set_file")) {
   	print "oiCould not open file $set_file !\n";
     	exit;
   }
	print "oi $set_file";
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";
	my $i;

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     	exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)> 1){
			#$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			$value = "";
			for ($i=1; $i<scalar(@array_settings); $i++){
				if (index($array_settings[$i],"\n") < 0){
					$value .=$array_settings[$i];
				}
				else{
					$value .= substr($array_settings[$i],0,index($array_settings[1],"\n"));
				}
				if ($i<scalar(@array_settings)-1){$value .=" ";}
			}
						
			if ($array_settings[0] eq "p_path_program"){
				$path_program = $value;					
			}elsif ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;
			}elsif ($array_settings[0] eq "p_work_in"){
				$work_in = $value;
			}elsif ($array_settings[0] eq "p_parameters"){
				$parameters = $value;
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;
			}elsif ($array_settings[0] eq "p_ext_align"){
				$ext_align = $value;
			}elsif ($array_settings[0] eq "p_work_out"){
				$work_out = $value;
			}elsif ($array_settings[0] eq "p_model_in"){
				$model_in = $value;
			}elsif ($array_settings[0] eq "p_model_out"){
				$model_out = $value;
			}elsif ($array_settings[0] eq "p_program"){
				$program = $value;
			}elsif ($array_settings[0] eq "p_model_ext_out"){
				$model_ext_out = $value;
			}elsif ($array_settings[0] eq "p_model_ext_in"){
				$model_ext_in = $value;
			}				
			print $value."\n";														
		}
	}	
	
	close SETFILE;
}

############################ sub main ##################################
sub main {
	my @families 		= ();
	my @family 			= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    }
	@families = <FAMILYFILE>;
	print "\n ================= Inicio ";
	system("date");
 	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			system ("date");
			&convertModels($new_sample,$dir);
			system ("date");			
		}
		$old_sample = $new_sample;					
	}
	print "\n ================= Fim ";
	system ("date");
	close FAMILYFILE;
}
############################ sub convertModels ##################################
sub convertModels {

	my $sample		= $_[0];
	my $dir			= $_[1];

	my $cmd 			= "";

	my $model_file_name_in = $model_in."_$sample$model_ext_in";
	my $dir_model_in = $dir. $sample. "/models/$kind_align/$kind_calib/$work_in/";
	print $work_in. "\n";
	
	my $model_file_name_out = $model_out."_$sample$model_ext_out";
	my $dir_model_out = $dir. $sample. "/models/$kind_align/$kind_calib/$work_out/";
	
	if (open(MODELFILE, $dir_model_out.$model_file_name_out)){
		system "rm $dir_model_out$model_file_name_out";
		print "remove $dir_model_out$model_file_name_out \n";
	}

	if (open(MODELFILE,$dir_model_in.$model_file_name_in)){
		 if (&isDirectory($dir_model_out) eq "false"){
			mkdir $dir_model_out;		
		 }
		 chdir $path_program;
		 $cmd = "perl $program $dir_model_in$model_file_name_in $dir_model_out$model_file_name_out $parameters";
       print $cmd."\n";
		 system $cmd;
		 
		 close MODELFILE;
	}
	else{
		print "ERROR file $dir_model_in$model_file_name_in not found\n" ;
	}	
}
############################ sub isDirectory ##################################
sub isDirectory{
	my $dir		= $_[0];
	opendir MYDIR, $dir;
	my @contents = readdir MYDIR;
	closedir MYDIR;
	if (scalar(@contents) == 0){
		return "false";	
	}
	return "true";
}
