#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;


my $directory 	= "";
my $outputFileList = "";
my $verbose			= "false";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-directory"){
			$directory = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFileList"){
			$outputFileList= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters\n";
	
	if ($directory eq ""){
		print "ERROR::createListFromDirectory:: Parameter -directory having the directory path is required!\n";
		exit;
	}
	print "-directory = $directory\n";
	
	if ($outputFileList eq ""){
		print "ERROR::createListFromDirectory:: Parameter -outputFileList having output file name is required!\n";
		exit;
	}
	print "-outputFileList = $outputFileList\n";
	
	if ($verbose ne "true" && $verbose ne "false"){
		print "ERROR::createListFromDirectory:: Parameter -verbose must be true or false!\n";
		exit;
	}	
	
	print "-verbose = $verbose\n";	
	
	print "ok\n";
}	

################################### sub main #####################################
sub main {
	
	my @array = FilesIO->listDirectory($directory);
	my $entry;
	my $info = "";
	
	foreach $entry (@array){
		$info .= $directory.$entry."\n";		
	}
	
	FilesIO->saveFile($outputFileList, $info, $verbose);	
	
}

