#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $file = "";
my $verbose = "false";
my $PKFile = ""; 
my $colF = "";
my $ext = "";
my $outputDir = "";

my $PROG_NAME = "perlLib::run::createMultipleFiles.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$file= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colF"){
			$colF = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-ext"){
			$ext = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputDir"){
			$outputDir = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($file, $PROG_NAME. "ERROR:: Parameter -inputfile is required");
	FilesIO->checkFile($file, "ERROR::".$PROG_NAME.":: $file NOT Found");		
	String->isEmpty($colF, $PROG_NAME. "ERROR:: Parameter -colF is required");
	String->isEmpty($outputDir, $PROG_NAME. "ERROR:: Parameter -outputDir is required");

	print "inputFile=$file\n";
	print "colF=$colF\n";
	print "outputDir=$outputDir\n";
	print "ext=$ext\n";
	print "verbose=$verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my @array_aux;		my $line;
	my $file_name;		my $field;

 	if (open(FILEIN, "$file")){
			while (my $line = <FILEIN>) {
				@array_aux = split(/\t/, $line);
				$field = $array_aux[$colF];
				$file_name = substr($field,0,2);
				$file_name = $outputDir.$file_name.".".$ext;
				FilesIO->apendFile($file_name, $line, $verbose);				
			}
	}
}
	
