#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;


my $alnFile 	= "";
my $outputDir 	= "";
my $kindAln 	= "";
my $verbose		= "false";
my $saveOneByOne = "true";
my $PROG_NAME = "perlLib::run::score::createSeqsFromAlignment.pl";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-alnFile"){
			$alnFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputDir"){
			$outputDir= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-kindAln"){
			$kindAln = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-saveOneByOne"){
			$saveOneByOne = $ARGV[$counter+1];		
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters\n";
	
	
	String->isEmpty($alnFile, "ERROR::".$PROG_NAME.":: Parameter -alnFile having Alignment file is required! ");	
	FilesIO->checkFile($alnFile, "ERROR::".$PROG_NAME.":: File NOT found ".$alnFile);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputDir, "ERROR::".$PROG_NAME.":: Parameter -outputDir is required it must contain the output directory! ");	
	String->isEmpty($kindAln, "ERROR::".$PROG_NAME.":: Parameter -kindAln is required it must contain the kind of alignment ex.: clustalw ! ");	
	

	print "-alnFile = $alnFile\n";
	print "-verbose = $verbose\n";
	print "-outputDir = $outputDir\n";
	print "-kindAln = $kindAln\n";

	print "ok\n";
}	

################################### sub main #####################################
sub main {
	
	my %hash_aln;					my $sequenceFile;				
	my $sequence;					my $name_seq;					
	my $algned_seq;					my $sequences = "";
	
	
	if ($kindAln eq "STOCKHOLM"){
		%hash_aln = STOCKHOLM->loadAlign($alnFile);
	}else{
		%hash_aln = Clustalw->loadAlign($alnFile);
	}
	
	while (my ($key, $value) = each %hash_aln){		
		$name_seq = $key;
		$name_seq = String->removeCaracter($name_seq, "\/");
		$algned_seq = $value;
		$sequenceFile = $outputDir.$name_seq.".seq";
		#Creating Sequential predicates
		$sequence = String->removeCaracter(String->removeCaracter($algned_seq, "."), "-");	
		$sequence = ">$name_seq\n".$sequence."\n";
		$sequences .= $sequence;
		if ($saveOneByOne eq "true"){
			FilesIO->saveFile($sequenceFile, $sequence, $verbose);	
		}			
	}	
	if ($saveOneByOne eq "false"){
		FilesIO->saveFile($outputDir, $sequences, $verbose);	
	}	
}

