#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;


my $database 	= "";
my $outputDir 	= "";
my $sep 		= " +";
my $accField	= "0";
my $verbose		= "false";
my $removeGaps =  "false";

my $PROG_NAME = "perlLib::run::createSeqsFromFasta.pl";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-database"){
			$database = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputDir"){
			$outputDir= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-sep"){
			$sep = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-accField"){
			$accField = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-removeGaps"){
			$removeGaps = $ARGV[$counter+1];		
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	
	String->isEmpty($database, "ERROR::".$PROG_NAME.":: Parameter -database having database in fasta format is required! ");	
	FilesIO->checkFile($database, "ERROR::".$PROG_NAME.":: File NOT found ".$database);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputDir, "ERROR::".$PROG_NAME.":: Parameter -outputDir is required it must contain the output directory! ");	
	

	print "-database = $database\n";
	print "-verbose = $verbose\n";
	print "-outputDir = $outputDir\n";
	print "-sep = $sep\n";
	print "-accField = $accField\n";

	print "ok\n";
}	

################################### sub main #####################################
sub main {
	
	my $sequenceFile;				my @array_aux;
	my $sequence;					my $name_seq;					
	my @array_seq = Sequences->getSequenceFromFastaArray2D($database);
	
	for (my $i=0; $i < scalar(@array_seq); $i++){
		$name_seq = String->removeCaracter($array_seq[$i][0], ">");
		$name_seq = String->removeCaracter($name_seq, "\n");
		$name_seq = String->removeCaracter($name_seq, "\r");
		$sequence = $array_seq[$i][1];
		$sequence = String->removeCaracter($sequence, "\r");
		if ($removeGaps eq "true"){
			$sequence  = String->removeCaracter($sequence, "-");
			$sequence = String->removeCaracter($sequence, ".");
		}
		@array_aux = split(/$sep/,$name_seq);
		$name_seq = String->removeCaracter($array_aux[$accField], " ");
		$name_seq =~ s/\//_/g;
		$sequenceFile = $name_seq.".fasta";
		#FilesIO->saveFile($outputDir.$sequenceFile, $array_seq[$i][0].Sequences->divideSeq($sequence, 60)."\n", $verbose);
		FilesIO->saveFile($outputDir.$sequenceFile, ">".$name_seq."\n".Sequences->divideSeq($sequence, 60)."\n", $verbose);
	}		
}

