#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Sequence::sequence;
use HMMs::HMMER::hmmer;
use Align::Primary::STOCKHOLM;

my $pfamFile = "";

my $verbose    	= "false";
my $modelName = "";
my $trainFile = "";
my $tmpDir = "";
my $iteration = 5;
my $database = "";
my $parameters = "";
my $evalue = 0.001;
my $save = 1; #1-model 2-aln


my $PROG_NAME = "perlLib::run::create_model_jackHmmer.pl";

my %hash_aln = ();
my %hash_seq_specie = (); 
my $run = "true";

#STOCKHOLM->convertSTOCKHOLMToFasta("/Users/julianab/test.aln-1.sto", "/Users/julianab/test.aln-3.sto", "true");
#exit;

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-seqFile"){
			$pfamFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-modelName"){
			$modelName = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-tmpDir"){
			$tmpDir = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-iteration"){
			$iteration = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-evalue"){
			$evalue = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-parameters"){
			$parameters = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-database"){
			$database = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-run"){
			$run = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-save"){
			$save = $ARGV[$counter+1];
		}									
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEqual($verbose,"true,false",$PROG_NAME."::ERROR::Parameter -verbose must be true or false!");
	String->isEmpty($pfamFile, $PROG_NAME."::ERROR::Parameter -seqFile having Pfam aligments is required!");
	FilesIO->checkFile($pfamFile, $PROG_NAME."ERROR:: File $pfamFile NOT found ");	
	String->isEmpty($modelName, $PROG_NAME."::ERROR::Parameter -modelName having directory to save probabilistic models is required!");
	String->isEmpty($database, $PROG_NAME."::ERROR::Parameter -database having database in fasta format is required!");
	FilesIO->checkFile($database, $PROG_NAME."ERROR:: File $database NOT found ");	
	String->isEmpty($tmpDir, $PROG_NAME."::ERROR::Parameter -tmpDir having temporary directory is required!");
	FilesIO->createDirectory($tmpDir, $verbose);
	
	print "-pfamFile = $pfamFile\n";
	print "-modelName = $modelName\n";
	print "-database = $database\n";
	print "-evalue = $evalue\n";
	print "-iteration = $iteration\n";
	print "-tmpDir = $tmpDir\n";
	print "-run = $run\n";
	print "-verbose = $verbose\n";
	print "-save = $save\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my $acc = "";						my @array_aux = ();
	my $specie	= "";					my $interval = "";
	my $key = "";						my $query_sequence;
	my $query_file;
	my $count = 0;						my $progress;
	my $modelNameTmp;
	
	$modelNameTmp = $tmpDir."model.hmm";
	$query_file = $pfamFile;

	if (FilesIO->isFile($modelName) eq "true"){
		print "LOG::".$PROG_NAME.":: File $modelName already created\n"; 
	}
	elsif ($run eq "true"){
		HMMER->runJackHmmer($modelNameTmp, $query_file, $database, $parameters, $iteration, $evalue, $save, $verbose);
		FilesIO->copyFile($modelNameTmp, $modelName, $verbose);
	}else{
		print "LOG::".$PROG_NAME."::Running::$modelName\n";
	}
}


	
