#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $file = "";
my $verbose = "false";
my $PKFile = ""; 
my $colPK = "";
my $outputFile = "";
my $word = "";

my $PROG_NAME = "perlLib::run::divideFile.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$file= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colPK"){
			$colPK = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-word"){
			$word = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($file, $PROG_NAME. "ERROR:: Parameter -inputfile is required");
	FilesIO->checkFile($file, "ERROR::".$PROG_NAME.":: $file NOT Found");	
	String->isEmpty($colPK, $PROG_NAME. "ERROR:: Parameter -colPK is required");
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");
	String->isEmpty($word, $PROG_NAME. "ERROR:: Parameter -word is required");

	print "inputFile=$file\n";
	print "colPK=$colPK\n";
	print "word=$word\n";
	print "outputFile=$outputFile\n";
	print "verbose=$verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $info1 = "";					my $info2 = "";
	my $key;
	
 	my @array_file = FilesIO->fileToArray2d($file, "\t");
	
	for (my $i = 0; $i < scalar(@array_file); $i++){
		$key = $array_file[$i][$colPK];
		if (index($key, $word) >= 0){
			$info1 .= Array->copyRowMatrixToString("\t", $i, \@array_file)."\n";
		}else{
			$info2 .= Array->copyRowMatrixToString("\t", $i, \@array_file)."\n";
		}		
	}
	FilesIO->saveFile($outputFile.".part1", $info1, $verbose);
	FilesIO->saveFile($outputFile.".part2", $info2, $verbose);
}
	
