#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $file = "";
my $verbose = "false";
my $PKFile = ""; 
my $colPK = "";
my $colInputFile = "";
my $outputFile = "";

my $PROG_NAME = "perlLib::run::filtreFilePK.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$file= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-PKFile"){
			$PKFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colPK"){
			$colPK = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colInputFile"){
			$colInputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($file, $PROG_NAME. "ERROR:: Parameter -inputfile is required");
	FilesIO->checkFile($file, "ERROR::".$PROG_NAME.":: $file NOT Found");	
	String->isEmpty($PKFile, $PROG_NAME. "ERROR:: Parameter -PKFile is required");
	FilesIO->checkFile($PKFile, "ERROR::".$PROG_NAME.":: $PKFile NOT Found");	
	String->isEmpty($colPK, $PROG_NAME. "ERROR:: Parameter -colPK is required");
	String->isEmpty($colInputFile, $PROG_NAME. "ERROR:: Parameter -colInputFile is required");
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");

	print "inputFile=$file\n";
	print "PKFile=$PKFile\n";
	print "colPK=$colPK\n";
	print "colInputFile=$colInputFile\n";
	print "outputFile=$outputFile\n";
	print "verbose=$verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	

 	my %hash = FilesIO->fileToHash($PKFile, "\t", $colPK);
	
	my $info = "";				my $pk;
	my @array_aux = ();

	if (open(FILEIN, "$file")){
		while (my $line = <FILEIN>) {
			@array_aux = split(/\t/, $line);
			if (exists($hash{$array_aux[$colInputFile]})){
				$info .= $line;
			}		
		}
	}
	FilesIO->saveFile($outputFile, $info, $verbose);		
}
	
