#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Hash;

my $file1 = "";
my $verbose = "false";
my $colFile1 = "";  # a set of cols seprated by ,
my $file2 = "";
my $colFile2 = "";  # a set of cols seprated by ,



my $outputFile = "";

my $PROG_NAME = "perlLib::run::filtreFileWithOutPKMultipleKeys.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-file1"){
			$file1= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-file2"){
			$file2 = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colFile1"){
			$colFile1 = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colFile2"){
			$colFile2 = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($file1, $PROG_NAME. "ERROR:: Parameter -file1 is required");
	FilesIO->checkFile($file1, "ERROR::".$PROG_NAME.":: $file1 NOT Found");	
	String->isEmpty($colFile1, $PROG_NAME. "ERROR:: Parameter -colFile1 is required");
	String->isEmpty($file2, $PROG_NAME. "ERROR:: Parameter -file2 is required");
	FilesIO->checkFile($file2, "ERROR::".$PROG_NAME.":: $file2 NOT Found");	
	String->isEmpty($colFile2, $PROG_NAME. "ERROR:: Parameter -colFile2 is required");
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");

	print "file1=$file1\n";
	print "file2=$file2\n";
	print "colFile1=$colFile1\n";
	print "colFile2=$colFile2\n";
	print "outputFile=$outputFile\n";
	print "verbose=$verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	
	my %hash1; 				my %hash2;
	%hash1 = FilesIO->fileToHashConcatKeyKeepLineFile($file1, "\t", $colFile1);
 	%hash2 = FilesIO->fileToHashConcatKeyKeepLineFile($file2, "\t", $colFile2);
	
	
	#while ( my ($key, $value) = each(%hash2) ) {
	#	print $key."\t".$value."\n";
	#		exit;
	#}

	
	#File1 - File2
	
	my $info = "";				my $pk;
	my @array_ret = ();
	
	while ( my ($key1, $value1) = each(%hash1) ) {
		
		if (!exists($hash2{$key1})){
			$info .= $value1;
		}		
	}
	
	FilesIO->saveFile($outputFile, $info, $verbose);		
}
	
