#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $file = "";
my $verbose = "false";
my $PKFile = ""; 
my $col = "";
my $kind = ""; #1: eq; 2: greater than cutoff; 3: smaller than cutoff
my $outputFile = "";
my $cutOFF = "";

my $PROG_NAME = "perlLib::run::filtreFilebyColumn.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$file= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-kind"){
			$kind = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-cutOFF"){
			$cutOFF = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($file, $PROG_NAME. "ERROR:: Parameter -inputfile is required");
	FilesIO->checkFile($file, "ERROR::".$PROG_NAME.":: $file NOT Found");	
	String->isEmpty($col, $PROG_NAME. "ERROR:: Parameter -col is required");
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");

	print "inputFile=$file\n";
	print "kind=$kind\n";
	print "col=$col\n";
	print "outputFile=$outputFile\n";
	print "verbose=$verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	
	my $info = "";				my $pk;
	my @array_aux = ();

	if (open(FILEIN, "$file")){
		while (my $line = <FILEIN>){
			@array_aux = split(/\t/, $line);
			if ($kind == 1 && $array_aux[$col] eq $cutOFF){
				$info .= $line;
			}elsif ($kind == 2 &&  $array_aux[$col] >= $cutOFF){
				$info .= $line;
			}elsif ($kind == 3 &&  $array_aux[$col] <= $cutOFF){
				$info .= $line;
			}			
		}
	}
	FilesIO->saveFile($outputFile, $info, $verbose);		
}
	
