#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $fastaFile = "";
my $verbose = "false";
my $outputFile = ""; 
my $range = "false";

my $PROG_NAME = "perlLib::run::concat.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-fastaFile"){
			$fastaFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-range"){
			$range = $ARGV[$counter+1];		
		}		
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	String->isEqual($verbose,"true,false",$PROG_NAME. "::ERROR::Parameter -verbose must be true or false!");
	String->isEmpty($tmpDir, $PROG_NAME."::ERROR::Parameter -tmpDir having temporary directory is required!");
	String->isEmpty($targetSequenceFile, $PROG_NAME."::ERROR::Parameter -targetSequenceFile having sequence target in fasta format is required!");
	FilesIO->checkFile($targetSequenceFile, $PROG_NAME."::ERROR::File $targetSequenceFile NOT found!");
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	
	my @array_seq = Sequences->getSequenceFromFastaArray2D($targetSequenceFile);
	my $sequence_new = Sequences->getInterval($array_seq[0][1], $starHit, $endHit);
	
	my @array = FilesIO->lineFileToArray($predList);
	
	my $info1; my $info2; my $info3 = "";  
	
	for (my $i=0; $i<scalar(@array); $i++){
		$array[$i] = String->removeCaracter($array[$i], "\n");  
		$info1 = FilesIO->lineFileToString($array[$i]);
		if ($breakLine eq "true"){
			$info1 .= "\n";
		}
		$info3 .= $info1;
		
	}
	FilesIO->saveFile($outputFile, $info3, $verbose);		
}
	
