#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;


my $fileList 	= "";
my $outputFile 	= "";
my $sep 		= " +";
my $accField	= "0";
my $verbose		= "false";


my $PROG_NAME = "perlLib::run::getNameFilesList.pl";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-fileList"){
			$fileList= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	
	String->isEmpty($fileList, "ERROR::".$PROG_NAME.":: Parameter -fileList having a file with a listt of files is required! ");	
	FilesIO->checkFile($fileList, "ERROR::".$PROG_NAME.":: File NOT found ".$fileList);
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required it must contain the output file! ");	
	

	print "-fileList = $fileList\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "ok\n";
}	

################################### sub main #####################################
sub main {
	
	my @array = FilesIO->lineFileToArray($fileList);
	my $nameFile;
	my $info ="";
	
	for (my $i=0; $i<scalar(@array); $i++){
		$nameFile = String->removeCaracter($array[$i],"\n");
		$nameFile = FilesIO->getNameFile($nameFile);
		$nameFile = substr($nameFile, 0, index($nameFile, ".".FilesIO->getExt($nameFile)));
		$info .= $nameFile."\n";
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
}

