#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $file = "";
my $verbose = "false";
my $outputFile = ""; 
my $cols	= "";
my $sep = "\t";
my $colsConcat = "";

my $PROG_NAME = "perlLib::run::getOneColumnFile.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-file"){
			$file = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$cols = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-sep"){
			$sep = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colsConcat"){
			$colsConcat = $ARGV[$counter+1];		
		}			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	
	String->isEmpty($file, "ERROR::".$PROG_NAME.":: Parameter -file having a file is required!");	
	FilesIO->checkFile($file, "ERROR::".$PROG_NAME.":: File NOT found ".$file);
	String->isEmpty($cols, "ERROR::".$PROG_NAME.":: Parameter -cols having colulns of file is required!");	
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required it must contain the output file! ");	
	

	print "-file = $file\n";
	print "-cols = $cols\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "-sep = $sep\n";
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $info = "";
	my @array_colsConcat =  ();
	
	my @array = FilesIO->fileToArray2d($file, $sep);
	
	@array = Array->copyColMatrixToArray2($cols, \@array);
	$info = Array->printArray("\n", \@array);
	FilesIO->saveFile($outputFile, $info, $verbose);		
}
	
