#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use HMMs::HMMER::hmmer;


my $modelFile 	= "";
my $outputFile 	= "";
my $familyId	= "";
my $resultFile 	= "";
my $verbose		= "false";
my $evalue = "10";


my $PROG_NAME = "perlLib::run::getResults_hmmer2.pl";	
	
&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-resultFile"){
			$resultFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}   			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile having output File is required!");
	String->isEmpty($resultFile, "ERROR::".$PROG_NAME.":: Parameter -resultFile having HMMER Result file name is required!");
	FilesIO->checkFile($resultFile, "ERROR::".$PROG_NAME.":: FILE NOT found ".$resultFile);
	
	print "-verbose = $verbose\n";
	print "-resultFile = $resultFile\n";
	print "-outputFile = $outputFile\n";
	print "-evalue = $evalue\n";
	print "ok\n";
}	

############################ sub main ##################################
sub main {
	HMMER->getAllDomainHitsHmmer2($resultFile, $outputFile, $verbose);	
}
