#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Align::Primary::blast;
use Sequence::sequence;

my $blastOutput = "";
my $evalue = "";
my $verbose = "false";
my $outputFile = ""; 
my $sep = "\t";
my $identity = "50";
my $MAXSEQ = "0";

my $PROG_NAME = "perlLib::run::getSequencesFromBlastOutput.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-blastOutput"){
			$blastOutput= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-evalue"){
			$evalue = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-identity"){
			$identity = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-MAXSEQ"){
			$MAXSEQ = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	
	String->isEmpty($blastOutput, "ERROR::".$PROG_NAME.":: Parameter -blastOutput having blast Output file is required!");	
	FilesIO->checkFile($blastOutput, "ERROR::".$PROG_NAME.":: File NOT found ".$blastOutput);
	String->isEmpty($evalue, "ERROR::".$PROG_NAME.":: Parameter -evalue is required!");	
	String->isEqual($verbose,"true,false", "ERROR:: ".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required it must contain the output file! ");	
	

	print "-blastOutput = $blastOutput\n";
	print "-evalue = $evalue\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "-identity = $identity\n";
	print "-MAXSEQ = $MAXSEQ\n";
	print "ok\n";
}

################################### sub main #####################################
sub main {
	Blast->getSequencesFromOutput($blastOutput, $evalue, $identity, $outputFile, $verbose);
	my @array_seqs = ();
	my $info = "";
	if ($MAXSEQ != 0){
		@array_seqs = Sequences->getSequenceFromFastaArray2D($outputFile);
		if (scalar(@array_seqs) > $MAXSEQ){
			for (my $j=0; $j< $MAXSEQ; $j++){
				$info .=$array_seqs[$j][0].$array_seqs[$j][1]."\n";
			}
			FilesIO->saveFile($outputFile, $info, $verbose);
		}
	}	
}
	
