#include <stdlib.h>
#include <fstream>
#include <vector>
#include <iostream>
#include <sstream>
#include <algorithm>

namespace Support
{
	/*comment*///ordem das rotas
	static const bool ASCENDING = true;
	static const bool DESCENDING = false;

	static const char FILE_NAME_SEPARATOR[2] = ".";

   static const unsigned int MAX_READS = 1024*256;
   static const unsigned int INVALID_IDENTIFICATION = -1;
   static const char END_OF_INFORMATION[2] = ";";
   static char SEPARATOR[2] = "	";
   static char VALUE_SEPARATOR[2] = ",";
   static const char END_OF_LINE = '\0';
   static const char COMMENTARY[2] = "#";
   static const double CONFIDENCE_FACTOR = 0.95;
}

template<class FIterator, typename T>
FIterator binarySearch(FIterator begin, FIterator end, const T& key)
{
    // Keep halving the search space until we reach the end of the vector
    FIterator NotFound = end;

    while(begin < end)
    {
        // Find the median value between the iterators
        FIterator Middle = begin + (std::distance(begin, end) / 2);

        // Re-adjust the iterators based on the median value
        if(*Middle == key)
        {
            return Middle;
        }
        else if(*Middle > key)
        {
            end = Middle;
        }
        else
        {
            begin = Middle + 1;
        }
    }

    return NotFound;
}

template< typename T >
bool readCSVfileN(const char * fileName, std::vector < std::vector < T > > * table, char separator = Support::SEPARATOR[0])
{
	std::ifstream file(fileName, std::ios::in);
	char in[Support::MAX_READS];
	std::string value;
	std::vector < T > sample(0);
	unsigned int bytesRead, position;

	if (not file)
	{
		std::cerr << fileName << " not found!" << std::endl;
		return NULL; //exit(1);
	}

	do
		file.getline(in, Support::MAX_READS);
	while (in[0] == Support::COMMENTARY[0] and not file.eof());
	if (file.eof()) return NULL;
	bytesRead = file.gcount();
	while(bytesRead >= 2)
	{
		table->push_back(sample);
		position = 0;
		do
		{
			value.clear();
			do
				value.push_back(in[position++]);
			while (position < bytesRead and in[position] != separator and in[position] != Support::END_OF_INFORMATION[0]);
			table->back().push_back(atof(value.data()));
			position++;
		}
		while (position < bytesRead and in[position -1] != Support::END_OF_INFORMATION[0]);

		do file.getline(in, Support::MAX_READS);
		while (in[0] == Support::COMMENTARY[0] and not file.eof());
		if (file.eof()) break;
		bytesRead = file.gcount();
	}
	file.close();

	return true;
}

template< typename T >
bool readCSVfileA(const char * fileName, std::vector < std::vector < T > > * table, char separator = Support::SEPARATOR[0])
{
	std::ifstream file(fileName, std::ios::in);
	char in[Support::MAX_READS];
	std::string value;
	std::vector < T > sample(0);
	unsigned int bytesRead, position;

	if (not file)
	{
		std::cerr << fileName << " not found!" << std::endl;
		return NULL; //exit(1);
	}

	do
		file.getline(in, Support::MAX_READS);
	while (in[0] == Support::COMMENTARY[0] and not file.eof());
	if (file.eof()) return NULL;
	bytesRead = file.gcount();
	while(bytesRead >= 2)
	{
		table->push_back(sample);
		position = 0;
		do
		{
			value.clear();
			do
				value.push_back(in[position++]);
			while (position < bytesRead and in[position] != separator and in[position] != Support::END_OF_INFORMATION[0]);
			table->back().push_back(value.data());
			position++;
		}
		while (position < bytesRead and in[position -1] != Support::END_OF_INFORMATION[0]);

		do file.getline(in, Support::MAX_READS);
		while (in[0] == Support::COMMENTARY[0] and not file.eof());
		if (file.eof()) break;
		bytesRead = file.gcount();
	}
	file.close();

	return true;
}

template< typename T >
bool writeCSVfile(const char * fileName, std::vector < std::vector < T > > * table, char separator = Support::SEPARATOR[0])
{
    std::ofstream file;

	file.open(fileName, std::ios::out);
	if (not file)
	{
		std::cerr << fileName << " not created!" << std::endl;
		exit(1);
	}
	std::cout << "Writing file:" << fileName << std::endl;

	for (unsigned int line = 0; line < table->size(); line++)
	{
		file << table->at(line).at(0);
		for (unsigned int hop = 1; hop < table->at(line).size(); hop++)
			file << Support::SEPARATOR << table->at(line).at(hop);
		file << Support::END_OF_INFORMATION  << std::endl;
	}
	file.close();

	return true;
}

int main(int nargs, char ** args)
{
	int result = 0;

	unsigned long int total = 0;
	bool found;
	std::vector < std::string > listToFind;
	std::vector < std::vector < std::string > > * searchSpace = new std::vector < std::vector < std::string > > ();
	std::vector < std::vector < std::string > > sortedSearchSpace;
	std::string toFind = args[2];
	std::vector < std::string > sampleLine;
	std::vector< std::string >::iterator it;

	readCSVfileA(args[1], searchSpace);

	//loading the list to find in the search space
	listToFind.push_back("");
	for (unsigned int character=0; character < toFind.size(); character++)
	{
		if (toFind.at(character) == Support::VALUE_SEPARATOR[0])
			listToFind.push_back("");
		else listToFind.back().push_back(toFind.at(character));
	}
	std::sort(listToFind.begin(), listToFind.end());

	//parsing and sorting the search space
	for (unsigned int line=0; line < searchSpace->size(); line++)
	{
		sortedSearchSpace.push_back(sampleLine);
		sortedSearchSpace.back().push_back("");
		for (unsigned int character=0; character < searchSpace->at(line).at(0).size(); character++)
		{
			if (searchSpace->at(line).at(0).at(character) == '-')
				sortedSearchSpace.back().push_back("");
			else sortedSearchSpace.back().back().push_back(searchSpace->at(line).at(0).at(character));
		}
		std::sort(sortedSearchSpace.back().begin(), sortedSearchSpace.back().end());
	}

	/*debug*/
//	std::cout << "elements to find in search space" << std::endl;
//	for (unsigned int string=0; string < listToFind.size(); string++)
//		std::cout << listToFind.at(string) << " , ";
//	std::cout << std::endl;
//	std::cout << "search space" << std::endl;
//	for (unsigned int line=0; line < sortedSearchSpace.size(); line++)
//	{
//		for (unsigned int column=0; column < sortedSearchSpace.at(line).size(); column++)
//			std::cout << sortedSearchSpace.at(line).at(column) << " , ";
//		std::cout << std::endl;
//	}
	/*debug*/

	//searching

	for (unsigned int line=0; line < sortedSearchSpace.size(); line++)
	{
		found = true;
		for (unsigned int string=0; string < listToFind.size() and found; string++)
		{
			it = binarySearch(sortedSearchSpace.at(line).begin(), sortedSearchSpace.at(line).end(), listToFind.at(string));
			if (it == sortedSearchSpace.at(line).end())
				found = false;
			else sortedSearchSpace.at(line).erase(it);
		}
		if (found)
			total += atoi(searchSpace->at(line).back().data());
	}

	std::cout << total << std::endl;

	return result;
}
