#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $file1 = "";
my $file2 = "";
my $verbose = "false";
my $colPK1 = "";
my $colPK2 = "";
my $outputFile = "";

my $PROG_NAME = "perlLib::run::joinFiles.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-file1"){
			$file1= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-file2"){
			$file2 = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colPK1"){
			$colPK1 = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colPK2"){
			$colPK2 = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($file1, $PROG_NAME. "ERROR:: Parameter -file1 is required");
	FilesIO->checkFile($file1, "ERROR::".$PROG_NAME.":: $file1 NOT Found");	
	String->isEmpty($file2, $PROG_NAME. "ERROR:: Parameter -file2 is required");
	FilesIO->checkFile($file2, "ERROR::".$PROG_NAME.":: $file2 NOT Found");	
	String->isEmpty($colPK1, $PROG_NAME. "ERROR:: Parameter -colPK1 is required");
	String->isEmpty($colPK2, $PROG_NAME. "ERROR:: Parameter -colPK2 is required");
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");

	print "file1=$file1\n";
	print "file2=file2\n";
	print "colPK1=$colPK1\n";
	print "colPK2=$colPK2\n";
	print "outputFile=$outputFile\n";
	print "verbose=$verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	

 	my %hash = FilesIO->fileToHash2($file2, "\t", $colPK2);
	
	my $info = "";				my $pk;
	my @array_aux = ();

	if (open(FILEIN, "$file1")){
		while (my $line1 = <FILEIN>) {
			$line1  =~ s/\n//g;
			@array_aux = split(/\t/, $line1);
			if (exists($hash{$array_aux[$colPK1]})){
				$info .= $line1."\t". $hash{$array_aux[$colPK1]}."\n";
			}else{
				print $PROG_NAME. "ERROR:: ".$array_aux[$colPK1]." NOT found in $file1\n";
			}		
		}
	}
	FilesIO->saveFile($outputFile, $info, $verbose);		
}
	
