#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use HMMs::HMMER::hmmer;

my $pfamFile 	= "";
my $outputFile 	= "";
my $verbose		= "false";


my $PROG_NAME = "perlLib::run::run_hmmer3.pl";	
	
&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-pfamFile"){
			$pfamFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}	   			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	String->isEmpty($pfamFile, "ERROR::".$PROG_NAME."::  Parameter -pfamFile having the PFAM result file  is required");
	FilesIO->checkFile($pfamFile, "ERROR::".$PROG_NAME.":: File NOT found ".$pfamFile);	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile having output file name is required");


	print "-pfamFile = $pfamFile\n";
	print "-outputFile = $outputFile\n";
	print "-verbose = $verbose\n";
	print "ok\n";	
}	

############################ sub main ##################################
sub main {
	
 HMMER->getAllDomainHmmScan($pfamFile, $outputFile, $verbose);

		
}