#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::Pdb;
use Database::ScopPattern;
use Sequence::protein;


my $sequenceFileList	= "";
my $inputClustalw  = "";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-sequenceFileList"){
			$sequenceFileList = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-inputClustalw"){
			$inputClustalw = $ARGV[$counter+1];		
		} 	
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters\n";
	
	if ($sequenceFileList eq ""){
		print "ERROR::prepareInputFileClustalw:: Parameter -sequenceFileList having a list with full path of all sequence files is required!\n";
		exit;
	}
	if (FilesIO->isFile($sequenceFileList) eq "false"){
		print "ERROR::prepareInputFileClustalw:: $sequenceFileList is NOT a File !\n";
		exit;
	}
	
	print "-sequenceFileList = $sequenceFileList\n";
	
	if ($inputClustalw eq ""){
		print "ERROR::prepareInputFileClustalw:: Parameter -tmpDir File name to save clustalw input is required!\n";
		exit;
	}
	
	if (FilesIO->getDirectory($inputClustalw) eq "false"){
		FilesIO->createDirectory(FilesIO->getDirectory($inputClustalw));
	}
	print "-inputClustalw = $inputClustalw\n";
	
	print "ok\n";
}	

################################### sub main #####################################
sub main {
	my $entry;
	my $info = ""; my $info_pdb;
	
	my @array = FilesIO->lineFileToArray($sequenceFileList);
	foreach $entry (@array) {
		$entry = String->removeCaracter($entry,"\n");
		if (FilesIO->isFile($entry) eq "false"){
			print "ERROR::prepareInputFileClustalw:: $entry is NOT a File !\n";
			exit;
		}
		
		$info_pdb =  FilesIO->lineFileToString($entry);
		if ($info_pdb eq ""){
			print "ERROR::prepareInputFileClustalw:: $entry is Empty!\n";
			exit;
		}
		$info .= $info_pdb."\n";
	}
	FilesIO->saveFile($inputClustalw, $info, "false");	
}
		
