#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;


my $fileTestSet	= "";
my $virtualPath = "";
my $outputFileList  = "";
my $exceptSupFamily			= "";
my $kindRun 		= "";
my $defaultFamily	= "";
my $verbose			= "false";
my $sep = "\n"; 

my $TOKEN_FAMILY = "FAMILY_FACTOR";
my $TOKEN_TAXON = "TAXON_SCOP";
my $TOKEN_ID = "ID_SCOP";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-fileTestSet"){
			$fileTestSet = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-virtualPath"){
			$virtualPath= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFileList"){
			$outputFileList= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-exceptSupFamily"){
			$exceptSupFamily= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-kindRun"){
			$kindRun = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-defaultFamily"){
			$defaultFamily = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-sep"){
			$sep = $ARGV[$counter+1];		
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters\n";
	
	if ($fileTestSet eq ""){
		print "ERROR::prepareListDataSet:: Parameter -fileTestSet having SCOP parseable file that correspond to dataset is required!\n";
		exit;
	}
	if (FilesIO->isFile($fileTestSet) eq "false"){
		print "ERROR::prepareListDataSet:: $fileTestSet is NOT a File !\n";
		exit;
	}
	
	print "-fileTestSet = $fileTestSet\n";
	
	if ($virtualPath eq ""){
		print "ERROR::prepareListDataSet:: Parameter -virtualPath having virtual path of list files is required!\n";
		exit;
	}
	print "-virtualPath = $virtualPath\n";
	
	if ($outputFileList eq ""){
		print "ERROR::prepareListDataSet:: Parameter -outputFileList having output file name is required!\n";
		exit;
	}
	print "-outputFileList = $outputFileList\n";
	
	if ($exceptSupFamily ne ""){
		print "-exceptSupFamily = $exceptSupFamily\n";
	}
	
	if ($kindRun eq ""){
		print "WARNING::prepareListDataSet:: Parameter -kindRun saying how to run (1 = by Family (default); 2 = bySequence) is required!\n";
		$kindRun = 2;
	}
	if ($kindRun ne "1" && $kindRun ne "2"){
		print "ERROR::prepareListDataSet:: Parameter -kindRun must be 1 or 2.\n";
		exit;
	}	
	print "-kindRun = $kindRun\n";
	
	if ($verbose ne "true" && $verbose ne "false"){
		print "ERROR::prepareListDataSet:: Parameter -verbose must be true or false!\n";
		exit;
	}	
	
	print "-verbose = $verbose\n";	
	print "-sep = $sep\n";	
	
	print "ok\n";
}	

################################### sub main #####################################
sub main {
	my @families 		= ();
	my $entry			= "";

	my $id_scop;
	my @array_line;
	my $taxon = "";
	my $family;

	my $info	= "";
	my $info_virtual = "";
		
	@families = FilesIO->lineFileToArray($fileTestSet);
	foreach $entry (@families) {
		@array_line = split(/\t/, $entry);
			
		if (index($array_line[0],"\n") != 0){
			$family = $array_line[0];
			$family =~ s/\n//g;
			$info_virtual = $virtualPath;
			$info_virtual =~ s/$TOKEN_FAMILY/$family/g;
			$info .= $info_virtual."\n";
		}
	}
	
	if ($info ne ""){
		FilesIO->saveFile($outputFileList, $info, $verbose);	
	}else{
		print "ERROR::prepareListDataSet2:: $fileTestSet has a format invalid\n";
		exit;
	}
}
