#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::ScopPattern;


my $fileTestSet	= "";
my $virtualPath = "";
my $outputFileList  = "";
my $exceptSupFamily			= "";
my $kindRun 		= "";
my $extention	= "";
my $verbose			= "false";
my $sep = "\n"; 

my $PROG_NAME = "PerlLib::run::prepareSimpleList.pl";


&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-listFile"){
			$fileTestSet = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-virtualPath"){
			$virtualPath= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFileList= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-extention"){
			$extention= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-sep"){
			$sep = $ARGV[$counter+1];		
		}
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters\n";
	

	String->isEmpty($fileTestSet, $PROG_NAME."::ERROR:: Parameter -listFile having LIST file!");
	FilesIO->checkFile($fileTestSet, $PROG_NAME."::ERROR:: File $fileTestSet NOT found!");		
	String->isEmpty($virtualPath, $PROG_NAME."::ERROR:: Parameter -virtualPath is required!");
	String->isEmpty($outputFileList, $PROG_NAME."::ERROR:: Parameter -outputFileList is required!");
	String->isEmpty($extention, $PROG_NAME."::ERROR:: Parameter -extention is required!");

	print "-verbose = $verbose\n";	
	print "-sep = $sep\n";	
	
	print "ok\n";
}	

################################### sub main #####################################
sub main {
	my @families 		= ();
	my $entry			= "";
	my $info	= "";
	my $path;
		
	@families = FilesIO->lineFileToArray($fileTestSet);
	foreach $entry (@families) {
		$entry =~ s/\n//g;
		$path = $virtualPath.$entry.$extention;
		$info .= $path."\n";
		
	}
	
	if ($info ne ""){
		FilesIO->saveFile($outputFileList, $info, $verbose);	
	}else{
		print "ERROR::prepareListDataSet2:: $fileTestSet has a format invalid\n";
		exit;
	}
}
