#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $file = "";
my $verbose = "false";
my $PKFile = ""; 
my $col = "";
my $outputFile = "";
my $T = "";
my $GT = 1; # 1= greater than; 2 smaller than;
my $sep = 1 # 1=\t; 2=space

my $PROG_NAME = "perlLib::run::removeLineFile.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$file= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-GT"){
			$GT = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-T"){
			$T = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-sep"){
			$sep = $ARGV[$counter+1];		
		}
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($file, $PROG_NAME. "ERROR:: Parameter -inputfile is required");
	FilesIO->checkFile($file, "ERROR::".$PROG_NAME.":: $file NOT Found");	
	String->isEmpty($col, $PROG_NAME. "ERROR:: Parameter -colPK is required");
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");

	print "inputFile=$file\n";
	print "col=$col\n";
	print "GT=$GT\n";
	print "T=$T\n";
	print "outputFile=$outputFile\n";
	print "verbose=$verbose\n";
	if ($sep ==1){
		$sep = "\t";
	}else{
		$sep = " +";
	}
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $line;			my @array;
	my $info = "";		my $count = 0;		my $countTotal = 0;
	
 	if (open(FILEIN, "$file")){
		while (my $line = <FILEIN>) {
			@array = split(/\t/, $line);
			if ($GT == 1){
				if ($array[$col] >= $T ){
					$info .= $line;
					$count++;
				}
			}else{
				if ($array[$col] <= $T ){
					$info .= $line;
					$count++;
				}
			}
			if ($count == 10000){
				FilesIO->apendFile($outputFile, $info, $verbose);
				$countTotal += $count;
				print "LOG::Saved ". $countTotal. "\n";
				$info = ""; $count= 0;
				
			}			
		}
 	}else{
 		print $PROG_NAME."::ERROR:: File $file is empty\n";
 	}
 	if ($info ne ""){
		FilesIO->apendFile($outputFile, $info, $verbose);
	}
}
	
