#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Hash;

my $fastaFile = "";
my $verbose = "false";
my $idsRemoveFile = ""; 
my $col = 0;
my $outputFile = "";

my $sepFasta = " +";
my $sepIDs = "\t";

my $PROG_NAME = "perlLib::run::removeSequencesFromFile.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-fastaFile"){
			$fastaFile= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-idsRemoveFile"){
			$idsRemoveFile = $ARGV[$counter+1];		
		}
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($fastaFile, $PROG_NAME. "ERROR:: Parameter -fastaFile is required");
	FilesIO->checkFile($fastaFile, "ERROR::".$PROG_NAME.":: $fastaFile NOT Found");
	
	FilesIO->checkFile($idsRemoveFile, "ERROR::".$PROG_NAME.":: $idsRemoveFile NOT Found");	
	String->isEmpty($idsRemoveFile, $PROG_NAME. "ERROR:: Parameter -idsRemoveFile is required");
		
	String->isEmpty($col, $PROG_NAME. "ERROR:: Parameter -colPK is required");
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");

	print "fastaFile=$fastaFile\n";
	print "col=$col\n";
	print "idsRemoveFile=$idsRemoveFile\n";
	print "outputFile=$outputFile\n";
	print "verbose=$verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $line;			my @array_aux;
	my $info = "";		my $i = 0;		my $annotation;
	my $sequence;		my $accProt;

	my %hash = FilesIO->fileToHash($idsRemoveFile, $sepIDs, 0); 
	
	#print Hash->printHash(\%hash);	
	
	
	my @sequences = FilesIO->lineFileToArray($fastaFile);
		
	print "total". scalar(@sequences)."\n";
	while ($i < scalar(@sequences)){
		if (index($sequences[$i],">") == 0){
			$annotation 	= $sequences[$i];
			@array_aux = split($sepFasta, $annotation);
			$accProt = 	 String->removeCaracter($array_aux[0], ">");			
		}
  		$i++;
 		
 		$sequence = "";
	    while ($i < scalar(@sequences) && (index($sequences[$i],">") != 0)){
 			$sequence.=  $sequences[$i];
            $i++;
            #print "i = $i \n";
        }      	
       # print "acc=".$accProt."--\n";	
        if (exists($hash{$accProt})){     	
                $info .= $annotation;
                $info .=  $sequence;
      			#print "entrou";
		}		
	}        
    
    FilesIO->saveFile($outputFile, $info, $verbose);
}
	
