#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Sequence::sequence;
use Align::Primary::STOCKHOLM;
use Align::Primary::nw_align;
use Util::Hash;
use Util::Array;

use analisys::analisys;
my @array_ev = ('1e-60', '1e-30','1e-15','1e-05','1','10');
	Analisys->initMatrixStaRow(2,\@array_ev);

#use HMMs::HMMER::hmmer;

#HMMER->getAllDomainHmmScan("/Users/julianab/projetos/PFAM_annotation/data/database/pfam/out.txt", "/Users/julianab/projetos/PFAM_annotation/data/database/pfam/out.txt.clean", "true");

#exit;
my $seqDir = "";

my $verbose    	= "false";
my $file = "";
my $date = "";
my $tmpDir = "";
my $NotDate = "false";

my $PROG_NAME = "PERL_LIB::run::rmFileByDate.pl";

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-file"){
			$file = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-date"){
			$date = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-NotDate"){
			$NotDate = $ARGV[$counter+1];
		}								
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEmpty($file, "ERROR::".$PROG_NAME.":: Parameter -file is required");
	FilesIO->checkFile($file, "ERROR::".$PROG_NAME.":: $file NOT Found");	
	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Verbose must be true or false");	
	String->isEmpty($date, "ERROR::".$PROG_NAME.":: Parameter -date is required ");
	
	print "-file = $file\n";
	print "-verbose = $verbose\n";
	print "-date = $date\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	
	$date =	String->replace($date, ":", " ");
	if ($NotDate eq "false"){
		FilesIO->removeFileByDate($file, $date, $verbose);
	}else{
		FilesIO->removeFileByNotDate($file, $date, $verbose);
	}
	
}
