#!/usr/bin/perl -w
use strict;


#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $dir_cemc		= "";

&getParameters;
&runCemcFamily;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}elsif ($ARGV[$counter] eq "-dircemc"){
			 $dir_cemc = $ARGV[$counter+1];
		}		 			
	}
}

############################ sub runCemcFamily ##################################
sub runCemcFamily{
	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $dir;
	my $name_file;
	my $new_sample;
	my $old_sample;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
    
    	@families = <FAMILYFILE>;
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;
			&moveFilesPdb($new_sample, $dir);
			
		}
		$old_sample = $new_sample;					
	}
	close FAMILYFILE;	
}

############################ sub moveFilesPdb ##################################
sub moveFilesPdb {
	my $new_sample	= $_[0];
	my $dir		= $_[1];
	my @array_file	= ();
	my @line_pdb	= ();
	my $line;
	my $pathFileFrom;
	my $pathDirTo;

	my $path_pdb_id = $dir.$new_sample."/pdb/". $new_sample	.".ids";

	unless (open(FILE, "$path_pdb_id")) {
       		print "Could not open file $path_pdb_id !\n";
        	exit;
	}
	@array_file = <FILE>;
	
	foreach $line (@array_file){
		@line_pdb = split(/:/,$line);
		print "$new_sample  ". $line_pdb[0]. "\n";
		$pathFileFrom = $dir. "pdb_files/pdb". $line_pdb[0]. ".ent";
		$pathDirTo = $dir_cemc . "data/";
		&copyPdbFileToCemc($pathFileFrom,$pathDirTo);		
	}

	#run cemc
	
	close FILE;
}

############################ sub copyPdbFileToCemc ##################################
sub copyPdbFileToCemc {
	my $pathFileFrom	= $_[0];	
	my $pathDirTo		= $_[1];
	
	my $cmd = "cp $pathFileFrom $pathDirTo";
	print $cmd. "\n";
	system ($cmd);
}
