

#!/usr/bin/perl -w

my $file_family;
my $dir_log;
my $log_file = "runClustalw.log";

unless (open(LOGFILE, ">$log_file")){
	print "$log_file was not created\n";
}

&getParameters();
&alignSequences();

close LOGFILE;
############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$file_family = $ARGV[$counter+1];		
		}
	}
}

############################ sub alignSequences #################################
sub alignSequences {
	my @families	= ();
	my @each_family;
	my $entry;
	my $pattern;
	my $pattern_old	= "";
	my $input_file_name_clustalw ="";
	my $output_file_name_clustalw = "";
	my $dir;
	my $new_sample =""; my $old_sample = "";
	my $dir_clustal;
	#read scop table file
	unless (open(FAMILYFILE, "$file_family")) {
       		print "Could not open file $file_family !\n";
        	exit;
	}
	my $count = 0;
	@families = <FAMILYFILE>;
	
	foreach $entry (@families) {
		
		@each_family	= split(/ +/,$entry);
		$new_sample = $each_family[0];
		
		if ($new_sample ne $old_sample){
			$dir = substr($each_family[4],0,index($each_family[4],"\n")). "/" ;
			$dir_clustal = $dir. $new_sample."/alignment/clustalw/";
			$dir_seq		 = $dir. $new_sample."/sequence/";
			opendir MYDIR, $dir_clustal;
			my @contents = readdir MYDIR;
			closedir MYDIR;
			if (scalar(@contents) == 0){
				mkdir $dir_clustal;			
			}
			$input_file_name_clustalw  = $dir_seq.$new_sample. ".clustal";
			
			$output_file_name_clustalw = $dir_clustal.$new_sample.".clustalw";
			#print $output_file_name_clustalw."\n";
			&alignClustalw($input_file_name_clustalw, $output_file_name_clustalw);
			
			
			
    		$old_sample = $new_sample;
			$count = $count +1;
		}
		
	}
	print "contador $count\n";
	close FAMILYFILE;
	
}

############################ sub getPattern ####################################
sub getPattern {
	my $num 	= $_[0];
	my $sep		= $_[1];
	my $string 	= $_[2];
	my $counter;
	my $indice;
	my $new_string 	= "";

	for($counter = 0 ; $counter < $num  ; $counter++){
		$indice 	= index($string, $sep);
		if ($indice >=0){
			$new_string 	= $new_string . substr($string,0,$indice+1);
			$string		= substr($string,$indice+1, length($string));			
		}
	}
	return $new_string;	
}

############################ sub alignClustalw #################################
sub alignClustalw{
	my $input_file_name	= $_[0];
	my $output_file_name	= $_[1];
	

	my $cmd = "clustalw -OUTFILE=$output_file_name -OUTORDER=INPUT -SEQNOS=OFF -MATRIX=GONNET -INFILE=$input_file_name";
	print  LOGFILE " File $input_file_name created \n";
	system ($cmd);
}




