#!/usr/bin/perl -w
use strict;
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use File::Files;

#Variaveis que comportam os parametros de entrada

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file		= "";
my $calib		= "yes";	
my $set_file		= "";
my $file_log		= "";
my $on_resume		= "no";

my $path_program  = "";

my $build_program	= "hmmbuild";
my $calibrate_program 	= "hmmcalibrate";
my $search_program 	= "hmmsearch";

my $kind_align		= "clustalw";
my $ext_align		= "";
my $ext_pdb		= "";
my $ext_mat		= "";
my $kind_calib		= "calibrated";	
my $work_fold		= "hmmer_atp";
my $parameters_build	= "";
my $parameters_search	= "";


my $linker_program	= "linker_Hmmer_PDB";
&getParameters;
&readParametersFile;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		}
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}

	unless (open(SETFILE, "$set_file")) {
   		print "oiCould not open file $set_file !\n";
     		exit;
   	}
	#print "oi $set_file";
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";
	my $i;

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     		exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)> 1){
			#$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			$value = "";
			for ($i=1; $i<scalar(@array_settings); $i++){
				if (index($array_settings[$i],"\n") < 0){
					$value .=$array_settings[$i];
				}
				else{
					$value .= substr($array_settings[$i],0,index($array_settings[1],"\n"));
				}
				if ($i<scalar(@array_settings)-1){$value .=" ";}
			}
						
			if ($array_settings[0] eq "p_path_program"){
				$path_program = $value;					
			}elsif ($array_settings[0] eq "p_build_program"){
				$build_program = $value;				
			}elsif ($array_settings[0] eq "p_calibrate_program"){
				$calibrate_program = $value;
			}elsif ($array_settings[0] eq "p_search_program"){
				$search_program = $value;
			}elsif ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;
			}elsif ($array_settings[0] eq "p_parameters_build"){
				$parameters_build = $value;
			}elsif ($array_settings[0] eq "p_parameters_search"){
				$parameters_search = $value;
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;
			}elsif ($array_settings[0] eq "p_ext_align"){
				$ext_align = $value;
			}elsif ($array_settings[0] eq "p_ext_pdb"){
				$ext_pdb = $value;
			}elsif ($array_settings[0] eq "p_ext_mat"){
				$ext_mat = $value;
			}elsif ($array_settings[0] eq "p_db"){
				$db_file = $value;
			}elsif ($array_settings[0] eq "p_calib"){
				$calib  = $value;
			}elsif ($array_settings[0] eq "p_file_log"){
				$file_log  = $value;
			}elsif ($array_settings[0] eq "p_on_resume"){
				$on_resume  = $value;
			}										
		}
	}	
	
	close SETFILE;
}

############################ sub main ##################################
sub main {
	my @families 		= ();
	my @family 		= ();
	my $entry		= "";
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir			= "";
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	print "\n";
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&runHMMER3dToGroup($new_sample,$dir); 
		}
		$old_sample = $new_sample;					
	}
	system ("date");
	close FAMILYFILE;
}
############################ sub runHMMERToGroup ################################
sub runHMMER3dToGroup {
	my $sample		= $_[0];
	my $dir			= $_[1];
	my @gruop_ids_file	= ();
	my @gruop_ids		= ();
	my $item 		= "";
	my $info_file		= "";
	my $chain		= "";
	my $id_pdb		= "";
	my $group_id		= "";
	my $qtd_seq		= 0;
	
	my $dir_pdb = $dir . $sample."/pdb/";
	my $path    = $dir_pdb.$sample.".groups";
	
	if (open(FILEG,"$path")){
		#print $path;
		@gruop_ids_file = <FILEG>;
		#@gruop_ids = split(/\n/,$gruop_ids_file);
		foreach $item (@gruop_ids_file){
			@gruop_ids = split(/ +/, $item); 
			$qtd_seq = substr($gruop_ids[1],0,index($gruop_ids[1],"\n"));
			if ($qtd_seq >1){
				system ("date");
				#&runLinkerHmmer($sample,$dir,$gruop_ids[0]);
				&runHmmBuild($sample,$dir,$gruop_ids[0]);
				if ($calib eq "yes"){
					&runCalibrate($sample,$dir,$gruop_ids[0]); 
				}
				system ("date");
			}
		}
		#&saveFile($dir_pdb.$sample.".pdb",$info_file);	
		close FILEG;
	}	
	else{
		print "ERROR: file $path not found\n";
	}	
}
############################ sub runLinkerHmmer ##################################

sub runLinkerHmmer {
	my $sample		= $_[0];
	my $dir			= $_[1];
	my $group_id		= $_[2];

	my $model_file_name   	= "hmmer3d_$group_id.hmm";
	#my $aln_file_name     	=  $sample."-FINAL.aln";
	my $aln_file_name     	=  $group_id.$ext_align;
	my $aln3d_new_file_name =  $group_id.$ext_mat;
	my $aln3d_file_name   	=  $group_id.$ext_pdb;

	my $dir_aln	  	=  $dir. $sample. "/alignment/$kind_align/";
	my $dir_aln_pdb		=  $dir. $sample. "/alignment/$kind_align/";
	my $parameters		=  "-align_$kind_align $dir_aln$aln_file_name -";
	$parameters		.=  $kind_align."_pdb $dir_aln_pdb$aln3d_file_name";

	#if (open(ALNFILE,$dir_aln.$aln3d_new_file_name)){
	#	print "file $dir_aln$aln3d_new_file_name already created.\n";
	#	close ALNFILE;
	#}
	#else{
	
		if (open(ALNFILE,$dir_aln_pdb.$aln3d_file_name)){
			my $cmd = $linker_program. " ".$parameters;
			print  "\n linker ". $cmd. "\n";
			system $cmd;		
			close ALNFILE;
		}
		else{
			print "File $dir_aln_pdb$aln3d_file_name not found\n";
		}		
	#}	
}

############################### sub runHmmBuild ####################################
sub runHmmBuild {
	my $sample		= $_[0];
	my $dir			= $_[1];
	my $group_id		= $_[2];

	my $model_file_name	= "hmmer_$group_id.hmm";
	my $aln_file_name   	=  $group_id."$ext_align";
	my $matriz_file_name 	=  $group_id."$ext_mat";
	my $msg = "";

	my $dir_aln	= $dir. $sample. "/alignment/$kind_align/";
	my $dir_model	= $dir. $sample. "/models/$kind_align/";
		
	my $parameters 		= $parameters_build ;#." --pdb $dir_aln$matriz_file_name";

	#if (open(MODELFILE,$dir_hmmer_model.$model_file_name)){
	#	print "file $dir_model$model_file_name already created.\n";
	#	close MODELFILE;
	#}
	#else{
		if (FilesIO->isDirectory($dir_model) eq "false"){
			mkdir $dir_model;		
		}
		$dir_model .= "$kind_calib/";
		if (FilesIO->isDirectory($dir_model) eq "false"){
				mkdir $dir_model;
		}
		my $dir_hmmer_model 	= $dir_model."$work_fold/";
		if (FilesIO->isDirectory($dir_hmmer_model) eq "false"){
			mkdir $dir_hmmer_model;	
		}
		
		my $cmd = $path_program.$build_program. " ".$parameters. " ";
		$cmd   .= $dir_hmmer_model.$model_file_name. " ". $dir_aln.$aln_file_name;
		print $cmd. "\n";
		system $cmd;
	#}	
}
############################ sub runCalibrate ##################################
sub runCalibrate {
	my $sample		= $_[0];
	my $dir			= $_[1];
	my $group_id		= $_[2];

	my $model_file_name = "hmmer_$group_id.hmm";
	my $dir_model = $dir. $sample. "/models/$kind_align/$kind_calib/";
	my $dir_hmmer_model = $dir_model."$work_fold/";

	if (open(MODELFILE,$dir_hmmer_model.$model_file_name)){
		my $cmd = $path_program.$calibrate_program. " ". $dir_hmmer_model .$model_file_name;
		print  "# Stating Calibrate\n ";
		system $cmd;
		print  $cmd. "\n";
		close MODELFILE;
	}
	else{
		print  "ERROR: file $dir_model$model_file_name have not created.\n";
	}	
}
############################ sub runSearch ##################################
sub runSearch {
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $model_file_name = "hmmer3d_$sample.hmm";
	my $result_file_name = "hmmer3d_$sample.result";
	
	my $dir_hmmer_model = "";
	my $dir_result = "";
	
	
	
	$dir_hmmer_model	= $dir. $sample. "/models/$kind_align/$kind_calib/hmmer3d/";	
	$dir_result	= $dir. $sample. "/result/$kind_align/";
	

	

	if (open(MODELFILE,$dir_hmmer_model.$model_file_name)){
		if (&isDirectory($dir_result) eq "false"){
			mkdir $dir_result;		
		}
		$dir_result .= "$kind_calib/";
		if (&isDirectory($dir_result) eq "false"){
			mkdir $dir_result;		
		}
		my $dir_hmmer_result	= $dir_result. "hmmer3d/";
		if (&isDirectory($dir_hmmer_result) eq "false"){
			mkdir $dir_hmmer_result;		
		}

		my $param = " -E 10 -T -100 ";	
		my $cmd = $search_program. " $param ".$dir_hmmer_model.$model_file_name. " ". $db_file. " > ".$dir_hmmer_result.$result_file_name ;
		print $cmd. "\n";
		system $cmd;
		close MODELFILE;
	}
	else{
		print "ERROR: file $dir_hmmer_model.$model_file_name have not created.\n";
	}	
}

############################ sub isDirectory ##################################
sub isDirectory {
	my $dir		= $_[0];
	opendir MYDIR, $dir;
	my @contents = readdir MYDIR;
	closedir MYDIR;
	if (scalar(@contents) == 0){
		return "false";	
	}
	return "true";
}
