#!/usr/bin/perl -w
use strict;
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use File::Files;


#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file			= "";
my $calib			= "yes";	
my $set_file		= "";
my $file_log		= "";
my $on_resume		= "no";

my $path_program  = "";

my $build_program			= "hmmbuild";
my $calibrate_program 	= "hmmcalibrate";
my $search_program 		= "hmmsearch";

my $kind_align				= "mammoth";
my $ext_align				= "";
my $kind_calib				= "calibrated";	
my $work_fold				= "hmmer_atp";
my $parameters_build		= "";
my $parameters_search	= "";


&getParameters;

&readParametersFile;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		}
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}

	unless (open(SETFILE, "$set_file")) {
   	print "oiCould not open file $set_file !\n";
     	exit;
   }
	print "oi $set_file";
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";
	my $i;

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     	exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)> 1){
			#$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			$value = "";
			for ($i=1; $i<scalar(@array_settings); $i++){
				if (index($array_settings[$i],"\n") < 0){
					$value .=$array_settings[$i];
				}
				else{
					$value .= substr($array_settings[$i],0,index($array_settings[1],"\n"));
				}
				if ($i<scalar(@array_settings)-1){$value .=" ";}
			}
						
			if ($array_settings[0] eq "p_path_program"){
				$path_program = $value;					
			}elsif ($array_settings[0] eq "p_build_program"){
				$build_program = $value;				
			}elsif ($array_settings[0] eq "p_calibrate_program"){
				$calibrate_program = $value;
			}elsif ($array_settings[0] eq "p_search_program"){
				$search_program = $value;
			}elsif ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;
			}elsif ($array_settings[0] eq "p_parameters_build"){
				$parameters_build = $value;
			}elsif ($array_settings[0] eq "p_parameters_search"){
				$parameters_search = $value;
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;
			}elsif ($array_settings[0] eq "p_ext_align"){
				$ext_align = $value;
			}elsif ($array_settings[0] eq "p_db"){
				$db_file = $value;
			}elsif ($array_settings[0] eq "p_calib"){
				$calib  = $value;
			}elsif ($array_settings[0] eq "p_file_log"){
				$file_log  = $value;
			}elsif ($array_settings[0] eq "p_on_resume"){
				$on_resume  = $value;
			}										
		}
	}	
	
	close SETFILE;
}
############################ sub getParameters ##################################
sub main {
	my @families 		= ();
	my @family 			= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	print "\n ================= Inicio ";
	system("date");
 	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			system ("date");
			if ($calib eq "yes"){
				#&runCalibrate($new_sample,$dir); 
			}
			&runSearch($new_sample,$dir,"_2d"); 
			&runSearch($new_sample,$dir,"_3d"); 
			&runSearch($new_sample,$dir,"_acc"); 
			&runSearch($new_sample,$dir,"_oi"); 
			system ("date");			
		}
		$old_sample = $new_sample;					
	}
	print "\n ================= Fim ";
	system ("date");
	close FAMILYFILE;
}
############################ sub runHmmBuild ##################################
sub runHmmBuild{
	my $sample		= $_[0];
	my $dir			= $_[1];


	my $model_file_name = "hmmer_$sample.hmm";
	#my $aln_file_name   =  $sample."-FINAL.aln";
	my $aln_file_name   =  $sample."$ext_align";
	my $msg = "";

	my $dir_aln	  = $dir. $sample. "/alignment/$kind_align/";
	my $dir_model = $dir. $sample. "/models/$kind_align/";
	
		
	if ($on_resume eq "yes" && open(MODELFILE,$dir_model."$kind_calib/".$model_file_name)){
		print  "file $dir_model$model_file_name already created.\n";
		close MODELFILE;
	}
	else{
		if (&isDirectory($dir_model) eq "false"){
			mkdir $dir_model;		
		}
		$dir_model .= "$kind_calib/";
		if (&isDirectory($dir_model) eq "false"){
				mkdir $dir_model;
		}
		my $dir_hmmer_model = $dir_model."$work_fold/";
		if (&isDirectory($dir_hmmer_model) eq "false"){
			mkdir $dir_hmmer_model;	
		}
		print  "# Stating Hmmbuild\n ";
		my $cmd = $path_program.$build_program. " $parameters_build ". $dir_hmmer_model.$model_file_name. " ". $dir_aln.$aln_file_name;
		system ($cmd);
		print  "# $cmd \n";
		#print  &findError($msg, "FATAL"). "\n";		
	}	
}
############################ sub runCalibrate ##################################
sub runCalibrate{
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $model_file_name = "hmmer_$sample.hmm";
	my $dir_model = $dir. $sample. "/models/$kind_align/$kind_calib/";
	my $dir_hmmer_model = $dir_model."$work_fold/";

	if (open(MODELFILE,$dir_hmmer_model.$model_file_name)){
		my $cmd = $path_program.$calibrate_program. " ". $dir_hmmer_model .$model_file_name;
		print  "# Stating Calibrate\n ";
		system $cmd;
		print  $cmd. "\n";
		close MODELFILE;
	}
	else{
		print  "ERROR: file $dir_model$model_file_name have not created.\n";
	}	
}
############################ sub runSearch ##################################
sub runSearch{
	my $sample		= $_[0];
	my $dir			= $_[1];
	my $kind_model	= $_[2];

	my $model_file_name = "hmmer_$sample$kind_model.hmm";
	my $result_file_name = "hmmer_$sample$kind_model.result";
	my $dir_hmmer_model = "";
	my $dir_result = "";
	
	
	$dir_hmmer_model	= $dir. $sample. "/models/$kind_align/$kind_calib/$work_fold/";	
	$dir_result	= $dir. $sample. "/result/$kind_align/$kind_calib/$work_fold/";
	

	if (open(MODELFILE,$dir_hmmer_model.$model_file_name)){
		if (FilesIO->isDirectory($dir_result) eq "false"){
			FilesIO->createDirectory($dir_result);		
		}
		print  "# Stating Search\n ";
		my $cmd = $path_program.$search_program. " $parameters_search ".$dir_hmmer_model.$model_file_name. " ". $db_file. " > ".$dir_result.$result_file_name ;
		print  $cmd. "\n";

		system $cmd;
		close MODELFILE;
	}
	else{
		print  "ERROR: file $dir_hmmer_model$model_file_name have not created.\n";
	}	
}

############################ sub isDirectory ##################################
sub isDirectory{
	my $dir		= $_[0];
	opendir MYDIR, $dir;
	my @contents = readdir MYDIR;
	closedir MYDIR;
	if (scalar(@contents) == 0){
		return "false";	
	}
	return "true";
}

############################ sub findError ##################################
sub findError{
	my $msg		= $_[0];
	my $tag		= $_[1];
	
	my @array_msg = split(/\n/, $msg);
	my $entry	  = "";
	
	foreach $entry (@array_msg){
		print "msg ". $entry."\n";
		if (index($entry, $tag) >=0){
			return $entry;
		}
	}
	return "";
}
