use strict;

use strict;
use lib "/home/juliana/tese/desenvolvimento/scripts_perl/teste_scop";
use File::Files;

#Variaveis que comportam os parametros de entrada
my $in_file 		= "";
my $db_file		= "";
my $calib		= "yes";	
my $set_file		= "";
my $file_log		= "";
my $on_resume		= "no";

my $path_program  = "";

my $build_program	= "hmmbuild";
my $calibrate_program 	= "hmmcalibrate";
my $search_program 	= "hmmpfam";

my $kind_align		= "clustalw";
my $ext_align		= "";
my $kind_calib		= "calibrated";	
my $work_fold		= "hmmer";
my $parameters_build	= "";
my $parameters_search	= "";


&getParameters;
&readParametersFile;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-setFile"){
			$set_file = $ARGV[$counter+1];		
		}
	}
}
############################ sub readParametersFile ##################################
sub readParametersFile {
	unless ($set_file ne ""){
		print "Setting file not found!\n";
		exit;
	}

	unless (open(SETFILE, "$set_file")) {
   		print "Could not open file $set_file !\n";
     		exit;
   	}
	#print "oi $set_file";
	my @array_set_file	= ();
	my @array_settings	= ();
	my $entry				= "";
	my $value				= "";
	my $i;

	@array_set_file = <SETFILE>;
	if (scalar(@array_set_file)< 0){
		print "File $set_file is empty!\n";
     		exit;
	}
	foreach $entry (@array_set_file) {
		@array_settings	= split(/ +/,$entry);
		
		if (index($array_settings[0],"#")< 0 && scalar(@array_settings)> 1){
			#$value = substr($array_settings[1],0,index($array_settings[1],"\n"));
			$value = "";
			for ($i=1; $i<scalar(@array_settings); $i++){
				if (index($array_settings[$i],"\n") < 0){
					$value .=$array_settings[$i];
				}
				else{
					$value .= substr($array_settings[$i],0,index($array_settings[1],"\n"));
				}
				if ($i<scalar(@array_settings)-1){$value .=" ";}
			}
						
			if ($array_settings[0] eq "p_path_program"){
				$path_program = $value;					
			}elsif ($array_settings[0] eq "p_kind_align"){
				$kind_align = $value;
			}elsif ($array_settings[0] eq "p_kind_calib"){
				$kind_calib = $value;
			}elsif ($array_settings[0] eq "p_work_fold"){
				$work_fold = $value;
			}elsif ($array_settings[0] eq "p_parameters_search"){
				$parameters_search = $value;
			}elsif ($array_settings[0] eq "p_file_in"){
				$in_file = $value;
			}elsif ($array_settings[0] eq "p_ext_align"){
				$ext_align = $value;
			}elsif ($array_settings[0] eq "p_db"){
				$db_file = $value;
			}elsif ($array_settings[0] eq "p_calib"){
				$calib  = $value;
			}elsif ($array_settings[0] eq "p_on_resume"){
				$on_resume  = $value;
			}	
		}
	}	
	
	close SETFILE;
}
############################ sub main ##################################
sub main {
	my @families 		= ();
	my @family 		= ();
	my $entry		= "";
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir			= "";
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	print "\n";
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			system ("date")
			&runHmmPfam($new_sample,$dir); 
		}
		$old_sample = $new_sample;	
	}
	system ("date");
	close FAMILYFILE;
}

############################ sub runHmmPfam ##################################
sub runHmmPfam {
	my $sample		= $_[0];
	my $dir			= $_[1];

	my $model_file_name = "hmmer_cat_$sample.hmm";
	my $result_file_name = "hmmpfamVit_$sample.result";
	my $dir_hmmer_model = "";
	my $dir_result = "";
	
	
	$dir_hmmer_model	= $dir. $sample. "/models/$kind_align/$kind_calib/$work_fold/";	
	$dir_result		= $dir. $sample. "/result/$kind_align/";
	

	if (open(MODELFILE,$dir_hmmer_model.$model_file_name)){
		if (FilesIO->isDirectory($dir_result) eq "false"){
			mkdir $dir_result;		
		}
		$dir_result .= "$kind_calib/";
		if (FilesIO->isDirectory($dir_result) eq "false"){
			mkdir $dir_result;		
		}
		my $dir_hmmer_result	= $dir_result. "$work_fold/";
		if (FilesIO->isDirectory($dir_hmmer_result) eq "false"){
			mkdir $dir_hmmer_result;		
		}
                if (FilesIO->isFile($dir_hmmer_result.$result_file_name) eq "false") {
		  print  "# Stating Search with hmmpfam \n ";
		  my $cmd = $path_program.$search_program. " $parameters_search ".$dir_hmmer_model.$model_file_name. " ";
		  $cmd .= $db_file. " > ".$dir_hmmer_result.$result_file_name ;
		  print  $cmd. "\n";
		  system $cmd;
                }
                else{
                  print  "ERROR: file $dir_hmmer_result.$result_file_name already have created.\n";
                }  
		close MODELFILE;
	}
	else{
		print  "ERROR: file $dir_hmmer_model$model_file_name have not created.\n";
	}	
}
