#!/usr/bin/perl -w
use strict;


#Variaveis que comportam os parametros de entrada
my $in_file 		= "";

my $home_mammoth 	= "/home/juliana/tese/desenvolvimento/mammoth/./mammothmult"; 

&getParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-filein"){
			$in_file = $ARGV[$counter+1];		
		}			
	}
}

############################ sub main #####################################
sub main{
	my @families 		= ();
	my @family 		= ();
	my $entry;
	my $old_sample		= "";
	my $new_sample		= "";
	my $dir;
		
	#read family file
	unless (open(FAMILYFILE, "$in_file")) {
       		print "Could not open file $in_file !\n";
        	exit;
    	}
	@families = <FAMILYFILE>;
	system ("date");
	print "\n";
	foreach $entry (@families) {
		@family	= split(/ +/,$entry);
		$new_sample = $family[0];
		#print $new_sample ."\n";
		if ($new_sample ne $old_sample){
			$dir = substr($family[4],0,index($family[4],"\n")). "/" ;	
			&runMammoth($new_sample,$dir); 
		}
		$old_sample = $new_sample;					
	}
	system ("date");
	close FAMILYFILE;

}
############################ sub runMammoth #####################################
sub runMammoth{
	my $sample	= $_[0];
	my $dir		= $_[1];

	my $general_dir	  = $dir.$sample;
	my $dir_pdb	  = $general_dir."/pdb/";
	my $file_pdb      = $sample.".pdb";
	my $aln_1d	  = $sample."-FINAL.aln";
	my $aln_3d	  = $sample."-FINAL.pdb";
	my $aln_log	  = $sample."-FINAL.log";
	my $dir_aln	  = $general_dir."/alignment/";
	my $cmd		  = $home_mammoth. " $file_pdb";
	my $msg		  = "";
	
	chdir($dir_pdb);
	if (open(FILEPDB,"$file_pdb")){
		#if (open(FILE3D,"$dir_aln.$aln_3d")){
		#	close FILE3D;
		#	print "file already created $dir_aln.$aln_3d\n";
		#}
		#else{
			mkdir($dir_aln);
		
			print $cmd ."\n";
			$msg = system($cmd);
			if ($msg == 0){
				system ("mv $aln_1d $dir_aln");
				system ("mv $aln_3d $dir_aln");
				system ("mv $aln_log $dir_aln");
				print "Success!!\n";
			}
			else{
				print "Error $msg!\n";
			}
		#}
	}
	else{
		print "error file $file_pdb not found \n";
	}
	close FILEPDB;
}
