#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Database::ScopPattern;

my $trans_factor_table 	= "";
my @scriptParameters		= ();
my @commandParameters 		= ();
my @prePostParameters		= ();
my @posPostParameters		= ();

my $logDir 			= "";
my $kindRun 		= "";
my $nameRun			= "";
my $info 			= "";
my $prePost			= "";
my $posPost			= "";
my $verbose			= "false";
my $qtdFile			= "";
my $cmd_total		= "";
my $count			= 0;
my $total_families  = 0;



my $counter = 0;
my $ending_value = scalar(@ARGV);

my $PROG_NAME = "transFactor::scripts::run::runTestSetPFAMFamily";


&getparameters;
&checkparametersScript;
&main_scop;



############################ sub getparametersScript ##################################
sub getparameters {
	
	$counter = 0 ; 
	while ( $counter < $ending_value){
		if($ARGV[$counter] eq "-trans_factor_table"){
			$trans_factor_table = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-nameRun"){
			$nameRun = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-logDir"){
			$logDir = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-kindRun"){
			$kindRun = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-qtdFile"){
			$qtdFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-prePost"){
			$counter++;
			@prePostParameters = &getparametersScript("-prePost");				
		}elsif($ARGV[$counter] eq "-posPost"){
			$counter++;
			@posPostParameters = &getparametersScript("-posPost");			
		}elsif($ARGV[$counter] eq "-scriptParameters"){
			$counter++;
			@scriptParameters = &getparametersScript("-scriptParameters");
		}elsif($ARGV[$counter] eq "-commandParameters"){
			$counter++;
			@commandParameters = &getparametersScript("-commandParameters")
		}
		$counter++;
	}
}

############################ sub getparametersScript ##################################
sub getparametersScript {
	my $name_parameter			= $_[0];	
	my $parameters_info = "";
	my @parameters = ();
	my $i = 0;
	
	
	if ($ARGV[$counter] ne "("){
		print "ERROR::runTestSet:: Incorrect $name_parameter must be (list of parameter)\n";
		exit;
	}	
	$counter++;
	while ($ARGV[$counter] ne ")" && $counter < $ending_value){
		$parameters_info .= $ARGV[$counter]. " ";
		#push(@parameters, $ARGV[$counter]);
		$counter++;						
	}
	if ($ARGV[$counter] ne ")"){
		print "ERROR::runTestSet:: Incorrect -$name_parameter must be (list of parameter)\n";
		exit;
	}
	@parameters = split(/,/, $parameters_info);
	
	return 	@parameters;
	
}

############################ sub checkparametersScript ##################################
sub checkparametersScript {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	
	String->isEmpty($trans_factor_table, "ERROR::".$PROG_NAME.":: List with Pfam acc numbers is required");
	FilesIO->checkFile($trans_factor_table, "ERROR::".$PROG_NAME.":: File NOT exists ".$trans_factor_table);	
	
	String->isEmpty($logDir, "ERROR::".$PROG_NAME.":: Log directory is required ");
	String->isEmpty($nameRun, "ERROR::".$PROG_NAME.":: Job name is required ");
	String->isEqual($verbose,"true,false", "ERROR:: Verbose must be true or false");
	
	print "-trans_factor_table = $trans_factor_table\n";	
	print "-logDir = $logDir\n";
	print "-nameRun = $nameRun\n";	
	print "-verbose = $verbose\n";		
	print "ok\n";
}	

########################### sub main ##################################
sub main_scop {
	my @families 		= ();
	
	my $family		= "";
	my $keyword		= "";
	my $sequenceId		= "";
	my $organism		= "";
	my $startAA_endAA	= "";

	@families = FilesIO->fileToArray2d($trans_factor_table, "\t");
	$total_families = scalar(@families);
	for(my $i=0; $i<scalar(@families); $i++) {
		if (index($families[$i][0],"\n") != 0 and index($families[$i][0],"#") != 0){
			$family= $families[$i][0];
			$keyword = $families[$i][1];
			$sequenceId = $families[$i][2];
			$organism = $families[$i][3];
			$startAA_endAA = $families[$i][4]; 	
			&runFamily($family, $keyword, $sequenceId, $organism, $startAA_endAA, $i +1);			
		}
	}
	FilesIO->saveFile($logDir.$nameRun.".sh", $info, "false");		
}

############################ sub main ##################################
sub runFamily {
	my $factor		= $_[0];
	my $keyword		= $_[1];	
	my $sequenceId	= $_[2];
	my $organism	= $_[3];
	my $startAA_endAA	= $_[4];
	my $count_file	= $_[5];
	
	my $file_name = "";
	
	#prePost 
	my $cmd = readArray($factor, $keyword, $sequenceId, $organism, $startAA_endAA, "\n", \@prePostParameters)."\n";	
	$cmd .= readArray($factor, $keyword, $sequenceId, $organism, $startAA_endAA,"",\@scriptParameters)."\n\n";	
	$cmd .= readArray($factor, $keyword, $sequenceId, $organism,$startAA_endAA,"\n",\@posPostParameters)."\n";
	
	$cmd_total .= $cmd;
	my $x = $count_file % $qtdFile;
	
	if (($x == 0 && $count_file != 0) || $count_file == $total_families){
		$cmd_total = &getSingleCmds($cmd_total);		
		$file_name = $logDir."$nameRun.file$count.sh";	
		if (index($cmd_total, "NUM_FILE") >= 0){
			$cmd_total =~ s/NUM_FILE/$count/g;
		}
		FilesIO->saveFile($file_name, $cmd_total, $verbose);
		
		if ($verbose eq "true"){
			print "LOG::" . $cmd_total."\n";
		}	

		$cmd = "";
		$cmd = readArray($factor, $keyword, $sequenceId, $organism, $startAA_endAA, "",\@commandParameters);
		$cmd .= $file_name."\n";
	
		if ($verbose eq "true"){
			print "LOG::" . $cmd."\n";
		}	
		$info .= $cmd;	
		$cmd_total = "";
		$count++;
	}					
}
############################ sub main ##################################
sub getSingleCmds{
	my $comand_lines 	= $_[0];
	 
	my $CMD = "";			my $START_CMD_ONCE	= "";
	my $END_CMD_ONCE= "";	my $line = "";
	my %dup_hash = ();
	  
	my @array = split(/\n/, $comand_lines);
	for (my $i=0; $i< scalar(@array); $i++){
	  	#print $array[$i]."\t".index($array[$i], "TOP")."\n";
		if (index($array[$i], "TOP") == 1){
			$line = substr($array[$i], 4, length($array[$i]));
			if (!exists($dup_hash{$line})){
				$START_CMD_ONCE .= $line."\n";
				$dup_hash{$line} = "";
			}	  		
	  	}elsif(index($array[$i], "BOTTOM") == 1){
	  		$line = substr($array[$i], 7, length($array[$i]));
			if (!exists($dup_hash{$line})){
				$END_CMD_ONCE .= $line."\n";
				$dup_hash{$line} = "";
			}	
	  	}else{
	  		$CMD .= $array[$i]."\n";
	  	}	  	
	 }
	 return $START_CMD_ONCE."\n\n".$CMD."\n\n".$END_CMD_ONCE;	
}

############################ sub main ##################################
sub readArray {
	
	my ($factor, $keyword, $sequenceId, $organism, $startAA_endAA, $endLine, $ref_firstArray) = @_;
	my $value2;
	my $sp = " ";
	my $cmd = "";
	
	for (my $i=0; $i< scalar(@{$ref_firstArray}); $i++){
		if (index(@{$ref_firstArray}[$i],"-virtualPath") >=0){
			$value2 = @{$ref_firstArray}[$i];		
		}else{
			$value2 =replaceData($factor, $keyword, $sequenceId, $organism,$startAA_endAA, @{$ref_firstArray}[$i]);				
		}				
		#print $value2."\n";
		if (index($value2,"END_LINE") >= 0){
			$cmd .= "\n\n";
		}else{
			$cmd .= $value2.$endLine;	
		}
				
	}	
	#print $cmd."\n";
	return $cmd;
	#exit;    
}

############################ sub main ##################################
sub replaceData {
	
	my $factor		= $_[0];
	my $keyword		= $_[1];	
	my $sequenceId	= $_[2];
	my $organism	= $_[3];
	my $startAA_endAA= $_[4];
	my $value2		= $_[5];
	#print "replaceDataFamily in ". $value2."\t";
	
	
	if (index(($value2),("FAMILY_FACTOR")) >= 0){
		$value2 = String->replace($value2,"FAMILY_FACTOR", $factor);						
	}	
	
	if (index(($value2),("KEYWORD")) >= 0){
		$value2 = String->replace($value2,"KEYWORD_FACTOR", $keyword); 							
	}
	
	if (index(($value2),("SEQUENCE_ID")) >= 0){
		$value2 = String->replace($value2,"SEQUENCE_ID", $sequenceId); 							
	}
	
	if (index(($value2),("ORGANISM")) >= 0){
		$value2 = String->replace($value2,"ORGANISM", $organism); 							
	}
	
	if (index(($value2),("STARTAA_ENDAA")) >= 0){
		$value2 = String->replace($value2,"STARTAA_ENDAA", $startAA_endAA); 							
	}

	if (index(($value2),("COMMA")) >= 0){
		$value2 = String->replace($value2,"COMMA", ","); 							
	}
	
	
	#print "out ". $value2."\n";
	return $value2;
}
