#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use HMMs::HMMER::hmmer;
use Align::Primary::STOCKHOLM;

my $alnFile 	= "";
my $modelFile 	= "";
my $verbose		= "false";


my $PROG_NAME = "perlLib::run::run_hmmer3.pl";	
	
&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-alnFile"){
			$alnFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-modelFile"){
			$modelFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}	   			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	String->isEmpty($alnFile, "ERROR::".$PROG_NAME."::  Parameter -alnFile having the alignment file  is required");
	FilesIO->checkFile($alnFile, "ERROR::".$PROG_NAME.":: File NOT found ".$alnFile);	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($modelFile, "ERROR::".$PROG_NAME.":: Parameter -modelFile having the model file name is required");


	print "-alnFile = $alnFile\n";
	print "-modelFile = $modelFile\n";
	print "-verbose = $verbose\n";
	print "ok\n";	
}	

############################ sub main ##################################
sub main {
	
	STOCKHOLM->convertToSTOCKHOLM($alnFile, $alnFile.".sto", $verbose);
	HMMER->buildModel($modelFile, $alnFile.".sto", "", "", $verbose);
		
}