#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use HMMs::HMMER::hmmer;


my $modelFile 	= "";
my $database 	= "";
my $familyId	= "";
my $resultFile 	= "";
my $verbose		= "false";
my $evalue = "10";


my $PROG_NAME = "perlLib::run::search_hmmer3.pl";	
	
&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-modelFile"){
			$modelFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-resultFile"){
			$resultFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-database"){
			$database = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-evalue"){
			$evalue = $ARGV[$counter+1];		
		}	   			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME\n";
	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($modelFile, "ERROR::".$PROG_NAME.":: Parameter -modelFile having HMMer model is required!");
	FilesIO->checkFile($modelFile, "ERROR::".$PROG_NAME.":: FILE NOT found ".$modelFile);
	String->isEmpty($resultFile, "ERROR::".$PROG_NAME.":: Parameter -resultFile having HMMER Result file name is required!");
	String->isEmpty($database, "ERROR::".$PROG_NAME.":: Parameter -database having database file is required!");
	FilesIO->checkFile($database, "ERROR::".$PROG_NAME.":: FILE NOT found".$database);	
	
	print "-modelFile = $modelFile\n";
	print "-verbose = $verbose\n";
	print "-resultFile = $resultFile\n";
	print "-database = $database\n";
	print "-evalue = $evalue\n";
	print "ok\n";
}	

############################ sub main ##################################
sub main {
	HMMER->search($modelFile, $resultFile, $database," --domE $evalue ", "", $verbose);	
}
