#!/usr/bin/perl -w
use strict;



my $file = "";
my $verbose = "false";
my $outputFile = ""; 
my $col = "0";
my $order = "asc";

my $PROG_NAME = "perlLib::run::sortFile.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-file"){
			$file = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-order"){
			$order = $ARGV[$counter+1];		
		}		
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	if ($file eq ""){
		print "ERROR::$PROG_NAME Parameter -file is required!\n";
		exit;
	}

	
	print "-file = $file\n";
	
	if ($verbose ne "true" && $verbose ne "false"){
		print "ERROR::$PROG_NAME:: Parameter -verbose must be true or false!\n";
		exit;
	}	
	
	print "-verbose = $verbose\n";	

	if ($outputFile eq ""){
		print "ERROR::$PROG_NAME:: Parameter -outputFile having a output file is required!\n";
		exit;
	}
	print "-outputFile = $outputFile\n";	
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my @array_sorted;
	my $info;
	
	my @array_file = fileToArray2d($file, "\t");
	
    if ($order eq "asc"){
    	@array_sorted = sortArray2d($col, \@array_file);
    }else{
    	@array_sorted = sortArray2dDesc($col, \@array_file);
    }
    
    if (open(FILE, ">$outputFile")){
    	$info = printMatrix("\t", "\n", \@array_sorted);
       	print FILE $info;     
       	if ($verbose eq "true") {
       		print "file $outputFile created\n";  
       	}       	     	 
        close FILE;
    }
		
}

############################ sub loadAlign1d ####################################
sub sortArray2d {
	my ($field, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	my @sorted = sort {$a->[$field] <=> $b->[$field];} @localmatrix; 
	return @sorted;
}


############################ sub loadAlign1d ####################################
sub sortArray2dDesc {
	my ($field, $matrix) = @_;
	my @localmatrix = @{$matrix};
	
	my @sorted = sort {  $b->[$field] <=> $a->[$field]; } @localmatrix; 
	return @sorted;
}


############################ sub saveFile ###################################
sub fileToArray2d {
	my $path_in = $_[0];
	my $sep 	= $_[1];
	my $eliminateCaracter 	= $_[2];
	
	if (!defined($eliminateCaracter)){
		$eliminateCaracter = "";
	}    
 
	
	my @array_file 	= ();
	my @array_aux 	= ();
	my @array_ret 	= ();
	my $line;
	my $count = 0;


	if (open(FILEIN, "$path_in")){
		@array_file = <FILEIN>;	
		foreach $line (@array_file){
			if (index($line, "\#") < 0){
				@array_aux = split(/$sep/, $line);
				for (my $i=0; $i<scalar(@array_aux); $i++){
					$array_aux[$i] = removeCaracter($array_aux[$i], $eliminateCaracter);
					if ($i == (scalar(@array_aux)-1)){
						$array_ret[$count][$i] = removeCaracter($array_aux[$i], "\n");
					}else{
						$array_ret[$count][$i] = $array_aux[$i];
					}				
				}
				$count++;
			}
		}
        close FILEIN;	
	}
	else {
	    print "ERROR::FilesIO::Could not open file $path_in to read !\n";
	}
	return @array_ret;
}

############################ sub loadAlign1d ####################################
sub printMatrix {
	my ($sepCol, $sepRow, $array) = @_;
	
	my @localArray = @{$array};
	
    my $info = "";
    my $col;
    
  	for (my $i = 0; $i < scalar(@localArray); $i++){
  		$col =  $#{$localArray[$i]} + 1;
  		for (my $j = 0; $j < $col; $j++){
  			$info .= removeCaracter($localArray[$i][$j], "\n");
  			if ($j != $col-1){
  				$info .= $sepCol;
  			}   		 		 
  		}
  		$info .= $sepRow;
  	}
  	if ($info eq ""){
  		@localArray = ();
  	}
  	return $info;
}

############################ sub getCaracter ###################################
sub removeCaracter {
	my $word 	= $_[0];
	my $car 	= $_[1];
	my $new_word = "";
	
	if (defined($word)){
		my $i;
		#print "word--$word--\n";
		my @array = split(//, $word);
		#print scalar(@array)."\n";
		for($i = 0 ; $i < scalar(@array) ; $i++){
			#print "array[$i]=$array[$i]\n";
			if ($array[$i] ne $car){
				$new_word .= $array[$i];
			}
		}
	}	
	return $new_word;
}


