#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;
use Util::Hash;

my $file = "";
my $verbose = "false";
my $col = "";  # a set of cols seprated by ,
my $kind = "1"; #1=Asc;  2=Desc
my $colFile2 = "";  # a set of cols seprated by ,
my $outputFile = "";



my $PROG_NAME = "perlLib::run::sortFileColumn.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-file"){
			$file= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-col"){
			$col = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-kind"){
			$kind = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($file, $PROG_NAME. "ERROR:: Parameter -file is required");
	FilesIO->checkFile($file, "ERROR::".$PROG_NAME.":: $file NOT Found");	
	String->isEmpty($col, $PROG_NAME. "ERROR:: Parameter -col is required");
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");

	print "file=$file\n";
	print "col=$col\n";	
	print "kind=$kind\n";
	print "outputFile=$outputFile\n";
	print "verbose=$verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	my $info = "";					my @VAR1 = ();
	
	my %hash1 = FilesIO->fileToHashConcatKeyKeepLineFile($file, " +", $col);
 	
 	my @array_keys = keys(%hash1);
 	
 	for (my $i=0; $i< scalar(@array_keys); $i++){
 		$VAR1[$i][0] = $array_keys[$i];
 	}
	@VAR1 = Array->sortArray2d(0, \@VAR1);
 	#print Array->printMatrix2("\t", "\n", \@VAR1);
 	#exit;
	
	for (my $i=1; $i< scalar(@VAR1); $i++){
		#print $VAR1[$i][0]."\n";
		if (exists($hash1{$VAR1[$i][0]})){
			$info .= $hash1{$VAR1[$i][0]};
		}
	}
	
		
	FilesIO->saveFile($outputFile, $info, $verbose);		
}
	
