#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use String::StringUtil;

my $file = "";
my $verbose = "false";
my $PKFile = ""; 
my $colPK = "";
my $outputDir = "";
my $ext = "";

my $PROG_NAME = "perlLib::run::splitFile.pl::";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$file= $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-colPK"){
			$colPK = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputDir"){
			$outputDir = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-ext"){
			$ext = $ARGV[$counter+1];		
		}	
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for $PROG_NAME \n";
	
	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($file, $PROG_NAME. "ERROR:: Parameter -inputfile is required");
	FilesIO->checkFile($file, "ERROR::".$PROG_NAME.":: $file NOT Found");	
	String->isEmpty($colPK, $PROG_NAME. "ERROR:: Parameter -colPK is required");
	String->isEmpty($outputDir, $PROG_NAME. "ERROR:: Parameter -outputDir is required");
	String->isEmpty($ext, $PROG_NAME. "ERROR:: Parameter -ext is required");

	print "inputFile=$file\n";
	print "colPK=$colPK\n";
	print "ext=$ext\n";
	print "outputDir=$outputDir\n";
	print "verbose=$verbose\n";
	
	print "ok\n";
}

################################### sub main #####################################
sub main {
	
	
 	my %hash = FilesIO->fileToHash($file, "\t", $colPK);
	my $fileName;
	
	while ( my ($key, $value) = each(%hash) ) {
		$fileName = $outputDir.$key.".".$ext;
		FilesIO->saveFile($fileName, $value, $verbose);
	}
}
	
