#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;

my $inputFile = "";
my $cols = "";
my $sep = "\t";
my $verbose = "false";

my $PROG_NAME = "PerlLib::run::util::checkFormat.pl";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-sep"){
			$sep = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-inputFile"){
			$inputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-cols"){
			$cols = $ARGV[$counter+1];
		}							
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME."::  Parameter -verbose must be true or false!");
	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile having input file for checking the format is required!");
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found ".$inputFile);	
	String->isEmpty($cols, "ERROR::".$PROG_NAME.":: Parameter -cols having how many cols is expected to have in the inputFile is required!");

	
	print "-inputFile = $inputFile\n";
	print "-cols = $cols\n";
	print "-verbose = $verbose\n";
	print "-sep = $sep\n";
	print "ok\n";	
}

############################ sub main ##################################
sub main{	
	
	my 	@data= FilesIO->lineFileToArray($inputFile);
	my @array_line;
	
	for (my $i = 0; $i <scalar(@data); $i++){
		@array_line = split(/\t/, $data[$i]);
		
		if (scalar(@array_line) != $cols){
			print $PROG_NAME."::ERROR:: Line ".$data[$i]." is out of format\n";
		}
	}
}	