#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Util::Array;

my $inputFile = "";
my $cols = "";
my $sep = "\t";
my $verbose = "false";
my $outputFile = "";

my $PROG_NAME = "PerlLib::run::util::getColsFromFile.pl";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-sep"){
			$sep = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-inputFile"){
			$inputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-cols"){#separate by :
			$cols = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){#separate by :
			$outputFile = $ARGV[$counter+1];
		}							
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME."::  Parameter -verbose must be true or false!");
	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile having input file for checking the format is required!");
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found ".$inputFile);	
	String->isEmpty($cols, "ERROR::".$PROG_NAME.":: Parameter -cols having how many cols is expected to have in the inputFile is required!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile having output File is required!");

	
	print "-inputFile = $inputFile\n";
	print "-cols = $cols\n";
	print "-verbose = $verbose\n";
	print "-sep = $sep\n";
	print "ok\n";	
}

############################ sub main ##################################
sub main{	
	
	my 	@data= FilesIO->fileToArray2d($inputFile, "\t");
	my @array_line;
	
	@data= Array->getSomeColsMatrix2($cols, \@data);
	my $info = Array->printMatrix2("\t", "\n", \@data);
	FilesIO->saveFile($outputFile, $info, $verbose);
	
}
	