#include <stdlib.h>
#include <fstream>
#include <vector>
#include <iostream>
#include <sstream>

namespace Support
{
	/*comment*///ordem das rotas
	static const bool ASCENDING = true;
	static const bool DESCENDING = false;

	static const char FILE_NAME_SEPARATOR[2] = ".";

   static const unsigned int MAX_READS = 1024*256;
   static const unsigned int INVALID_IDENTIFICATION = -1;
   static const char END_OF_INFORMATION[2] = ";";
   static char SEPARATOR[2] = "	";
   static const char END_OF_LINE = '\0';
   static const char COMMENTARY[2] = "#";
   static const double CONFIDENCE_FACTOR = 0.95;
}

template< typename T >
bool readCSVfileN(const char * fileName, std::vector < std::vector < T > > * table, char separator = Support::SEPARATOR[0])
{
	std::ifstream file(fileName, std::ios::in);
	char in[Support::MAX_READS];
	std::string value;
	std::vector < T > sample(0);
	unsigned int bytesRead, position;

	if (not file)
	{
		std::cerr << fileName << " not found!" << std::endl;
		return NULL; //exit(1);
	}

	do
		file.getline(in, Support::MAX_READS);
	while (in[0] == Support::COMMENTARY[0] and not file.eof());
	if (file.eof()) return NULL;
	bytesRead = file.gcount();
	while(bytesRead >= 2)
	{
		table->push_back(sample);
		position = 0;
		do
		{
			value.clear();
			do
				value.push_back(in[position++]);
			while (position < bytesRead and in[position] != separator and in[position] != Support::END_OF_INFORMATION[0]);
			table->back().push_back(atof(value.data()));
			position++;
		}
		while (position < bytesRead and in[position -1] != Support::END_OF_INFORMATION[0]);

		do file.getline(in, Support::MAX_READS);
		while (in[0] == Support::COMMENTARY[0] and not file.eof());
		if (file.eof()) break;
		bytesRead = file.gcount();
	}
	file.close();

	return true;
}

template< typename T >
bool readCSVfileA(const char * fileName, std::vector < std::vector < T > > * table, char separator = Support::SEPARATOR[0])
{
	std::ifstream file(fileName, std::ios::in);
	char in[Support::MAX_READS];
	std::string value;
	std::vector < T > sample(0);
	unsigned int bytesRead, position;

	if (not file)
	{
		std::cerr << fileName << " not found!" << std::endl;
		return NULL; //exit(1);
	}

	do
		file.getline(in, Support::MAX_READS);
	while (in[0] == Support::COMMENTARY[0] and not file.eof());
	if (file.eof()) return NULL;
	bytesRead = file.gcount();
	while(bytesRead >= 2)
	{
		table->push_back(sample);
		position = 0;
		do
		{
			value.clear();
			do
				value.push_back(in[position++]);
			while (position < bytesRead and in[position] != separator and in[position] != Support::END_OF_INFORMATION[0]);
			table->back().push_back(value.data());
			position++;
		}
		while (position < bytesRead and in[position -1] != Support::END_OF_INFORMATION[0]);

		do file.getline(in, Support::MAX_READS);
		while (in[0] == Support::COMMENTARY[0] and not file.eof());
		if (file.eof()) break;
		bytesRead = file.gcount();
	}
	file.close();

	return true;
}

template< typename T >
bool writeCSVfile(const char * fileName, std::vector < std::vector < T > > * table, char separator = Support::SEPARATOR[0])
{
    std::ofstream file;

	file.open(fileName, std::ios::out);
	if (not file)
	{
		std::cerr << fileName << " not created!" << std::endl;
		exit(1);
	}
	std::cout << "Writing file:" << fileName << std::endl;

	for (unsigned int line = 0; line < table->size(); line++)
	{
		file << table->at(line).at(0);
		for (unsigned int hop = 1; hop < table->at(line).size(); hop++)
			file << Support::SEPARATOR << table->at(line).at(hop);
		file << Support::END_OF_INFORMATION  << std::endl;
	}
	file.close();

	return true;
}

void buildDomainLifeTree(int nargs, char ** args)
{
	//args parameters
	float maxDistance = atof(args[1]);
    std::string lifeTreeSpeciesFileName(args[2]);
    std::string lifeTreeFileName(args[3]);
    std::string speciesFileName(args[4]);

    //tables
    std::vector < std::vector < std::string > > * lifeTreeSpecies = new std::vector < std::vector < std::string > > ();
	std::vector < std::vector < float > > * lifeTree = new std::vector <std::vector < float > > ();
	std::vector < std::vector < std::string > > * domainSpecies = new std::vector <std::vector < std::string > > ();
	std::vector < std::vector < float > > * domainLifeTree = new std::vector <std::vector < float > > ();

	//loading tables and rows/columns labels
	readCSVfileA(lifeTreeSpeciesFileName.data(), lifeTreeSpecies);
	readCSVfileN(lifeTreeFileName.data(), lifeTree);
	readCSVfileA(speciesFileName.data(), domainSpecies);

	//initially, table domainLifeTree is load with the maximum value
	domainLifeTree = new std::vector <std::vector < float > > (lifeTreeSpecies->size());
	for (unsigned int line = 0; line < lifeTreeSpecies->size(); line++)
	{
		domainLifeTree->at(line).resize(lifeTreeSpecies->size(), maxDistance);
		//The distance between the same specie is zero
		domainLifeTree->at(line).at(line) = 0;
	}

    for (unsigned int specieA = 0; specieA < domainSpecies->size(); specieA++)
    {
    	//std::cout << "processing " << specieA << std::endl;
        for (unsigned int specieC = 0; specieC < lifeTreeSpecies->size(); specieC++)
        {
        	if (domainSpecies->at(specieA).back() == lifeTreeSpecies->at(specieC).back())
        	{
        		for (unsigned int specieB = specieA +1; specieB < domainSpecies->size(); specieB++)
        		{
            		for (unsigned int specieD = 0; specieD < lifeTreeSpecies->size(); specieD++)
            		{
						if (domainSpecies->at(specieB).back() == lifeTreeSpecies->at(specieD).back())
						{
//							if (specieC < specieD)
							{
								domainLifeTree->at(specieA).at(specieB) = lifeTree->at(specieC).at(specieD);
								domainLifeTree->at(specieB).at(specieA) = lifeTree->at(specieC).at(specieD);
							}
//							else
							{
//								domainLifeTree->at(specieA).at(specieB) = lifeTree->at(specieD).at(specieC);
//								domainLifeTree->at(specieB).at(specieA) = lifeTree->at(specieD).at(specieC);
							}
						}
                	}
        		}
        	}
        }
    }

    std::cout << "matrix" << Support::SEPARATOR[0];
    for (unsigned int specieA = 0; specieA < domainSpecies->size(); specieA++)
    	std::cout << domainSpecies->at(specieA).back() << Support::SEPARATOR[0];
	std::cout << std::endl;

    for (unsigned int specieA = 0; specieA < domainSpecies->size(); specieA++)
	{
    	std::cout << domainSpecies->at(specieA).back();
		for (unsigned int specieB = 0; specieB < domainSpecies->size(); specieB++)
			std::cout << Support::SEPARATOR[0] << domainLifeTree->at(specieA).at(specieB);
		std::cout << std::endl;
	}
}

int main(int nargs, char ** args)
{
	int result = 0;

	//executar pre.sh nas arvores para gerar a lista de especies e tirar os labels das arvores
	//executar o buildLifeTree - > gera a matriz completa de especies
	//tirar o debug do arquivo gerado pelo buildLifeTree
	//executar buildDomainLifeTree por domain

	//buildLifeTree(nargs,args);
	buildDomainLifeTree(nargs,args);

	return result;
}
