#include <stdlib.h>
#include <fstream>
#include <vector>
#include <iostream>
#include <sstream>

namespace Support
{
	/*comment*///ordem das rotas
	static const bool ASCENDING = true;
	static const bool DESCENDING = false;

	static const char FILE_NAME_SEPARATOR[2] = ".";

   static const unsigned int MAX_READS = 1024*256;
   static const unsigned int INVALID_IDENTIFICATION = -1;
   static const char END_OF_INFORMATION[2] = ";";
   static char SEPARATOR[2] = "	";
   static const char END_OF_LINE = '\0';
   static const char COMMENTARY[2] = "#";
   static const double CONFIDENCE_FACTOR = 0.95;
}

template< typename T >
bool readCSVfileN(const char * fileName, std::vector < std::vector < T > > * table, char separator = Support::SEPARATOR[0])
{
	std::ifstream file(fileName, std::ios::in);
	char in[Support::MAX_READS];
	std::string value;
	std::vector < T > sample(0);
	unsigned int bytesRead, position;

	if (not file)
	{
		std::cerr << fileName << " not found!" << std::endl;
		return NULL; //exit(1);
	}

	do
		file.getline(in, Support::MAX_READS);
	while (in[0] == Support::COMMENTARY[0] and not file.eof());
	if (file.eof()) return NULL;
	bytesRead = file.gcount();
	while(bytesRead >= 2)
	{
		table->push_back(sample);
		position = 0;
		do
		{
			value.clear();
			do
				value.push_back(in[position++]);
			while (position < bytesRead and in[position] != separator and in[position] != Support::END_OF_INFORMATION[0]);
			table->back().push_back(atof(value.data()));
			position++;
		}
		while (position < bytesRead and in[position -1] != Support::END_OF_INFORMATION[0]);

		do file.getline(in, Support::MAX_READS);
		while (in[0] == Support::COMMENTARY[0] and not file.eof());
		if (file.eof()) break;
		bytesRead = file.gcount();
	}
	file.close();

	return true;
}

template< typename T >
bool readCSVfileA(const char * fileName, std::vector < std::vector < T > > * table, char separator = Support::SEPARATOR[0])
{
	std::ifstream file(fileName, std::ios::in);
	char in[Support::MAX_READS];
	std::string value;
	std::vector < T > sample(0);
	unsigned int bytesRead, position;

	if (not file)
	{
		std::cerr << fileName << " not found!" << std::endl;
		return NULL; //exit(1);
	}

	do
		file.getline(in, Support::MAX_READS);
	while (in[0] == Support::COMMENTARY[0] and not file.eof());
	if (file.eof()) return NULL;
	bytesRead = file.gcount();
	while(bytesRead >= 2)
	{
		table->push_back(sample);
		position = 0;
		do
		{
			value.clear();
			do
				value.push_back(in[position++]);
			while (position < bytesRead and in[position] != separator and in[position] != Support::END_OF_INFORMATION[0]);
			table->back().push_back(value.data());
			position++;
		}
		while (position < bytesRead and in[position -1] != Support::END_OF_INFORMATION[0]);

		do file.getline(in, Support::MAX_READS);
		while (in[0] == Support::COMMENTARY[0] and not file.eof());
		if (file.eof()) break;
		bytesRead = file.gcount();
	}
	file.close();

	return true;
}

template< typename T >
bool writeCSVfile(const char * fileName, std::vector < std::vector < T > > * table, char separator = Support::SEPARATOR[0])
{
    std::ofstream file;

	file.open(fileName, std::ios::out);
	if (not file)
	{
		std::cerr << fileName << " not created!" << std::endl;
		exit(1);
	}
	std::cout << "Writing file:" << fileName << std::endl;

	for (unsigned int line = 0; line < table->size(); line++)
	{
		file << table->at(line).at(0);
		for (unsigned int hop = 1; hop < table->at(line).size(); hop++)
			file << Support::SEPARATOR << table->at(line).at(hop);
		file << Support::END_OF_INFORMATION  << std::endl;
	}
	file.close();

	return true;
}

void buildLifeTree(int nargs, char ** args)
{
	std::stringstream aux;
	std::string labelFileTermination = "label";
	unsigned int numberOfTrees = (nargs -3);

	//args parameters
	float maxDistance = atof(args[1]);
    std::string lifeTreeSpeciesFileName(args[2]);
    std::string lifeTreesSpeciesFileName[numberOfTrees];
    //loading tree names
	for (unsigned int tree = 0; tree < numberOfTrees; tree++)
		lifeTreesSpeciesFileName[tree] = args[tree +3];

    //tables
    std::vector < std::vector < std::string > > * lifeTreeSpecies = new std::vector < std::vector < std::string > > ();
	std::vector < std::vector < std::string > > * lifeTreesSpecies[numberOfTrees];
	std::vector < std::vector < float > > * lifeTree = new std::vector <std::vector < float > > ();
	std::vector < std::vector < float > > * lifeTrees[numberOfTrees];

	//loading tables and rows/columns labels
	readCSVfileA(lifeTreeSpeciesFileName.data(), lifeTreeSpecies);
	for (unsigned int tree = 0; tree < numberOfTrees; tree++)
	{
		lifeTrees[tree] = new std::vector < std::vector < float > > ();
		lifeTreesSpecies[tree] = new std::vector < std::vector < std::string > > ();
		aux.str("");
		aux << lifeTreesSpeciesFileName[tree].substr(0,lifeTreesSpeciesFileName[tree].rfind(Support::FILE_NAME_SEPARATOR[0]) +1) << labelFileTermination.data();
		readCSVfileN(lifeTreesSpeciesFileName[tree].data(), lifeTrees[tree]);
		readCSVfileA(aux.str().data(), lifeTreesSpecies[tree]);
	}

	//initially, table lifeTree is load with the maximum value
	lifeTree = new std::vector <std::vector < float > > (lifeTreeSpecies->size());
	for (unsigned int line = 0; line < lifeTreeSpecies->size(); line++)
	{
		lifeTree->at(line).resize(lifeTreeSpecies->size(), maxDistance);
		//The distance between the same specie is zero
		lifeTree->at(line).at(line) = 0;
	}

	/*debug*/
//	for (unsigned int line = 0; line < lifeTreeSpecies->size(); line++)
//		std::cout << lifeTreeSpecies->at(line).back() << ",";
//	std::cout << "end" << std::endl;
//	for (unsigned int tree = 0; tree < numberOfTrees; tree++)
//	{
//		for (unsigned int line = 0; line < lifeTreesSpecies[tree]->size(); line++)
//			std::cout << lifeTreesSpecies[tree]->at(line).back() << ",";
//		std::cout << "end" << std::endl;
//	}

	//sort species alphabetically only from lifeTree

	//loading table lifeTree from the others tables lifeTrees
	//all these tables are a triangular matrices
	for (unsigned int specieA = 0; specieA < lifeTreeSpecies->size(); specieA++)
	{
		std::cout << "processing specie " << specieA << " of " << lifeTreeSpecies->size() -1 << std::endl;
		for (unsigned int specieB = specieA +1; specieB < lifeTreeSpecies->size(); specieB++)
		{
			for (unsigned int tree = 0; tree < numberOfTrees; tree++)
			{
				for (unsigned int specieC = 0; specieC < lifeTreesSpecies[tree]->size(); specieC++)
				{
					if (lifeTreeSpecies->at(specieA).back() == lifeTreesSpecies[tree]->at(specieC).back())
					{
						for (unsigned int specieD = 0; specieD < lifeTreesSpecies[tree]->size(); specieD++)
						{
							if (lifeTreeSpecies->at(specieB).back() == lifeTreesSpecies[tree]->at(specieD).back())
							{
								if (lifeTree->at(specieA).at(specieB) > lifeTrees[tree]->at(specieC).at(specieD))
								{
									lifeTree->at(specieA).at(specieB) = lifeTrees[tree]->at(specieC).at(specieD);
									lifeTree->at(specieB).at(specieA) = lifeTrees[tree]->at(specieC).at(specieD);
								}
							}
						}
						break;
					}
				}
			}
		}
	}

	for (unsigned int specieA = 0; specieA < lifeTreeSpecies->size(); specieA++)
	{
		std::cout << lifeTree->at(specieA).at(0);
		for (unsigned int specieB = 1; specieB < lifeTreeSpecies->size(); specieB++)
			std::cout << Support::SEPARATOR[0] << lifeTree->at(specieA).at(specieB);
		std::cout << std::endl;
	}
}

int main(int nargs, char ** args)
{
	int result = 0;

	buildLifeTree(nargs,args);

	return result;
}
