if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Align::Primary::clustalw;
use Util::Number;
use PhyTree::phylip;

my $TREE_EXT = "_phyml_tree.txt";
my $BINARY_TREE_PROGRAM = "retree";

my $PROG_NAME = "PFAM_annotation::scripts::specie::create_matrix_protDist.pl";

my $inputFile = "";
my $outputFile = "";
my $verbose =  "";
my $option= "1"; #1=create protdist 2=neighbor
my $tmpDir = "";

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$inputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-option"){
			$option = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-tmpDir"){
			$tmpDir = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}							
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	

	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile required");
	FilesIO->checkFile($inputFile, "ERROR:: ".$PROG_NAME.":: File Not found".$inputFile);
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile required");
	
	print "-inputFile = $inputFile\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "-tmpDir = $tmpDir\n";
	print "-option = $option\n";
	print "ok\n";	
}	

############################ sub checkParameters ##################################
sub main {
	
	if ($option == 1){
		PHYLIP->runProtDist($inputFile, $outputFile, $tmpDir, "false", $verbose);
	}elsif ($option == 2){
		PHYLIP->runNeighbor($inputFile, $outputFile, $tmpDir, $verbose);
	}elsif ($option == 3){
		PHYLIP->formatMatDist($inputFile, $outputFile, $tmpDir, $verbose);
	}  
	
	
}
	