

export ENV_VAR_FILE=$1;
export TABLE=$2;
export LOG_DIR=$3;
export NAME_PROG=$4;
export QTD_FILE=$5;
export SEQ_FILE=$6;
export DB_BUILD=$7;
export ITERACTION=$8;
export SEQ_FILE_OUT=$9;
export PSSM_FILE_OUT=${10};
export EVALUE=${11};
export TMP_DIR=${12};

source $ENV_VAR_FILE;


perl $PERL_LIB/run/runTestSetPFAMFamily.pl \
-trans_factor_table $TABLE \
-nameRun ${NAME_PROG}_runFamily \
-logDir $LOG_DIR \
-kindRun 1 \
-qtdFile $QTD_FILE \
-prePost \( \
echo \" LOG::START \", \
date, \
echo \$HOSTNAME, \
export PERL_LIB=$PERL_LIB, \
export PATH=\$PATH\:$PATH_PSIBLAST\;, \
mkdir -p $TMP_DIR \
\) \
-scriptParameters \( \
END_LINE,\
if [ -s $SEQ_FILE_OUT ], \
END_LINE, \
then, \
END_LINE, \
echo \"FILE $SEQ_FILE_OUT was already created \", \
END_LINE, \
else, \
END_LINE, \
perl $PERL_LIB/run/run_psi_blast.pl, \
-seqFile $SEQ_FILE, \
-dbBuild $DB_BUILD, \
-iteration $ITERACTION, \
-pssmFile $PSSM_FILE_OUT, \
-seqFileOut $TMP_DIR/seq.out, \
-evalue $EVALUE, \
-tmpDir $TMP_DIR, \
END_LINE, \
perl $PERL_LIB/run/getSequencesFromBlastOutput.pl, \
-blastOutput $TMP_DIR/seq.out, \
-evalue $EVALUE, \
-outputFile $SEQ_FILE_OUT, \
-identity 30, \
-MAXSEQ 200, \
END_LINE, \
fi, \
END_LINE \
\) \
-posPost \( \
echo \" LOG::END \", \
date \
\) \
-commandParameters  \( bash \)

