

export VERBOSE=false;

export ENV_VAR_FILE=$1;

export TF_TABLE=$2;
export LOG_DIR=$3;
export NAME_PROG=$4;
export QTD_FILE=$5;

export Sequence_FILE=$6;
export HMM_FILE=$7;
export OUTPUT_FILE=$8;


source $ENV_VAR_FILE;

perl $PERL_LIB/run/runTestSetPFAMFamily.pl \
-trans_factor_table $TF_TABLE \
-nameRun ${NAME_PROG}_runFamily \
-logDir $LOG_DIR \
-kindRun 1 \
-qtdFile $QTD_FILE \
-prePost \( \
echo \"LOG::START::FAMILY_FACTOR\", \
TOP date, \
TOP echo \$HOSTNAME, \
TOP export SCRIPT_DIR=$SCRIPT_DIR, \
TOP export PERL_LIB=$PERL_LIB, \
TOP export PATH=$PATH_PSIBLAST\:$PATH, \
TOP export TMP_DIR=$TMP/, \
TOP mkdir -p \$TMP_DIR, \
TOP cp $Sequence_FILE \$TMP_DIR/database.fasta, \
echo \"Coping data\", \
cp $HMM_FILE \$TMP_DIR/FAMILY_FACTOR.hmm, \
END_LINE \
\) \
-scriptParameters \( \
END_LINE,\
perl $PERL_LIB/HMMs/HMMER/hmmer.pl, \
-kind 2, \
-arg1 \$TMP_DIR/FAMILY_FACTOR.hmm, \
-arg2 \$TMP_DIR/FAMILY_FACTOR.output, \
-arg3 \$TMP_DIR/database.fasta, \
-verbose $VERBOSE, \
END_LINE, \
if [ -s \$TMP_DIR/FAMILY_FACTOR.output.out ], \
END_LINE, \
then, \
END_LINE, \
cp \$TMP_DIR/FAMILY_FACTOR.output.out $OUTPUT_FILE, \
END_LINE, \
else, \
END_LINE, \
echo \"ERROR::File Not created $OUTPUT_FILE\", \
END_LINE, \
fi, \
END_LINE \
\)  \
-posPost \( \
echo \"LOG::END::FAMILY_FACTOR\", \
BOTTOM rm -rf \$TMP_DIR, \
BOTTOM date \
\) \
-commandParameters  \( bash \)

