package Blast;


if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}


use String::StringUtil;
use File::Files;
use Sequence::sequence;
use Util::HTML;
use Align::Primary::blast;
use strict;
use Database::PFAM;

my $align_program = "blastall";
my $formatdb_program = "formatdb";
my $NO_HITS = "***** No hits found ******";
my $HITS_FOUND = "Sequences producing significant alignments:";
my $EXPECT = "Expect";
my $QUERY  = "Query=";
my $QUERY_IN = "Query:";
my $SBJCT_IN = "Sbjct";
my $SCORE = "Score =";
my $LENGTH = "Length =";
my $IDENTITY = "Identities =";

############################ sub runFormatFiletoSam ##################################
sub formatdb {

    my $db    = $_[1];
 	my $path_program	= $_[2];
 	my $verbose	= $_[3];
	
	if (!defined($verbose)){
		$verbose = "true";
	}
    
 	
 	my $count_file = 0;
 	
 	if (FilesIO->isFile($db) eq "false"){
		print "ERROR::perlLib::Blast::  $db is NOT a File !\n";
		exit;
	}
	
	if ((FilesIO->isFile($db.".phr") eq "false") || (FilesIO->isFile($db.".pin") eq "false") || (FilesIO->isFile($db.".psq") eq "false")){
		my $cmd = $path_program.$formatdb_program. " -i ". $db;
 		if ($verbose eq "true"){
 			print $cmd."\n";
 		}
  		system ($cmd);
	}elsif ($verbose eq "true"){
		print "perlLib::Blast::  $db is already formated !\n";
	} 	
}

############################ sub runFormatFiletoSam ##################################
sub run {

    my $db    			= $_[1];
 	my $path_program	= $_[2];
 	my $query			= $_[3];
 	my $outputFile		= $_[4];
 	my $verbose			= $_[5];
	
	if (!defined($verbose)){
		$verbose = "true";
	}
    
 	
 	my $cmd = $path_program.$align_program. " -p blastp -d ". $db. " -i ". $query. " -o ". $outputFile;
 	if ($verbose eq "true"){
 		print $cmd."\n";
 	}
  	system ($cmd);
  	
  	if (FilesIO->isFile($outputFile) eq "false"){
  		print "ERROR::perlLib::Blast:: Output File $outputFile NOT created\n";
		exit;
  	}
}


############################ sub runFormatFiletoSam ##################################
sub runSourceCode {

    my $db    			= $_[1];
 	my $parameters		= $_[2];
 	my $query			= $_[3];
 	my $outputFile		= $_[4];
 	my $verbose			= $_[5];
	
	if (!defined($verbose)){
		$verbose = "true";
	}
    
 	my $align_program = "blastp";
 	my $cmd = $align_program. " $parameters -db ". $db. " -query ". $query. " -out ". $outputFile;
 	if ($verbose eq "true"){
 		print $cmd."\n";
 	}
  	system ($cmd);
  	
  	if (FilesIO->isFile($outputFile) eq "false"){
  		print "ERROR::perlLib::Blast:: Output File $outputFile NOT created\n";
		exit;
  	}
}


############################ sub runFormatFiletoSam ##################################
sub getEvalue {

    my $outputFile	= $_[1];
    my $entry;
    
    my @array = FilesIO->lineFileToArray($outputFile);
	my $ev;
	foreach $entry (@array) {
		if (index($entry, $NO_HITS) >= 0){
			return 10000;
		}elsif (index($entry, $EXPECT)>= 0){
			my @array = split(/,/, $entry);
			my @array2 =  split(/=/, $array[1]);
			$ev = $array2[1];
			$ev = Blast->formatEvalue($ev);
			return $ev;
		}
	}    
}

############################ sub runFormatFiletoSam ##################################
sub formatEvalue {

 	my $ev	= $_[1];
 	if (index($ev, " e-") >=0){
		$ev = String->replace($ev, " e", "1e");	
	}else{
		$ev = String->replace($ev, " ", "");	
	}
	return $ev;
}




############################ sub runFormatFiletoSam ##################################
sub getEvalueFromLine {
	 my $line	= $_[1];
	 my @array = split(/,/, $line);
	 my @array2 =  split(/=/, $array[1]);
	 $array2[1] = String->removeCaracter($array2[1], " ");
	 return $array2[1];
}

############################ sub runFormatFiletoSam ##################################
sub getBlastHitFromFileFormated {
	 my $resultParsedFile	= $_[1];
	 my $removeOverlap		= $_[2];
	 
	 if (!defined($removeOverlap)){
	 	$removeOverlap = "false";
	 }
	 
	 my @array = FilesIO->fileToArray2d($resultParsedFile, "\t");
	 my %record = (); my @array_ret = ();
	 
	 for (my $i =0; $i < scalar(@array); $i++) {
	 	$array_ret[$i][0] = $array[$i][10];#evalue
	 	$array_ret[$i][1] = $array[$i][8];#startHit
	 	$array_ret[$i][2] = $array[$i][9]; #endHit
	 	$array_ret[$i][3] = $array[$i][6];#startHitQuery
	 	$array_ret[$i][4] = $array[$i][7]; #endHitQuery
	 	$array_ret[$i][5] = $array[$i][11];#score
	 	$array_ret[$i][6] = $array[$i][2];#identity
	 	$array_ret[$i][7] = $array[$i][12];#positivity
	 }
	 
	 if ($removeOverlap eq "true"){
	 	return Blast->removeOverlapHit(\@array_ret);
	 }
	 
	return @array_ret;
}

############################ sub runFormatFiletoSam ##################################
sub removeOverlapHit{
	my ($lixo, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $array) = @_;
	my @localArray = @{$array};
	
	my $startHit_i;				my $startHit_j;
	my $endHit_i;				my $endHit_j;
	my $evalue_i;				my $evalue_j;
	my $save = "true";			my $domain_i; 
	my $info = "";				my $domain_j;
	my @array_ret = ();
	
	for (my $i =0; $i < scalar(@localArray); $i++) {
		$startHit_i = $localArray[$i][1];
		$endHit_i = $localArray[$i][2];
		$evalue_i = $localArray[$i][0];
		$domain_i = $localArray[$i][4];
		$save = "true";
		#print " NEW == > $startHit_i $endHit_i $evalue_i\n";
		for (my $j =0; $j < scalar(@localArray); $j++) {
			if ($i != $j){
				$startHit_j = $localArray[$j][1];
				$endHit_j = $localArray[$j][2];	
				$evalue_j = $localArray[$j][0];		
				$domain_j = $localArray[$j][4];
				#print "$startHit_j $endHit_j $evalue_j\n";
				if (Blast->isOverlapHit($startHit_i, $endHit_i, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j) eq "true" ){				
					if ($evalue_i > $evalue_j){
						$save = "false";
						$j = scalar(@localArray);
						#print "found better\n";
					}
				}
			}			
		}
		if ($save eq "true"){
			
			for (my $i =0; $i < scalar(@array_ret); $i++) {
				$startHit_j = $array_ret[$i][1];
				$endHit_j = $array_ret[$i][2];
				if ($array_ret[$i][1] eq  $startHit_i && $array_ret[$i][2] eq  $endHit_i && $array_ret[$i][0] eq  $evalue_i){
					$save  = "false";
				}elsif (Blast->isOverlapHit($startHit_i, $endHit_i, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j) eq "true" ){		
					$save  = "false";
				}
			}
			if ($save eq "true"){
				#print "===> SAVE  $startHit_i $endHit_i $evalue_i\n";
				push(@array_ret, $localArray[$i]);
			}
		}
	}
	return @array_ret;
}


############################ sub runFormatFiletoSam ##################################
sub removeOverlapHitClans{
	my ($lixo, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $clanFile, $array) = @_;
	my @localArray = @{$array};
	
	
	my $startHit_i;				my $startHit_j;
	my $endHit_i;				my $endHit_j;
	my $evalue_i;				my $evalue_j;
	my $save = "true";			my $domain_i; 
	my $info = "";				my $domain_j;
	my $clan_i;					my $clan_j;
	my @array_ret = ();
	
	for (my $i =0; $i < scalar(@localArray); $i++) {
		$startHit_i = $localArray[$i][1];
		$endHit_i = $localArray[$i][2];
		$evalue_i = $localArray[$i][0];
		$domain_i = $localArray[$i][4];
		$save = "true";
		#print " NEW == > $startHit_i $endHit_i $evalue_i\n";
		for (my $j =0; $j < scalar(@localArray); $j++) {
			if ($i != $j){
				$startHit_j = $localArray[$j][1];
				$endHit_j = $localArray[$j][2];	
				$evalue_j = $localArray[$j][0];		
				$domain_j = $localArray[$j][4];
				#print "$startHit_j $endHit_j $evalue_j\n";
				if (Blast->isOverlapHit($startHit_i, $endHit_i, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j) eq "true" ){
					
					$clan_i = PFAM->getOneClan($clanFile, $domain_i, "false");
					$clan_j = PFAM->getOneClan($clanFile, $domain_j, "false");
					#print "$domain_i $clan_i  $domain_j $clan_j\n";
					if ($clan_i ne "None" &&  $clan_j ne "None" && $clan_i eq $clan_j && $evalue_i > $evalue_j){
						$save = "false";
						$j = scalar(@localArray);
						#print "found better\n";
					}
				}
			}			
		}
		if ($save eq "true"){
			#print "===> SAVE  $startHit_i $endHit_i $evalue_i\n";
			for (my $i =0; $i < scalar(@array_ret); $i++) {
				$startHit_j = $array_ret[$i][1];
				$endHit_j = $array_ret[$i][2];
				if ($array_ret[$i][1] eq  $startHit_i && $array_ret[$i][2] eq  $endHit_i && $array_ret[$i][0] eq  $evalue_i){
					$save  = "false";
				}elsif (Blast->isOverlapHit($startHit_i, $endHit_i, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j) eq "true" ){		
					$save  = "false";
				}
			}
			if ($save eq "true"){
				push(@array_ret, $localArray[$i]);
			}
		}
	}
	return @array_ret;
}


############################ sub runFormatFiletoSam ##################################
sub removeOverlapHitMax{
	my ($lixo, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap,  $array) = @_;
	my @localArray = @{$array};
	@localArray = Array->sortArray2d(0, \@localArray);
	
	my $startHit_i;				my $startHit_j;
	my $endHit_i;				my $endHit_j;
	my $evalue_i;				my $evalue_j;
	my $save = "true";			my $domain_i;
	my $info = "";				my $domain_j;
	my @array_ret = ();			my $stop;
	my $i =0;					my  $j;
	while ( $i < scalar(@localArray)) {
		$startHit_i = $localArray[$i][1];
		$endHit_i = $localArray[$i][2];
		$evalue_i = $localArray[$i][0];
		$domain_i = $localArray[$i][4];
		$save = "true";
		
		if ($i == scalar(@localArray) -1){
			$j = 0;
		}else{
			$j =$i+1;
		}
		#print " NEW $i == > $startHit_i $endHit_i $evalue_i j=$j\n";
		$stop = "false";
		while ($j < scalar(@localArray) && $stop eq "false") {
			$startHit_j = $localArray[$j][1];
			$endHit_j = $localArray[$j][2];	
			$evalue_j = $localArray[$j][0];		
			$domain_j = $localArray[$j][4];
			
		#	print " $j $startHit_j $endHit_j $evalue_j\n";
			if (Blast->isOverlapHit($startHit_i, $endHit_i, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j) eq "true" ){				
				if ($evalue_i < $evalue_j){
					$save = "false";					
					$stop = "true";						
		#			print "found better\n";
				}
			}else{
				$stop = "true";	
			}	
			$j++;		
		}
		if ($save eq "true"){
		#	print "===> SAVE  $startHit_i $endHit_i $evalue_i\n";
			push(@array_ret, $localArray[$i]);				
		}
		if ($i < scalar(@localArray)-1){
			$i = $j-1;
		}else{
			$i++;
		}
			
	}
	return @array_ret;
}



############################ sub runFormatFiletoSam ##################################
sub removePartialOverlapHit{
	my ($lixo, $startHit, $endHit, $domain, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $array) = @_;
	
	my @localArray = @{$array};
	@localArray = Array->sortArray2d(1, \@localArray);
	
	my $startHit_j;				my $endHit_j;
	my $save;					my @array_ret = ();
	my $domain_j;
	
	#print "Remove overlap with $startHit $endHit\n";
	for (my $j =0; $j < scalar(@localArray); $j++) {
		$startHit_j = $localArray[$j][1];
		$endHit_j 	= $localArray[$j][2];
		$domain_j	= $localArray[$j][4];
		$save = "true";	
		#print ">>>> $startHit_j $endHit_j\n";
		if (Blast->isOverlapHit($startHit, $endHit, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain, $domain_j) eq "true" ){
			$save = "false";
			#print "overlap\n";
		}
		if ($save eq "true"){
			#print "===> SAVE  $startHit_j $endHit_j \n";
			push(@array_ret, $localArray[$j]);
		}
	}
	return @array_ret;
}

############################ sub runFormatFiletoSam ##################################
sub calculateOverlapSize{
	my $startHit_i			= $_[1];
	my $endHit_i 			= $_[2];
	my $startHit_j			= $_[3];
	my $endHit_j			= $_[4];
	
	my $overlapAA = 0;
	
	if ($startHit_i <= $startHit_j && $startHit_i <= $endHit_j && $endHit_i >= $startHit_j && $endHit_i >= $endHit_j){
		$overlapAA = ($endHit_j - $startHit_j) + 1;
	} 
	elsif($startHit_i >= $startHit_j && $startHit_i <= $endHit_j && $endHit_i >= $startHit_j && $endHit_i <= $endHit_j){
		$overlapAA = ($endHit_i - $startHit_i) + 1;
	} 
	elsif ( ($startHit_i >= $startHit_j && $startHit_i <= $endHit_j)){
		$overlapAA = ($endHit_j - $startHit_i) + 1;
	}
	elsif($endHit_i >= $startHit_j && $endHit_i <= $endHit_j){
		$overlapAA = ($endHit_i - $startHit_j) + 1;	
	}	
	return $overlapAA;
}


############################ sub runFormatFiletoSam ##################################
sub calculateOverlapPerc{
	my $startHit_i			= $_[1];
	my $endHit_i 			= $_[2];
	my $startHit_j			= $_[3];
	my $endHit_j			= $_[4];
	
	my $overlapAA = Blast->calculateOverlapSize($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	my $size_i = ($endHit_i - $startHit_i) + 1;
	my $perc_overlap = $overlapAA/$size_i;
	return $perc_overlap;
}

############################ sub runFormatFiletoSam ##################################
sub isOverlapHitClan{
	my $startHit_i			= $_[1];
	my $endHit_i 			= $_[2];
	my $startHit_j			= $_[3];
	my $endHit_j			= $_[4];
	my $overlapAA_alowed  	= $_[5];
	my $perc_overlap_alowed	= $_[6];
	my $domains_overlap		= $_[7];
	my $domain_i			= $_[8];
	my $domain_j			= $_[9];
	my $clanFile			= $_[10];
	
	#print "startHit_i = $startHit_i\nendHit_i = $endHit_i\nstartHit_j = $startHit_j\nendHit_j = $endHit_j\noverlapAA_alowed = $overlapAA_alowed\nperc_overlap_alowed = $perc_overlap_alowed\n";
	#print "domains = \n$domain_i\n$domain_j\n";
	my $overlapAA = 0;			my $perc_overlap_i = 0;
	my $perc_overlap_j = 0;
	
	#print "size_i = $size_i\n";
	
	$overlapAA = Blast->calculateOverlapSize($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	
	#print "overlapAA = $overlapAA\n";
	if ($domains_overlap ne ""){
		#print "\nentrou1\n";
		my $domain_i_j = $domain_i.":".$domain_j;
		my $domain_j_i = $domain_j.":".$domain_i;		
		if (index($domains_overlap, $domain_i_j) >= 0 || index($domains_overlap, $domain_j_i) >= 0){
			#print "\nentrou2\n";
			if ($overlapAA > 0){
				return "false";
			}
		}
		
	}
	
	if ($overlapAA_alowed == 0 && $perc_overlap_alowed == 0){
		if ($overlapAA == 0){
			return "false";
		}else{
			return "true";
		}		
	}
	$perc_overlap_i = Blast->calculateOverlapPerc($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	$perc_overlap_j = Blast->calculateOverlapPerc($startHit_j, $endHit_j, $startHit_i, $endHit_i);
	#print "overlapAA = $overlapAA\tperc_overlap = $perc_overlap_i\n";
	#print "overlapAA = $overlapAA\tperc_overlap = $perc_overlap_j\n";
	#print $perc_overlap_alowed."\n\n";
	
	if ($overlapAA ==0){
		return "false";
	}elsif ($overlapAA <= $overlapAA_alowed && $perc_overlap_i <= $perc_overlap_alowed && $perc_overlap_j <= $perc_overlap_alowed){
		#print "overlap false1\n\n";
		return "false";
	}else{
		my $clan_i = PFAM->getOneClan($clanFile, $domain_i, "false");
		my $clan_j = PFAM->getOneClan($clanFile, $domain_j, "false");
		if ($clan_i ne "None" &&  $clan_j ne "None" && $clan_i ne $clan_j){
			return "false";
		}
	}
	#if ($perc_overlap_i <= $perc_overlap_alowed || $perc_overlap_j <= $perc_overlap_alowed){
	#	print "overlap false2\n\n";
	#	return "false";
	#}
	
	#print "overlap true\n\n";
	return "true";
}

	
############################ sub runFormatFiletoSam ##################################
sub isOverlapHit{
	my $startHit_i			= $_[1];
	my $endHit_i 			= $_[2];
	my $startHit_j			= $_[3];
	my $endHit_j			= $_[4];
	my $overlapAA_alowed  	= $_[5];
	my $perc_overlap_alowed	= $_[6];
	my $domains_overlap		= $_[7];
	my $domain_i			= $_[8];
	my $domain_j			= $_[9];
	
	#print "startHit_i = $startHit_i\nendHit_i = $endHit_i\nstartHit_j = $startHit_j\nendHit_j = $endHit_j\noverlapAA_alowed = $overlapAA_alowed\nperc_overlap_alowed = $perc_overlap_alowed\n";
	#print "domains = \n$domain_i\n$domain_j\n";
	my $overlapAA = 0;			my $perc_overlap_i = 0;
	my $perc_overlap_j = 0;
	
	#print "size_i = $size_i\n";
	
	$overlapAA = Blast->calculateOverlapSize($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	
	#print "overlapAA = $overlapAA\n";
	if ($domains_overlap ne ""){
		#print "\nentrou1\n";
		my $domain_i_j = $domain_i.":".$domain_j;
		my $domain_j_i = $domain_j.":".$domain_i;		
		if (index($domains_overlap, $domain_i_j) >= 0 || index($domains_overlap, $domain_j_i) >= 0){
			#print "\nentrou2\n";
			if ($overlapAA > 0){
				return "false";
			}
		}
		
	}
	
	if ($overlapAA_alowed == 0 && $perc_overlap_alowed == 0){
		if ($overlapAA == 0){
			return "false";
		}else{
			return "true";
		}		
	}
	$perc_overlap_i = Blast->calculateOverlapPerc($startHit_i, $endHit_i, $startHit_j, $endHit_j);
	$perc_overlap_j = Blast->calculateOverlapPerc($startHit_j, $endHit_j, $startHit_i, $endHit_i);
	#print "overlapAA = $overlapAA\tperc_overlap = $perc_overlap_i\n";
	#print "overlapAA = $overlapAA\tperc_overlap = $perc_overlap_j\n";
	#print $perc_overlap_alowed."\n\n";
	
	if ($overlapAA ==0){
		return "false";
	}elsif ($overlapAA <= $overlapAA_alowed && $perc_overlap_i <= $perc_overlap_alowed && $perc_overlap_j <= $perc_overlap_alowed){
		#print "overlap false1\n\n";
		return "false";
	}
	#if ($perc_overlap_i <= $perc_overlap_alowed || $perc_overlap_j <= $perc_overlap_alowed){
	#	print "overlap false2\n\n";
	#	return "false";
	#}
	
	#print "overlap true\n\n";
	return "true";
}

############################ sub runFormatFiletoSam ##################################
sub getHitsWithOverlap{
	my ($lixo, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $startHit, $endHit, $array) = @_;
	
	my @localArray = @{$array};
	
	my $startHit_j;				my $endHit_j;
	my $save;					my @array_ret = ();
	my $domain_j;
	
	#print "Remove overlap with $startHit $endHit\n";
	for (my $j =0; $j < scalar(@localArray); $j++) {
		$startHit_j = $localArray[$j][1];
		$endHit_j 	= $localArray[$j][2];
		$domain_j 	= $localArray[$j][4];
		$save = "false";	
		#print "$startHit_j $endHit_j\n";
		if (Blast->isOverlapHit($startHit, $endHit, $startHit_j, $endHit_j, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $domain_j) eq "true"){
				$save = "true";
				#print "overlap\n";
		}
		if ($save eq "true"){
			#print "===> SAVE  $startHit_j $endHit_j \n";
			push(@array_ret, $localArray[$j]);
		}
	}
	return @array_ret;
}

############################ sub runFormatFiletoSam ##################################
sub removeWeakOverlap{
	my ($lixo, $overlapAA_alowed, $perc_overlap_alowed, $domains_overlap, $domain_i, $startHit, $endHit, $array) = @_;
	
	my @localArray = @{$array};
	
	my $startHit_j;				my $endHit_j;
	my $save;					my @array_ret = ();
	my $domain_j;				my $perc_overlap;
	
	#print "Remove overlap with $startHit $endHit\n";
	for (my $j =0; $j < scalar(@localArray); $j++) {
		$startHit_j = $localArray[$j][1];
		$endHit_j 	= $localArray[$j][2];
		$domain_j 	= $localArray[$j][4];
		$save = "false";	
		#print "$startHit_j $endHit_j $perc_overlap\n";
		$perc_overlap = Blast->calculateOverlapPerc($startHit, $endHit, $startHit_j, $endHit_j);
		if ($perc_overlap >= $perc_overlap_alowed){
				$save = "true";
				push(@array_ret, $localArray[$j]);
				#print "overlap\n";
		}
	}
	return @array_ret;
}

############################ sub runFormatFiletoSam ##################################
sub removeHitsEvalue{
	my ($lixo, $evalueCutOFF, $array) = @_;
	
	my @localArray = @{$array};
	
	my $evalue;			my @array_ret = ();	
	
	for (my $j =0; $j < scalar(@localArray); $j++) {
		$evalue = $localArray[$j][0];
		if ($evalue <= $evalueCutOFF){
				push(@array_ret, $localArray[$j]);
				#print "overlap\n";
		}
	}
	return @array_ret;
}




############################ sub runFormatFiletoSam ##################################
sub removeOverlapHitEvalue{
	my ($lixo, $cutOffEv, $array) = @_;
	my @localArray = @{$array};
	
	my $startHit_i;				my $startHit_j;
	my $endHit_i;				my $endHit_j;
	my $evalue_i;				my $evalue_j;
	my $save = "true";			my $domain_i;
	my $info = "";				my $domain_j;
	my @array_ret = ();
	
	for (my $i =0; $i < scalar(@localArray); $i++) {
		$startHit_i = $localArray[$i][1];
		$endHit_i = $localArray[$i][2];
		$evalue_i = $localArray[$i][0];
		$domain_i = $localArray[$i][4];
		$save = "true";
		#print " NEW == > $startHit_i $endHit_i $evalue_i $domain_i\n";
		for (my $j =0; $j < scalar(@localArray); $j++) {
			if ($i != $j){
				$startHit_j = $localArray[$j][1];
				$endHit_j = $localArray[$j][2];	
				$evalue_j = $localArray[$j][0];		
				$domain_j = $localArray[$j][4];
				#print "$startHit_j $endHit_j $evalue_j $domain_j\n";
				if ( ($startHit_i >= $startHit_j && $startHit_i <= $endHit_j) || ($endHit_i >= $startHit_j && $endHit_i <= $endHit_j) ||
					( $startHit_j >= $startHit_i && $startHit_j <= $endHit_i && $endHit_j >= $startHit_i && $startHit_j <= $endHit_i)){
					
					if ($evalue_i <= $cutOffEv && $domain_i ne $domain_j){
						$save = "true";
					}elsif ($evalue_i > $evalue_j){
						$save = "false";
						$j = scalar(@localArray);
						#print "found better\n";
					}
				}
			}			
		}
		if ($save eq "true"){
			#print "===> SAVE  $startHit_i $endHit_i $evalue_i\n";
			for (my $i =0; $i < scalar(@array_ret); $i++) {
				if ($array_ret[$i][1] eq  $startHit_i && $array_ret[$i][2] eq  $endHit_i && $array_ret[$i][0] eq  $evalue_i){
					$save  = "false";
				}
			}
			if ($save eq "true"){
				push(@array_ret, $localArray[$i]);
			}
		}
	}
	return @array_ret;
}
############################ sub runFormatFiletoSam ##################################
sub getScoreFromLine {
	 my $line	= $_[1];
	 my @array = split(/,/, $line);
	 my @array2 =  split(/=/, $array[0]);
	 @array  =  split(/ +/, $array2[1]);
	 return $array[1];
}

############################ sub runFormatFiletoSam ##################################
sub getIdentityFromLine {
	 my $line	= $_[1];
	 my @array = split(/,/, $line);
	 my @array2 =  split(/=/, $array[0]);
	 @array2 =  split(/\(/, $array2[1]);
	 $array2[1] = String->removeCaracter($array2[1], ")");
	 return $array2[1];
}

############################ sub runFormatFiletoSam ##################################
sub getQueryStartFromLine {
	 my $line	= $_[1];
	 my $start	= $_[2];
	 
	 if ($start == 0){
	 	 my @array = split(/ +/, $line);
	 	return $array[1];
	 }
	 return $start;	
}

############################ sub runFormatFiletoSam ##################################
sub getQueryEndFromLine {
	 my $line	= $_[1];
	 my @array = split(/ +/, $line);
	 return String->removeCaracter($array[3], "\n");
}




############################ sub runFormatFiletoSam ##################################
sub getBestHit {

    my $outputFile	= $_[1];
    my $entry;
    my $sequenceName;
      
    my @array = FilesIO->lineFileToArray($outputFile);
	
	for (my $i=0; $i < scalar(@array); $i++) {
		$entry = $array[$i];
		if (index($entry, $NO_HITS) >= 0){
			return $NO_HITS;
		}elsif (index($entry, $HITS_FOUND)>= 0){	
			$i = $i + 4;
			$sequenceName = String->removeCaracter($array[$i], "\n");		
			return $sequenceName;
		}		
	}
    
}

############################ sub runFormatFiletoSam ##################################
sub hasResult {

    my $outputFile	= $_[1];
    my $entry;
    my $sequenceName;
      
    my @array = FilesIO->lineFileToArray($outputFile);
	
	for (my $i=0; $i < scalar(@array); $i++) {
		$entry = $array[$i];
		if (index($entry, $NO_HITS) >= 0){
			return "false";
		}	
	}
    return "true";
}


############################ sub runFormatFiletoSam ##################################
sub getAllEvalue {

    my $outputFile	= $_[1];
    my $entry;
    my @array_evalues = ();
    
    my @array = FilesIO->lineFileToArray($outputFile);
	my @array1; my @array2;
	my $ev;
	foreach $entry (@array) {
		if (index($entry, $NO_HITS) >= 0){
			push(@array_evalues,100);
		}
		if (index($entry, $EXPECT)>= 0){
			@array1 = split(/,/, $entry);
			@array2 =  split(/=/, $array1[1]);
			$ev = $array2[1];
			$ev = Blast->formatEvalue($ev);
			push(@array_evalues, $ev);
		}
	}
    return @array_evalues;
}



############################ sub runFormatFiletoSam ##################################
sub parseResultOld {

    my $outputFile	= $_[1];
    my $entry;
    my @array_evalues = ();
    
    my @array = FilesIO->lineFileToArray($outputFile);
	my @array_hits; my @array2 = ();
	my $j =0;
	for (my $i =0; $i < scalar(@array); $i++) {
		if (index($array[$i], $NO_HITS) >= 0){
			return $NO_HITS;
		}
		elsif (index($array[$i], $HITS_FOUND)>= 0){	
			$i = $i +2;
			$j = 0;
			while($array[$i] ne "\n" && $i < scalar(@array)){
				@array2 = split(/ +/, $array[$i]);
				$array_hits[$j][1] = String->removeCaracter($array2[scalar(@array2) -1], "\n");#evalue
				$array_hits[$j][2] = $array2[scalar(@array2) -2];#score
				for (my $k = 0; $k<scalar(@array2) -2; $k++){
					
					if ($k != scalar(@array2) -3){
						$array_hits[$j][0] .= $array2[$k]." ";
					}else{
						$array_hits[$j][0] .= String->replace2($array2[$k], ".", "");
					}
				}
				$j++;
				$i++;
			}
					
		}		
	}
	
}

############################ sub runFormatFiletoSam ##################################
sub parseResultOneQuerySCOP {

    my $outputFile	= $_[1];
    my $entry;
    my $info = "";
    
    my @array = FilesIO->lineFileToArray($outputFile);
	my @array_hits; 
	
	for (my $i =0; $i < scalar(@array); $i++) {
		if (index($array[$i], $NO_HITS) >= 0){
			return $info;
		}
		elsif (index($array[$i], $HITS_FOUND)>= 0){	
			$i= $i +2;
			while ($array[$i] ne "\n" && $i < scalar(@array)){
				@array_hits = split(/ +/,  String->removeCaracter(String->removeSpaceExcess($array[$i]),"\n"));
				$info .= $array_hits[0]."\t".$array_hits[1]."\t".$array_hits[scalar(@array_hits) -1]."\n";
				$i++;
			}
			 $i = scalar(@array);		
		}		
	}
	return $info;	
}

############################ sub runFormatFiletoSam ##################################
sub parseResult {

    my $outputFile	= $_[1];
    my $entry;
    my @array_evalues = ();
    my $info = "";
    
    my @array = FilesIO->lineFileToArray($outputFile);
	my @array_hits; my @array2 = ();
	my $j =0;
	for (my $i =0; $i < scalar(@array); $i++) {
		if (index($array[$i], $NO_HITS) >= 0){
			return $NO_HITS;
		}
		elsif (index($array[$i], ">")>= 0){	
			while ((index($array[$i], "Database:")< 0) && $i < scalar(@array)){
				$info .= $array[$i];
				$i++;
			}
			 $i = scalar(@array);		
		}		
	}
	return $info;	
}
############################ sub runFormatFiletoSam ##################################
sub verifyExistsHit {
    my $hits	= $_[1];
    my $new_hit	= $_[2];
    
    my @array = String->StringToArray2d($hits,"\n", "\t");
    my @array_new_hit = String->StringToArray2d($new_hit,"\n", "\t");
    for(my $i=0; $i < scalar(@array); $i++){
    	if ($array[$i][0] eq $array_new_hit[0][0]  && 
    	    $array[$i][6] eq $array_new_hit[0][6]  &&
    		$array[$i][7] eq $array_new_hit[0][7]){
    			return "true";    		
    	}
    }
    return "false";
}

############################ sub runFormatFiletoSam ##################################
sub parseResultByQuery {
    my $resultParsedFile	= $_[1];
    my %hash_query = Blast->parseResultManyQueries($resultParsedFile);
    while ( my ($key, $value) = each(%hash_query) ) {
       return $value;
    }
    
}

############################ sub runFormatFiletoSam ##################################
sub getSequencesFromOutput {
    my $resultParsedFile	= $_[1];
    my $evalue				= $_[2];
    my $identity			= $_[3];
    my $outputFile			= $_[4];
    my $verbose				= $_[5];
    
    my $evalue_local;		my $identity_local;
    my $stop = "false";		my $sequence;
    my $info = "";			my $count=0;
    my %hash_seqs = ();		my $count_real = 0;
    
    my @array = FilesIO->lineFileToArrayWithToken($resultParsedFile, $SCORE);
    #print "Size".scalar(@array)."\n";
    for (my $i =0; $i < scalar(@array); $i++) {
    	 #print "I  $i"."\n";
    	 #print $array[$i];
    	if (index($array[$i], $SCORE) >= 0) {  
    		$evalue_local = Blast->getEvalueFromLine($array[$i]);
    		$i++;
    		#print "I  $i"."\n";
    		$identity_local = String->removeCaracter(Blast->getIdentityFromLine($array[$i]), "%");
    		#print $identity."\t";print $identity_local." $evalue_local $evalue\n";
    		if ($evalue_local <= $evalue && $identity_local >= $identity){# I comented because sometimes I don't have any sequence
    		#if ($evalue_local <= $evalue){
    			$sequence = "";			$stop ="false";
    			while ($stop eq "false" && $i < scalar(@array)){
    				$i++;
    				#print "I  $i"."\n";
    				#print $array[$i];
    				if (index($array[$i], $SBJCT_IN) >= 0){ 
    					$sequence .= Blast->extractSequence($array[$i]);
    				}elsif (index($array[$i], $SCORE) >= 0){
    					$stop = "true";
    					$i--;
    				}
    			}
    			$count++;
    			$sequence=Sequences->divideSeq($sequence, 50);
    			if (!exists($hash_seqs{$sequence})){    				
    				$info .=">seq$count $evalue_local $identity_local\n$sequence\n";
    				$hash_seqs{$sequence} = "seq$count";
    				$count_real++;
    			}
    			
    			
    		}
    	}
    }
   # print $info."\n";
    FilesIO->saveFile($outputFile, $info, $verbose);
  	#print "LOG::BLAST QTD SEQ $count_real ::\n";
  
}


############################ sub runFormatFiletoSam ##################################
sub getSequencesFromOutputEvalue {
    my $resultParsedFile	= $_[1];
    my $evalue				= $_[2];
    my $outputFile			= $_[3];
    my $verbose				= $_[4];
    
    my $evalue_local;		my $identity_local;
    my $stop = "false";		my $sequence;
    my $info = "";			my $count=0;
    my %hash_seqs = ();		my $count_real = 0;
    
    my @array = FilesIO->lineFileToArrayWithToken($resultParsedFile, $SCORE);
    #print "Size".scalar(@array)."\n";
    for (my $i =0; $i < scalar(@array); $i++) {
    	 #print "I  $i"."\n";
    	 #print $array[$i];
    	if (index($array[$i], $SCORE) >= 0) {  
    		$evalue_local = Blast->getEvalueFromLine($array[$i]);
    		$i++;
    		#print "I  $i"."\n";
    		$identity_local = String->removeCaracter(Blast->getIdentityFromLine($array[$i]), "%");
    		#print $identity."\t";print $identity_local."\n";
    		if ($evalue_local <= $evalue){# I comented because sometimes I don't have any sequence
    		#if ($evalue_local <= $evalue){
    			$sequence = "";			$stop ="false";
    			while ($stop eq "false" && $i < scalar(@array)){
    				$i++;
    				#print "I  $i"."\n";
    				#print $array[$i];
    				if (index($array[$i], $SBJCT_IN) >= 0){ 
    					$sequence .= Blast->extractSequence($array[$i]);
    				}elsif (index($array[$i], $SCORE) >= 0){
    					$stop = "true";
    					$i--;
    				}
    			}
    			$count++;
    			$sequence=Sequences->divideSeq($sequence, 50);
    			if (!exists($hash_seqs{$sequence})){    				
    				$info .=">seq$count $evalue_local $identity_local\n$sequence\n";
    				$hash_seqs{$sequence} = "seq$count";
    				$count_real++;
    			}
    			
    			
    		}
    	}
    }
   # print $info."\n";
    FilesIO->saveFile($outputFile, $info, $verbose);
  	#print "LOG::BLAST QTD SEQ $count_real ::\n";
  
}

############################ sub runFormatFiletoSam ##################################
sub getCloseSequencesFromOutput {
    my $resultParsedFile	= $_[1];
    my $evalue				= $_[2];
    my $identity			= $_[3];
    my $outputFile			= $_[4];
    my $verbose				= $_[5];
    
    my $evalue_local;		my $identity_local;
    my $stop = "false";		my $sequence;
    my $info = "";			my $count=0;
    my %hash_seqs = ();		my $count_real = 0;
    
    my @array = FilesIO->lineFileToArrayWithToken($resultParsedFile, $SCORE);
    print "Size".scalar(@array)."\n";
    for (my $i =0; $i < scalar(@array); $i++) {
    	 #print "I  $i"."\n";
    	 #print $array[$i];
    	if (index($array[$i], $SCORE) >= 0) {  
    		$evalue_local = Blast->getEvalueFromLine($array[$i]);
    		$i++;
    		#print "I  $i"."\n";
    		$identity_local = String->removeCaracter(Blast->getIdentityFromLine($array[$i]), "%");
    		print $identity."\t";print $identity_local."\n";
    		#if ($identity_local >= $identity){# I comented because sometimes I don't have any sequence
    		if ($evalue_local <= $evalue){
    			$sequence = "";			$stop ="false";
    			while ($stop eq "false" && $i < scalar(@array)){
    				$i++;
    				#print "I  $i"."\n";
    				#print $array[$i];
    				if (index($array[$i], $SBJCT_IN) >= 0){ 
    					$sequence .= Blast->extractSequence($array[$i]);
    				}elsif (index($array[$i], $SCORE) >= 0){
    					$stop = "true";
    					$i--;
    				}
    			}
    			$count++;
    			$sequence=Sequences->divideSeq($sequence, 50);
    			if (!exists($hash_seqs{$sequence})){    				
    				$info .=">seq$count $evalue_local $identity_local\n$sequence\n";
    				$hash_seqs{$sequence} = "seq$count";
    				$count_real++;
    			}
    			
    			
    		}
    	}
    }
   # print $info."\n";
    FilesIO->saveFile($outputFile, $info, $verbose);
  	print "LOG::BLAST QTD SEQ $count_real ::\n";
  
}

############################ sub runFormatFiletoSam ##################################
sub extractSequence {
 	my $line	= $_[1];
	my @array = split(/ +/, $line);
	return String->removeCaracter($array[2], "-");
}

############################ sub runFormatFiletoSam ##################################
sub parseResultManyQueries {
    my $resultParsedFile	= $_[1];
 
    my @array = FilesIO->lineFileToArray($resultParsedFile);
    my $anotation = ""; my $score; my $evalue; my $identity; 
    my %hash_queries = (); my $query_name; my $query_name_old; my @query_array;
    my $info = "";
    my $anotation_found = "false";
   	my $start_query= 0; my $end_query = 0; my $start_Sbjct = 0; my $end_Sbjct = 0;
   	my $len_hit;
    
    for (my $i =0; $i < scalar(@array); $i++) {
    	#print $array[$i];
    	if (index($array[$i], $QUERY) >= 0) {  
    		@query_array = split(/ +/, $array[$i]);
    		$query_name = $query_array[1];
    	}	    	
   		if (index($array[$i], ">") >= 0){   				
   			if ($anotation_found eq "true"){
    			$info = $anotation."\t".$score."\t".$evalue."\t".$identity."\t".$start_query."\t".$end_query."\t".$start_Sbjct."\t".$end_Sbjct."\t".$len_hit."\n";
    			if (!exists($hash_queries{$query_name_old})){
    				$hash_queries{$query_name_old} = $info;
   				}else{
   					if (Blast->verifyExistsHit($hash_queries{$query_name_old}, $info) eq "false"){
   						$hash_queries{$query_name_old} .= $info;	
   					}   							
   				}
   				$anotation_found = "false";
   				$start_query= 0; $end_query = 0; $start_Sbjct = 0; $end_Sbjct = 0;$anotation="";
    		}
    		$query_name_old = $query_name;
    		while ($anotation_found eq "false" && $i < scalar(@array)){
    			$anotation .= String->removeCaracter($array[$i], "\n");
    			$i++;
   				if (index($array[$i], $LENGTH) >= 0){
   					$anotation_found = "true";
   					$anotation .= String->removeCaracter($array[$i], "\n");    						
   					$anotation = String->removeSpaceExcess($anotation);
   					$len_hit  = Blast->getLengthHitFromAnnotation($anotation);  						
   					$i++;
    			}
    		}
    	}    	
    	if (index($array[$i], $SCORE) >= 0){
   			$score = Blast->getScoreFromLine($array[$i]);
   		}
   		if (index($array[$i], $EXPECT) >= 0){
   			$evalue = Blast->getEvalueFromLine($array[$i]);
    	}
    	if (index($array[$i], $IDENTITY) >= 0){
    		$identity = Blast->getIdentityFromLine($array[$i]);
   		}
   		if (index($array[$i], $QUERY_IN) >= 0){
   			$start_query = Blast->getQueryStartFromLine($array[$i], $start_query);
   		}
   		if (index($array[$i], $QUERY_IN) >= 0){
    		$end_query = Blast->getQueryEndFromLine($array[$i]);
    	}
    	if (index($array[$i], $SBJCT_IN) >= 0){
    		$start_Sbjct = Blast->getQueryStartFromLine($array[$i], $start_Sbjct);
    	}
    	if (index($array[$i], $SBJCT_IN) >= 0){
    		$end_Sbjct = Blast->getQueryEndFromLine($array[$i]);
    	}      		
   }
   $info = $anotation."\t".$score."\t".$evalue."\t".$identity."\t".$start_query."\t".$end_query."\t".$start_Sbjct."\t".$end_Sbjct."\t".$len_hit."\n";
   if (!exists($hash_queries{$query_name_old})){
   		$hash_queries{$query_name_old} = $info;
   	}else{
   		if (Blast->verifyExistsHit($hash_queries{$query_name_old}, $info) eq "false"){
   			$hash_queries{$query_name_old} .= $info;	
   		}   			
   }
	return %hash_queries;
}


############################ sub runFormatFiletoSam ##################################
sub getSpecieFromAnnotation {

    my $annotation	= $_[1];
    $annotation = String->getSubStringToFrom($annotation, "[", "]");
    #print "DEBUG ".$annotation."\n";
    
    my @array = split(/\]\[/, $annotation);
    #print "DEBUG ".scalar(@array)."\n";
    my @array_ret = (); my $entry;
    my %hash_aux = ();
    foreach $entry (@array){
    	$entry = String->removeCaracter($entry, "]");   
    	$entry = String->removeCaracter($entry, "["); 
    	if (!exists($hash_aux{$entry})){
    		push(@array_ret, $entry);
    		$hash_aux{$entry} =  ""; #eliminating duplicates
    	}
    }
    #print "DEBUG Ret ".scalar(@array_ret)."\n";
    return @array_ret;    
}

############################ sub runFormatFiletoSam ##################################
sub getLengthHitFromAnnotation {

    my $annotation	= $_[1];
 
    my @array = split(/Length =/, $annotation);
    my $entry = String->removeCaracter($array[1], " ");   
    return $entry;    
}

############################ sub runFormatFiletoSam ##################################
sub getSpeciesFromQueries {

    my $hash	= $_[1];
    my $key; my $value;
    my @array; my @array_species;my $entry;
    
    my %hash_species = ();
    while (($key, $value) = each(%$hash)) {
    	@array = String->StringToArray2d($value,"\n", "\t");
    	for(my $i=0; $i < scalar(@array); $i++){
    		@array_species = Blast->getSpecieFromAnnotation($array[$i][0]);
    		foreach $entry (@array_species){
    			if (!exists($hash_species{$entry})){
    				$hash_species{$entry} = $entry;
   				}
    		}    	
    	}    	
    }
 	return %hash_species;    
}

############################ sub runFormatFiletoSam ##################################
sub getOnlyBestEvalue {

    my $resultParsedFile	= $_[1];
    my @array = FilesIO->fileToArray2d($resultParsedFile, "\t");
    my $evalueBest =  1000;
    my $info;
    for (my $i =0; $i < scalar(@array); $i++) {
    	if ($array[$i][10] < $evalueBest){
    		$info = $array[$i][0]."\t".$array[$i][1]."\t".$array[$i][2]."\t".$array[$i][3]."\t".$array[$i][4]."\t".$array[$i][5]."\t".$array[$i][6]."\t";
    		$info .= $array[$i][7]."\t".$array[$i][8]."\t".$array[$i][9]."\t".$array[$i][10]."\t".$array[$i][11]."\n";
    		$evalueBest = $array[$i][10] 
    	}
    }
    FilesIO->saveFile($resultParsedFile, $info, "false");
    
}
############################ sub runFormatFiletoSam ##################################
sub parseResultHTMLHits {

    my $resultParsedFile	= $_[1];
    my $querySequence   	= $_[2];
    my $lenTotal			= $_[3];
    
	my @array = FilesIO->fileToArray2d($resultParsedFile, "\t");
	my @arraySeq = Sequences->getSequenceFromFastaArray2D($querySequence);
	my $lenQuery =  Sequences->lengthSequence($arraySeq[0][1]);
	my $lenHit;
	#my $lenTotal = $lenQuery;
	my $scale = $lenTotal/$lenQuery;
	my $imghit; my $lenHitImg; my $lenCompHit; my $rest;
	my @arrayImg = ();
	my $info = "";
	
	for (my $i =0; $i < scalar(@array); $i++) {
		$lenHit = $array[$i][7] - $array[$i][6] + 1;
		$lenHitImg = $lenHit*$scale;
		$imghit =  HTML->createImg($array[$i][10], "0", "4",  Blast->findColorScore($array[$i][11]), $lenHitImg);
		if ($array[$i][7] == $lenQuery){
			$arrayImg[0] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0), ($lenTotal-$lenHitImg)/2);
			$arrayImg[1] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0), ($lenTotal-$lenHitImg)/2);
			$arrayImg[2] = $imghit;
		}elsif ($array[$i][6] == 1){
			$arrayImg[0] = $imghit;
			$arrayImg[1] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0), ($lenTotal-$lenHitImg)/2);
			$arrayImg[2] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0), ($lenTotal-$lenHitImg)/2);
		}else{
			$arrayImg[1] = $imghit;
			$lenCompHit = ($lenQuery - $array[$i][7] + 1)*$scale;
			$arrayImg[2] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0), $lenCompHit);
			$rest = $lenTotal - ($lenCompHit + $lenHitImg);
			$arrayImg[0] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0), $rest);	
		}
		$info .= HTML->tableFromArray("0", "left", "","0", "0", \@arrayImg);
	}
	return $info;	
}

############################ sub runFormatFiletoSam ##################################
sub parseResultHTMLHitsByResult {

    my $resultParsedFile	= $_[1];
    my $querySequence   	= $_[2];
    my $lenTotal			= $_[3];
    my $path				= $_[4];
    
	my @array = FilesIO->fileToArray2d($resultParsedFile, "\t");
	my @arraySeq = Sequences->getSequenceFromFastaArray2D($querySequence);
	my $lenQuery =  Sequences->lengthSequence($arraySeq[0][1]);
	my $lenHit;
	#my $lenTotal = $lenQuery;
	my $scale = $lenTotal/$lenQuery;
	my $imghit; my $lenHitImg; my $lenCompHit; my $rest;
	my @arrayImg = ();
	my $info = "";
	
	#for (my $i =0; $i < scalar(@array); $i++) {
	for (my $i =0; $i < 1; $i++) {
		$lenHit = $array[$i][9] - $array[$i][8] + 1;
		$lenHitImg = $lenHit*$scale;
		$imghit =  HTML->createImg($array[$i][10], "0", "4",  Blast->findColorScore($array[$i][11],$path), $lenHitImg);
		if ($array[$i][9] == $lenQuery){
			$arrayImg[0] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), ($lenTotal-$lenHitImg)/2);
			$arrayImg[1] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), ($lenTotal-$lenHitImg)/2);
			$arrayImg[2] = $imghit;
		}elsif ($array[$i][8] == 1){
			$arrayImg[0] = $imghit;
			$arrayImg[1] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), ($lenTotal-$lenHitImg)/2);
			$arrayImg[2] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), ($lenTotal-$lenHitImg)/2);
		}else{
			$arrayImg[1] = $imghit;
			$lenCompHit = ($lenQuery - $array[$i][9] + 1)*$scale;
			$arrayImg[2] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), $lenCompHit);
			$rest = $lenTotal - ($lenCompHit + $lenHitImg);
			$arrayImg[0] =  HTML->createImg("", "0", "4",  Blast->findColorScore(0,$path), $rest);	
		}
		$info .= HTML->tableFromArray("0", "left", "","0", "0", \@arrayImg);
	}
	return $info;	
}

############################ sub runFormatFiletoSam ##################################
sub representQuery {
	my $queryId				= $_[1];
    my $querySequence   	= $_[2];
    my $img				   	= $_[3];
    my $lenTotal			= $_[4];
    my $lenQueryReal;
    my $lenQuery;
	my $info = "";
	my @array_ret2 = ();
	
	my @arraySeq = Sequences->getSequenceFromFastaArray2D($querySequence);
	$lenQueryReal =  Sequences->lengthSequence($arraySeq[0][1]);
	
	if (!defined($lenTotal)){
		$lenQuery = $lenQueryReal;
	}else{
		$lenQuery = $lenTotal;
	}
	
	
	#$info =  $queryId. " ($lenQuery)" ."\t";
	$array_ret2[0] =  $queryId. " ($lenQueryReal)" ;
	$array_ret2[1] = HTML->createImg("", "0", "4",  $img, $lenQuery);
	
	return @array_ret2;
	
}
############################ sub runFormatFiletoSam ##################################
sub findColorScore {
	my $score	= $_[1];
	my $path	= $_[2];
	
	if ($score < 40 && $score > 0){
		return $path."/img/black.gif";
	}elsif ($score >=40 && $score < 50){
		return $path."/img/blue.gif";
	}elsif ($score >=50 && $score < 80){
		return $path."/img/green.gif";
	}elsif ($score >=80 && $score < 200){
		return $path."/img/purple.gif";
	}elsif ($score >=200){
		return $path."/img/red.gif";
	}else {
		return $path."/img/white.gif";
	}
}


1
