#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}


use File::Files;
use Util::Array;
use Util::Hash;
use analisys::analisys;
use Sequence::Domain;
use Sequence::sequence;
use Database::PFAM;


my $PROG_NAME = "CASH_26::scripts::FDR::create_fasta_fdrSingleSequence.pl";

my $verbose    	= "false";
my $fastaFile  		= "";	
my $kmer			= "1"; #1=shuffled by aminoacids 2=shuffled by 2-mers
my $outputFile = "";
my $repetition = 20;
my $factor = "";


&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-fastaFile"){
			$fastaFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-kmer"){
			$kmer = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-repetition"){
			$repetition= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-factor"){
			$factor= $ARGV[$counter+1];
		}										
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	

	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($fastaFile, $PROG_NAME."ERROR:: Parameter -fastaFile is required");
	FilesIO->checkFile($fastaFile, $PROG_NAME."ERROR:: File $fastaFile NOT found ");	
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");
	
	print "-fastaFile = $fastaFile\n";
	print "-outputFile = $outputFile\n";
	print "-kmer = $kmer\n";		
	print "-repetition = $repetition\n";	
	print "-verbose = $verbose\n";
	print "ok\n";	
}

############################ sub main ##################################
sub main{	
	my $sequence;				my %hash;
	my $aux;					my @arrayKeys;
	my $random_number;			my $shuff_seq;
	my $key;					my $info = "";
	my $ann;
	
	my @sequences = Sequences->getSequenceFromFastaArray2D($fastaFile);
	
	for (my $i=0; $i<scalar(@sequences); $i++){
		$sequence = String->removeCaracter($sequences[$i][1], "\n");		
		if ($verbose eq "true"){print "HASH\n". Hash->printHash(\%hash)."\n";}
		for (my $j=0; $j< $repetition; $j++){
			$shuff_seq = "";
			%hash = Sequences->createHashSequence($sequence, $kmer); 
			while (keys(%hash)){
				@arrayKeys = keys(%hash);
				if ($verbose eq "true"){print " disp Keys ". Array->printArray("\t", \@arrayKeys)."\n";}
				$random_number = int(rand(scalar(@arrayKeys)));
				if ($verbose eq "true"){print "Rand".$random_number."\n";}
				$key = $arrayKeys[$random_number];
				if ($verbose eq "true"){print "key $key\n";	print "add to shuff ".$hash{$key}."\n";}
				$shuff_seq .=$hash{$key};
				delete($hash{$key});
				if ($verbose eq "true"){print "New HASH\n". Hash->printHash(\%hash)."\n";}
			}
			if ($factor ne ""){
				$ann =  String->removeCaracter($sequences[$i][0], "\n")."_".$factor."\n";
			}else{
				$ann =  $sequences[$i][0];
			}
			
			$info .= $ann.Sequences->divideSeq(lc($shuff_seq), 60)."\n";
		}		
		print "LOG::$i/".(scalar(@sequences))."\n";		
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
}	