#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}


use File::Files;
use Util::Array;
use Util::Hash;
use analisys::analisys;
use Sequence::Domain;
use Sequence::sequence;
use Database::PFAM;
use List::Util qw(shuffle);


my $PROG_NAME = "perlLib::FDR::FDR::create_fasta_fdr_v3.pl";

my $verbose    	= "false";
my $fastaFile  		= "";	
my $kmer			= "1"; #1=shuffled by aminoacids 2=shuffled by 2-mers
my $outputFile = "";
my $concat = "false";
my $repetition = 20;
my $nameSeq = "";
my $reversal = "false";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-fastaFile"){
			$fastaFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-kmer"){
			$kmer = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-repetition"){
			$repetition= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-concat"){
			$concat= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-nameSeq"){
			$nameSeq= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-reversal"){
			$reversal= $ARGV[$counter+1];
		}										
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	

	String->isEqual($verbose,"true,false", $PROG_NAME."ERROR:: Parameter -verbose must be true or false");
	String->isEmpty($fastaFile, $PROG_NAME."ERROR:: Parameter -fastaFile is required");
	FilesIO->checkFile($fastaFile, $PROG_NAME."ERROR:: File $fastaFile NOT found ");	
	String->isEmpty($outputFile, $PROG_NAME. "ERROR:: Parameter -outputFile is required");
	
	print "-fastaFile = $fastaFile\n";
	print "-outputFile = $outputFile\n";
	print "-kmer = $kmer\n";		
	print "-repetition = $repetition\n";	
	print "-verbose = $verbose\n";
	print "ok\n";	
}

############################ sub main ##################################
sub main{	
	my $sequence;				my %hash;
	my $aux;					my @arrayKeys;
	my $random_number;			my $shuff_seq;
	my $annotation;				my $info = "";
	my @chars;					my @shuff;
	my $sequenceN;				my @array_aux = ();
	my $new_annotation;
	
	
	my @sequences = Sequences->getSequenceFromFastaArray2D($fastaFile);
	if ($reversal eq "true"){
			$kmer = 1;
	}
 
	for (my $i=0; $i<scalar(@sequences); $i++){
		$annotation = $sequences[$i][0];
		$sequence = String->removeCaracter($sequences[$i][1], "\n");	
		@chars = Sequences->createSequenceArray($sequence, $kmer);	
		
		for (my $j=0; $j< $repetition; $j++){
			if ($reversal eq "true"){
				@shuff = reverse @chars;
			}else{
				@shuff =  shuffle(@chars);
			}
		
			$shuff_seq = Array->printArray("", \@shuff);
			if ($concat eq "true"){
				$sequenceN = $sequence.$shuff_seq;
			}else{
				$sequenceN = $shuff_seq;
			}
			if ($nameSeq ne ""){
				@array_aux = split(/\t/, $annotation);
				#print $array_aux[0]."\n";
				$new_annotation = $array_aux[0]."_".$nameSeq.$j."\t".$array_aux[1];
			}else{
				$new_annotation = $annotation;
			}
			$info .= $new_annotation. Sequences->divideSeq($sequenceN, 60)."\n";
		}		
		print "LOG::$i/".(scalar(@sequences))."\n";		
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
}	