package PSIBLAST2;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Align::Primary::blast;
use Database::ScopPattern; 
use Util::Array;

my $build = "psiblast";
my $search = "psiblast";
my $formatdb_program = "makeblastdb";
my $TAG_RESULT = "Sequences producing significant alignments:";

########################### sub buildPSSM ##############################
sub buildPSSM {
	my $seq_file		= $_[1];
    my $database		= $_[2];
    my $iteration		= $_[3];
    my $pssm_file		= $_[4];
    my $seq_file_out	= $_[5];
    my $evalue			= $_[6];
    my $parameter		= $_[7];
    my $verbose			= $_[8];
	
	if (!defined($verbose)){
		$verbose = "true";
	}
	#verify directory

	FilesIO->createDirFromFile($seq_file_out);
	
	#print "path data" . $path_data."\n";
	
	
	my $cmd =$build." -db ".$database." -query ". $seq_file;
	if ($iteration ne "") {
		$cmd .= " -num_iterations ". $iteration;
	}
	
	if ($pssm_file ne ""){
		FilesIO->createDirFromFile($pssm_file);
		#if (FilesIO->getExt($pssm_file) eq ".out"){
			$cmd .= " -out_ascii_pssm ".$pssm_file.".out";
		#}else{
			$cmd .= " -out_pssm ".$pssm_file;
		#}		
	}
	
	$cmd .= " -out ".$seq_file_out.$parameter." -evalue $evalue ";
	
	if ($verbose eq "true") {
		print $cmd."\n";
	}	
	system $cmd;
	
	if ($pssm_file ne ""){
		if (FilesIO->isFile($pssm_file) eq "false"){
			print "ERROR::perlLib::psi_blast:: $pssm_file NOT created!\n";
		}elsif ($verbose eq "true") {
			print "perlLib::psi_blast:: $pssm_file created!\n";
		}
	}
	
	if (FilesIO->isFile($seq_file_out) eq "false"){
		print "ERROR::perlLib::psi_blast:: $seq_file_out NOT created!\n";
	}elsif ($verbose eq "true") {
		print "perlLib::psi_blast:: $seq_file_out created!\n";
	}
	
}

########################### sub searchPSSM ##############################
sub searchPSSM {
	my $database		= $_[1];
    my $pssm_file		= $_[2];
    my $search_file_out	= $_[3];
    my $parameter		= $_[4];
    my $verbose			= $_[5];
	
	if (!defined($verbose)){
		$verbose = "true";
	}
   

	my $cmd = $build. " -db ". $database. " -in_pssm ". $pssm_file .$parameter. " -out ". $search_file_out;
	
	if ($verbose eq "true") {
		print $cmd."\n";
	}
	system $cmd;
	
	if (FilesIO->isFile($search_file_out) eq "false" ){
		print "WARNING::perlLib::psi_blast:: $search_file_out is NOT created!\n";
		#exit;
	}elsif ($verbose eq "true") {
		print "perlLib::psi_blast:: File $search_file_out is created!\n";
	}	
}

########################### sub searchPSSM ##############################
sub getResultPSSM {
	my $result_file		= $_[1];
	
	my @results = FilesIO->lineFileToArray($result_file);
	my $i = 0;
	my $info = "";
	my @array_line;
	my @array_result = ();
	my $j = 0;
	my $evalue;
	
	while($i < scalar(@results)) {
		#print $results[$i];
		if (index($results[$i], $TAG_RESULT) >=0){
			$i += 2;
			#print "oi = $i ".$results[$i];
			
			while ($results[$i] ne "\n" && $i < scalar(@results)){	
				@array_line = split(/ +/, $results[$i]);	
				$array_result[$j] = $array_line[0]."\t".$array_line[1]."\t";
				$evalue = String->trim(substr($results[$i],76,length($results[$i])));
				$evalue = String->removeCaracter($evalue, "\n");
				$array_result[$j] .=$evalue; 
				$j++;	
				$info .= $results[$i];
				$i++;
			}	
			#print $info;		
		}
		$i++;
	}
	#print $info;	
	return @array_result;
}


############################ sub runFormatFiletoSam ##################################
sub formatdb {

    my $db    	= $_[1];
 	my $verbose	= $_[2];
 	my $delete	= $_[3];
 	my $entry; my $count =0;
	
	if (!defined($verbose)){
		$verbose = "true";
	}
	if (!defined($delete)){
		$delete = "false";
	}
 	
 	if ($delete eq "true"){
 		FilesIO->removeFile("$db.phr", "false");
 		FilesIO->removeFile("$db.pin", "false");
 		FilesIO->removeFile("$db.psq", "false");
 	}
 	else{
 		my $dir = FilesIO->getDirectory($db);
		my @array = FilesIO->listDirectoryFromPrefixFile("$db.*",$dir."tmp");
	
		foreach $entry (@array){
			$entry = FilesIO->getExt($entry);
			#print $entry."-----\n";
			if ($entry eq "phr" || $entry eq "pin" || $entry eq "psq"){
				$count++;
			}
		}
 	}
 		
	if ($count < 3){
		my $cmd = $formatdb_program. " -in ". $db;
 		if ($verbose eq "true"){
 			print $cmd."\n";
 		}
  		system ($cmd);
	}elsif ($verbose eq "true"){
		print "perlLib::Blast::  $db is already formated !\n";
	} 	
}
