package Protein;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}
use strict;
use Sequence::sequence;

my $charged = "DEHIKLRV";
my $positivelyCharged =  "HKR";
my $negativelyCharged = "DE";
my $polar = "DEHKNQRSTWY";
my $aliphatic = "ILV";
my $aromatic= "FHWY";
my $small= "AGST";
my $tiny= "AG";
my $bulky= "FHRWY";
my $hydrophobic= "ILMV";
my $hydrophobicAromatic = "FWY";
my $neutralWeaklyHydrophobic= "AGPST";
my $hydrophilicAcidic= "EDNQ";
my $hydrophilicBasic= "KRH";
my $acidic= "ED";
my $polarUncharged = "NQ";

my @amino = ("ALA", "ARG", "ASP", "ASN", "CYS", "GLN", "GLU", "GLY", "HIS", "ILE", "LEU", "LYS", "MET", "PHE", "PRO", "SER", "THR", "TRP", "TYR", "VAL");
my %amino_table = (
	ALA => 'a',
	LEU => 'l',
	ARG => 'r',
	LYS => 'k',
	ASN => 'n',
	MET => 'm',
	ASP => 'd',
	PHE => 'f',
	CYS => 'c',
	PRO => 'p',
	GLN => 'q',
	SER => 's',
	GLU => 'e',
	THR => 't',
	GLY => 'g',
	TRP => 'w',
	HIS => 'h',
	TYR => 'y',
	ILE => 'i',
	VAL => 'v',
    );

my @amino1d = ("a", "l", "r", "k", "n", "m", "d", "f", "c",	"p", "q", "s", "e", "t", "g", "w", "h", "y", "i", "v");

my %amino_table_index = (
'a'=>1,
'l'=>2,
'r'=>3,
'k'=>4,
'n'=>5,
'm'=>6,
'd'=>7,
'f'=>8,
'c'=>9,
'p'=>10,
'q'=>11,
's'=>12,
'e'=>13,
't'=>14,
'g'=>15,
'w'=>16,
'h'=>17,
'y'=>18,
'i'=>19,
'v'=>20,
'-'=>21
);

############################ sub isAmino ###################################
sub getIndexAmino{
	my $aa	= $_[1];
	
	if (exists($amino_table_index{lc($aa)})){
		return $amino_table_index{lc($aa)};
	}
	else{
		print "Sequence::protein:: ERROR:: Index for $aa NOT found in amino_table_index\n";
		exit;
	}
}

############################ sub isAmino ###################################
sub isAmino{
	my $res	= $_[1];
	
	my $entry;
	my $found = "false";
	
	foreach $entry (@amino) {
		if ($res eq $entry){
			$found = "true";
		}
	}
	return $found;

}

############################ sub isAmino ###################################
sub getSimbol{
	my $cod_3	= $_[1];
	
	if (exists($amino_table{$cod_3})){
		return $amino_table{$cod_3};
	}
	return "";

}

############################ sub isAmino ###################################
sub getAmino1d{
	
	return @amino1d;

}

############################ sub isAmino ###################################
sub isCharged{
	my $amino	= $_[1];
	
	if (index(uc($amino), $charged) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isPositivelyCharged{
	my $amino	= $_[1];
	
	if (index(uc($amino), $positivelyCharged) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isNegativelyCharged{
	my $amino	= $_[1];
	
	if (index(uc($amino), $negativelyCharged) >=0){
		return "true";
	}
	return "false";
}
	
############################ sub isAmino ###################################
sub isPolar{
	my $amino	= $_[1];
	
	if (index(uc($amino), $polar) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isAliphatic{
	my $amino	= $_[1];
	
	if (index(uc($amino), $aliphatic) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isAromatic{
	my $amino	= $_[1];
	
	if (index(uc($amino), $aromatic) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isSmall{
	my $amino	= $_[1];
	
	if (index(uc($amino), $small) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isTiny{
	my $amino	= $_[1];
	
	if (index(uc($amino), $tiny) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isBulky{
	my $amino	= $_[1];
	
	if (index(uc($amino), $bulky) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isHydrophobic{
	my $amino	= $_[1];
	
	if (index(uc($amino), $hydrophobic) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isHydrophobicAromatic{
	my $amino	= $_[1];
	
	if (index(uc($amino), $hydrophobicAromatic) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isNeutralWeaklyHydrophobic{
	my $amino	= $_[1];
	
	if (index(uc($amino), $neutralWeaklyHydrophobic) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isHydrophilicAcidic{
	my $amino	= $_[1];
	
	if (index(uc($amino), $hydrophilicAcidic) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isHydrophilicBasic{
	my $amino	= $_[1];
	
	if (index(uc($amino), $hydrophilicBasic) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isAcidic{
	my $amino	= $_[1];
	
	if (index(uc($amino), $acidic) >=0){
		return "true";
	}
	return "false";
}

############################ sub isAmino ###################################
sub isPolarUncharged{
	my $amino	= $_[1];
	
	if (index(uc($amino), $polarUncharged) >=0){
		return "true";
	}
	return "false";
}

############################ sub create ####################################
sub findPercent{
	my $sequenceFile	 = $_[1];
  	my $propertie		 = $_[2];
  	my $verbose		     = $_[3];
  	
  	my $set;
  	my $entry_seq;
  	my $entry_set;
  	my $count = 0;
  	my $perc = 0;
  	my $info = "";
  	
  	my @array_seqs = Sequences->getSequenceFromFastaArray2D($sequenceFile); 
  	my $sequence = $array_seqs[0][1];
  	my $len_seq = length($sequence);
  	my @array_seq = split(//, $sequence);
  	
  	if (uc($propertie) eq uc("charged")){
  		$set = $charged;
  	}elsif (uc($propertie) eq uc("positivelycharged")){
  		$set = $positivelyCharged;
  	}elsif (uc($propertie) eq uc("negativelycharged")){
  		$set = $negativelyCharged;
  	}elsif (uc($propertie) eq uc("polar")){
  		$set = $polar;
  	}elsif (uc($propertie) eq uc("aliphatic")){
  		$set = $aliphatic;
  	}elsif (uc($propertie) eq uc("aromatic")){
  		$set = $aromatic;
  	}elsif (uc($propertie) eq uc("small")){
  		$set = $small;
  	}elsif (uc($propertie) eq uc("tiny")){
  		$set = $tiny;
  	}elsif (uc($propertie) eq uc("bulky")){
  		$set = $bulky;
  	}elsif (uc($propertie) eq uc("hydrophobic")){
  		$set = $hydrophobic;
  	}elsif (uc($propertie) eq uc("hydrophobicaromatic")){
  		$set = $hydrophobicAromatic;
  	}elsif (uc($propertie) eq uc("neutralweaklyhydrophobic")){
  		$set = $neutralWeaklyHydrophobic;
  	}elsif (uc($propertie) eq uc("hydrophilicacidic")){
  		$set = $hydrophilicAcidic;
  	}elsif (uc($propertie) eq uc("hydrophilicbasic")){
  		$set = $hydrophilicBasic;
  	}elsif (uc($propertie) eq uc("acidic")){
  		$set = $acidic;
  	}elsif (uc($propertie) eq uc("polaruncharged")){
  		$set = $polarUncharged;
  	}else{
  		print "ERROR::perlLib::Sequence::Protein:: Propertie $propertie NOT found\n";
  		exit;
  	}
  	  	
  	my @array_set = split(//, $set);
  	
  	foreach $entry_set (@array_set){
  		foreach $entry_seq (@array_seq){
  			if (uc($entry_seq) eq uc($entry_set)){
  				$count++;
  			}  		
  		}  		
  	}
  	
  	if ($count != 0){
  		$perc = ($count / $len_seq) * 100;  			
  	}
  	return $perc;
}

############################ sub create ####################################
sub createAminoacidPairRatio{
	my $sequenceFile	 = $_[1];
	my $aminoPair		 = $_[2];
	
	
	my $pair;
	my $count_pair = 0;
	my @array_seqs = Sequences->getSequenceFromFastaArray2D($sequenceFile); 
  	my $sequence = $array_seqs[0][1];
	
	my @array_seq = split(//, $sequence);
	
	for (my $i=0; $i < scalar(@array_seq) -1; $i++){
		$pair = $array_seq[$i].$array_seq[$i+1];
		if (uc($pair) eq uc($aminoPair)){
					$count_pair++;
		}				
	}
    #print "$count_pair ";			
	return $count_pair;	
}

############################ sub create ####################################
sub createAminoacidRatio{
	my $sequenceFile	 = $_[1];
	my $amino		 = $_[2];

	my $count = 0;
	my @array_seqs = Sequences->getSequenceFromFastaArray2D($sequenceFile); 
  	my $sequence = $array_seqs[0][1];
	my $len_seq = length($sequence);
	my @array_seq = split(//, $sequence);
	
	for (my $i=0; $i < scalar(@array_seq); $i++){
		if (uc($array_seq[$i]) eq uc($amino)){
			$count++;
		}				
	}
    #print "$count_pair ";		
    my $ratio = $count/$len_seq;	
	return $ratio;	
}

############################ sub mutateProtein ####################################
sub mutateProtein{
	my $sequence	 	= $_[1];
	my $mutationPerc 	= $_[2];
	my $start		 	= $_[3];
	my $end		 	 	= $_[4];
	
	my $ann;				my $seq;
	my $size;				my $numMutate;
	my @aa_sequence; 		my $numRand;
	my $aaRand;				my $aa;
	
	

	$size = $end - $start + 1;
	$numMutate = int($mutationPerc*$size);
	#print "numMutate=".$numMutate."\n";
	@aa_sequence = split(//,$sequence);
	#print $sequence."\n"; print $size."\n";
	for (my $j=0; $j < $numMutate; $j++){
			$numRand = int(rand($size)) + $start;			
			$aaRand  = int(rand(20));			
			$aa = $amino1d[$aaRand];			
			$aa_sequence[$numRand] = $aa;
			#print "numRand = ".$numRand."\n";
			#print "aaRand = ".$aaRand."\n";
			#print "aa = ".$aa."\n";
			#print Array->printArray("\t", \@aa_sequence)."\n";
			
	}
	return  Array->printArray("", \@aa_sequence);
}

1
