#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use PSSM::psi_blast_source_code;
use Database::ScopPattern;
use Align::Primary::blast;
use Sequence::sequence;


my $psiBlastFile	= "";
my $identity	 = "";
my $searchFileOut  = "";
my $evalue = "0.0001"; 
my $verbose = "false";
my $format = "";
my $outputFile = "";

my $PROG_NAME = "perlLib::run::getSequences_psi_blast.pl";


&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-psiBlastFile"){
			$psiBlastFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-evalue"){
			$evalue = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-identity"){
			$identity = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];		
		}	           	  	 			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEqual($verbose,"true,false",$PROG_NAME."::ERROR::Parameter -verbose must be true or false!");
	
	String->isEmpty($psiBlastFile, $PROG_NAME."::ERROR::Parameter -psiBlastFile having PSI-BLAST output is required!");
	FilesIO->checkFile($psiBlastFile, $PROG_NAME."ERROR:: File $psiBlastFile NOT found ");	
	String->isEmpty($outputFile, $PROG_NAME."::ERROR::Parameter -outputFile having output File  is required!");

	print "$psiBlastFile=$psiBlastFile\n";
	print "evalue=$evalue\n";
	print "verbose=$verbose\n";
	print "identity=$identity\n";
	print "outputFile=$outputFile\n";
	print "ok\n";
}	


########################### sub main ####################################
sub main { 
	
	Blast->getCloseSequencesFromOutput($psiBlastFile, $evalue, $identity, $outputFile);
}
