#!/usr/bin/perl -w
use strict;

if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use PSSM::psi_blast_source_code;
use Database::ScopPattern;
use Align::Primary::blast;
use Sequence::sequence;


my $pssmFile	= "";
my $dbSearch	 = "";
my $searchFileOut  = "";
my $evalue = "0.0001"; 
my $verbose = "false";
my $format = "";
my $formatDB = "false";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-pssmFile"){
			$pssmFile = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-dbSearch"){
			$dbSearch = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-searchFileOut"){
			$searchFileOut = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-evalue"){
			$evalue = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-format"){
			$format = $ARGV[$counter+1];		
		}elsif($ARGV[$counter] eq "-formatDB"){
			$formatDB = $ARGV[$counter+1];		
		}		           	  	 			
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters for search_psi_blast\n";
	
	
	if ($pssmFile eq ""){
		print "ERROR::run_psi_blast:: Parameter -pssmFile having PSSM file output is required!\n";
		exit;
	}
	print "-pssmFile = $pssmFile\n";	
	
	if ($dbSearch eq ""){
		print "ERROR::run_psi_blast:: Parameter -dbSearch having database for searching in PSSM is required!\n";
		exit;
	}
	
	if (FilesIO->isFile($dbSearch) eq "false"){
		print "ERROR::run_psi_blast:: $dbSearch is NOT Found!\n";
		exit;
	}
	print "-dbSearch = $dbSearch\n";		
	
	if ($searchFileOut eq ""){
		print "ERROR::run_psi_blast:: Parameter -searchFileOut having search file output is required!\n";
		exit;
	}
	print "-searchFileOut = $searchFileOut\n";
	
	if ($verbose ne "false" && $verbose ne "true"){
		print "ERROR::mountSequenceNegFromFastaDatabase:: Parameter -verbose must be true or false\n";
		exit;
	}
	print "-verbose = $verbose\n";
	
	print "-formatDB = $formatDB\n";
	
	print "ok\n";
}	


########################### sub main ####################################
sub main { 
	my $entry;
	my $info = "";

	#PSIBLAST2->formatdb($dbSearch, $verbose, $formatDB);
	
	if ($format ne ""){
		$format = " -outfmt 6 ";
	}
	
	my $dir = FilesIO->getDirectory($searchFileOut);
	FilesIO->createDirectory($dir);
	
	PSIBLAST2->searchPSSM($dbSearch, $pssmFile, $searchFileOut, " -num_iterations 1 -evalue $evalue $format ", $verbose);
}
